#pragma once
#include "ChannelData.h"
#include "CNmx.h"

#define N_STATIC_CH_DISPLAY		(64)
#define N_DIGIIO_DISPLAY		(128)
#define N_MAX_SAMPLING_CHANNELS	(256)
NMX_PHANDLE pHandleNmx = NULL;


/* --> Sample-Buffer for endless sampling:
 * It is known that defining this buffer globally is not a good practice regarding software design.
* However:
* - Visual C++/CLI does not allow defining a standard C++ - Array as a class member.
* - Most people using C++ will probably not use .NET, instead they use QT or something else.
* Therefore this buffer is define globally here. Feel free to integrate it into your software structure. */
signed long *paaslRingBuf[N_MAX_SAMPLING_CHANNELS];



// Callback Demo
unsigned long ulNCallback = 0;
unsigned long ulCallbackContext = 0x12345678;
void NMX_CALLCONV Callback_NewStatic32(void* pvContext)
{
	ulNCallback++;
}



namespace CppCLR_WinformsProjekt {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Runtime::InteropServices;
	using namespace System::IO;

	/// <summary>
	/// Zusammenfassung fr Form1
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: Konstruktorcode hier hinzufgen.
			//
		}

	protected:
		/// <summary>
		/// Verwendete Ressourcen bereinigen.
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Button^  btnConnect;
	private: System::ComponentModel::IContainer^  components;
	protected:

	private:
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>

		System::Windows::Forms::ListBox^  lbHistory;
		CNmx *clNmx;
		BOOL bConnected;
		unsigned long ulBoxInfoUpdates;
		unsigned long ulChannelInfoUpdates;
		unsigned long ulStatic1stCh;
		unsigned long ulNSamplingElements;
		BOOL bNewStatic;
		BOOL bNewSamplingData;
		BOOL bNewReconnected;
		unsigned long ulCtrReconnects;
		unsigned long ulCtrSamplingNotificationsNewData;
		unsigned long ulCtrSamplingNotificationsFinished;
		unsigned long ulCtrSamplingNotificationsAllReceived;
		unsigned long ulCtrSamplingNotificationsError;
		unsigned long ulCtrSamplingNotificationsBufferOverflow;
		unsigned long ulCtrSamplingNotificationTimeout;
		array<ChannelData^> ^aclChannelData;
		unsigned long ulSamplePeriodUltraFast;
		unsigned long ulSamplePeriodFast;
		unsigned long ulSamplePeriodStandard;
		unsigned long ulSamplingEndlessArrayLength;
		unsigned long ulSamplingArrayRowNewest;
		unsigned long long udSamplingCtrNewest;
		BOOL bSamplingReadRows;
		BOOL bWriteDigitalOutputData;
	private: System::Windows::Forms::TabControl^  tabControlMain;



	private: System::Windows::Forms::TabPage^  tbReadme;
	private: System::Windows::Forms::TabPage^  tbBoxInfo;
	private: System::Windows::Forms::DataGridView^  dataGridViewBoxInfo;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  dgvBox_No;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  dgvBox_Name;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  dgvBox_Serial;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  dgvBox_MAC;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  dgvBox_Fw;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  dgvBox_Hw;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  dgvBox_NChannels;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  dgvBox_NDigiIn;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  dgvBox_NDigiOut;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  dgBox_ProductionCode;
	private: System::Windows::Forms::TabPage^  tbChannelInfo;
	private: System::Windows::Forms::Button^  btnChannelInfoUpdate;
	private: System::Windows::Forms::DataGridView^  dataGridViewChInfo;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  dgvChannel_No;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  dgvChannel_Location;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  dgvChannel_Type;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  dgvChannel_Unit;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  dgvChannel_FactorToUnit;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  dgvChannel_Digits;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  dgvChannel_OrderNo;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  dgvChannel_SerNo;
	private: System::Windows::Forms::Label^  lbBoxInfoUpdates;
	private: System::Windows::Forms::Label^  lbChInfoUpdates;
	private: System::Windows::Forms::TabPage^  tbStatic;
	private: System::Windows::Forms::RadioButton^  rbStaticCH57_64;

	private: System::Windows::Forms::RadioButton^  rbStaticCH49_56;

	private: System::Windows::Forms::RadioButton^  rbStaticCH41_48;

	private: System::Windows::Forms::RadioButton^  rbStaticCH33_40;
	private: System::Windows::Forms::Label^  lbStaticDiff8;


	private: System::Windows::Forms::Label^  lbStaticMax8;

	private: System::Windows::Forms::Label^  lbStaticMin8;
	private: System::Windows::Forms::Label^  lbStaticDiff7;


	private: System::Windows::Forms::Label^  lbStaticMax7;

	private: System::Windows::Forms::Label^  lbStaticMin7;
	private: System::Windows::Forms::Label^  lbStaticDiff6;


	private: System::Windows::Forms::Label^  lbStaticMax6;

	private: System::Windows::Forms::Label^  lbStaticMin6;
	private: System::Windows::Forms::Label^  lbStaticDiff5;


	private: System::Windows::Forms::Label^  lbStaticMax5;

	private: System::Windows::Forms::Label^  lbStaticMin5;
	private: System::Windows::Forms::Label^  lbStaticDiff4;


	private: System::Windows::Forms::Label^  lbStaticMax4;

	private: System::Windows::Forms::Label^  lbStaticMin4;
	private: System::Windows::Forms::Label^  lbStaticDiff3;


	private: System::Windows::Forms::Label^  lbStaticMax3;

	private: System::Windows::Forms::Label^  lbStaticMin3;
private: System::Windows::Forms::Label^  lbStaticDiff2;


	private: System::Windows::Forms::Label^  lbStaticMax2;

	private: System::Windows::Forms::Label^  lbStaticMin2;
private: System::Windows::Forms::Label^  lbStaticDiff1;


private: System::Windows::Forms::Label^  lbStaticMax1;

	private: System::Windows::Forms::Label^  lbStaticMin1;

	private: System::Windows::Forms::Label^  label39;
	private: System::Windows::Forms::Label^  label38;
	private: System::Windows::Forms::Label^  label37;
	private: System::Windows::Forms::Label^  lbStaticHwStat8;

	private: System::Windows::Forms::Label^  lbStaticUnit8;

private: System::Windows::Forms::Label^  lbStaticDigits8;

private: System::Windows::Forms::Label^  lbStaticCh8;
private: System::Windows::Forms::Label^  lbStaticHwStat7;


private: System::Windows::Forms::Label^  lbStaticUnit7;

private: System::Windows::Forms::Label^  lbStaticDigits7;

private: System::Windows::Forms::Label^  lbStaticCh7;
private: System::Windows::Forms::Label^  lbStaticHwStat6;


private: System::Windows::Forms::Label^  lbStaticUnit6;

private: System::Windows::Forms::Label^  lbStaticDigits6;

private: System::Windows::Forms::Label^  lbStaticCh6;
private: System::Windows::Forms::Label^  lbStaticHwStat5;


private: System::Windows::Forms::Label^  lbStaticUnit5;

private: System::Windows::Forms::Label^  lbStaticDigits5;

private: System::Windows::Forms::Label^  lbStaticCh5;


private: System::Windows::Forms::Label^  lbStaticUnit4;

private: System::Windows::Forms::Label^  lbStaticDigits4;

private: System::Windows::Forms::Label^  lbStaticCh4;
private: System::Windows::Forms::Label^  lbStaticHwStat3;


private: System::Windows::Forms::Label^  lbStaticUnit3;

private: System::Windows::Forms::Label^  lbStaticDigits3;

private: System::Windows::Forms::Label^  lbStaticCh3;
private: System::Windows::Forms::Label^  lbStaticHwStat2;


private: System::Windows::Forms::Label^  lbStaticUnit2;

private: System::Windows::Forms::Label^  lbStaticDigits2;

private: System::Windows::Forms::Label^  lbStaticCh2;
private: System::Windows::Forms::Label^  lbStaticHwStat1;


private: System::Windows::Forms::Label^  lbStaticUnit1;

private: System::Windows::Forms::Label^  lbStaticDigits1;

private: System::Windows::Forms::Label^  lbStaticCh1;

	private: System::Windows::Forms::Label^  label4;
	private: System::Windows::Forms::Label^  label3;
	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::GroupBox^  groupBox1;
	private: System::Windows::Forms::RadioButton^  rbStaticCH25_32;
	private: System::Windows::Forms::RadioButton^  rbStaticCH17_24;
	private: System::Windows::Forms::RadioButton^  rbStaticCH9_16;
	private: System::Windows::Forms::RadioButton^  rbStaticCH1_8;
	private: System::Windows::Forms::Label^  lbStaticHwStat4;
	private: System::Windows::Forms::Label^  lbStaticUpdates;
	private: System::Windows::Forms::Timer^  tmrStatic;
private: System::Windows::Forms::Button^  btnStaticResetMinMax;
private: System::Windows::Forms::TabPage^  tbDigi;
private: System::Windows::Forms::GroupBox^  groupBox3;
private: System::Windows::Forms::GroupBox^  groupBox2;
private: System::Windows::Forms::CheckBox^  cbDOut_48;

private: System::Windows::Forms::CheckBox^  cbDOut_47;

private: System::Windows::Forms::CheckBox^  cbDOut_46;

private: System::Windows::Forms::CheckBox^  cbDOut_45;

private: System::Windows::Forms::CheckBox^  cbDOut_44;

private: System::Windows::Forms::CheckBox^  cbDOut_43;

private: System::Windows::Forms::CheckBox^  cbDOut_42;

private: System::Windows::Forms::CheckBox^  cbDOut_41;

private: System::Windows::Forms::CheckBox^  cbDOut_40;

private: System::Windows::Forms::CheckBox^  cbDOut_39;

private: System::Windows::Forms::CheckBox^  cbDOut_38;

private: System::Windows::Forms::CheckBox^  cbDOut_37;

private: System::Windows::Forms::CheckBox^  cbDOut_36;

private: System::Windows::Forms::CheckBox^  cbDOut_35;

private: System::Windows::Forms::CheckBox^  cbDOut_34;

private: System::Windows::Forms::CheckBox^  cbDOut_33;

private: System::Windows::Forms::CheckBox^  cbDOut_32;

private: System::Windows::Forms::CheckBox^  cbDOut_31;

private: System::Windows::Forms::CheckBox^  cbDOut_30;

private: System::Windows::Forms::CheckBox^  cbDOut_29;

private: System::Windows::Forms::CheckBox^  cbDOut_28;

private: System::Windows::Forms::CheckBox^  cbDOut_27;

private: System::Windows::Forms::CheckBox^  cbDOut_26;

private: System::Windows::Forms::CheckBox^  cbDOut_25;

private: System::Windows::Forms::CheckBox^  cbDOut_24;

private: System::Windows::Forms::CheckBox^  cbDOut_23;

private: System::Windows::Forms::CheckBox^  cbDOut_22;

private: System::Windows::Forms::CheckBox^  cbDOut_21;

private: System::Windows::Forms::CheckBox^  cbDOut_20;

private: System::Windows::Forms::CheckBox^  cbDOut_19;

private: System::Windows::Forms::CheckBox^  cbDOut_18;

private: System::Windows::Forms::CheckBox^  cbDOut_17;

private: System::Windows::Forms::CheckBox^  cbDOut_16;

private: System::Windows::Forms::CheckBox^  cbDOut_15;

private: System::Windows::Forms::CheckBox^  cbDOut_14;

private: System::Windows::Forms::CheckBox^  cbDOut_13;

private: System::Windows::Forms::CheckBox^  cbDOut_12;

private: System::Windows::Forms::CheckBox^  cbDOut_11;

private: System::Windows::Forms::CheckBox^  cbDOut_10;

private: System::Windows::Forms::CheckBox^  cbDOut_9;

private: System::Windows::Forms::CheckBox^  cbDOut_8;

private: System::Windows::Forms::CheckBox^  cbDOut_7;

private: System::Windows::Forms::CheckBox^  cbDOut_6;

private: System::Windows::Forms::CheckBox^  cbDOut_5;

private: System::Windows::Forms::CheckBox^  cbDOut_4;

private: System::Windows::Forms::CheckBox^  cbDOut_3;

private: System::Windows::Forms::CheckBox^  cbDOut_2;

private: System::Windows::Forms::CheckBox^  cbDOut_1;
private: System::Windows::Forms::CheckBox^  cbDOut_64;

private: System::Windows::Forms::CheckBox^  cbDOut_63;

private: System::Windows::Forms::CheckBox^  cbDOut_62;

private: System::Windows::Forms::CheckBox^  cbDOut_61;

private: System::Windows::Forms::CheckBox^  cbDOut_60;

private: System::Windows::Forms::CheckBox^  cbDOut_59;

private: System::Windows::Forms::CheckBox^  cbDOut_58;

private: System::Windows::Forms::CheckBox^  cbDOut_57;

private: System::Windows::Forms::CheckBox^  cbDOut_56;

private: System::Windows::Forms::CheckBox^  cbDOut_55;

private: System::Windows::Forms::CheckBox^  cbDOut_54;

private: System::Windows::Forms::CheckBox^  cbDOut_53;

private: System::Windows::Forms::CheckBox^  cbDOut_52;

private: System::Windows::Forms::CheckBox^  cbDOut_51;

private: System::Windows::Forms::CheckBox^  cbDOut_50;

private: System::Windows::Forms::CheckBox^  cbDOut_49;
private: System::Windows::Forms::CheckBox^  cbDOut_80;


private: System::Windows::Forms::CheckBox^  cbDOut_79;

private: System::Windows::Forms::CheckBox^  cbDOut_78;

private: System::Windows::Forms::CheckBox^  cbDOut_77;

private: System::Windows::Forms::CheckBox^  cbDOut_76;

private: System::Windows::Forms::CheckBox^  cbDOut_75;

private: System::Windows::Forms::CheckBox^  cbDOut_74;

private: System::Windows::Forms::CheckBox^  cbDOut_73;

private: System::Windows::Forms::CheckBox^  cbDOut_72;

private: System::Windows::Forms::CheckBox^  cbDOut_71;

private: System::Windows::Forms::CheckBox^  cbDOut_70;

private: System::Windows::Forms::CheckBox^  cbDOut_69;

private: System::Windows::Forms::CheckBox^  cbDOut_68;

private: System::Windows::Forms::CheckBox^  cbDOut_67;

private: System::Windows::Forms::CheckBox^  cbDOut_66;

private: System::Windows::Forms::CheckBox^  cbDOut_65;
private: System::Windows::Forms::CheckBox^  cbDOut_128;


private: System::Windows::Forms::CheckBox^  cbDOut_127;

private: System::Windows::Forms::CheckBox^  cbDOut_126;

private: System::Windows::Forms::CheckBox^  cbDOut_125;

private: System::Windows::Forms::CheckBox^  cbDOut_124;

private: System::Windows::Forms::CheckBox^  cbDOut_123;

private: System::Windows::Forms::CheckBox^  cbDOut_122;

private: System::Windows::Forms::CheckBox^  cbDOut_121;

private: System::Windows::Forms::CheckBox^  cbDOut_120;

private: System::Windows::Forms::CheckBox^  cbDOut_119;

private: System::Windows::Forms::CheckBox^  cbDOut_118;

private: System::Windows::Forms::CheckBox^  cbDOut_117;

private: System::Windows::Forms::CheckBox^  cbDOut_116;

private: System::Windows::Forms::CheckBox^  cbDOut_115;

private: System::Windows::Forms::CheckBox^  cbDOut_114;

private: System::Windows::Forms::CheckBox^  cbDOut_113;

private: System::Windows::Forms::CheckBox^  cbDOut_112;

private: System::Windows::Forms::CheckBox^  cbDOut_111;

private: System::Windows::Forms::CheckBox^  cbDOut_110;

private: System::Windows::Forms::CheckBox^  cbDOut_109;

private: System::Windows::Forms::CheckBox^  cbDOut_108;

private: System::Windows::Forms::CheckBox^  cbDOut_107;

private: System::Windows::Forms::CheckBox^  cbDOut_106;

private: System::Windows::Forms::CheckBox^  cbDOut_105;

private: System::Windows::Forms::CheckBox^  cbDOut_104;

private: System::Windows::Forms::CheckBox^  cbDOut_103;

private: System::Windows::Forms::CheckBox^  cbDOut_102;

private: System::Windows::Forms::CheckBox^  cbDOut_101;

private: System::Windows::Forms::CheckBox^  cbDOut_100;

private: System::Windows::Forms::CheckBox^  cbDOut_99;

private: System::Windows::Forms::CheckBox^  cbDOut_98;

private: System::Windows::Forms::CheckBox^  cbDOut_97;

private: System::Windows::Forms::CheckBox^  cbDOut_96;

private: System::Windows::Forms::CheckBox^  cbDOut_95;

private: System::Windows::Forms::CheckBox^  cbDOut_94;

private: System::Windows::Forms::CheckBox^  cbDOut_93;

private: System::Windows::Forms::CheckBox^  cbDOut_92;

private: System::Windows::Forms::CheckBox^  cbDOut_91;

private: System::Windows::Forms::CheckBox^  cbDOut_90;

private: System::Windows::Forms::CheckBox^  cbDOut_89;

private: System::Windows::Forms::CheckBox^  cbDOut_88;

private: System::Windows::Forms::CheckBox^  cbDOut_87;

private: System::Windows::Forms::CheckBox^  cbDOut_86;


private: System::Windows::Forms::CheckBox^  cbDOut_84;

private: System::Windows::Forms::CheckBox^  cbDOut_83;

private: System::Windows::Forms::CheckBox^  cbDOut_82;

private: System::Windows::Forms::CheckBox^  cbDOut_81;
private: System::Windows::Forms::CheckBox^  cbDOut_85;
private: System::Windows::Forms::Label^  lbDIn_2;

private: System::Windows::Forms::Label^  lbDIn_1;
private: System::Windows::Forms::Label^  lbDIn_32;


private: System::Windows::Forms::Label^  lbDIn_31;

private: System::Windows::Forms::Label^  lbDIn_30;

private: System::Windows::Forms::Label^  lbDIn_29;

private: System::Windows::Forms::Label^  lbDIn_28;

private: System::Windows::Forms::Label^  lbDIn_27;

private: System::Windows::Forms::Label^  lbDIn_26;

private: System::Windows::Forms::Label^  lbDIn_25;

private: System::Windows::Forms::Label^  lbDIn_24;

private: System::Windows::Forms::Label^  lbDIn_23;

private: System::Windows::Forms::Label^  lbDIn_22;

private: System::Windows::Forms::Label^  lbDIn_21;

private: System::Windows::Forms::Label^  lbDIn_20;

private: System::Windows::Forms::Label^  lbDIn_19;

private: System::Windows::Forms::Label^  lbDIn_18;

private: System::Windows::Forms::Label^  lbDIn_17;

private: System::Windows::Forms::Label^  lbDIn_16;

private: System::Windows::Forms::Label^  lbDIn_15;

private: System::Windows::Forms::Label^  lbDIn_14;

private: System::Windows::Forms::Label^  lbDIn_13;

private: System::Windows::Forms::Label^  lbDIn_12;

private: System::Windows::Forms::Label^  lbDIn_11;

private: System::Windows::Forms::Label^  lbDIn_10;

private: System::Windows::Forms::Label^  lbDIn_9;

private: System::Windows::Forms::Label^  lbDIn_8;

private: System::Windows::Forms::Label^  lbDIn_7;

private: System::Windows::Forms::Label^  lbDIn_6;

private: System::Windows::Forms::Label^  lbDIn_5;

private: System::Windows::Forms::Label^  lbDIn_4;

private: System::Windows::Forms::Label^  lbDIn_3;
private: System::Windows::Forms::Label^  lbDIn_48;


private: System::Windows::Forms::Label^  lbDIn_47;

private: System::Windows::Forms::Label^  lbDIn_46;

private: System::Windows::Forms::Label^  lbDIn_45;

private: System::Windows::Forms::Label^  lbDIn_44;

private: System::Windows::Forms::Label^  lbDIn_43;

private: System::Windows::Forms::Label^  lbDIn_42;

private: System::Windows::Forms::Label^  lbDIn_41;

private: System::Windows::Forms::Label^  lbDIn_40;

private: System::Windows::Forms::Label^  lbDIn_39;

private: System::Windows::Forms::Label^  lbDIn_38;

private: System::Windows::Forms::Label^  lbDIn_37;

private: System::Windows::Forms::Label^  lbDIn_36;

private: System::Windows::Forms::Label^  lbDIn_35;

private: System::Windows::Forms::Label^  lbDIn_34;

private: System::Windows::Forms::Label^  lbDIn_33;
private: System::Windows::Forms::Label^  lbDIn_64;


private: System::Windows::Forms::Label^  lbDIn_63;

private: System::Windows::Forms::Label^  lbDIn_62;

private: System::Windows::Forms::Label^  lbDIn_61;

private: System::Windows::Forms::Label^  lbDIn_60;

private: System::Windows::Forms::Label^  lbDIn_59;

private: System::Windows::Forms::Label^  lbDIn_58;

private: System::Windows::Forms::Label^  lbDIn_57;

private: System::Windows::Forms::Label^  lbDIn_56;

private: System::Windows::Forms::Label^  lbDIn_55;


private: System::Windows::Forms::Label^  lbDIn_53;

private: System::Windows::Forms::Label^  lbDIn_52;

private: System::Windows::Forms::Label^  lbDIn_51;

private: System::Windows::Forms::Label^  lbDIn_50;

private: System::Windows::Forms::Label^  lbDIn_49;
private: System::Windows::Forms::Label^  lbDIn_128;


private: System::Windows::Forms::Label^  lbDIn_127;

private: System::Windows::Forms::Label^  lbDIn_126;

private: System::Windows::Forms::Label^  lbDIn_125;

private: System::Windows::Forms::Label^  lbDIn_124;

private: System::Windows::Forms::Label^  lbDIn_123;

private: System::Windows::Forms::Label^  lbDIn_122;

private: System::Windows::Forms::Label^  lbDIn_121;

private: System::Windows::Forms::Label^  lbDIn_120;

private: System::Windows::Forms::Label^  lbDIn_119;

private: System::Windows::Forms::Label^  lbDIn_118;

private: System::Windows::Forms::Label^  lbDIn_117;

private: System::Windows::Forms::Label^  lbDIn_116;

private: System::Windows::Forms::Label^  lbDIn_115;

private: System::Windows::Forms::Label^  lbDIn_114;

private: System::Windows::Forms::Label^  lbDIn_113;

private: System::Windows::Forms::Label^  lbDIn_112;

private: System::Windows::Forms::Label^  lbDIn_111;

private: System::Windows::Forms::Label^  lbDIn_110;

private: System::Windows::Forms::Label^  lbDIn_109;

private: System::Windows::Forms::Label^  lbDIn_108;

private: System::Windows::Forms::Label^  lbDIn_107;

private: System::Windows::Forms::Label^  lbDIn_106;

private: System::Windows::Forms::Label^  lbDIn_105;

private: System::Windows::Forms::Label^  lbDIn_104;

private: System::Windows::Forms::Label^  lbDIn_103;

private: System::Windows::Forms::Label^  lbDIn_102;

private: System::Windows::Forms::Label^  lbDIn_101;

private: System::Windows::Forms::Label^  lbDIn_100;

private: System::Windows::Forms::Label^  lbDIn_99;

private: System::Windows::Forms::Label^  lbDIn_98;

private: System::Windows::Forms::Label^  lbDIn_97;

private: System::Windows::Forms::Label^  lbDIn_96;

private: System::Windows::Forms::Label^  lbDIn_95;

private: System::Windows::Forms::Label^  lbDIn_94;

private: System::Windows::Forms::Label^  lbDIn_93;

private: System::Windows::Forms::Label^  lbDIn_92;

private: System::Windows::Forms::Label^  lbDIn_91;

private: System::Windows::Forms::Label^  lbDIn_90;

private: System::Windows::Forms::Label^  lbDIn_89;

private: System::Windows::Forms::Label^  lbDIn_88;

private: System::Windows::Forms::Label^  lbDIn_87;

private: System::Windows::Forms::Label^  lbDIn_86;

private: System::Windows::Forms::Label^  lbDIn_85;

private: System::Windows::Forms::Label^  lbDIn_84;

private: System::Windows::Forms::Label^  lbDIn_83;

private: System::Windows::Forms::Label^  lbDIn_82;

private: System::Windows::Forms::Label^  lbDIn_81;

private: System::Windows::Forms::Label^  lbDIn_80;

private: System::Windows::Forms::Label^  lbDIn_79;

private: System::Windows::Forms::Label^  lbDIn_78;

private: System::Windows::Forms::Label^  lbDIn_77;

private: System::Windows::Forms::Label^  lbDIn_76;

private: System::Windows::Forms::Label^  lbDIn_75;

private: System::Windows::Forms::Label^  lbDIn_74;

private: System::Windows::Forms::Label^  lbDIn_73;

private: System::Windows::Forms::Label^  lbDIn_72;

private: System::Windows::Forms::Label^  lbDIn_71;

private: System::Windows::Forms::Label^  lbDIn_70;

private: System::Windows::Forms::Label^  lbDIn_69;

private: System::Windows::Forms::Label^  lbDIn_68;

private: System::Windows::Forms::Label^  lbDIn_67;

private: System::Windows::Forms::Label^  lbDIn_66;

private: System::Windows::Forms::Label^  lbDIn_65;

private: System::Windows::Forms::Label^  lbDIn_54;
private: System::Windows::Forms::Label^  lbDInUpdates;
private: System::Windows::Forms::Timer^  tmrUpdateDateTime;
private: System::Windows::Forms::TabPage^  tbSampling;
private: System::Windows::Forms::Button^  btnSamplingAddChannelsAll;
private: System::Windows::Forms::Button^  btnSamplingReset;

private: System::Windows::Forms::Button^  btnSampling_AddOutputsAll;
private: System::Windows::Forms::Button^  btnSampling_AddInputsAll;
private: System::Windows::Forms::Label^  lbSampling_NElements;
private: System::Windows::Forms::Button^  btnSampling_AddChannels;
private: System::Windows::Forms::GroupBox^  groupBox4;
private: System::Windows::Forms::Button^  btnSampling_Store;
private: System::Windows::Forms::Button^  btnSampling_TLimitedStart;

private: System::Windows::Forms::Button^  btnSampling_PrepareFiniteT;
private: System::Windows::Forms::NumericUpDown^  nuSampling_TimeNSamples;
private: System::Windows::Forms::Label^  label5;



private: System::Windows::Forms::Button^  btnSampling_Stop;



private: System::Windows::Forms::Timer^  tmrSampling;
private: System::Windows::Forms::GroupBox^  groupBox5;
private: System::Windows::Forms::Label^  lbSampling_NotificationsNewData;
private: System::Windows::Forms::Label^  lbSampling_MaxSamples;
private: System::Windows::Forms::Label^  lbSampling_NSamplesReceived;
private: System::Windows::Forms::Label^  lbSampling_NotificationAllReceived;
private: System::Windows::Forms::Label^  lbSampling_NotificationFinished;

private: System::Windows::Forms::Label^  lbSampling_NotificationError;
private: System::Windows::Forms::Label^  lbSampling_NotificationBufOverflow;
private: System::Windows::Forms::GroupBox^  groupBox7;
private: System::Windows::Forms::RadioButton^  rbSampling_TimeStandard;
private: System::Windows::Forms::RadioButton^  rbSampling_TimeMid;
private: System::Windows::Forms::RadioButton^  rbSampling_TimeHigh;
private: System::Windows::Forms::GroupBox^  groupBox6;
private: System::Windows::Forms::Label^  label7;
private: System::Windows::Forms::Button^  btnSampling_EndlessStop;
private: System::Windows::Forms::Button^  btnSampling_EndlessStore;


private: System::Windows::Forms::Button^  btnSampling_TEndlessStart;

private: System::Windows::Forms::Button^  btnSampling_PrepareEndlessT;

private: System::Windows::Forms::NumericUpDown^  nuSampling_TimeKeepSamples;
private: System::Windows::Forms::Label^  label6;
private: System::Windows::Forms::Timer^  tmrSamplingEndlessReadData;
private: System::Windows::Forms::CheckedListBox^  cblSampling_MeasChannels;
private: System::Windows::Forms::CheckedListBox^  cblSampling_DigitalOutputs;

private: System::Windows::Forms::CheckedListBox^  cblSampling_DigitalInputs;
private: System::Windows::Forms::Label^  label14;
private: System::Windows::Forms::Label^  label13;
private: System::Windows::Forms::Label^  label12;
private: System::Windows::Forms::Label^  label11;
private: System::Windows::Forms::Label^  label10;
private: System::Windows::Forms::Label^  label9;
private: System::Windows::Forms::Label^  label8;
private: System::Windows::Forms::Button^  btnSampling_AddDigitalOutputs;

private: System::Windows::Forms::Button^  btnSampling_AddDigitalInputs;

private: System::Windows::Forms::Label^  label15;
private: System::Windows::Forms::Label^  label17;
private: System::Windows::Forms::RadioButton^  rbSampling_TEndlessReadRows;
private: System::Windows::Forms::RadioButton^  rbSampling_TEndlessReadCols;
private: System::Windows::Forms::Label^  label16;
private: System::Windows::Forms::RadioButton^  rbSampling_TLimitedReadRows;
private: System::Windows::Forms::RadioButton^  rbSampling_TLimitedReadCols;
private: System::Windows::Forms::Label^  lbSampling_NotificationTimeout;
private: System::Windows::Forms::Label^  lbConnectionStatus;
private: System::Windows::Forms::CheckBox^  cbStaticFastUpdate;
private: System::Windows::Forms::Label^  label18;
private: System::Windows::Forms::Button^  btnDigiEnableOutputWrite;
private: System::Windows::Forms::TabPage^  tbMisc1;
private: System::Windows::Forms::TextBox^  tbChannelSetParameterTx;

private: System::Windows::Forms::Label^  label19;
private: System::Windows::Forms::Label^  label23;
private: System::Windows::Forms::NumericUpDown^  nuChannelSetParameterNo;

private: System::Windows::Forms::Label^  label22;
private: System::Windows::Forms::Button^  btnChannelSetParameter;
private: System::Windows::Forms::TextBox^  tbChannelSetParameterRx;

private: System::Windows::Forms::Label^  label21;
private: System::Windows::Forms::Label^  label20;
private: System::Windows::Forms::Label^  label24;
private: System::Windows::Forms::NumericUpDown^  nuChannelSetConfigNo;

private: System::Windows::Forms::Label^  label25;
private: System::Windows::Forms::Button^  btnChannelSetConfig;
private: System::Windows::Forms::TextBox^  tbChannelSetConfigRx;
private: System::Windows::Forms::Label^  label26;
private: System::Windows::Forms::Label^  label27;
private: System::Windows::Forms::TextBox^  tbChannelSetConfigTx;
private: System::Windows::Forms::Label^  label28;
private: System::Windows::Forms::Label^  label30;
private: System::Windows::Forms::Label^  label29;
private: System::Windows::Forms::Label^  label32;
private: System::Windows::Forms::Label^  label31;
private: System::Windows::Forms::TextBox^  tBoxReadme;
private: System::Windows::Forms::TabPage^  tbSamplingAddOn;
private: System::Windows::Forms::GroupBox^  groupBox8;
private: System::Windows::Forms::Button^  btnSamplingDInTrgSet;

private: System::Windows::Forms::Label^  label36;
private: System::Windows::Forms::ComboBox^  cbSamplingDInTrgPol;

private: System::Windows::Forms::Label^  label35;
private: System::Windows::Forms::ComboBox^  cbSamplingDInTrgMode;

private: System::Windows::Forms::Label^  label34;
private: System::Windows::Forms::ComboBox^  cbSamplingDInTrgBit;

private: System::Windows::Forms::Label^  label33;
private: System::Windows::Forms::ComboBox^  cbSamplingDInTrgByte;

private: System::Windows::Forms::TextBox^  textBox2;
private: System::Windows::Forms::TextBox^  textBox1;
private: System::Windows::Forms::GroupBox^  groupBox9;
private: System::Windows::Forms::TextBox^  textBox3;
private: System::Windows::Forms::Label^  label40;
private: System::Windows::Forms::NumericUpDown^  nuSamplingTftFilterPeriod;
private: System::Windows::Forms::NumericUpDown^  nuSamplingTftNSamples;

private: System::Windows::Forms::Label^  label41;
private: System::Windows::Forms::Label^  label43;
private: System::Windows::Forms::ComboBox^  cbSamplingTftTriggerPolarity;

private: System::Windows::Forms::Label^  label44;
private: System::Windows::Forms::ComboBox^  cbSamplingTftTriggerMode;

private: System::Windows::Forms::Label^  label45;
private: System::Windows::Forms::ComboBox^  cbSamplingTftTriggerBit;

private: System::Windows::Forms::Label^  label46;
private: System::Windows::Forms::ComboBox^  cbSamplingTftTriggerByte;

private: System::Windows::Forms::Label^  label42;
private: System::Windows::Forms::NumericUpDown^  nuSamplingTftNTailSamples;



private: System::Windows::Forms::Button^  btnSamplingPrepareCustomTft;

private: System::Windows::Forms::GroupBox^  groupBox10;
private: System::Windows::Forms::TextBox^  textBox4;
private: System::Windows::Forms::GroupBox^  groupBox11;
private: System::Windows::Forms::Label^  label48;
private: System::Windows::Forms::ComboBox^  cbSamplingPositionTriggerChannel;

private: System::Windows::Forms::NumericUpDown^  nuSamplingPositionNSamples;

private: System::Windows::Forms::Label^  label47;
private: System::Windows::Forms::TextBox^  textBox5;
private: System::Windows::Forms::NumericUpDown^  nuSamplingPositionScale;

private: System::Windows::Forms::Label^  label49;
private: System::Windows::Forms::TextBox^  textBox6;
private: System::Windows::Forms::GroupBox^  groupBox12;
private: System::Windows::Forms::Button^  btnSamplingPreparePosition;

private: System::Windows::Forms::NumericUpDown^  nuSamplingPositionDistance;

private: System::Windows::Forms::Label^  label51;
private: System::Windows::Forms::NumericUpDown^  nuSamplingPositionStart;

private: System::Windows::Forms::Label^  label50;
private: System::Windows::Forms::Label^  label53;
private: System::Windows::Forms::Label^  label52;












	private: System::Windows::Forms::Button^  btnBoxInfoUpdate;


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung.
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			this->btnConnect = (gcnew System::Windows::Forms::Button());
			this->lbHistory = (gcnew System::Windows::Forms::ListBox());
			this->tabControlMain = (gcnew System::Windows::Forms::TabControl());
			this->tbReadme = (gcnew System::Windows::Forms::TabPage());
			this->tBoxReadme = (gcnew System::Windows::Forms::TextBox());
			this->tbBoxInfo = (gcnew System::Windows::Forms::TabPage());
			this->lbBoxInfoUpdates = (gcnew System::Windows::Forms::Label());
			this->btnBoxInfoUpdate = (gcnew System::Windows::Forms::Button());
			this->dataGridViewBoxInfo = (gcnew System::Windows::Forms::DataGridView());
			this->dgvBox_No = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->dgvBox_Name = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->dgvBox_Serial = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->dgvBox_MAC = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->dgvBox_Fw = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->dgvBox_Hw = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->dgvBox_NChannels = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->dgvBox_NDigiIn = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->dgvBox_NDigiOut = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->dgBox_ProductionCode = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->tbChannelInfo = (gcnew System::Windows::Forms::TabPage());
			this->lbChInfoUpdates = (gcnew System::Windows::Forms::Label());
			this->btnChannelInfoUpdate = (gcnew System::Windows::Forms::Button());
			this->dataGridViewChInfo = (gcnew System::Windows::Forms::DataGridView());
			this->dgvChannel_No = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->dgvChannel_Location = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->dgvChannel_Type = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->dgvChannel_Unit = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->dgvChannel_FactorToUnit = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->dgvChannel_Digits = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->dgvChannel_OrderNo = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->dgvChannel_SerNo = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->tbStatic = (gcnew System::Windows::Forms::TabPage());
			this->label18 = (gcnew System::Windows::Forms::Label());
			this->cbStaticFastUpdate = (gcnew System::Windows::Forms::CheckBox());
			this->btnStaticResetMinMax = (gcnew System::Windows::Forms::Button());
			this->lbStaticUpdates = (gcnew System::Windows::Forms::Label());
			this->rbStaticCH57_64 = (gcnew System::Windows::Forms::RadioButton());
			this->rbStaticCH49_56 = (gcnew System::Windows::Forms::RadioButton());
			this->rbStaticCH41_48 = (gcnew System::Windows::Forms::RadioButton());
			this->rbStaticCH33_40 = (gcnew System::Windows::Forms::RadioButton());
			this->lbStaticDiff8 = (gcnew System::Windows::Forms::Label());
			this->lbStaticMax8 = (gcnew System::Windows::Forms::Label());
			this->lbStaticMin8 = (gcnew System::Windows::Forms::Label());
			this->lbStaticDiff7 = (gcnew System::Windows::Forms::Label());
			this->lbStaticMax7 = (gcnew System::Windows::Forms::Label());
			this->lbStaticMin7 = (gcnew System::Windows::Forms::Label());
			this->lbStaticDiff6 = (gcnew System::Windows::Forms::Label());
			this->lbStaticMax6 = (gcnew System::Windows::Forms::Label());
			this->lbStaticMin6 = (gcnew System::Windows::Forms::Label());
			this->lbStaticDiff5 = (gcnew System::Windows::Forms::Label());
			this->lbStaticMax5 = (gcnew System::Windows::Forms::Label());
			this->lbStaticMin5 = (gcnew System::Windows::Forms::Label());
			this->lbStaticDiff4 = (gcnew System::Windows::Forms::Label());
			this->lbStaticMax4 = (gcnew System::Windows::Forms::Label());
			this->lbStaticMin4 = (gcnew System::Windows::Forms::Label());
			this->lbStaticDiff3 = (gcnew System::Windows::Forms::Label());
			this->lbStaticMax3 = (gcnew System::Windows::Forms::Label());
			this->lbStaticMin3 = (gcnew System::Windows::Forms::Label());
			this->lbStaticDiff2 = (gcnew System::Windows::Forms::Label());
			this->lbStaticMax2 = (gcnew System::Windows::Forms::Label());
			this->lbStaticMin2 = (gcnew System::Windows::Forms::Label());
			this->lbStaticDiff1 = (gcnew System::Windows::Forms::Label());
			this->lbStaticMax1 = (gcnew System::Windows::Forms::Label());
			this->lbStaticMin1 = (gcnew System::Windows::Forms::Label());
			this->label39 = (gcnew System::Windows::Forms::Label());
			this->label38 = (gcnew System::Windows::Forms::Label());
			this->label37 = (gcnew System::Windows::Forms::Label());
			this->lbStaticHwStat8 = (gcnew System::Windows::Forms::Label());
			this->lbStaticUnit8 = (gcnew System::Windows::Forms::Label());
			this->lbStaticDigits8 = (gcnew System::Windows::Forms::Label());
			this->lbStaticCh8 = (gcnew System::Windows::Forms::Label());
			this->lbStaticHwStat7 = (gcnew System::Windows::Forms::Label());
			this->lbStaticUnit7 = (gcnew System::Windows::Forms::Label());
			this->lbStaticDigits7 = (gcnew System::Windows::Forms::Label());
			this->lbStaticCh7 = (gcnew System::Windows::Forms::Label());
			this->lbStaticHwStat6 = (gcnew System::Windows::Forms::Label());
			this->lbStaticUnit6 = (gcnew System::Windows::Forms::Label());
			this->lbStaticDigits6 = (gcnew System::Windows::Forms::Label());
			this->lbStaticCh6 = (gcnew System::Windows::Forms::Label());
			this->lbStaticHwStat5 = (gcnew System::Windows::Forms::Label());
			this->lbStaticUnit5 = (gcnew System::Windows::Forms::Label());
			this->lbStaticDigits5 = (gcnew System::Windows::Forms::Label());
			this->lbStaticCh5 = (gcnew System::Windows::Forms::Label());
			this->lbStaticHwStat4 = (gcnew System::Windows::Forms::Label());
			this->lbStaticUnit4 = (gcnew System::Windows::Forms::Label());
			this->lbStaticDigits4 = (gcnew System::Windows::Forms::Label());
			this->lbStaticCh4 = (gcnew System::Windows::Forms::Label());
			this->lbStaticHwStat3 = (gcnew System::Windows::Forms::Label());
			this->lbStaticUnit3 = (gcnew System::Windows::Forms::Label());
			this->lbStaticDigits3 = (gcnew System::Windows::Forms::Label());
			this->lbStaticCh3 = (gcnew System::Windows::Forms::Label());
			this->lbStaticHwStat2 = (gcnew System::Windows::Forms::Label());
			this->lbStaticUnit2 = (gcnew System::Windows::Forms::Label());
			this->lbStaticDigits2 = (gcnew System::Windows::Forms::Label());
			this->lbStaticCh2 = (gcnew System::Windows::Forms::Label());
			this->lbStaticHwStat1 = (gcnew System::Windows::Forms::Label());
			this->lbStaticUnit1 = (gcnew System::Windows::Forms::Label());
			this->lbStaticDigits1 = (gcnew System::Windows::Forms::Label());
			this->lbStaticCh1 = (gcnew System::Windows::Forms::Label());
			this->label4 = (gcnew System::Windows::Forms::Label());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->groupBox1 = (gcnew System::Windows::Forms::GroupBox());
			this->rbStaticCH25_32 = (gcnew System::Windows::Forms::RadioButton());
			this->rbStaticCH17_24 = (gcnew System::Windows::Forms::RadioButton());
			this->rbStaticCH9_16 = (gcnew System::Windows::Forms::RadioButton());
			this->rbStaticCH1_8 = (gcnew System::Windows::Forms::RadioButton());
			this->tbDigi = (gcnew System::Windows::Forms::TabPage());
			this->lbDInUpdates = (gcnew System::Windows::Forms::Label());
			this->groupBox3 = (gcnew System::Windows::Forms::GroupBox());
			this->btnDigiEnableOutputWrite = (gcnew System::Windows::Forms::Button());
			this->cbDOut_128 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_127 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_126 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_125 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_124 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_123 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_122 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_121 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_120 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_119 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_118 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_117 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_116 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_115 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_114 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_113 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_112 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_111 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_110 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_109 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_108 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_107 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_106 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_105 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_104 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_103 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_102 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_101 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_100 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_99 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_98 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_97 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_96 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_95 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_94 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_93 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_92 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_91 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_90 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_89 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_88 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_87 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_86 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_85 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_84 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_83 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_82 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_81 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_80 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_79 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_78 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_77 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_76 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_75 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_74 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_73 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_72 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_71 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_70 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_69 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_68 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_67 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_66 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_65 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_64 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_63 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_62 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_61 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_60 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_59 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_58 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_57 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_56 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_55 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_54 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_53 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_52 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_51 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_50 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_49 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_48 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_47 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_46 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_45 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_44 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_43 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_42 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_41 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_40 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_39 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_38 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_37 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_36 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_35 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_34 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_33 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_32 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_31 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_30 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_29 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_28 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_27 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_26 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_25 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_24 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_23 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_22 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_21 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_20 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_19 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_18 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_17 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_16 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_15 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_14 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_13 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_12 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_11 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_10 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_9 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_8 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_7 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_6 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_5 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_4 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_3 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_2 = (gcnew System::Windows::Forms::CheckBox());
			this->cbDOut_1 = (gcnew System::Windows::Forms::CheckBox());
			this->groupBox2 = (gcnew System::Windows::Forms::GroupBox());
			this->lbDIn_128 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_127 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_126 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_125 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_124 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_123 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_122 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_121 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_120 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_119 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_118 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_117 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_116 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_115 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_114 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_113 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_112 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_111 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_110 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_109 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_108 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_107 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_106 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_105 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_104 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_103 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_102 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_101 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_100 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_99 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_98 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_97 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_96 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_95 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_94 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_93 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_92 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_91 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_90 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_89 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_88 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_87 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_86 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_85 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_84 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_83 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_82 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_81 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_80 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_79 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_78 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_77 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_76 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_75 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_74 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_73 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_72 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_71 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_70 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_69 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_68 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_67 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_66 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_65 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_64 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_63 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_62 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_61 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_60 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_59 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_58 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_57 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_56 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_55 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_54 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_53 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_52 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_51 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_50 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_49 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_48 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_47 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_46 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_45 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_44 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_43 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_42 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_41 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_40 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_39 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_38 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_37 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_36 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_35 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_34 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_33 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_32 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_31 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_30 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_29 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_28 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_27 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_26 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_25 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_24 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_23 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_22 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_21 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_20 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_19 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_18 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_17 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_16 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_15 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_14 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_13 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_12 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_11 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_10 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_9 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_8 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_7 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_6 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_5 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_4 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_3 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_2 = (gcnew System::Windows::Forms::Label());
			this->lbDIn_1 = (gcnew System::Windows::Forms::Label());
			this->tbSampling = (gcnew System::Windows::Forms::TabPage());
			this->label15 = (gcnew System::Windows::Forms::Label());
			this->label14 = (gcnew System::Windows::Forms::Label());
			this->label13 = (gcnew System::Windows::Forms::Label());
			this->label12 = (gcnew System::Windows::Forms::Label());
			this->label11 = (gcnew System::Windows::Forms::Label());
			this->label10 = (gcnew System::Windows::Forms::Label());
			this->label9 = (gcnew System::Windows::Forms::Label());
			this->label8 = (gcnew System::Windows::Forms::Label());
			this->btnSampling_AddDigitalOutputs = (gcnew System::Windows::Forms::Button());
			this->btnSampling_AddDigitalInputs = (gcnew System::Windows::Forms::Button());
			this->cblSampling_DigitalOutputs = (gcnew System::Windows::Forms::CheckedListBox());
			this->cblSampling_DigitalInputs = (gcnew System::Windows::Forms::CheckedListBox());
			this->cblSampling_MeasChannels = (gcnew System::Windows::Forms::CheckedListBox());
			this->groupBox7 = (gcnew System::Windows::Forms::GroupBox());
			this->rbSampling_TimeStandard = (gcnew System::Windows::Forms::RadioButton());
			this->rbSampling_TimeMid = (gcnew System::Windows::Forms::RadioButton());
			this->rbSampling_TimeHigh = (gcnew System::Windows::Forms::RadioButton());
			this->groupBox6 = (gcnew System::Windows::Forms::GroupBox());
			this->label17 = (gcnew System::Windows::Forms::Label());
			this->rbSampling_TEndlessReadRows = (gcnew System::Windows::Forms::RadioButton());
			this->rbSampling_TEndlessReadCols = (gcnew System::Windows::Forms::RadioButton());
			this->label7 = (gcnew System::Windows::Forms::Label());
			this->btnSampling_EndlessStop = (gcnew System::Windows::Forms::Button());
			this->btnSampling_EndlessStore = (gcnew System::Windows::Forms::Button());
			this->btnSampling_TEndlessStart = (gcnew System::Windows::Forms::Button());
			this->btnSampling_PrepareEndlessT = (gcnew System::Windows::Forms::Button());
			this->nuSampling_TimeKeepSamples = (gcnew System::Windows::Forms::NumericUpDown());
			this->label6 = (gcnew System::Windows::Forms::Label());
			this->groupBox5 = (gcnew System::Windows::Forms::GroupBox());
			this->lbSampling_NotificationTimeout = (gcnew System::Windows::Forms::Label());
			this->lbSampling_NotificationBufOverflow = (gcnew System::Windows::Forms::Label());
			this->lbSampling_NotificationError = (gcnew System::Windows::Forms::Label());
			this->lbSampling_NotificationFinished = (gcnew System::Windows::Forms::Label());
			this->lbSampling_NotificationAllReceived = (gcnew System::Windows::Forms::Label());
			this->lbSampling_NotificationsNewData = (gcnew System::Windows::Forms::Label());
			this->lbSampling_MaxSamples = (gcnew System::Windows::Forms::Label());
			this->lbSampling_NSamplesReceived = (gcnew System::Windows::Forms::Label());
			this->groupBox4 = (gcnew System::Windows::Forms::GroupBox());
			this->label16 = (gcnew System::Windows::Forms::Label());
			this->rbSampling_TLimitedReadRows = (gcnew System::Windows::Forms::RadioButton());
			this->rbSampling_TLimitedReadCols = (gcnew System::Windows::Forms::RadioButton());
			this->btnSampling_Stop = (gcnew System::Windows::Forms::Button());
			this->btnSampling_Store = (gcnew System::Windows::Forms::Button());
			this->btnSampling_TLimitedStart = (gcnew System::Windows::Forms::Button());
			this->btnSampling_PrepareFiniteT = (gcnew System::Windows::Forms::Button());
			this->nuSampling_TimeNSamples = (gcnew System::Windows::Forms::NumericUpDown());
			this->label5 = (gcnew System::Windows::Forms::Label());
			this->btnSampling_AddChannels = (gcnew System::Windows::Forms::Button());
			this->lbSampling_NElements = (gcnew System::Windows::Forms::Label());
			this->btnSampling_AddOutputsAll = (gcnew System::Windows::Forms::Button());
			this->btnSampling_AddInputsAll = (gcnew System::Windows::Forms::Button());
			this->btnSamplingReset = (gcnew System::Windows::Forms::Button());
			this->btnSamplingAddChannelsAll = (gcnew System::Windows::Forms::Button());
			this->tbSamplingAddOn = (gcnew System::Windows::Forms::TabPage());
			this->groupBox11 = (gcnew System::Windows::Forms::GroupBox());
			this->label53 = (gcnew System::Windows::Forms::Label());
			this->label52 = (gcnew System::Windows::Forms::Label());
			this->nuSamplingPositionDistance = (gcnew System::Windows::Forms::NumericUpDown());
			this->label51 = (gcnew System::Windows::Forms::Label());
			this->nuSamplingPositionStart = (gcnew System::Windows::Forms::NumericUpDown());
			this->label50 = (gcnew System::Windows::Forms::Label());
			this->textBox6 = (gcnew System::Windows::Forms::TextBox());
			this->groupBox12 = (gcnew System::Windows::Forms::GroupBox());
			this->btnSamplingPreparePosition = (gcnew System::Windows::Forms::Button());
			this->nuSamplingPositionScale = (gcnew System::Windows::Forms::NumericUpDown());
			this->label49 = (gcnew System::Windows::Forms::Label());
			this->label48 = (gcnew System::Windows::Forms::Label());
			this->cbSamplingPositionTriggerChannel = (gcnew System::Windows::Forms::ComboBox());
			this->nuSamplingPositionNSamples = (gcnew System::Windows::Forms::NumericUpDown());
			this->label47 = (gcnew System::Windows::Forms::Label());
			this->textBox5 = (gcnew System::Windows::Forms::TextBox());
			this->groupBox9 = (gcnew System::Windows::Forms::GroupBox());
			this->textBox4 = (gcnew System::Windows::Forms::TextBox());
			this->groupBox10 = (gcnew System::Windows::Forms::GroupBox());
			this->btnSamplingPrepareCustomTft = (gcnew System::Windows::Forms::Button());
			this->label43 = (gcnew System::Windows::Forms::Label());
			this->cbSamplingTftTriggerPolarity = (gcnew System::Windows::Forms::ComboBox());
			this->label44 = (gcnew System::Windows::Forms::Label());
			this->cbSamplingTftTriggerMode = (gcnew System::Windows::Forms::ComboBox());
			this->label45 = (gcnew System::Windows::Forms::Label());
			this->cbSamplingTftTriggerBit = (gcnew System::Windows::Forms::ComboBox());
			this->label46 = (gcnew System::Windows::Forms::Label());
			this->cbSamplingTftTriggerByte = (gcnew System::Windows::Forms::ComboBox());
			this->label42 = (gcnew System::Windows::Forms::Label());
			this->nuSamplingTftNTailSamples = (gcnew System::Windows::Forms::NumericUpDown());
			this->nuSamplingTftNSamples = (gcnew System::Windows::Forms::NumericUpDown());
			this->label41 = (gcnew System::Windows::Forms::Label());
			this->nuSamplingTftFilterPeriod = (gcnew System::Windows::Forms::NumericUpDown());
			this->label40 = (gcnew System::Windows::Forms::Label());
			this->textBox3 = (gcnew System::Windows::Forms::TextBox());
			this->groupBox8 = (gcnew System::Windows::Forms::GroupBox());
			this->btnSamplingDInTrgSet = (gcnew System::Windows::Forms::Button());
			this->label36 = (gcnew System::Windows::Forms::Label());
			this->cbSamplingDInTrgPol = (gcnew System::Windows::Forms::ComboBox());
			this->label35 = (gcnew System::Windows::Forms::Label());
			this->cbSamplingDInTrgMode = (gcnew System::Windows::Forms::ComboBox());
			this->label34 = (gcnew System::Windows::Forms::Label());
			this->cbSamplingDInTrgBit = (gcnew System::Windows::Forms::ComboBox());
			this->label33 = (gcnew System::Windows::Forms::Label());
			this->cbSamplingDInTrgByte = (gcnew System::Windows::Forms::ComboBox());
			this->textBox2 = (gcnew System::Windows::Forms::TextBox());
			this->textBox1 = (gcnew System::Windows::Forms::TextBox());
			this->tbMisc1 = (gcnew System::Windows::Forms::TabPage());
			this->label32 = (gcnew System::Windows::Forms::Label());
			this->label31 = (gcnew System::Windows::Forms::Label());
			this->label30 = (gcnew System::Windows::Forms::Label());
			this->label29 = (gcnew System::Windows::Forms::Label());
			this->label24 = (gcnew System::Windows::Forms::Label());
			this->nuChannelSetConfigNo = (gcnew System::Windows::Forms::NumericUpDown());
			this->label25 = (gcnew System::Windows::Forms::Label());
			this->btnChannelSetConfig = (gcnew System::Windows::Forms::Button());
			this->tbChannelSetConfigRx = (gcnew System::Windows::Forms::TextBox());
			this->label26 = (gcnew System::Windows::Forms::Label());
			this->label27 = (gcnew System::Windows::Forms::Label());
			this->tbChannelSetConfigTx = (gcnew System::Windows::Forms::TextBox());
			this->label28 = (gcnew System::Windows::Forms::Label());
			this->label23 = (gcnew System::Windows::Forms::Label());
			this->nuChannelSetParameterNo = (gcnew System::Windows::Forms::NumericUpDown());
			this->label22 = (gcnew System::Windows::Forms::Label());
			this->btnChannelSetParameter = (gcnew System::Windows::Forms::Button());
			this->tbChannelSetParameterRx = (gcnew System::Windows::Forms::TextBox());
			this->label21 = (gcnew System::Windows::Forms::Label());
			this->label20 = (gcnew System::Windows::Forms::Label());
			this->tbChannelSetParameterTx = (gcnew System::Windows::Forms::TextBox());
			this->label19 = (gcnew System::Windows::Forms::Label());
			this->tmrStatic = (gcnew System::Windows::Forms::Timer(this->components));
			this->tmrUpdateDateTime = (gcnew System::Windows::Forms::Timer(this->components));
			this->tmrSampling = (gcnew System::Windows::Forms::Timer(this->components));
			this->tmrSamplingEndlessReadData = (gcnew System::Windows::Forms::Timer(this->components));
			this->lbConnectionStatus = (gcnew System::Windows::Forms::Label());
			this->tabControlMain->SuspendLayout();
			this->tbReadme->SuspendLayout();
			this->tbBoxInfo->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->dataGridViewBoxInfo))->BeginInit();
			this->tbChannelInfo->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->dataGridViewChInfo))->BeginInit();
			this->tbStatic->SuspendLayout();
			this->tbDigi->SuspendLayout();
			this->groupBox3->SuspendLayout();
			this->groupBox2->SuspendLayout();
			this->tbSampling->SuspendLayout();
			this->groupBox7->SuspendLayout();
			this->groupBox6->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuSampling_TimeKeepSamples))->BeginInit();
			this->groupBox5->SuspendLayout();
			this->groupBox4->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuSampling_TimeNSamples))->BeginInit();
			this->tbSamplingAddOn->SuspendLayout();
			this->groupBox11->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuSamplingPositionDistance))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuSamplingPositionStart))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuSamplingPositionScale))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuSamplingPositionNSamples))->BeginInit();
			this->groupBox9->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuSamplingTftNTailSamples))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuSamplingTftNSamples))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuSamplingTftFilterPeriod))->BeginInit();
			this->groupBox8->SuspendLayout();
			this->tbMisc1->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuChannelSetConfigNo))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuChannelSetParameterNo))->BeginInit();
			this->SuspendLayout();
			// 
			// btnConnect
			// 
			this->btnConnect->Location = System::Drawing::Point(4, 463);
			this->btnConnect->Name = L"btnConnect";
			this->btnConnect->Size = System::Drawing::Size(158, 56);
			this->btnConnect->TabIndex = 0;
			this->btnConnect->Text = L"Connect";
			this->btnConnect->UseVisualStyleBackColor = true;
			this->btnConnect->Click += gcnew System::EventHandler(this, &Form1::btnConnect_Click);
			// 
			// lbHistory
			// 
			this->lbHistory->FormattingEnabled = true;
			this->lbHistory->Location = System::Drawing::Point(168, 437);
			this->lbHistory->Name = L"lbHistory";
			this->lbHistory->Size = System::Drawing::Size(705, 82);
			this->lbHistory->TabIndex = 1;
			// 
			// tabControlMain
			// 
			this->tabControlMain->Controls->Add(this->tbReadme);
			this->tabControlMain->Controls->Add(this->tbBoxInfo);
			this->tabControlMain->Controls->Add(this->tbChannelInfo);
			this->tabControlMain->Controls->Add(this->tbStatic);
			this->tabControlMain->Controls->Add(this->tbDigi);
			this->tabControlMain->Controls->Add(this->tbSampling);
			this->tabControlMain->Controls->Add(this->tbSamplingAddOn);
			this->tabControlMain->Controls->Add(this->tbMisc1);
			this->tabControlMain->Location = System::Drawing::Point(4, 4);
			this->tabControlMain->Name = L"tabControlMain";
			this->tabControlMain->SelectedIndex = 0;
			this->tabControlMain->Size = System::Drawing::Size(873, 427);
			this->tabControlMain->TabIndex = 2;
			// 
			// tbReadme
			// 
			this->tbReadme->Controls->Add(this->tBoxReadme);
			this->tbReadme->Location = System::Drawing::Point(4, 22);
			this->tbReadme->Name = L"tbReadme";
			this->tbReadme->Padding = System::Windows::Forms::Padding(3);
			this->tbReadme->Size = System::Drawing::Size(865, 401);
			this->tbReadme->TabIndex = 0;
			this->tbReadme->Text = L"Readme";
			this->tbReadme->UseVisualStyleBackColor = true;
			// 
			// tBoxReadme
			// 
			this->tBoxReadme->ForeColor = System::Drawing::SystemColors::WindowText;
			this->tBoxReadme->Location = System::Drawing::Point(6, 6);
			this->tBoxReadme->Multiline = true;
			this->tBoxReadme->Name = L"tBoxReadme";
			this->tBoxReadme->ReadOnly = true;
			this->tBoxReadme->Size = System::Drawing::Size(853, 389);
			this->tBoxReadme->TabIndex = 0;
			// 
			// tbBoxInfo
			// 
			this->tbBoxInfo->Controls->Add(this->lbBoxInfoUpdates);
			this->tbBoxInfo->Controls->Add(this->btnBoxInfoUpdate);
			this->tbBoxInfo->Controls->Add(this->dataGridViewBoxInfo);
			this->tbBoxInfo->Location = System::Drawing::Point(4, 22);
			this->tbBoxInfo->Name = L"tbBoxInfo";
			this->tbBoxInfo->Padding = System::Windows::Forms::Padding(3);
			this->tbBoxInfo->Size = System::Drawing::Size(865, 401);
			this->tbBoxInfo->TabIndex = 1;
			this->tbBoxInfo->Text = L"Box Info";
			this->tbBoxInfo->UseVisualStyleBackColor = true;
			// 
			// lbBoxInfoUpdates
			// 
			this->lbBoxInfoUpdates->AutoSize = true;
			this->lbBoxInfoUpdates->Location = System::Drawing::Point(6, 377);
			this->lbBoxInfoUpdates->Name = L"lbBoxInfoUpdates";
			this->lbBoxInfoUpdates->Size = System::Drawing::Size(82, 13);
			this->lbBoxInfoUpdates->TabIndex = 2;
			this->lbBoxInfoUpdates->Text = L"No updates yet.";
			// 
			// btnBoxInfoUpdate
			// 
			this->btnBoxInfoUpdate->Location = System::Drawing::Point(331, 372);
			this->btnBoxInfoUpdate->Name = L"btnBoxInfoUpdate";
			this->btnBoxInfoUpdate->Size = System::Drawing::Size(201, 23);
			this->btnBoxInfoUpdate->TabIndex = 1;
			this->btnBoxInfoUpdate->Text = L"Update";
			this->btnBoxInfoUpdate->UseVisualStyleBackColor = true;
			this->btnBoxInfoUpdate->Click += gcnew System::EventHandler(this, &Form1::btnBoxInfoUpdate_Click);
			// 
			// dataGridViewBoxInfo
			// 
			this->dataGridViewBoxInfo->AllowUserToAddRows = false;
			this->dataGridViewBoxInfo->AllowUserToDeleteRows = false;
			this->dataGridViewBoxInfo->ColumnHeadersHeightSizeMode = System::Windows::Forms::DataGridViewColumnHeadersHeightSizeMode::AutoSize;
			this->dataGridViewBoxInfo->Columns->AddRange(gcnew cli::array< System::Windows::Forms::DataGridViewColumn^  >(10) {
				this->dgvBox_No,
					this->dgvBox_Name, this->dgvBox_Serial, this->dgvBox_MAC, this->dgvBox_Fw, this->dgvBox_Hw, this->dgvBox_NChannels, this->dgvBox_NDigiIn,
					this->dgvBox_NDigiOut, this->dgBox_ProductionCode
			});
			this->dataGridViewBoxInfo->Location = System::Drawing::Point(6, 6);
			this->dataGridViewBoxInfo->Name = L"dataGridViewBoxInfo";
			this->dataGridViewBoxInfo->ReadOnly = true;
			this->dataGridViewBoxInfo->Size = System::Drawing::Size(853, 360);
			this->dataGridViewBoxInfo->TabIndex = 0;
			// 
			// dgvBox_No
			// 
			this->dgvBox_No->HeaderText = L"No";
			this->dgvBox_No->Name = L"dgvBox_No";
			this->dgvBox_No->ReadOnly = true;
			this->dgvBox_No->Width = 25;
			// 
			// dgvBox_Name
			// 
			this->dgvBox_Name->HeaderText = L"Name";
			this->dgvBox_Name->Name = L"dgvBox_Name";
			this->dgvBox_Name->ReadOnly = true;
			this->dgvBox_Name->Width = 150;
			// 
			// dgvBox_Serial
			// 
			this->dgvBox_Serial->HeaderText = L"Serial";
			this->dgvBox_Serial->Name = L"dgvBox_Serial";
			this->dgvBox_Serial->ReadOnly = true;
			this->dgvBox_Serial->Width = 80;
			// 
			// dgvBox_MAC
			// 
			this->dgvBox_MAC->HeaderText = L"MAC";
			this->dgvBox_MAC->Name = L"dgvBox_MAC";
			this->dgvBox_MAC->ReadOnly = true;
			// 
			// dgvBox_Fw
			// 
			this->dgvBox_Fw->HeaderText = L"Firmware";
			this->dgvBox_Fw->Name = L"dgvBox_Fw";
			this->dgvBox_Fw->ReadOnly = true;
			this->dgvBox_Fw->Width = 60;
			// 
			// dgvBox_Hw
			// 
			this->dgvBox_Hw->HeaderText = L"Hardware";
			this->dgvBox_Hw->Name = L"dgvBox_Hw";
			this->dgvBox_Hw->ReadOnly = true;
			this->dgvBox_Hw->Width = 80;
			// 
			// dgvBox_NChannels
			// 
			this->dgvBox_NChannels->HeaderText = L"Channels";
			this->dgvBox_NChannels->Name = L"dgvBox_NChannels";
			this->dgvBox_NChannels->ReadOnly = true;
			this->dgvBox_NChannels->Width = 60;
			// 
			// dgvBox_NDigiIn
			// 
			this->dgvBox_NDigiIn->HeaderText = L"Digital Inputs";
			this->dgvBox_NDigiIn->Name = L"dgvBox_NDigiIn";
			this->dgvBox_NDigiIn->ReadOnly = true;
			this->dgvBox_NDigiIn->Width = 60;
			// 
			// dgvBox_NDigiOut
			// 
			this->dgvBox_NDigiOut->HeaderText = L"Digital Outputs";
			this->dgvBox_NDigiOut->Name = L"dgvBox_NDigiOut";
			this->dgvBox_NDigiOut->ReadOnly = true;
			this->dgvBox_NDigiOut->Width = 60;
			// 
			// dgBox_ProductionCode
			// 
			this->dgBox_ProductionCode->HeaderText = L"Production Code";
			this->dgBox_ProductionCode->Name = L"dgBox_ProductionCode";
			this->dgBox_ProductionCode->ReadOnly = true;
			this->dgBox_ProductionCode->Width = 60;
			// 
			// tbChannelInfo
			// 
			this->tbChannelInfo->Controls->Add(this->lbChInfoUpdates);
			this->tbChannelInfo->Controls->Add(this->btnChannelInfoUpdate);
			this->tbChannelInfo->Controls->Add(this->dataGridViewChInfo);
			this->tbChannelInfo->Location = System::Drawing::Point(4, 22);
			this->tbChannelInfo->Name = L"tbChannelInfo";
			this->tbChannelInfo->Padding = System::Windows::Forms::Padding(3);
			this->tbChannelInfo->Size = System::Drawing::Size(865, 401);
			this->tbChannelInfo->TabIndex = 2;
			this->tbChannelInfo->Text = L"Channel Info";
			this->tbChannelInfo->UseVisualStyleBackColor = true;
			// 
			// lbChInfoUpdates
			// 
			this->lbChInfoUpdates->AutoSize = true;
			this->lbChInfoUpdates->Location = System::Drawing::Point(6, 377);
			this->lbChInfoUpdates->Name = L"lbChInfoUpdates";
			this->lbChInfoUpdates->Size = System::Drawing::Size(86, 13);
			this->lbChInfoUpdates->TabIndex = 3;
			this->lbChInfoUpdates->Text = L"Not updated yet.";
			// 
			// btnChannelInfoUpdate
			// 
			this->btnChannelInfoUpdate->Location = System::Drawing::Point(335, 372);
			this->btnChannelInfoUpdate->Name = L"btnChannelInfoUpdate";
			this->btnChannelInfoUpdate->Size = System::Drawing::Size(201, 23);
			this->btnChannelInfoUpdate->TabIndex = 2;
			this->btnChannelInfoUpdate->Text = L"Update";
			this->btnChannelInfoUpdate->UseVisualStyleBackColor = true;
			this->btnChannelInfoUpdate->Click += gcnew System::EventHandler(this, &Form1::btnChannelInfoUpdate_Click);
			// 
			// dataGridViewChInfo
			// 
			this->dataGridViewChInfo->AllowUserToAddRows = false;
			this->dataGridViewChInfo->AllowUserToDeleteRows = false;
			this->dataGridViewChInfo->ColumnHeadersHeightSizeMode = System::Windows::Forms::DataGridViewColumnHeadersHeightSizeMode::AutoSize;
			this->dataGridViewChInfo->Columns->AddRange(gcnew cli::array< System::Windows::Forms::DataGridViewColumn^  >(8) {
				this->dgvChannel_No,
					this->dgvChannel_Location, this->dgvChannel_Type, this->dgvChannel_Unit, this->dgvChannel_FactorToUnit, this->dgvChannel_Digits,
					this->dgvChannel_OrderNo, this->dgvChannel_SerNo
			});
			this->dataGridViewChInfo->Location = System::Drawing::Point(6, 6);
			this->dataGridViewChInfo->Name = L"dataGridViewChInfo";
			this->dataGridViewChInfo->ReadOnly = true;
			this->dataGridViewChInfo->RowTemplate->DefaultCellStyle->WrapMode = System::Windows::Forms::DataGridViewTriState::True;
			this->dataGridViewChInfo->RowTemplate->Height = 33;
			this->dataGridViewChInfo->Size = System::Drawing::Size(853, 360);
			this->dataGridViewChInfo->TabIndex = 0;
			// 
			// dgvChannel_No
			// 
			this->dgvChannel_No->HeaderText = L"No";
			this->dgvChannel_No->Name = L"dgvChannel_No";
			this->dgvChannel_No->ReadOnly = true;
			this->dgvChannel_No->Width = 25;
			// 
			// dgvChannel_Location
			// 
			this->dgvChannel_Location->HeaderText = L"Location";
			this->dgvChannel_Location->Name = L"dgvChannel_Location";
			this->dgvChannel_Location->ReadOnly = true;
			// 
			// dgvChannel_Type
			// 
			this->dgvChannel_Type->HeaderText = L"Type";
			this->dgvChannel_Type->Name = L"dgvChannel_Type";
			this->dgvChannel_Type->ReadOnly = true;
			this->dgvChannel_Type->Width = 60;
			// 
			// dgvChannel_Unit
			// 
			this->dgvChannel_Unit->HeaderText = L"Unit";
			this->dgvChannel_Unit->Name = L"dgvChannel_Unit";
			this->dgvChannel_Unit->ReadOnly = true;
			this->dgvChannel_Unit->Width = 40;
			// 
			// dgvChannel_FactorToUnit
			// 
			this->dgvChannel_FactorToUnit->HeaderText = L"Factor to Unit (see documentation)";
			this->dgvChannel_FactorToUnit->Name = L"dgvChannel_FactorToUnit";
			this->dgvChannel_FactorToUnit->ReadOnly = true;
			this->dgvChannel_FactorToUnit->Width = 150;
			// 
			// dgvChannel_Digits
			// 
			this->dgvChannel_Digits->HeaderText = L"Decimal Digits (Default)";
			this->dgvChannel_Digits->Name = L"dgvChannel_Digits";
			this->dgvChannel_Digits->ReadOnly = true;
			// 
			// dgvChannel_OrderNo
			// 
			this->dgvChannel_OrderNo->HeaderText = L"Order No";
			this->dgvChannel_OrderNo->Name = L"dgvChannel_OrderNo";
			this->dgvChannel_OrderNo->ReadOnly = true;
			this->dgvChannel_OrderNo->Width = 125;
			// 
			// dgvChannel_SerNo
			// 
			this->dgvChannel_SerNo->HeaderText = L"Serial No";
			this->dgvChannel_SerNo->Name = L"dgvChannel_SerNo";
			this->dgvChannel_SerNo->ReadOnly = true;
			this->dgvChannel_SerNo->Width = 125;
			// 
			// tbStatic
			// 
			this->tbStatic->Controls->Add(this->label18);
			this->tbStatic->Controls->Add(this->cbStaticFastUpdate);
			this->tbStatic->Controls->Add(this->btnStaticResetMinMax);
			this->tbStatic->Controls->Add(this->lbStaticUpdates);
			this->tbStatic->Controls->Add(this->rbStaticCH57_64);
			this->tbStatic->Controls->Add(this->rbStaticCH49_56);
			this->tbStatic->Controls->Add(this->rbStaticCH41_48);
			this->tbStatic->Controls->Add(this->rbStaticCH33_40);
			this->tbStatic->Controls->Add(this->lbStaticDiff8);
			this->tbStatic->Controls->Add(this->lbStaticMax8);
			this->tbStatic->Controls->Add(this->lbStaticMin8);
			this->tbStatic->Controls->Add(this->lbStaticDiff7);
			this->tbStatic->Controls->Add(this->lbStaticMax7);
			this->tbStatic->Controls->Add(this->lbStaticMin7);
			this->tbStatic->Controls->Add(this->lbStaticDiff6);
			this->tbStatic->Controls->Add(this->lbStaticMax6);
			this->tbStatic->Controls->Add(this->lbStaticMin6);
			this->tbStatic->Controls->Add(this->lbStaticDiff5);
			this->tbStatic->Controls->Add(this->lbStaticMax5);
			this->tbStatic->Controls->Add(this->lbStaticMin5);
			this->tbStatic->Controls->Add(this->lbStaticDiff4);
			this->tbStatic->Controls->Add(this->lbStaticMax4);
			this->tbStatic->Controls->Add(this->lbStaticMin4);
			this->tbStatic->Controls->Add(this->lbStaticDiff3);
			this->tbStatic->Controls->Add(this->lbStaticMax3);
			this->tbStatic->Controls->Add(this->lbStaticMin3);
			this->tbStatic->Controls->Add(this->lbStaticDiff2);
			this->tbStatic->Controls->Add(this->lbStaticMax2);
			this->tbStatic->Controls->Add(this->lbStaticMin2);
			this->tbStatic->Controls->Add(this->lbStaticDiff1);
			this->tbStatic->Controls->Add(this->lbStaticMax1);
			this->tbStatic->Controls->Add(this->lbStaticMin1);
			this->tbStatic->Controls->Add(this->label39);
			this->tbStatic->Controls->Add(this->label38);
			this->tbStatic->Controls->Add(this->label37);
			this->tbStatic->Controls->Add(this->lbStaticHwStat8);
			this->tbStatic->Controls->Add(this->lbStaticUnit8);
			this->tbStatic->Controls->Add(this->lbStaticDigits8);
			this->tbStatic->Controls->Add(this->lbStaticCh8);
			this->tbStatic->Controls->Add(this->lbStaticHwStat7);
			this->tbStatic->Controls->Add(this->lbStaticUnit7);
			this->tbStatic->Controls->Add(this->lbStaticDigits7);
			this->tbStatic->Controls->Add(this->lbStaticCh7);
			this->tbStatic->Controls->Add(this->lbStaticHwStat6);
			this->tbStatic->Controls->Add(this->lbStaticUnit6);
			this->tbStatic->Controls->Add(this->lbStaticDigits6);
			this->tbStatic->Controls->Add(this->lbStaticCh6);
			this->tbStatic->Controls->Add(this->lbStaticHwStat5);
			this->tbStatic->Controls->Add(this->lbStaticUnit5);
			this->tbStatic->Controls->Add(this->lbStaticDigits5);
			this->tbStatic->Controls->Add(this->lbStaticCh5);
			this->tbStatic->Controls->Add(this->lbStaticHwStat4);
			this->tbStatic->Controls->Add(this->lbStaticUnit4);
			this->tbStatic->Controls->Add(this->lbStaticDigits4);
			this->tbStatic->Controls->Add(this->lbStaticCh4);
			this->tbStatic->Controls->Add(this->lbStaticHwStat3);
			this->tbStatic->Controls->Add(this->lbStaticUnit3);
			this->tbStatic->Controls->Add(this->lbStaticDigits3);
			this->tbStatic->Controls->Add(this->lbStaticCh3);
			this->tbStatic->Controls->Add(this->lbStaticHwStat2);
			this->tbStatic->Controls->Add(this->lbStaticUnit2);
			this->tbStatic->Controls->Add(this->lbStaticDigits2);
			this->tbStatic->Controls->Add(this->lbStaticCh2);
			this->tbStatic->Controls->Add(this->lbStaticHwStat1);
			this->tbStatic->Controls->Add(this->lbStaticUnit1);
			this->tbStatic->Controls->Add(this->lbStaticDigits1);
			this->tbStatic->Controls->Add(this->lbStaticCh1);
			this->tbStatic->Controls->Add(this->label4);
			this->tbStatic->Controls->Add(this->label3);
			this->tbStatic->Controls->Add(this->label2);
			this->tbStatic->Controls->Add(this->label1);
			this->tbStatic->Controls->Add(this->groupBox1);
			this->tbStatic->Controls->Add(this->rbStaticCH25_32);
			this->tbStatic->Controls->Add(this->rbStaticCH17_24);
			this->tbStatic->Controls->Add(this->rbStaticCH9_16);
			this->tbStatic->Controls->Add(this->rbStaticCH1_8);
			this->tbStatic->Location = System::Drawing::Point(4, 22);
			this->tbStatic->Name = L"tbStatic";
			this->tbStatic->Padding = System::Windows::Forms::Padding(3);
			this->tbStatic->Size = System::Drawing::Size(865, 401);
			this->tbStatic->TabIndex = 3;
			this->tbStatic->Text = L"Static Measurement";
			this->tbStatic->UseVisualStyleBackColor = true;
			// 
			// label18
			// 
			this->label18->AutoSize = true;
			this->label18->Location = System::Drawing::Point(604, 36);
			this->label18->Name = L"label18";
			this->label18->Size = System::Drawing::Size(57, 13);
			this->label18->TabIndex = 76;
			this->label18->Text = L"(Rounded)";
			// 
			// cbStaticFastUpdate
			// 
			this->cbStaticFastUpdate->AutoSize = true;
			this->cbStaticFastUpdate->Checked = true;
			this->cbStaticFastUpdate->CheckState = System::Windows::Forms::CheckState::Checked;
			this->cbStaticFastUpdate->Location = System::Drawing::Point(739, 19);
			this->cbStaticFastUpdate->Name = L"cbStaticFastUpdate";
			this->cbStaticFastUpdate->Size = System::Drawing::Size(96, 17);
			this->cbStaticFastUpdate->TabIndex = 75;
			this->cbStaticFastUpdate->Text = L"Enable median";
			this->cbStaticFastUpdate->UseVisualStyleBackColor = true;
			this->cbStaticFastUpdate->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbStaticFastUpdate_CheckedChanged);
			// 
			// btnStaticResetMinMax
			// 
			this->btnStaticResetMinMax->Location = System::Drawing::Point(732, 369);
			this->btnStaticResetMinMax->Name = L"btnStaticResetMinMax";
			this->btnStaticResetMinMax->Size = System::Drawing::Size(128, 23);
			this->btnStaticResetMinMax->TabIndex = 74;
			this->btnStaticResetMinMax->Text = L"Reset Min/Max";
			this->btnStaticResetMinMax->UseVisualStyleBackColor = true;
			this->btnStaticResetMinMax->Click += gcnew System::EventHandler(this, &Form1::btnStaticResetMinMax_Click);
			// 
			// lbStaticUpdates
			// 
			this->lbStaticUpdates->AutoSize = true;
			this->lbStaticUpdates->Location = System::Drawing::Point(736, 324);
			this->lbStaticUpdates->Name = L"lbStaticUpdates";
			this->lbStaticUpdates->Size = System::Drawing::Size(56, 13);
			this->lbStaticUpdates->TabIndex = 73;
			this->lbStaticUpdates->Text = L"0 Updates";
			// 
			// rbStaticCH57_64
			// 
			this->rbStaticCH57_64->AutoSize = true;
			this->rbStaticCH57_64->Location = System::Drawing::Point(739, 216);
			this->rbStaticCH57_64->Name = L"rbStaticCH57_64";
			this->rbStaticCH57_64->Size = System::Drawing::Size(97, 17);
			this->rbStaticCH57_64->TabIndex = 72;
			this->rbStaticCH57_64->Text = L"Channel 57..64";
			this->rbStaticCH57_64->UseVisualStyleBackColor = true;
			this->rbStaticCH57_64->CheckedChanged += gcnew System::EventHandler(this, &Form1::rbStaticCH1_8_CheckedChanged);
			// 
			// rbStaticCH49_56
			// 
			this->rbStaticCH49_56->AutoSize = true;
			this->rbStaticCH49_56->Location = System::Drawing::Point(739, 193);
			this->rbStaticCH49_56->Name = L"rbStaticCH49_56";
			this->rbStaticCH49_56->Size = System::Drawing::Size(97, 17);
			this->rbStaticCH49_56->TabIndex = 71;
			this->rbStaticCH49_56->Text = L"Channel 49..56";
			this->rbStaticCH49_56->UseVisualStyleBackColor = true;
			this->rbStaticCH49_56->CheckedChanged += gcnew System::EventHandler(this, &Form1::rbStaticCH1_8_CheckedChanged);
			// 
			// rbStaticCH41_48
			// 
			this->rbStaticCH41_48->AutoSize = true;
			this->rbStaticCH41_48->Location = System::Drawing::Point(739, 170);
			this->rbStaticCH41_48->Name = L"rbStaticCH41_48";
			this->rbStaticCH41_48->Size = System::Drawing::Size(97, 17);
			this->rbStaticCH41_48->TabIndex = 70;
			this->rbStaticCH41_48->Text = L"Channel 41..48";
			this->rbStaticCH41_48->UseVisualStyleBackColor = true;
			this->rbStaticCH41_48->CheckedChanged += gcnew System::EventHandler(this, &Form1::rbStaticCH1_8_CheckedChanged);
			// 
			// rbStaticCH33_40
			// 
			this->rbStaticCH33_40->AutoSize = true;
			this->rbStaticCH33_40->Location = System::Drawing::Point(739, 147);
			this->rbStaticCH33_40->Name = L"rbStaticCH33_40";
			this->rbStaticCH33_40->Size = System::Drawing::Size(97, 17);
			this->rbStaticCH33_40->TabIndex = 69;
			this->rbStaticCH33_40->Text = L"Channel 33..40";
			this->rbStaticCH33_40->UseVisualStyleBackColor = true;
			this->rbStaticCH33_40->CheckedChanged += gcnew System::EventHandler(this, &Form1::rbStaticCH1_8_CheckedChanged);
			// 
			// lbStaticDiff8
			// 
			this->lbStaticDiff8->AutoSize = true;
			this->lbStaticDiff8->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticDiff8->Location = System::Drawing::Point(600, 365);
			this->lbStaticDiff8->Name = L"lbStaticDiff8";
			this->lbStaticDiff8->Size = System::Drawing::Size(13, 17);
			this->lbStaticDiff8->TabIndex = 68;
			this->lbStaticDiff8->Text = L"*";
			// 
			// lbStaticMax8
			// 
			this->lbStaticMax8->AutoSize = true;
			this->lbStaticMax8->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticMax8->Location = System::Drawing::Point(500, 365);
			this->lbStaticMax8->Name = L"lbStaticMax8";
			this->lbStaticMax8->Size = System::Drawing::Size(13, 17);
			this->lbStaticMax8->TabIndex = 67;
			this->lbStaticMax8->Text = L"*";
			// 
			// lbStaticMin8
			// 
			this->lbStaticMin8->AutoSize = true;
			this->lbStaticMin8->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticMin8->Location = System::Drawing::Point(400, 365);
			this->lbStaticMin8->Name = L"lbStaticMin8";
			this->lbStaticMin8->Size = System::Drawing::Size(13, 17);
			this->lbStaticMin8->TabIndex = 66;
			this->lbStaticMin8->Text = L"*";
			// 
			// lbStaticDiff7
			// 
			this->lbStaticDiff7->AutoSize = true;
			this->lbStaticDiff7->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticDiff7->Location = System::Drawing::Point(600, 320);
			this->lbStaticDiff7->Name = L"lbStaticDiff7";
			this->lbStaticDiff7->Size = System::Drawing::Size(13, 17);
			this->lbStaticDiff7->TabIndex = 65;
			this->lbStaticDiff7->Text = L"*";
			// 
			// lbStaticMax7
			// 
			this->lbStaticMax7->AutoSize = true;
			this->lbStaticMax7->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticMax7->Location = System::Drawing::Point(500, 320);
			this->lbStaticMax7->Name = L"lbStaticMax7";
			this->lbStaticMax7->Size = System::Drawing::Size(13, 17);
			this->lbStaticMax7->TabIndex = 64;
			this->lbStaticMax7->Text = L"*";
			// 
			// lbStaticMin7
			// 
			this->lbStaticMin7->AutoSize = true;
			this->lbStaticMin7->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticMin7->Location = System::Drawing::Point(400, 320);
			this->lbStaticMin7->Name = L"lbStaticMin7";
			this->lbStaticMin7->Size = System::Drawing::Size(13, 17);
			this->lbStaticMin7->TabIndex = 63;
			this->lbStaticMin7->Text = L"*";
			// 
			// lbStaticDiff6
			// 
			this->lbStaticDiff6->AutoSize = true;
			this->lbStaticDiff6->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticDiff6->Location = System::Drawing::Point(600, 275);
			this->lbStaticDiff6->Name = L"lbStaticDiff6";
			this->lbStaticDiff6->Size = System::Drawing::Size(13, 17);
			this->lbStaticDiff6->TabIndex = 62;
			this->lbStaticDiff6->Text = L"*";
			// 
			// lbStaticMax6
			// 
			this->lbStaticMax6->AutoSize = true;
			this->lbStaticMax6->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticMax6->Location = System::Drawing::Point(500, 275);
			this->lbStaticMax6->Name = L"lbStaticMax6";
			this->lbStaticMax6->Size = System::Drawing::Size(13, 17);
			this->lbStaticMax6->TabIndex = 61;
			this->lbStaticMax6->Text = L"*";
			// 
			// lbStaticMin6
			// 
			this->lbStaticMin6->AutoSize = true;
			this->lbStaticMin6->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticMin6->Location = System::Drawing::Point(400, 275);
			this->lbStaticMin6->Name = L"lbStaticMin6";
			this->lbStaticMin6->Size = System::Drawing::Size(13, 17);
			this->lbStaticMin6->TabIndex = 60;
			this->lbStaticMin6->Text = L"*";
			// 
			// lbStaticDiff5
			// 
			this->lbStaticDiff5->AutoSize = true;
			this->lbStaticDiff5->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticDiff5->Location = System::Drawing::Point(600, 230);
			this->lbStaticDiff5->Name = L"lbStaticDiff5";
			this->lbStaticDiff5->Size = System::Drawing::Size(13, 17);
			this->lbStaticDiff5->TabIndex = 59;
			this->lbStaticDiff5->Text = L"*";
			// 
			// lbStaticMax5
			// 
			this->lbStaticMax5->AutoSize = true;
			this->lbStaticMax5->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticMax5->Location = System::Drawing::Point(500, 230);
			this->lbStaticMax5->Name = L"lbStaticMax5";
			this->lbStaticMax5->Size = System::Drawing::Size(13, 17);
			this->lbStaticMax5->TabIndex = 58;
			this->lbStaticMax5->Text = L"*";
			// 
			// lbStaticMin5
			// 
			this->lbStaticMin5->AutoSize = true;
			this->lbStaticMin5->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticMin5->Location = System::Drawing::Point(400, 230);
			this->lbStaticMin5->Name = L"lbStaticMin5";
			this->lbStaticMin5->Size = System::Drawing::Size(13, 17);
			this->lbStaticMin5->TabIndex = 57;
			this->lbStaticMin5->Text = L"*";
			// 
			// lbStaticDiff4
			// 
			this->lbStaticDiff4->AutoSize = true;
			this->lbStaticDiff4->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticDiff4->Location = System::Drawing::Point(600, 185);
			this->lbStaticDiff4->Name = L"lbStaticDiff4";
			this->lbStaticDiff4->Size = System::Drawing::Size(13, 17);
			this->lbStaticDiff4->TabIndex = 56;
			this->lbStaticDiff4->Text = L"*";
			// 
			// lbStaticMax4
			// 
			this->lbStaticMax4->AutoSize = true;
			this->lbStaticMax4->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticMax4->Location = System::Drawing::Point(500, 185);
			this->lbStaticMax4->Name = L"lbStaticMax4";
			this->lbStaticMax4->Size = System::Drawing::Size(13, 17);
			this->lbStaticMax4->TabIndex = 55;
			this->lbStaticMax4->Text = L"*";
			// 
			// lbStaticMin4
			// 
			this->lbStaticMin4->AutoSize = true;
			this->lbStaticMin4->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticMin4->Location = System::Drawing::Point(400, 185);
			this->lbStaticMin4->Name = L"lbStaticMin4";
			this->lbStaticMin4->Size = System::Drawing::Size(13, 17);
			this->lbStaticMin4->TabIndex = 54;
			this->lbStaticMin4->Text = L"*";
			// 
			// lbStaticDiff3
			// 
			this->lbStaticDiff3->AutoSize = true;
			this->lbStaticDiff3->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticDiff3->Location = System::Drawing::Point(600, 140);
			this->lbStaticDiff3->Name = L"lbStaticDiff3";
			this->lbStaticDiff3->Size = System::Drawing::Size(13, 17);
			this->lbStaticDiff3->TabIndex = 53;
			this->lbStaticDiff3->Text = L"*";
			// 
			// lbStaticMax3
			// 
			this->lbStaticMax3->AutoSize = true;
			this->lbStaticMax3->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticMax3->Location = System::Drawing::Point(500, 140);
			this->lbStaticMax3->Name = L"lbStaticMax3";
			this->lbStaticMax3->Size = System::Drawing::Size(13, 17);
			this->lbStaticMax3->TabIndex = 52;
			this->lbStaticMax3->Text = L"*";
			// 
			// lbStaticMin3
			// 
			this->lbStaticMin3->AutoSize = true;
			this->lbStaticMin3->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticMin3->Location = System::Drawing::Point(400, 140);
			this->lbStaticMin3->Name = L"lbStaticMin3";
			this->lbStaticMin3->Size = System::Drawing::Size(13, 17);
			this->lbStaticMin3->TabIndex = 51;
			this->lbStaticMin3->Text = L"*";
			// 
			// lbStaticDiff2
			// 
			this->lbStaticDiff2->AutoSize = true;
			this->lbStaticDiff2->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticDiff2->Location = System::Drawing::Point(600, 95);
			this->lbStaticDiff2->Name = L"lbStaticDiff2";
			this->lbStaticDiff2->Size = System::Drawing::Size(13, 17);
			this->lbStaticDiff2->TabIndex = 50;
			this->lbStaticDiff2->Text = L"*";
			// 
			// lbStaticMax2
			// 
			this->lbStaticMax2->AutoSize = true;
			this->lbStaticMax2->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticMax2->Location = System::Drawing::Point(500, 95);
			this->lbStaticMax2->Name = L"lbStaticMax2";
			this->lbStaticMax2->Size = System::Drawing::Size(13, 17);
			this->lbStaticMax2->TabIndex = 49;
			this->lbStaticMax2->Text = L"*";
			// 
			// lbStaticMin2
			// 
			this->lbStaticMin2->AutoSize = true;
			this->lbStaticMin2->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticMin2->Location = System::Drawing::Point(400, 95);
			this->lbStaticMin2->Name = L"lbStaticMin2";
			this->lbStaticMin2->Size = System::Drawing::Size(13, 17);
			this->lbStaticMin2->TabIndex = 48;
			this->lbStaticMin2->Text = L"*";
			// 
			// lbStaticDiff1
			// 
			this->lbStaticDiff1->AutoSize = true;
			this->lbStaticDiff1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticDiff1->Location = System::Drawing::Point(600, 55);
			this->lbStaticDiff1->Name = L"lbStaticDiff1";
			this->lbStaticDiff1->Size = System::Drawing::Size(13, 17);
			this->lbStaticDiff1->TabIndex = 47;
			this->lbStaticDiff1->Text = L"*";
			// 
			// lbStaticMax1
			// 
			this->lbStaticMax1->AutoSize = true;
			this->lbStaticMax1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticMax1->Location = System::Drawing::Point(500, 55);
			this->lbStaticMax1->Name = L"lbStaticMax1";
			this->lbStaticMax1->Size = System::Drawing::Size(13, 17);
			this->lbStaticMax1->TabIndex = 46;
			this->lbStaticMax1->Text = L"*";
			// 
			// lbStaticMin1
			// 
			this->lbStaticMin1->AutoSize = true;
			this->lbStaticMin1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticMin1->Location = System::Drawing::Point(400, 55);
			this->lbStaticMin1->Name = L"lbStaticMin1";
			this->lbStaticMin1->Size = System::Drawing::Size(13, 17);
			this->lbStaticMin1->TabIndex = 45;
			this->lbStaticMin1->Text = L"*";
			// 
			// label39
			// 
			this->label39->AutoSize = true;
			this->label39->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->label39->Location = System::Drawing::Point(600, 19);
			this->label39->Name = L"label39";
			this->label39->Size = System::Drawing::Size(68, 17);
			this->label39->TabIndex = 44;
			this->label39->Text = L"Max - Min";
			// 
			// label38
			// 
			this->label38->AutoSize = true;
			this->label38->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->label38->Location = System::Drawing::Point(500, 19);
			this->label38->Name = L"label38";
			this->label38->Size = System::Drawing::Size(66, 17);
			this->label38->TabIndex = 43;
			this->label38->Text = L"Maximum";
			// 
			// label37
			// 
			this->label37->AutoSize = true;
			this->label37->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->label37->Location = System::Drawing::Point(400, 19);
			this->label37->Name = L"label37";
			this->label37->Size = System::Drawing::Size(63, 17);
			this->label37->TabIndex = 42;
			this->label37->Text = L"Minimum";
			// 
			// lbStaticHwStat8
			// 
			this->lbStaticHwStat8->AutoSize = true;
			this->lbStaticHwStat8->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticHwStat8->Location = System::Drawing::Point(250, 365);
			this->lbStaticHwStat8->Name = L"lbStaticHwStat8";
			this->lbStaticHwStat8->Size = System::Drawing::Size(13, 17);
			this->lbStaticHwStat8->TabIndex = 41;
			this->lbStaticHwStat8->Text = L"*";
			// 
			// lbStaticUnit8
			// 
			this->lbStaticUnit8->AutoSize = true;
			this->lbStaticUnit8->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticUnit8->Location = System::Drawing::Point(170, 365);
			this->lbStaticUnit8->Name = L"lbStaticUnit8";
			this->lbStaticUnit8->Size = System::Drawing::Size(13, 17);
			this->lbStaticUnit8->TabIndex = 40;
			this->lbStaticUnit8->Text = L"*";
			// 
			// lbStaticDigits8
			// 
			this->lbStaticDigits8->AutoSize = true;
			this->lbStaticDigits8->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticDigits8->Location = System::Drawing::Point(85, 365);
			this->lbStaticDigits8->Name = L"lbStaticDigits8";
			this->lbStaticDigits8->Size = System::Drawing::Size(13, 17);
			this->lbStaticDigits8->TabIndex = 39;
			this->lbStaticDigits8->Text = L"*";
			// 
			// lbStaticCh8
			// 
			this->lbStaticCh8->AutoSize = true;
			this->lbStaticCh8->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticCh8->Location = System::Drawing::Point(10, 365);
			this->lbStaticCh8->Name = L"lbStaticCh8";
			this->lbStaticCh8->Size = System::Drawing::Size(16, 17);
			this->lbStaticCh8->TabIndex = 38;
			this->lbStaticCh8->Text = L"8";
			// 
			// lbStaticHwStat7
			// 
			this->lbStaticHwStat7->AutoSize = true;
			this->lbStaticHwStat7->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticHwStat7->Location = System::Drawing::Point(250, 320);
			this->lbStaticHwStat7->Name = L"lbStaticHwStat7";
			this->lbStaticHwStat7->Size = System::Drawing::Size(13, 17);
			this->lbStaticHwStat7->TabIndex = 37;
			this->lbStaticHwStat7->Text = L"*";
			// 
			// lbStaticUnit7
			// 
			this->lbStaticUnit7->AutoSize = true;
			this->lbStaticUnit7->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticUnit7->Location = System::Drawing::Point(170, 320);
			this->lbStaticUnit7->Name = L"lbStaticUnit7";
			this->lbStaticUnit7->Size = System::Drawing::Size(13, 17);
			this->lbStaticUnit7->TabIndex = 36;
			this->lbStaticUnit7->Text = L"*";
			// 
			// lbStaticDigits7
			// 
			this->lbStaticDigits7->AutoSize = true;
			this->lbStaticDigits7->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticDigits7->Location = System::Drawing::Point(85, 320);
			this->lbStaticDigits7->Name = L"lbStaticDigits7";
			this->lbStaticDigits7->Size = System::Drawing::Size(13, 17);
			this->lbStaticDigits7->TabIndex = 35;
			this->lbStaticDigits7->Text = L"*";
			// 
			// lbStaticCh7
			// 
			this->lbStaticCh7->AutoSize = true;
			this->lbStaticCh7->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticCh7->Location = System::Drawing::Point(10, 320);
			this->lbStaticCh7->Name = L"lbStaticCh7";
			this->lbStaticCh7->Size = System::Drawing::Size(16, 17);
			this->lbStaticCh7->TabIndex = 34;
			this->lbStaticCh7->Text = L"7";
			// 
			// lbStaticHwStat6
			// 
			this->lbStaticHwStat6->AutoSize = true;
			this->lbStaticHwStat6->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticHwStat6->Location = System::Drawing::Point(250, 275);
			this->lbStaticHwStat6->Name = L"lbStaticHwStat6";
			this->lbStaticHwStat6->Size = System::Drawing::Size(13, 17);
			this->lbStaticHwStat6->TabIndex = 33;
			this->lbStaticHwStat6->Text = L"*";
			// 
			// lbStaticUnit6
			// 
			this->lbStaticUnit6->AutoSize = true;
			this->lbStaticUnit6->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticUnit6->Location = System::Drawing::Point(170, 275);
			this->lbStaticUnit6->Name = L"lbStaticUnit6";
			this->lbStaticUnit6->Size = System::Drawing::Size(13, 17);
			this->lbStaticUnit6->TabIndex = 32;
			this->lbStaticUnit6->Text = L"*";
			// 
			// lbStaticDigits6
			// 
			this->lbStaticDigits6->AutoSize = true;
			this->lbStaticDigits6->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticDigits6->Location = System::Drawing::Point(85, 275);
			this->lbStaticDigits6->Name = L"lbStaticDigits6";
			this->lbStaticDigits6->Size = System::Drawing::Size(13, 17);
			this->lbStaticDigits6->TabIndex = 31;
			this->lbStaticDigits6->Text = L"*";
			// 
			// lbStaticCh6
			// 
			this->lbStaticCh6->AutoSize = true;
			this->lbStaticCh6->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticCh6->Location = System::Drawing::Point(10, 275);
			this->lbStaticCh6->Name = L"lbStaticCh6";
			this->lbStaticCh6->Size = System::Drawing::Size(16, 17);
			this->lbStaticCh6->TabIndex = 30;
			this->lbStaticCh6->Text = L"6";
			// 
			// lbStaticHwStat5
			// 
			this->lbStaticHwStat5->AutoSize = true;
			this->lbStaticHwStat5->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticHwStat5->Location = System::Drawing::Point(250, 230);
			this->lbStaticHwStat5->Name = L"lbStaticHwStat5";
			this->lbStaticHwStat5->Size = System::Drawing::Size(13, 17);
			this->lbStaticHwStat5->TabIndex = 29;
			this->lbStaticHwStat5->Text = L"*";
			// 
			// lbStaticUnit5
			// 
			this->lbStaticUnit5->AutoSize = true;
			this->lbStaticUnit5->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticUnit5->Location = System::Drawing::Point(170, 230);
			this->lbStaticUnit5->Name = L"lbStaticUnit5";
			this->lbStaticUnit5->Size = System::Drawing::Size(13, 17);
			this->lbStaticUnit5->TabIndex = 28;
			this->lbStaticUnit5->Text = L"*";
			// 
			// lbStaticDigits5
			// 
			this->lbStaticDigits5->AutoSize = true;
			this->lbStaticDigits5->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticDigits5->Location = System::Drawing::Point(85, 230);
			this->lbStaticDigits5->Name = L"lbStaticDigits5";
			this->lbStaticDigits5->Size = System::Drawing::Size(13, 17);
			this->lbStaticDigits5->TabIndex = 27;
			this->lbStaticDigits5->Text = L"*";
			// 
			// lbStaticCh5
			// 
			this->lbStaticCh5->AutoSize = true;
			this->lbStaticCh5->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticCh5->Location = System::Drawing::Point(10, 230);
			this->lbStaticCh5->Name = L"lbStaticCh5";
			this->lbStaticCh5->Size = System::Drawing::Size(16, 17);
			this->lbStaticCh5->TabIndex = 26;
			this->lbStaticCh5->Text = L"5";
			// 
			// lbStaticHwStat4
			// 
			this->lbStaticHwStat4->AutoSize = true;
			this->lbStaticHwStat4->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticHwStat4->Location = System::Drawing::Point(250, 185);
			this->lbStaticHwStat4->Name = L"lbStaticHwStat4";
			this->lbStaticHwStat4->Size = System::Drawing::Size(13, 17);
			this->lbStaticHwStat4->TabIndex = 25;
			this->lbStaticHwStat4->Text = L"*";
			// 
			// lbStaticUnit4
			// 
			this->lbStaticUnit4->AutoSize = true;
			this->lbStaticUnit4->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticUnit4->Location = System::Drawing::Point(170, 185);
			this->lbStaticUnit4->Name = L"lbStaticUnit4";
			this->lbStaticUnit4->Size = System::Drawing::Size(13, 17);
			this->lbStaticUnit4->TabIndex = 24;
			this->lbStaticUnit4->Text = L"*";
			// 
			// lbStaticDigits4
			// 
			this->lbStaticDigits4->AutoSize = true;
			this->lbStaticDigits4->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticDigits4->Location = System::Drawing::Point(85, 185);
			this->lbStaticDigits4->Name = L"lbStaticDigits4";
			this->lbStaticDigits4->Size = System::Drawing::Size(13, 17);
			this->lbStaticDigits4->TabIndex = 23;
			this->lbStaticDigits4->Text = L"*";
			// 
			// lbStaticCh4
			// 
			this->lbStaticCh4->AutoSize = true;
			this->lbStaticCh4->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticCh4->Location = System::Drawing::Point(10, 185);
			this->lbStaticCh4->Name = L"lbStaticCh4";
			this->lbStaticCh4->Size = System::Drawing::Size(16, 17);
			this->lbStaticCh4->TabIndex = 22;
			this->lbStaticCh4->Text = L"4";
			// 
			// lbStaticHwStat3
			// 
			this->lbStaticHwStat3->AutoSize = true;
			this->lbStaticHwStat3->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticHwStat3->Location = System::Drawing::Point(250, 140);
			this->lbStaticHwStat3->Name = L"lbStaticHwStat3";
			this->lbStaticHwStat3->Size = System::Drawing::Size(13, 17);
			this->lbStaticHwStat3->TabIndex = 21;
			this->lbStaticHwStat3->Text = L"*";
			// 
			// lbStaticUnit3
			// 
			this->lbStaticUnit3->AutoSize = true;
			this->lbStaticUnit3->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticUnit3->Location = System::Drawing::Point(170, 140);
			this->lbStaticUnit3->Name = L"lbStaticUnit3";
			this->lbStaticUnit3->Size = System::Drawing::Size(13, 17);
			this->lbStaticUnit3->TabIndex = 20;
			this->lbStaticUnit3->Text = L"*";
			// 
			// lbStaticDigits3
			// 
			this->lbStaticDigits3->AutoSize = true;
			this->lbStaticDigits3->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticDigits3->Location = System::Drawing::Point(85, 140);
			this->lbStaticDigits3->Name = L"lbStaticDigits3";
			this->lbStaticDigits3->Size = System::Drawing::Size(13, 17);
			this->lbStaticDigits3->TabIndex = 19;
			this->lbStaticDigits3->Text = L"*";
			// 
			// lbStaticCh3
			// 
			this->lbStaticCh3->AutoSize = true;
			this->lbStaticCh3->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticCh3->Location = System::Drawing::Point(10, 140);
			this->lbStaticCh3->Name = L"lbStaticCh3";
			this->lbStaticCh3->Size = System::Drawing::Size(16, 17);
			this->lbStaticCh3->TabIndex = 18;
			this->lbStaticCh3->Text = L"3";
			// 
			// lbStaticHwStat2
			// 
			this->lbStaticHwStat2->AutoSize = true;
			this->lbStaticHwStat2->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticHwStat2->Location = System::Drawing::Point(250, 95);
			this->lbStaticHwStat2->Name = L"lbStaticHwStat2";
			this->lbStaticHwStat2->Size = System::Drawing::Size(13, 17);
			this->lbStaticHwStat2->TabIndex = 17;
			this->lbStaticHwStat2->Text = L"*";
			// 
			// lbStaticUnit2
			// 
			this->lbStaticUnit2->AutoSize = true;
			this->lbStaticUnit2->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticUnit2->Location = System::Drawing::Point(170, 95);
			this->lbStaticUnit2->Name = L"lbStaticUnit2";
			this->lbStaticUnit2->Size = System::Drawing::Size(13, 17);
			this->lbStaticUnit2->TabIndex = 16;
			this->lbStaticUnit2->Text = L"*";
			// 
			// lbStaticDigits2
			// 
			this->lbStaticDigits2->AutoSize = true;
			this->lbStaticDigits2->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticDigits2->Location = System::Drawing::Point(85, 95);
			this->lbStaticDigits2->Name = L"lbStaticDigits2";
			this->lbStaticDigits2->Size = System::Drawing::Size(13, 17);
			this->lbStaticDigits2->TabIndex = 15;
			this->lbStaticDigits2->Text = L"*";
			// 
			// lbStaticCh2
			// 
			this->lbStaticCh2->AutoSize = true;
			this->lbStaticCh2->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticCh2->Location = System::Drawing::Point(10, 95);
			this->lbStaticCh2->Name = L"lbStaticCh2";
			this->lbStaticCh2->Size = System::Drawing::Size(16, 17);
			this->lbStaticCh2->TabIndex = 14;
			this->lbStaticCh2->Text = L"2";
			// 
			// lbStaticHwStat1
			// 
			this->lbStaticHwStat1->AutoSize = true;
			this->lbStaticHwStat1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticHwStat1->Location = System::Drawing::Point(250, 55);
			this->lbStaticHwStat1->Name = L"lbStaticHwStat1";
			this->lbStaticHwStat1->Size = System::Drawing::Size(13, 17);
			this->lbStaticHwStat1->TabIndex = 13;
			this->lbStaticHwStat1->Text = L"*";
			// 
			// lbStaticUnit1
			// 
			this->lbStaticUnit1->AutoSize = true;
			this->lbStaticUnit1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticUnit1->Location = System::Drawing::Point(170, 55);
			this->lbStaticUnit1->Name = L"lbStaticUnit1";
			this->lbStaticUnit1->Size = System::Drawing::Size(13, 17);
			this->lbStaticUnit1->TabIndex = 12;
			this->lbStaticUnit1->Text = L"*";
			// 
			// lbStaticDigits1
			// 
			this->lbStaticDigits1->AutoSize = true;
			this->lbStaticDigits1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticDigits1->Location = System::Drawing::Point(85, 55);
			this->lbStaticDigits1->Name = L"lbStaticDigits1";
			this->lbStaticDigits1->Size = System::Drawing::Size(13, 17);
			this->lbStaticDigits1->TabIndex = 11;
			this->lbStaticDigits1->Text = L"*";
			// 
			// lbStaticCh1
			// 
			this->lbStaticCh1->AutoSize = true;
			this->lbStaticCh1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbStaticCh1->Location = System::Drawing::Point(10, 55);
			this->lbStaticCh1->Name = L"lbStaticCh1";
			this->lbStaticCh1->Size = System::Drawing::Size(16, 17);
			this->lbStaticCh1->TabIndex = 10;
			this->lbStaticCh1->Text = L"1";
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->label4->Location = System::Drawing::Point(250, 19);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(109, 17);
			this->label4->TabIndex = 9;
			this->label4->Text = L"HardwareStatus";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->label3->Location = System::Drawing::Point(170, 19);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(33, 17);
			this->label3->TabIndex = 8;
			this->label3->Text = L"Unit";
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->label2->Location = System::Drawing::Point(85, 19);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(43, 17);
			this->label2->TabIndex = 7;
			this->label2->Text = L"Digits";
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->label1->Location = System::Drawing::Point(10, 19);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(60, 17);
			this->label1->TabIndex = 6;
			this->label1->Text = L"Channel";
			// 
			// groupBox1
			// 
			this->groupBox1->Location = System::Drawing::Point(725, 6);
			this->groupBox1->Name = L"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(5, 386);
			this->groupBox1->TabIndex = 4;
			this->groupBox1->TabStop = false;
			// 
			// rbStaticCH25_32
			// 
			this->rbStaticCH25_32->AutoSize = true;
			this->rbStaticCH25_32->Location = System::Drawing::Point(739, 124);
			this->rbStaticCH25_32->Name = L"rbStaticCH25_32";
			this->rbStaticCH25_32->Size = System::Drawing::Size(97, 17);
			this->rbStaticCH25_32->TabIndex = 3;
			this->rbStaticCH25_32->Text = L"Channel 25..32";
			this->rbStaticCH25_32->UseVisualStyleBackColor = true;
			this->rbStaticCH25_32->CheckedChanged += gcnew System::EventHandler(this, &Form1::rbStaticCH1_8_CheckedChanged);
			// 
			// rbStaticCH17_24
			// 
			this->rbStaticCH17_24->AutoSize = true;
			this->rbStaticCH17_24->Location = System::Drawing::Point(739, 101);
			this->rbStaticCH17_24->Name = L"rbStaticCH17_24";
			this->rbStaticCH17_24->Size = System::Drawing::Size(97, 17);
			this->rbStaticCH17_24->TabIndex = 2;
			this->rbStaticCH17_24->Text = L"Channel 17..24";
			this->rbStaticCH17_24->UseVisualStyleBackColor = true;
			this->rbStaticCH17_24->CheckedChanged += gcnew System::EventHandler(this, &Form1::rbStaticCH1_8_CheckedChanged);
			// 
			// rbStaticCH9_16
			// 
			this->rbStaticCH9_16->AutoSize = true;
			this->rbStaticCH9_16->Location = System::Drawing::Point(739, 78);
			this->rbStaticCH9_16->Name = L"rbStaticCH9_16";
			this->rbStaticCH9_16->Size = System::Drawing::Size(91, 17);
			this->rbStaticCH9_16->TabIndex = 1;
			this->rbStaticCH9_16->Text = L"Channel 9..16";
			this->rbStaticCH9_16->UseVisualStyleBackColor = true;
			this->rbStaticCH9_16->CheckedChanged += gcnew System::EventHandler(this, &Form1::rbStaticCH1_8_CheckedChanged);
			// 
			// rbStaticCH1_8
			// 
			this->rbStaticCH1_8->AutoSize = true;
			this->rbStaticCH1_8->Checked = true;
			this->rbStaticCH1_8->Location = System::Drawing::Point(739, 55);
			this->rbStaticCH1_8->Name = L"rbStaticCH1_8";
			this->rbStaticCH1_8->Size = System::Drawing::Size(85, 17);
			this->rbStaticCH1_8->TabIndex = 0;
			this->rbStaticCH1_8->TabStop = true;
			this->rbStaticCH1_8->Text = L"Channel 1..8";
			this->rbStaticCH1_8->UseVisualStyleBackColor = true;
			this->rbStaticCH1_8->CheckedChanged += gcnew System::EventHandler(this, &Form1::rbStaticCH1_8_CheckedChanged);
			// 
			// tbDigi
			// 
			this->tbDigi->Controls->Add(this->lbDInUpdates);
			this->tbDigi->Controls->Add(this->groupBox3);
			this->tbDigi->Controls->Add(this->groupBox2);
			this->tbDigi->Location = System::Drawing::Point(4, 22);
			this->tbDigi->Name = L"tbDigi";
			this->tbDigi->Padding = System::Windows::Forms::Padding(3);
			this->tbDigi->Size = System::Drawing::Size(865, 401);
			this->tbDigi->TabIndex = 4;
			this->tbDigi->Text = L"Digital I/O";
			this->tbDigi->UseVisualStyleBackColor = true;
			// 
			// lbDInUpdates
			// 
			this->lbDInUpdates->AutoSize = true;
			this->lbDInUpdates->Location = System::Drawing::Point(13, 378);
			this->lbDInUpdates->Name = L"lbDInUpdates";
			this->lbDInUpdates->Size = System::Drawing::Size(56, 13);
			this->lbDInUpdates->TabIndex = 74;
			this->lbDInUpdates->Text = L"0 Updates";
			// 
			// groupBox3
			// 
			this->groupBox3->Controls->Add(this->btnDigiEnableOutputWrite);
			this->groupBox3->Controls->Add(this->cbDOut_128);
			this->groupBox3->Controls->Add(this->cbDOut_127);
			this->groupBox3->Controls->Add(this->cbDOut_126);
			this->groupBox3->Controls->Add(this->cbDOut_125);
			this->groupBox3->Controls->Add(this->cbDOut_124);
			this->groupBox3->Controls->Add(this->cbDOut_123);
			this->groupBox3->Controls->Add(this->cbDOut_122);
			this->groupBox3->Controls->Add(this->cbDOut_121);
			this->groupBox3->Controls->Add(this->cbDOut_120);
			this->groupBox3->Controls->Add(this->cbDOut_119);
			this->groupBox3->Controls->Add(this->cbDOut_118);
			this->groupBox3->Controls->Add(this->cbDOut_117);
			this->groupBox3->Controls->Add(this->cbDOut_116);
			this->groupBox3->Controls->Add(this->cbDOut_115);
			this->groupBox3->Controls->Add(this->cbDOut_114);
			this->groupBox3->Controls->Add(this->cbDOut_113);
			this->groupBox3->Controls->Add(this->cbDOut_112);
			this->groupBox3->Controls->Add(this->cbDOut_111);
			this->groupBox3->Controls->Add(this->cbDOut_110);
			this->groupBox3->Controls->Add(this->cbDOut_109);
			this->groupBox3->Controls->Add(this->cbDOut_108);
			this->groupBox3->Controls->Add(this->cbDOut_107);
			this->groupBox3->Controls->Add(this->cbDOut_106);
			this->groupBox3->Controls->Add(this->cbDOut_105);
			this->groupBox3->Controls->Add(this->cbDOut_104);
			this->groupBox3->Controls->Add(this->cbDOut_103);
			this->groupBox3->Controls->Add(this->cbDOut_102);
			this->groupBox3->Controls->Add(this->cbDOut_101);
			this->groupBox3->Controls->Add(this->cbDOut_100);
			this->groupBox3->Controls->Add(this->cbDOut_99);
			this->groupBox3->Controls->Add(this->cbDOut_98);
			this->groupBox3->Controls->Add(this->cbDOut_97);
			this->groupBox3->Controls->Add(this->cbDOut_96);
			this->groupBox3->Controls->Add(this->cbDOut_95);
			this->groupBox3->Controls->Add(this->cbDOut_94);
			this->groupBox3->Controls->Add(this->cbDOut_93);
			this->groupBox3->Controls->Add(this->cbDOut_92);
			this->groupBox3->Controls->Add(this->cbDOut_91);
			this->groupBox3->Controls->Add(this->cbDOut_90);
			this->groupBox3->Controls->Add(this->cbDOut_89);
			this->groupBox3->Controls->Add(this->cbDOut_88);
			this->groupBox3->Controls->Add(this->cbDOut_87);
			this->groupBox3->Controls->Add(this->cbDOut_86);
			this->groupBox3->Controls->Add(this->cbDOut_85);
			this->groupBox3->Controls->Add(this->cbDOut_84);
			this->groupBox3->Controls->Add(this->cbDOut_83);
			this->groupBox3->Controls->Add(this->cbDOut_82);
			this->groupBox3->Controls->Add(this->cbDOut_81);
			this->groupBox3->Controls->Add(this->cbDOut_80);
			this->groupBox3->Controls->Add(this->cbDOut_79);
			this->groupBox3->Controls->Add(this->cbDOut_78);
			this->groupBox3->Controls->Add(this->cbDOut_77);
			this->groupBox3->Controls->Add(this->cbDOut_76);
			this->groupBox3->Controls->Add(this->cbDOut_75);
			this->groupBox3->Controls->Add(this->cbDOut_74);
			this->groupBox3->Controls->Add(this->cbDOut_73);
			this->groupBox3->Controls->Add(this->cbDOut_72);
			this->groupBox3->Controls->Add(this->cbDOut_71);
			this->groupBox3->Controls->Add(this->cbDOut_70);
			this->groupBox3->Controls->Add(this->cbDOut_69);
			this->groupBox3->Controls->Add(this->cbDOut_68);
			this->groupBox3->Controls->Add(this->cbDOut_67);
			this->groupBox3->Controls->Add(this->cbDOut_66);
			this->groupBox3->Controls->Add(this->cbDOut_65);
			this->groupBox3->Controls->Add(this->cbDOut_64);
			this->groupBox3->Controls->Add(this->cbDOut_63);
			this->groupBox3->Controls->Add(this->cbDOut_62);
			this->groupBox3->Controls->Add(this->cbDOut_61);
			this->groupBox3->Controls->Add(this->cbDOut_60);
			this->groupBox3->Controls->Add(this->cbDOut_59);
			this->groupBox3->Controls->Add(this->cbDOut_58);
			this->groupBox3->Controls->Add(this->cbDOut_57);
			this->groupBox3->Controls->Add(this->cbDOut_56);
			this->groupBox3->Controls->Add(this->cbDOut_55);
			this->groupBox3->Controls->Add(this->cbDOut_54);
			this->groupBox3->Controls->Add(this->cbDOut_53);
			this->groupBox3->Controls->Add(this->cbDOut_52);
			this->groupBox3->Controls->Add(this->cbDOut_51);
			this->groupBox3->Controls->Add(this->cbDOut_50);
			this->groupBox3->Controls->Add(this->cbDOut_49);
			this->groupBox3->Controls->Add(this->cbDOut_48);
			this->groupBox3->Controls->Add(this->cbDOut_47);
			this->groupBox3->Controls->Add(this->cbDOut_46);
			this->groupBox3->Controls->Add(this->cbDOut_45);
			this->groupBox3->Controls->Add(this->cbDOut_44);
			this->groupBox3->Controls->Add(this->cbDOut_43);
			this->groupBox3->Controls->Add(this->cbDOut_42);
			this->groupBox3->Controls->Add(this->cbDOut_41);
			this->groupBox3->Controls->Add(this->cbDOut_40);
			this->groupBox3->Controls->Add(this->cbDOut_39);
			this->groupBox3->Controls->Add(this->cbDOut_38);
			this->groupBox3->Controls->Add(this->cbDOut_37);
			this->groupBox3->Controls->Add(this->cbDOut_36);
			this->groupBox3->Controls->Add(this->cbDOut_35);
			this->groupBox3->Controls->Add(this->cbDOut_34);
			this->groupBox3->Controls->Add(this->cbDOut_33);
			this->groupBox3->Controls->Add(this->cbDOut_32);
			this->groupBox3->Controls->Add(this->cbDOut_31);
			this->groupBox3->Controls->Add(this->cbDOut_30);
			this->groupBox3->Controls->Add(this->cbDOut_29);
			this->groupBox3->Controls->Add(this->cbDOut_28);
			this->groupBox3->Controls->Add(this->cbDOut_27);
			this->groupBox3->Controls->Add(this->cbDOut_26);
			this->groupBox3->Controls->Add(this->cbDOut_25);
			this->groupBox3->Controls->Add(this->cbDOut_24);
			this->groupBox3->Controls->Add(this->cbDOut_23);
			this->groupBox3->Controls->Add(this->cbDOut_22);
			this->groupBox3->Controls->Add(this->cbDOut_21);
			this->groupBox3->Controls->Add(this->cbDOut_20);
			this->groupBox3->Controls->Add(this->cbDOut_19);
			this->groupBox3->Controls->Add(this->cbDOut_18);
			this->groupBox3->Controls->Add(this->cbDOut_17);
			this->groupBox3->Controls->Add(this->cbDOut_16);
			this->groupBox3->Controls->Add(this->cbDOut_15);
			this->groupBox3->Controls->Add(this->cbDOut_14);
			this->groupBox3->Controls->Add(this->cbDOut_13);
			this->groupBox3->Controls->Add(this->cbDOut_12);
			this->groupBox3->Controls->Add(this->cbDOut_11);
			this->groupBox3->Controls->Add(this->cbDOut_10);
			this->groupBox3->Controls->Add(this->cbDOut_9);
			this->groupBox3->Controls->Add(this->cbDOut_8);
			this->groupBox3->Controls->Add(this->cbDOut_7);
			this->groupBox3->Controls->Add(this->cbDOut_6);
			this->groupBox3->Controls->Add(this->cbDOut_5);
			this->groupBox3->Controls->Add(this->cbDOut_4);
			this->groupBox3->Controls->Add(this->cbDOut_3);
			this->groupBox3->Controls->Add(this->cbDOut_2);
			this->groupBox3->Controls->Add(this->cbDOut_1);
			this->groupBox3->Location = System::Drawing::Point(435, 6);
			this->groupBox3->Name = L"groupBox3";
			this->groupBox3->Size = System::Drawing::Size(424, 389);
			this->groupBox3->TabIndex = 1;
			this->groupBox3->TabStop = false;
			this->groupBox3->Text = L"Digital Outputs";
			// 
			// btnDigiEnableOutputWrite
			// 
			this->btnDigiEnableOutputWrite->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Bold,
				System::Drawing::GraphicsUnit::Point, static_cast<System::Byte>(0)));
			this->btnDigiEnableOutputWrite->ForeColor = System::Drawing::Color::Red;
			this->btnDigiEnableOutputWrite->Location = System::Drawing::Point(7, 360);
			this->btnDigiEnableOutputWrite->Name = L"btnDigiEnableOutputWrite";
			this->btnDigiEnableOutputWrite->Size = System::Drawing::Size(408, 23);
			this->btnDigiEnableOutputWrite->TabIndex = 128;
			this->btnDigiEnableOutputWrite->Text = L"Click to ENABLE writing output data to device";
			this->btnDigiEnableOutputWrite->UseVisualStyleBackColor = true;
			this->btnDigiEnableOutputWrite->Click += gcnew System::EventHandler(this, &Form1::btnDigiEnableOutputWrite_Click);
			// 
			// cbDOut_128
			// 
			this->cbDOut_128->AutoSize = true;
			this->cbDOut_128->Location = System::Drawing::Point(371, 336);
			this->cbDOut_128->Name = L"cbDOut_128";
			this->cbDOut_128->Size = System::Drawing::Size(44, 17);
			this->cbDOut_128->TabIndex = 127;
			this->cbDOut_128->Text = L"128";
			this->cbDOut_128->UseVisualStyleBackColor = true;
			this->cbDOut_128->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_127
			// 
			this->cbDOut_127->AutoSize = true;
			this->cbDOut_127->Location = System::Drawing::Point(371, 316);
			this->cbDOut_127->Name = L"cbDOut_127";
			this->cbDOut_127->Size = System::Drawing::Size(44, 17);
			this->cbDOut_127->TabIndex = 126;
			this->cbDOut_127->Text = L"127";
			this->cbDOut_127->UseVisualStyleBackColor = true;
			this->cbDOut_127->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_126
			// 
			this->cbDOut_126->AutoSize = true;
			this->cbDOut_126->Location = System::Drawing::Point(371, 296);
			this->cbDOut_126->Name = L"cbDOut_126";
			this->cbDOut_126->Size = System::Drawing::Size(44, 17);
			this->cbDOut_126->TabIndex = 125;
			this->cbDOut_126->Text = L"126";
			this->cbDOut_126->UseVisualStyleBackColor = true;
			this->cbDOut_126->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_125
			// 
			this->cbDOut_125->AutoSize = true;
			this->cbDOut_125->Location = System::Drawing::Point(371, 276);
			this->cbDOut_125->Name = L"cbDOut_125";
			this->cbDOut_125->Size = System::Drawing::Size(44, 17);
			this->cbDOut_125->TabIndex = 124;
			this->cbDOut_125->Text = L"125";
			this->cbDOut_125->UseVisualStyleBackColor = true;
			this->cbDOut_125->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_124
			// 
			this->cbDOut_124->AutoSize = true;
			this->cbDOut_124->Location = System::Drawing::Point(371, 256);
			this->cbDOut_124->Name = L"cbDOut_124";
			this->cbDOut_124->Size = System::Drawing::Size(44, 17);
			this->cbDOut_124->TabIndex = 123;
			this->cbDOut_124->Text = L"124";
			this->cbDOut_124->UseVisualStyleBackColor = true;
			this->cbDOut_124->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_123
			// 
			this->cbDOut_123->AutoSize = true;
			this->cbDOut_123->Location = System::Drawing::Point(371, 236);
			this->cbDOut_123->Name = L"cbDOut_123";
			this->cbDOut_123->Size = System::Drawing::Size(44, 17);
			this->cbDOut_123->TabIndex = 122;
			this->cbDOut_123->Text = L"123";
			this->cbDOut_123->UseVisualStyleBackColor = true;
			this->cbDOut_123->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_122
			// 
			this->cbDOut_122->AutoSize = true;
			this->cbDOut_122->Location = System::Drawing::Point(371, 216);
			this->cbDOut_122->Name = L"cbDOut_122";
			this->cbDOut_122->Size = System::Drawing::Size(44, 17);
			this->cbDOut_122->TabIndex = 121;
			this->cbDOut_122->Text = L"122";
			this->cbDOut_122->UseVisualStyleBackColor = true;
			this->cbDOut_122->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_121
			// 
			this->cbDOut_121->AutoSize = true;
			this->cbDOut_121->Location = System::Drawing::Point(371, 196);
			this->cbDOut_121->Name = L"cbDOut_121";
			this->cbDOut_121->Size = System::Drawing::Size(44, 17);
			this->cbDOut_121->TabIndex = 120;
			this->cbDOut_121->Text = L"121";
			this->cbDOut_121->UseVisualStyleBackColor = true;
			this->cbDOut_121->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_120
			// 
			this->cbDOut_120->AutoSize = true;
			this->cbDOut_120->Location = System::Drawing::Point(371, 160);
			this->cbDOut_120->Name = L"cbDOut_120";
			this->cbDOut_120->Size = System::Drawing::Size(44, 17);
			this->cbDOut_120->TabIndex = 119;
			this->cbDOut_120->Text = L"120";
			this->cbDOut_120->UseVisualStyleBackColor = true;
			this->cbDOut_120->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_119
			// 
			this->cbDOut_119->AutoSize = true;
			this->cbDOut_119->Location = System::Drawing::Point(371, 140);
			this->cbDOut_119->Name = L"cbDOut_119";
			this->cbDOut_119->Size = System::Drawing::Size(44, 17);
			this->cbDOut_119->TabIndex = 118;
			this->cbDOut_119->Text = L"119";
			this->cbDOut_119->UseVisualStyleBackColor = true;
			this->cbDOut_119->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_118
			// 
			this->cbDOut_118->AutoSize = true;
			this->cbDOut_118->Location = System::Drawing::Point(371, 120);
			this->cbDOut_118->Name = L"cbDOut_118";
			this->cbDOut_118->Size = System::Drawing::Size(44, 17);
			this->cbDOut_118->TabIndex = 117;
			this->cbDOut_118->Text = L"118";
			this->cbDOut_118->UseVisualStyleBackColor = true;
			this->cbDOut_118->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_117
			// 
			this->cbDOut_117->AutoSize = true;
			this->cbDOut_117->Location = System::Drawing::Point(371, 100);
			this->cbDOut_117->Name = L"cbDOut_117";
			this->cbDOut_117->Size = System::Drawing::Size(44, 17);
			this->cbDOut_117->TabIndex = 116;
			this->cbDOut_117->Text = L"117";
			this->cbDOut_117->UseVisualStyleBackColor = true;
			this->cbDOut_117->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_116
			// 
			this->cbDOut_116->AutoSize = true;
			this->cbDOut_116->Location = System::Drawing::Point(371, 80);
			this->cbDOut_116->Name = L"cbDOut_116";
			this->cbDOut_116->Size = System::Drawing::Size(44, 17);
			this->cbDOut_116->TabIndex = 115;
			this->cbDOut_116->Text = L"116";
			this->cbDOut_116->UseVisualStyleBackColor = true;
			this->cbDOut_116->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_115
			// 
			this->cbDOut_115->AutoSize = true;
			this->cbDOut_115->Location = System::Drawing::Point(371, 60);
			this->cbDOut_115->Name = L"cbDOut_115";
			this->cbDOut_115->Size = System::Drawing::Size(44, 17);
			this->cbDOut_115->TabIndex = 114;
			this->cbDOut_115->Text = L"115";
			this->cbDOut_115->UseVisualStyleBackColor = true;
			this->cbDOut_115->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_114
			// 
			this->cbDOut_114->AutoSize = true;
			this->cbDOut_114->Location = System::Drawing::Point(371, 40);
			this->cbDOut_114->Name = L"cbDOut_114";
			this->cbDOut_114->Size = System::Drawing::Size(44, 17);
			this->cbDOut_114->TabIndex = 113;
			this->cbDOut_114->Text = L"114";
			this->cbDOut_114->UseVisualStyleBackColor = true;
			this->cbDOut_114->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_113
			// 
			this->cbDOut_113->AutoSize = true;
			this->cbDOut_113->Location = System::Drawing::Point(371, 20);
			this->cbDOut_113->Name = L"cbDOut_113";
			this->cbDOut_113->Size = System::Drawing::Size(44, 17);
			this->cbDOut_113->TabIndex = 112;
			this->cbDOut_113->Text = L"113";
			this->cbDOut_113->UseVisualStyleBackColor = true;
			this->cbDOut_113->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_112
			// 
			this->cbDOut_112->AutoSize = true;
			this->cbDOut_112->Location = System::Drawing::Point(319, 336);
			this->cbDOut_112->Name = L"cbDOut_112";
			this->cbDOut_112->Size = System::Drawing::Size(44, 17);
			this->cbDOut_112->TabIndex = 111;
			this->cbDOut_112->Text = L"112";
			this->cbDOut_112->UseVisualStyleBackColor = true;
			this->cbDOut_112->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_111
			// 
			this->cbDOut_111->AutoSize = true;
			this->cbDOut_111->Location = System::Drawing::Point(319, 316);
			this->cbDOut_111->Name = L"cbDOut_111";
			this->cbDOut_111->Size = System::Drawing::Size(44, 17);
			this->cbDOut_111->TabIndex = 110;
			this->cbDOut_111->Text = L"111";
			this->cbDOut_111->UseVisualStyleBackColor = true;
			this->cbDOut_111->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_110
			// 
			this->cbDOut_110->AutoSize = true;
			this->cbDOut_110->Location = System::Drawing::Point(319, 296);
			this->cbDOut_110->Name = L"cbDOut_110";
			this->cbDOut_110->Size = System::Drawing::Size(44, 17);
			this->cbDOut_110->TabIndex = 109;
			this->cbDOut_110->Text = L"110";
			this->cbDOut_110->UseVisualStyleBackColor = true;
			this->cbDOut_110->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_109
			// 
			this->cbDOut_109->AutoSize = true;
			this->cbDOut_109->Location = System::Drawing::Point(319, 276);
			this->cbDOut_109->Name = L"cbDOut_109";
			this->cbDOut_109->Size = System::Drawing::Size(44, 17);
			this->cbDOut_109->TabIndex = 108;
			this->cbDOut_109->Text = L"109";
			this->cbDOut_109->UseVisualStyleBackColor = true;
			this->cbDOut_109->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_108
			// 
			this->cbDOut_108->AutoSize = true;
			this->cbDOut_108->Location = System::Drawing::Point(319, 256);
			this->cbDOut_108->Name = L"cbDOut_108";
			this->cbDOut_108->Size = System::Drawing::Size(44, 17);
			this->cbDOut_108->TabIndex = 107;
			this->cbDOut_108->Text = L"108";
			this->cbDOut_108->UseVisualStyleBackColor = true;
			this->cbDOut_108->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_107
			// 
			this->cbDOut_107->AutoSize = true;
			this->cbDOut_107->Location = System::Drawing::Point(319, 236);
			this->cbDOut_107->Name = L"cbDOut_107";
			this->cbDOut_107->Size = System::Drawing::Size(44, 17);
			this->cbDOut_107->TabIndex = 106;
			this->cbDOut_107->Text = L"107";
			this->cbDOut_107->UseVisualStyleBackColor = true;
			this->cbDOut_107->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_106
			// 
			this->cbDOut_106->AutoSize = true;
			this->cbDOut_106->Location = System::Drawing::Point(319, 216);
			this->cbDOut_106->Name = L"cbDOut_106";
			this->cbDOut_106->Size = System::Drawing::Size(44, 17);
			this->cbDOut_106->TabIndex = 105;
			this->cbDOut_106->Text = L"106";
			this->cbDOut_106->UseVisualStyleBackColor = true;
			this->cbDOut_106->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_105
			// 
			this->cbDOut_105->AutoSize = true;
			this->cbDOut_105->Location = System::Drawing::Point(319, 196);
			this->cbDOut_105->Name = L"cbDOut_105";
			this->cbDOut_105->Size = System::Drawing::Size(44, 17);
			this->cbDOut_105->TabIndex = 104;
			this->cbDOut_105->Text = L"105";
			this->cbDOut_105->UseVisualStyleBackColor = true;
			this->cbDOut_105->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_104
			// 
			this->cbDOut_104->AutoSize = true;
			this->cbDOut_104->Location = System::Drawing::Point(319, 160);
			this->cbDOut_104->Name = L"cbDOut_104";
			this->cbDOut_104->Size = System::Drawing::Size(44, 17);
			this->cbDOut_104->TabIndex = 103;
			this->cbDOut_104->Text = L"104";
			this->cbDOut_104->UseVisualStyleBackColor = true;
			this->cbDOut_104->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_103
			// 
			this->cbDOut_103->AutoSize = true;
			this->cbDOut_103->Location = System::Drawing::Point(319, 140);
			this->cbDOut_103->Name = L"cbDOut_103";
			this->cbDOut_103->Size = System::Drawing::Size(44, 17);
			this->cbDOut_103->TabIndex = 102;
			this->cbDOut_103->Text = L"103";
			this->cbDOut_103->UseVisualStyleBackColor = true;
			this->cbDOut_103->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_102
			// 
			this->cbDOut_102->AutoSize = true;
			this->cbDOut_102->Location = System::Drawing::Point(319, 120);
			this->cbDOut_102->Name = L"cbDOut_102";
			this->cbDOut_102->Size = System::Drawing::Size(44, 17);
			this->cbDOut_102->TabIndex = 101;
			this->cbDOut_102->Text = L"102";
			this->cbDOut_102->UseVisualStyleBackColor = true;
			this->cbDOut_102->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_101
			// 
			this->cbDOut_101->AutoSize = true;
			this->cbDOut_101->Location = System::Drawing::Point(319, 100);
			this->cbDOut_101->Name = L"cbDOut_101";
			this->cbDOut_101->Size = System::Drawing::Size(44, 17);
			this->cbDOut_101->TabIndex = 100;
			this->cbDOut_101->Text = L"101";
			this->cbDOut_101->UseVisualStyleBackColor = true;
			this->cbDOut_101->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_100
			// 
			this->cbDOut_100->AutoSize = true;
			this->cbDOut_100->Location = System::Drawing::Point(319, 80);
			this->cbDOut_100->Name = L"cbDOut_100";
			this->cbDOut_100->Size = System::Drawing::Size(44, 17);
			this->cbDOut_100->TabIndex = 99;
			this->cbDOut_100->Text = L"100";
			this->cbDOut_100->UseVisualStyleBackColor = true;
			this->cbDOut_100->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_99
			// 
			this->cbDOut_99->AutoSize = true;
			this->cbDOut_99->Location = System::Drawing::Point(319, 60);
			this->cbDOut_99->Name = L"cbDOut_99";
			this->cbDOut_99->Size = System::Drawing::Size(38, 17);
			this->cbDOut_99->TabIndex = 98;
			this->cbDOut_99->Text = L"99";
			this->cbDOut_99->UseVisualStyleBackColor = true;
			this->cbDOut_99->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_98
			// 
			this->cbDOut_98->AutoSize = true;
			this->cbDOut_98->Location = System::Drawing::Point(319, 40);
			this->cbDOut_98->Name = L"cbDOut_98";
			this->cbDOut_98->Size = System::Drawing::Size(38, 17);
			this->cbDOut_98->TabIndex = 97;
			this->cbDOut_98->Text = L"98";
			this->cbDOut_98->UseVisualStyleBackColor = true;
			this->cbDOut_98->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_97
			// 
			this->cbDOut_97->AutoSize = true;
			this->cbDOut_97->Location = System::Drawing::Point(319, 20);
			this->cbDOut_97->Name = L"cbDOut_97";
			this->cbDOut_97->Size = System::Drawing::Size(38, 17);
			this->cbDOut_97->TabIndex = 96;
			this->cbDOut_97->Text = L"97";
			this->cbDOut_97->UseVisualStyleBackColor = true;
			this->cbDOut_97->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_96
			// 
			this->cbDOut_96->AutoSize = true;
			this->cbDOut_96->Location = System::Drawing::Point(267, 336);
			this->cbDOut_96->Name = L"cbDOut_96";
			this->cbDOut_96->Size = System::Drawing::Size(38, 17);
			this->cbDOut_96->TabIndex = 95;
			this->cbDOut_96->Text = L"96";
			this->cbDOut_96->UseVisualStyleBackColor = true;
			this->cbDOut_96->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_95
			// 
			this->cbDOut_95->AutoSize = true;
			this->cbDOut_95->Location = System::Drawing::Point(267, 316);
			this->cbDOut_95->Name = L"cbDOut_95";
			this->cbDOut_95->Size = System::Drawing::Size(38, 17);
			this->cbDOut_95->TabIndex = 94;
			this->cbDOut_95->Text = L"95";
			this->cbDOut_95->UseVisualStyleBackColor = true;
			this->cbDOut_95->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_94
			// 
			this->cbDOut_94->AutoSize = true;
			this->cbDOut_94->Location = System::Drawing::Point(267, 296);
			this->cbDOut_94->Name = L"cbDOut_94";
			this->cbDOut_94->Size = System::Drawing::Size(38, 17);
			this->cbDOut_94->TabIndex = 93;
			this->cbDOut_94->Text = L"94";
			this->cbDOut_94->UseVisualStyleBackColor = true;
			this->cbDOut_94->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_93
			// 
			this->cbDOut_93->AutoSize = true;
			this->cbDOut_93->Location = System::Drawing::Point(267, 276);
			this->cbDOut_93->Name = L"cbDOut_93";
			this->cbDOut_93->Size = System::Drawing::Size(38, 17);
			this->cbDOut_93->TabIndex = 92;
			this->cbDOut_93->Text = L"93";
			this->cbDOut_93->UseVisualStyleBackColor = true;
			this->cbDOut_93->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_92
			// 
			this->cbDOut_92->AutoSize = true;
			this->cbDOut_92->Location = System::Drawing::Point(267, 256);
			this->cbDOut_92->Name = L"cbDOut_92";
			this->cbDOut_92->Size = System::Drawing::Size(38, 17);
			this->cbDOut_92->TabIndex = 91;
			this->cbDOut_92->Text = L"92";
			this->cbDOut_92->UseVisualStyleBackColor = true;
			this->cbDOut_92->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_91
			// 
			this->cbDOut_91->AutoSize = true;
			this->cbDOut_91->Location = System::Drawing::Point(267, 236);
			this->cbDOut_91->Name = L"cbDOut_91";
			this->cbDOut_91->Size = System::Drawing::Size(38, 17);
			this->cbDOut_91->TabIndex = 90;
			this->cbDOut_91->Text = L"91";
			this->cbDOut_91->UseVisualStyleBackColor = true;
			this->cbDOut_91->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_90
			// 
			this->cbDOut_90->AutoSize = true;
			this->cbDOut_90->Location = System::Drawing::Point(267, 216);
			this->cbDOut_90->Name = L"cbDOut_90";
			this->cbDOut_90->Size = System::Drawing::Size(38, 17);
			this->cbDOut_90->TabIndex = 89;
			this->cbDOut_90->Text = L"90";
			this->cbDOut_90->UseVisualStyleBackColor = true;
			this->cbDOut_90->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_89
			// 
			this->cbDOut_89->AutoSize = true;
			this->cbDOut_89->Location = System::Drawing::Point(267, 196);
			this->cbDOut_89->Name = L"cbDOut_89";
			this->cbDOut_89->Size = System::Drawing::Size(38, 17);
			this->cbDOut_89->TabIndex = 88;
			this->cbDOut_89->Text = L"89";
			this->cbDOut_89->UseVisualStyleBackColor = true;
			this->cbDOut_89->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_88
			// 
			this->cbDOut_88->AutoSize = true;
			this->cbDOut_88->Location = System::Drawing::Point(267, 160);
			this->cbDOut_88->Name = L"cbDOut_88";
			this->cbDOut_88->Size = System::Drawing::Size(38, 17);
			this->cbDOut_88->TabIndex = 87;
			this->cbDOut_88->Text = L"88";
			this->cbDOut_88->UseVisualStyleBackColor = true;
			this->cbDOut_88->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_87
			// 
			this->cbDOut_87->AutoSize = true;
			this->cbDOut_87->Location = System::Drawing::Point(267, 140);
			this->cbDOut_87->Name = L"cbDOut_87";
			this->cbDOut_87->Size = System::Drawing::Size(38, 17);
			this->cbDOut_87->TabIndex = 86;
			this->cbDOut_87->Text = L"87";
			this->cbDOut_87->UseVisualStyleBackColor = true;
			this->cbDOut_87->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_86
			// 
			this->cbDOut_86->AutoSize = true;
			this->cbDOut_86->Location = System::Drawing::Point(267, 120);
			this->cbDOut_86->Name = L"cbDOut_86";
			this->cbDOut_86->Size = System::Drawing::Size(38, 17);
			this->cbDOut_86->TabIndex = 85;
			this->cbDOut_86->Text = L"86";
			this->cbDOut_86->UseVisualStyleBackColor = true;
			this->cbDOut_86->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_85
			// 
			this->cbDOut_85->AutoSize = true;
			this->cbDOut_85->Location = System::Drawing::Point(267, 100);
			this->cbDOut_85->Name = L"cbDOut_85";
			this->cbDOut_85->Size = System::Drawing::Size(38, 17);
			this->cbDOut_85->TabIndex = 84;
			this->cbDOut_85->Text = L"85";
			this->cbDOut_85->UseVisualStyleBackColor = true;
			this->cbDOut_85->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_84
			// 
			this->cbDOut_84->AutoSize = true;
			this->cbDOut_84->Location = System::Drawing::Point(267, 80);
			this->cbDOut_84->Name = L"cbDOut_84";
			this->cbDOut_84->Size = System::Drawing::Size(38, 17);
			this->cbDOut_84->TabIndex = 83;
			this->cbDOut_84->Text = L"84";
			this->cbDOut_84->UseVisualStyleBackColor = true;
			this->cbDOut_84->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_83
			// 
			this->cbDOut_83->AutoSize = true;
			this->cbDOut_83->Location = System::Drawing::Point(267, 60);
			this->cbDOut_83->Name = L"cbDOut_83";
			this->cbDOut_83->Size = System::Drawing::Size(38, 17);
			this->cbDOut_83->TabIndex = 82;
			this->cbDOut_83->Text = L"83";
			this->cbDOut_83->UseVisualStyleBackColor = true;
			this->cbDOut_83->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_82
			// 
			this->cbDOut_82->AutoSize = true;
			this->cbDOut_82->Location = System::Drawing::Point(267, 40);
			this->cbDOut_82->Name = L"cbDOut_82";
			this->cbDOut_82->Size = System::Drawing::Size(38, 17);
			this->cbDOut_82->TabIndex = 81;
			this->cbDOut_82->Text = L"82";
			this->cbDOut_82->UseVisualStyleBackColor = true;
			this->cbDOut_82->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_81
			// 
			this->cbDOut_81->AutoSize = true;
			this->cbDOut_81->Location = System::Drawing::Point(267, 20);
			this->cbDOut_81->Name = L"cbDOut_81";
			this->cbDOut_81->Size = System::Drawing::Size(38, 17);
			this->cbDOut_81->TabIndex = 80;
			this->cbDOut_81->Text = L"81";
			this->cbDOut_81->UseVisualStyleBackColor = true;
			this->cbDOut_81->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_80
			// 
			this->cbDOut_80->AutoSize = true;
			this->cbDOut_80->Location = System::Drawing::Point(215, 336);
			this->cbDOut_80->Name = L"cbDOut_80";
			this->cbDOut_80->Size = System::Drawing::Size(38, 17);
			this->cbDOut_80->TabIndex = 79;
			this->cbDOut_80->Text = L"80";
			this->cbDOut_80->UseVisualStyleBackColor = true;
			this->cbDOut_80->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_79
			// 
			this->cbDOut_79->AutoSize = true;
			this->cbDOut_79->Location = System::Drawing::Point(215, 316);
			this->cbDOut_79->Name = L"cbDOut_79";
			this->cbDOut_79->Size = System::Drawing::Size(38, 17);
			this->cbDOut_79->TabIndex = 78;
			this->cbDOut_79->Text = L"79";
			this->cbDOut_79->UseVisualStyleBackColor = true;
			this->cbDOut_79->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_78
			// 
			this->cbDOut_78->AutoSize = true;
			this->cbDOut_78->Location = System::Drawing::Point(215, 296);
			this->cbDOut_78->Name = L"cbDOut_78";
			this->cbDOut_78->Size = System::Drawing::Size(38, 17);
			this->cbDOut_78->TabIndex = 77;
			this->cbDOut_78->Text = L"78";
			this->cbDOut_78->UseVisualStyleBackColor = true;
			this->cbDOut_78->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_77
			// 
			this->cbDOut_77->AutoSize = true;
			this->cbDOut_77->Location = System::Drawing::Point(215, 276);
			this->cbDOut_77->Name = L"cbDOut_77";
			this->cbDOut_77->Size = System::Drawing::Size(38, 17);
			this->cbDOut_77->TabIndex = 76;
			this->cbDOut_77->Text = L"77";
			this->cbDOut_77->UseVisualStyleBackColor = true;
			this->cbDOut_77->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_76
			// 
			this->cbDOut_76->AutoSize = true;
			this->cbDOut_76->Location = System::Drawing::Point(215, 256);
			this->cbDOut_76->Name = L"cbDOut_76";
			this->cbDOut_76->Size = System::Drawing::Size(38, 17);
			this->cbDOut_76->TabIndex = 75;
			this->cbDOut_76->Text = L"76";
			this->cbDOut_76->UseVisualStyleBackColor = true;
			this->cbDOut_76->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_75
			// 
			this->cbDOut_75->AutoSize = true;
			this->cbDOut_75->Location = System::Drawing::Point(215, 236);
			this->cbDOut_75->Name = L"cbDOut_75";
			this->cbDOut_75->Size = System::Drawing::Size(38, 17);
			this->cbDOut_75->TabIndex = 74;
			this->cbDOut_75->Text = L"75";
			this->cbDOut_75->UseVisualStyleBackColor = true;
			this->cbDOut_75->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_74
			// 
			this->cbDOut_74->AutoSize = true;
			this->cbDOut_74->Location = System::Drawing::Point(215, 216);
			this->cbDOut_74->Name = L"cbDOut_74";
			this->cbDOut_74->Size = System::Drawing::Size(38, 17);
			this->cbDOut_74->TabIndex = 73;
			this->cbDOut_74->Text = L"74";
			this->cbDOut_74->UseVisualStyleBackColor = true;
			this->cbDOut_74->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_73
			// 
			this->cbDOut_73->AutoSize = true;
			this->cbDOut_73->Location = System::Drawing::Point(215, 196);
			this->cbDOut_73->Name = L"cbDOut_73";
			this->cbDOut_73->Size = System::Drawing::Size(38, 17);
			this->cbDOut_73->TabIndex = 72;
			this->cbDOut_73->Text = L"73";
			this->cbDOut_73->UseVisualStyleBackColor = true;
			this->cbDOut_73->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_72
			// 
			this->cbDOut_72->AutoSize = true;
			this->cbDOut_72->Location = System::Drawing::Point(215, 160);
			this->cbDOut_72->Name = L"cbDOut_72";
			this->cbDOut_72->Size = System::Drawing::Size(38, 17);
			this->cbDOut_72->TabIndex = 71;
			this->cbDOut_72->Text = L"72";
			this->cbDOut_72->UseVisualStyleBackColor = true;
			this->cbDOut_72->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_71
			// 
			this->cbDOut_71->AutoSize = true;
			this->cbDOut_71->Location = System::Drawing::Point(215, 140);
			this->cbDOut_71->Name = L"cbDOut_71";
			this->cbDOut_71->Size = System::Drawing::Size(38, 17);
			this->cbDOut_71->TabIndex = 70;
			this->cbDOut_71->Text = L"71";
			this->cbDOut_71->UseVisualStyleBackColor = true;
			this->cbDOut_71->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_70
			// 
			this->cbDOut_70->AutoSize = true;
			this->cbDOut_70->Location = System::Drawing::Point(215, 120);
			this->cbDOut_70->Name = L"cbDOut_70";
			this->cbDOut_70->Size = System::Drawing::Size(38, 17);
			this->cbDOut_70->TabIndex = 69;
			this->cbDOut_70->Text = L"70";
			this->cbDOut_70->UseVisualStyleBackColor = true;
			this->cbDOut_70->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_69
			// 
			this->cbDOut_69->AutoSize = true;
			this->cbDOut_69->Location = System::Drawing::Point(215, 100);
			this->cbDOut_69->Name = L"cbDOut_69";
			this->cbDOut_69->Size = System::Drawing::Size(38, 17);
			this->cbDOut_69->TabIndex = 68;
			this->cbDOut_69->Text = L"69";
			this->cbDOut_69->UseVisualStyleBackColor = true;
			this->cbDOut_69->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_68
			// 
			this->cbDOut_68->AutoSize = true;
			this->cbDOut_68->Location = System::Drawing::Point(215, 80);
			this->cbDOut_68->Name = L"cbDOut_68";
			this->cbDOut_68->Size = System::Drawing::Size(38, 17);
			this->cbDOut_68->TabIndex = 67;
			this->cbDOut_68->Text = L"68";
			this->cbDOut_68->UseVisualStyleBackColor = true;
			this->cbDOut_68->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_67
			// 
			this->cbDOut_67->AutoSize = true;
			this->cbDOut_67->Location = System::Drawing::Point(215, 60);
			this->cbDOut_67->Name = L"cbDOut_67";
			this->cbDOut_67->Size = System::Drawing::Size(38, 17);
			this->cbDOut_67->TabIndex = 66;
			this->cbDOut_67->Text = L"67";
			this->cbDOut_67->UseVisualStyleBackColor = true;
			this->cbDOut_67->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_66
			// 
			this->cbDOut_66->AutoSize = true;
			this->cbDOut_66->Location = System::Drawing::Point(215, 40);
			this->cbDOut_66->Name = L"cbDOut_66";
			this->cbDOut_66->Size = System::Drawing::Size(38, 17);
			this->cbDOut_66->TabIndex = 65;
			this->cbDOut_66->Text = L"66";
			this->cbDOut_66->UseVisualStyleBackColor = true;
			this->cbDOut_66->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_65
			// 
			this->cbDOut_65->AutoSize = true;
			this->cbDOut_65->Location = System::Drawing::Point(215, 20);
			this->cbDOut_65->Name = L"cbDOut_65";
			this->cbDOut_65->Size = System::Drawing::Size(38, 17);
			this->cbDOut_65->TabIndex = 64;
			this->cbDOut_65->Text = L"65";
			this->cbDOut_65->UseVisualStyleBackColor = true;
			this->cbDOut_65->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_64
			// 
			this->cbDOut_64->AutoSize = true;
			this->cbDOut_64->Location = System::Drawing::Point(165, 336);
			this->cbDOut_64->Name = L"cbDOut_64";
			this->cbDOut_64->Size = System::Drawing::Size(38, 17);
			this->cbDOut_64->TabIndex = 63;
			this->cbDOut_64->Text = L"64";
			this->cbDOut_64->UseVisualStyleBackColor = true;
			this->cbDOut_64->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_63
			// 
			this->cbDOut_63->AutoSize = true;
			this->cbDOut_63->Location = System::Drawing::Point(165, 316);
			this->cbDOut_63->Name = L"cbDOut_63";
			this->cbDOut_63->Size = System::Drawing::Size(38, 17);
			this->cbDOut_63->TabIndex = 62;
			this->cbDOut_63->Text = L"63";
			this->cbDOut_63->UseVisualStyleBackColor = true;
			this->cbDOut_63->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_62
			// 
			this->cbDOut_62->AutoSize = true;
			this->cbDOut_62->Location = System::Drawing::Point(165, 296);
			this->cbDOut_62->Name = L"cbDOut_62";
			this->cbDOut_62->Size = System::Drawing::Size(38, 17);
			this->cbDOut_62->TabIndex = 61;
			this->cbDOut_62->Text = L"62";
			this->cbDOut_62->UseVisualStyleBackColor = true;
			this->cbDOut_62->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_61
			// 
			this->cbDOut_61->AutoSize = true;
			this->cbDOut_61->Location = System::Drawing::Point(165, 276);
			this->cbDOut_61->Name = L"cbDOut_61";
			this->cbDOut_61->Size = System::Drawing::Size(38, 17);
			this->cbDOut_61->TabIndex = 60;
			this->cbDOut_61->Text = L"61";
			this->cbDOut_61->UseVisualStyleBackColor = true;
			this->cbDOut_61->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_60
			// 
			this->cbDOut_60->AutoSize = true;
			this->cbDOut_60->Location = System::Drawing::Point(165, 256);
			this->cbDOut_60->Name = L"cbDOut_60";
			this->cbDOut_60->Size = System::Drawing::Size(38, 17);
			this->cbDOut_60->TabIndex = 59;
			this->cbDOut_60->Text = L"60";
			this->cbDOut_60->UseVisualStyleBackColor = true;
			this->cbDOut_60->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_59
			// 
			this->cbDOut_59->AutoSize = true;
			this->cbDOut_59->Location = System::Drawing::Point(165, 236);
			this->cbDOut_59->Name = L"cbDOut_59";
			this->cbDOut_59->Size = System::Drawing::Size(38, 17);
			this->cbDOut_59->TabIndex = 58;
			this->cbDOut_59->Text = L"59";
			this->cbDOut_59->UseVisualStyleBackColor = true;
			this->cbDOut_59->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_58
			// 
			this->cbDOut_58->AutoSize = true;
			this->cbDOut_58->Location = System::Drawing::Point(165, 216);
			this->cbDOut_58->Name = L"cbDOut_58";
			this->cbDOut_58->Size = System::Drawing::Size(38, 17);
			this->cbDOut_58->TabIndex = 57;
			this->cbDOut_58->Text = L"58";
			this->cbDOut_58->UseVisualStyleBackColor = true;
			this->cbDOut_58->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_57
			// 
			this->cbDOut_57->AutoSize = true;
			this->cbDOut_57->Location = System::Drawing::Point(165, 196);
			this->cbDOut_57->Name = L"cbDOut_57";
			this->cbDOut_57->Size = System::Drawing::Size(38, 17);
			this->cbDOut_57->TabIndex = 56;
			this->cbDOut_57->Text = L"57";
			this->cbDOut_57->UseVisualStyleBackColor = true;
			this->cbDOut_57->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_56
			// 
			this->cbDOut_56->AutoSize = true;
			this->cbDOut_56->Location = System::Drawing::Point(165, 160);
			this->cbDOut_56->Name = L"cbDOut_56";
			this->cbDOut_56->Size = System::Drawing::Size(38, 17);
			this->cbDOut_56->TabIndex = 55;
			this->cbDOut_56->Text = L"56";
			this->cbDOut_56->UseVisualStyleBackColor = true;
			this->cbDOut_56->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_55
			// 
			this->cbDOut_55->AutoSize = true;
			this->cbDOut_55->Location = System::Drawing::Point(165, 140);
			this->cbDOut_55->Name = L"cbDOut_55";
			this->cbDOut_55->Size = System::Drawing::Size(38, 17);
			this->cbDOut_55->TabIndex = 54;
			this->cbDOut_55->Text = L"55";
			this->cbDOut_55->UseVisualStyleBackColor = true;
			this->cbDOut_55->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_54
			// 
			this->cbDOut_54->AutoSize = true;
			this->cbDOut_54->Location = System::Drawing::Point(165, 120);
			this->cbDOut_54->Name = L"cbDOut_54";
			this->cbDOut_54->Size = System::Drawing::Size(38, 17);
			this->cbDOut_54->TabIndex = 53;
			this->cbDOut_54->Text = L"54";
			this->cbDOut_54->UseVisualStyleBackColor = true;
			this->cbDOut_54->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_53
			// 
			this->cbDOut_53->AutoSize = true;
			this->cbDOut_53->Location = System::Drawing::Point(165, 100);
			this->cbDOut_53->Name = L"cbDOut_53";
			this->cbDOut_53->Size = System::Drawing::Size(38, 17);
			this->cbDOut_53->TabIndex = 52;
			this->cbDOut_53->Text = L"53";
			this->cbDOut_53->UseVisualStyleBackColor = true;
			this->cbDOut_53->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_52
			// 
			this->cbDOut_52->AutoSize = true;
			this->cbDOut_52->Location = System::Drawing::Point(165, 80);
			this->cbDOut_52->Name = L"cbDOut_52";
			this->cbDOut_52->Size = System::Drawing::Size(38, 17);
			this->cbDOut_52->TabIndex = 51;
			this->cbDOut_52->Text = L"52";
			this->cbDOut_52->UseVisualStyleBackColor = true;
			this->cbDOut_52->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_51
			// 
			this->cbDOut_51->AutoSize = true;
			this->cbDOut_51->Location = System::Drawing::Point(165, 60);
			this->cbDOut_51->Name = L"cbDOut_51";
			this->cbDOut_51->Size = System::Drawing::Size(38, 17);
			this->cbDOut_51->TabIndex = 50;
			this->cbDOut_51->Text = L"51";
			this->cbDOut_51->UseVisualStyleBackColor = true;
			this->cbDOut_51->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_50
			// 
			this->cbDOut_50->AutoSize = true;
			this->cbDOut_50->Location = System::Drawing::Point(165, 40);
			this->cbDOut_50->Name = L"cbDOut_50";
			this->cbDOut_50->Size = System::Drawing::Size(38, 17);
			this->cbDOut_50->TabIndex = 49;
			this->cbDOut_50->Text = L"50";
			this->cbDOut_50->UseVisualStyleBackColor = true;
			this->cbDOut_50->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_49
			// 
			this->cbDOut_49->AutoSize = true;
			this->cbDOut_49->Location = System::Drawing::Point(165, 20);
			this->cbDOut_49->Name = L"cbDOut_49";
			this->cbDOut_49->Size = System::Drawing::Size(38, 17);
			this->cbDOut_49->TabIndex = 48;
			this->cbDOut_49->Text = L"49";
			this->cbDOut_49->UseVisualStyleBackColor = true;
			this->cbDOut_49->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_48
			// 
			this->cbDOut_48->AutoSize = true;
			this->cbDOut_48->Location = System::Drawing::Point(111, 336);
			this->cbDOut_48->Name = L"cbDOut_48";
			this->cbDOut_48->Size = System::Drawing::Size(38, 17);
			this->cbDOut_48->TabIndex = 47;
			this->cbDOut_48->Text = L"48";
			this->cbDOut_48->UseVisualStyleBackColor = true;
			this->cbDOut_48->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_47
			// 
			this->cbDOut_47->AutoSize = true;
			this->cbDOut_47->Location = System::Drawing::Point(111, 316);
			this->cbDOut_47->Name = L"cbDOut_47";
			this->cbDOut_47->Size = System::Drawing::Size(38, 17);
			this->cbDOut_47->TabIndex = 46;
			this->cbDOut_47->Text = L"47";
			this->cbDOut_47->UseVisualStyleBackColor = true;
			this->cbDOut_47->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_46
			// 
			this->cbDOut_46->AutoSize = true;
			this->cbDOut_46->Location = System::Drawing::Point(111, 296);
			this->cbDOut_46->Name = L"cbDOut_46";
			this->cbDOut_46->Size = System::Drawing::Size(38, 17);
			this->cbDOut_46->TabIndex = 45;
			this->cbDOut_46->Text = L"46";
			this->cbDOut_46->UseVisualStyleBackColor = true;
			this->cbDOut_46->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_45
			// 
			this->cbDOut_45->AutoSize = true;
			this->cbDOut_45->Location = System::Drawing::Point(111, 276);
			this->cbDOut_45->Name = L"cbDOut_45";
			this->cbDOut_45->Size = System::Drawing::Size(38, 17);
			this->cbDOut_45->TabIndex = 44;
			this->cbDOut_45->Text = L"45";
			this->cbDOut_45->UseVisualStyleBackColor = true;
			this->cbDOut_45->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_44
			// 
			this->cbDOut_44->AutoSize = true;
			this->cbDOut_44->Location = System::Drawing::Point(111, 256);
			this->cbDOut_44->Name = L"cbDOut_44";
			this->cbDOut_44->Size = System::Drawing::Size(38, 17);
			this->cbDOut_44->TabIndex = 43;
			this->cbDOut_44->Text = L"44";
			this->cbDOut_44->UseVisualStyleBackColor = true;
			this->cbDOut_44->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_43
			// 
			this->cbDOut_43->AutoSize = true;
			this->cbDOut_43->Location = System::Drawing::Point(111, 236);
			this->cbDOut_43->Name = L"cbDOut_43";
			this->cbDOut_43->Size = System::Drawing::Size(38, 17);
			this->cbDOut_43->TabIndex = 42;
			this->cbDOut_43->Text = L"43";
			this->cbDOut_43->UseVisualStyleBackColor = true;
			this->cbDOut_43->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_42
			// 
			this->cbDOut_42->AutoSize = true;
			this->cbDOut_42->Location = System::Drawing::Point(111, 216);
			this->cbDOut_42->Name = L"cbDOut_42";
			this->cbDOut_42->Size = System::Drawing::Size(38, 17);
			this->cbDOut_42->TabIndex = 41;
			this->cbDOut_42->Text = L"42";
			this->cbDOut_42->UseVisualStyleBackColor = true;
			this->cbDOut_42->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_41
			// 
			this->cbDOut_41->AutoSize = true;
			this->cbDOut_41->Location = System::Drawing::Point(111, 196);
			this->cbDOut_41->Name = L"cbDOut_41";
			this->cbDOut_41->Size = System::Drawing::Size(38, 17);
			this->cbDOut_41->TabIndex = 40;
			this->cbDOut_41->Text = L"41";
			this->cbDOut_41->UseVisualStyleBackColor = true;
			this->cbDOut_41->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_40
			// 
			this->cbDOut_40->AutoSize = true;
			this->cbDOut_40->Location = System::Drawing::Point(111, 160);
			this->cbDOut_40->Name = L"cbDOut_40";
			this->cbDOut_40->Size = System::Drawing::Size(38, 17);
			this->cbDOut_40->TabIndex = 39;
			this->cbDOut_40->Text = L"40";
			this->cbDOut_40->UseVisualStyleBackColor = true;
			this->cbDOut_40->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_39
			// 
			this->cbDOut_39->AutoSize = true;
			this->cbDOut_39->Location = System::Drawing::Point(111, 140);
			this->cbDOut_39->Name = L"cbDOut_39";
			this->cbDOut_39->Size = System::Drawing::Size(38, 17);
			this->cbDOut_39->TabIndex = 38;
			this->cbDOut_39->Text = L"39";
			this->cbDOut_39->UseVisualStyleBackColor = true;
			this->cbDOut_39->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_38
			// 
			this->cbDOut_38->AutoSize = true;
			this->cbDOut_38->Location = System::Drawing::Point(111, 120);
			this->cbDOut_38->Name = L"cbDOut_38";
			this->cbDOut_38->Size = System::Drawing::Size(38, 17);
			this->cbDOut_38->TabIndex = 37;
			this->cbDOut_38->Text = L"38";
			this->cbDOut_38->UseVisualStyleBackColor = true;
			this->cbDOut_38->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_37
			// 
			this->cbDOut_37->AutoSize = true;
			this->cbDOut_37->Location = System::Drawing::Point(111, 100);
			this->cbDOut_37->Name = L"cbDOut_37";
			this->cbDOut_37->Size = System::Drawing::Size(38, 17);
			this->cbDOut_37->TabIndex = 36;
			this->cbDOut_37->Text = L"37";
			this->cbDOut_37->UseVisualStyleBackColor = true;
			this->cbDOut_37->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_36
			// 
			this->cbDOut_36->AutoSize = true;
			this->cbDOut_36->Location = System::Drawing::Point(111, 80);
			this->cbDOut_36->Name = L"cbDOut_36";
			this->cbDOut_36->Size = System::Drawing::Size(38, 17);
			this->cbDOut_36->TabIndex = 35;
			this->cbDOut_36->Text = L"36";
			this->cbDOut_36->UseVisualStyleBackColor = true;
			this->cbDOut_36->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_35
			// 
			this->cbDOut_35->AutoSize = true;
			this->cbDOut_35->Location = System::Drawing::Point(111, 60);
			this->cbDOut_35->Name = L"cbDOut_35";
			this->cbDOut_35->Size = System::Drawing::Size(38, 17);
			this->cbDOut_35->TabIndex = 34;
			this->cbDOut_35->Text = L"35";
			this->cbDOut_35->UseVisualStyleBackColor = true;
			this->cbDOut_35->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_34
			// 
			this->cbDOut_34->AutoSize = true;
			this->cbDOut_34->Location = System::Drawing::Point(111, 40);
			this->cbDOut_34->Name = L"cbDOut_34";
			this->cbDOut_34->Size = System::Drawing::Size(38, 17);
			this->cbDOut_34->TabIndex = 33;
			this->cbDOut_34->Text = L"34";
			this->cbDOut_34->UseVisualStyleBackColor = true;
			this->cbDOut_34->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_33
			// 
			this->cbDOut_33->AutoSize = true;
			this->cbDOut_33->Location = System::Drawing::Point(111, 20);
			this->cbDOut_33->Name = L"cbDOut_33";
			this->cbDOut_33->Size = System::Drawing::Size(38, 17);
			this->cbDOut_33->TabIndex = 32;
			this->cbDOut_33->Text = L"33";
			this->cbDOut_33->UseVisualStyleBackColor = true;
			this->cbDOut_33->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_32
			// 
			this->cbDOut_32->AutoSize = true;
			this->cbDOut_32->Location = System::Drawing::Point(59, 336);
			this->cbDOut_32->Name = L"cbDOut_32";
			this->cbDOut_32->Size = System::Drawing::Size(38, 17);
			this->cbDOut_32->TabIndex = 31;
			this->cbDOut_32->Text = L"32";
			this->cbDOut_32->UseVisualStyleBackColor = true;
			this->cbDOut_32->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_31
			// 
			this->cbDOut_31->AutoSize = true;
			this->cbDOut_31->Location = System::Drawing::Point(59, 316);
			this->cbDOut_31->Name = L"cbDOut_31";
			this->cbDOut_31->Size = System::Drawing::Size(38, 17);
			this->cbDOut_31->TabIndex = 30;
			this->cbDOut_31->Text = L"31";
			this->cbDOut_31->UseVisualStyleBackColor = true;
			this->cbDOut_31->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_30
			// 
			this->cbDOut_30->AutoSize = true;
			this->cbDOut_30->Location = System::Drawing::Point(59, 296);
			this->cbDOut_30->Name = L"cbDOut_30";
			this->cbDOut_30->Size = System::Drawing::Size(38, 17);
			this->cbDOut_30->TabIndex = 29;
			this->cbDOut_30->Text = L"30";
			this->cbDOut_30->UseVisualStyleBackColor = true;
			this->cbDOut_30->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_29
			// 
			this->cbDOut_29->AutoSize = true;
			this->cbDOut_29->Location = System::Drawing::Point(59, 276);
			this->cbDOut_29->Name = L"cbDOut_29";
			this->cbDOut_29->Size = System::Drawing::Size(38, 17);
			this->cbDOut_29->TabIndex = 28;
			this->cbDOut_29->Text = L"29";
			this->cbDOut_29->UseVisualStyleBackColor = true;
			this->cbDOut_29->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_28
			// 
			this->cbDOut_28->AutoSize = true;
			this->cbDOut_28->Location = System::Drawing::Point(59, 256);
			this->cbDOut_28->Name = L"cbDOut_28";
			this->cbDOut_28->Size = System::Drawing::Size(38, 17);
			this->cbDOut_28->TabIndex = 27;
			this->cbDOut_28->Text = L"28";
			this->cbDOut_28->UseVisualStyleBackColor = true;
			this->cbDOut_28->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_27
			// 
			this->cbDOut_27->AutoSize = true;
			this->cbDOut_27->Location = System::Drawing::Point(59, 236);
			this->cbDOut_27->Name = L"cbDOut_27";
			this->cbDOut_27->Size = System::Drawing::Size(38, 17);
			this->cbDOut_27->TabIndex = 26;
			this->cbDOut_27->Text = L"27";
			this->cbDOut_27->UseVisualStyleBackColor = true;
			this->cbDOut_27->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_26
			// 
			this->cbDOut_26->AutoSize = true;
			this->cbDOut_26->Location = System::Drawing::Point(59, 216);
			this->cbDOut_26->Name = L"cbDOut_26";
			this->cbDOut_26->Size = System::Drawing::Size(38, 17);
			this->cbDOut_26->TabIndex = 25;
			this->cbDOut_26->Text = L"26";
			this->cbDOut_26->UseVisualStyleBackColor = true;
			this->cbDOut_26->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_25
			// 
			this->cbDOut_25->AutoSize = true;
			this->cbDOut_25->Location = System::Drawing::Point(59, 196);
			this->cbDOut_25->Name = L"cbDOut_25";
			this->cbDOut_25->Size = System::Drawing::Size(38, 17);
			this->cbDOut_25->TabIndex = 24;
			this->cbDOut_25->Text = L"25";
			this->cbDOut_25->UseVisualStyleBackColor = true;
			this->cbDOut_25->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_24
			// 
			this->cbDOut_24->AutoSize = true;
			this->cbDOut_24->Location = System::Drawing::Point(59, 160);
			this->cbDOut_24->Name = L"cbDOut_24";
			this->cbDOut_24->Size = System::Drawing::Size(38, 17);
			this->cbDOut_24->TabIndex = 23;
			this->cbDOut_24->Text = L"24";
			this->cbDOut_24->UseVisualStyleBackColor = true;
			this->cbDOut_24->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_23
			// 
			this->cbDOut_23->AutoSize = true;
			this->cbDOut_23->Location = System::Drawing::Point(59, 140);
			this->cbDOut_23->Name = L"cbDOut_23";
			this->cbDOut_23->Size = System::Drawing::Size(38, 17);
			this->cbDOut_23->TabIndex = 22;
			this->cbDOut_23->Text = L"23";
			this->cbDOut_23->UseVisualStyleBackColor = true;
			this->cbDOut_23->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_22
			// 
			this->cbDOut_22->AutoSize = true;
			this->cbDOut_22->Location = System::Drawing::Point(59, 120);
			this->cbDOut_22->Name = L"cbDOut_22";
			this->cbDOut_22->Size = System::Drawing::Size(38, 17);
			this->cbDOut_22->TabIndex = 21;
			this->cbDOut_22->Text = L"22";
			this->cbDOut_22->UseVisualStyleBackColor = true;
			this->cbDOut_22->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_21
			// 
			this->cbDOut_21->AutoSize = true;
			this->cbDOut_21->Location = System::Drawing::Point(59, 100);
			this->cbDOut_21->Name = L"cbDOut_21";
			this->cbDOut_21->Size = System::Drawing::Size(38, 17);
			this->cbDOut_21->TabIndex = 20;
			this->cbDOut_21->Text = L"21";
			this->cbDOut_21->UseVisualStyleBackColor = true;
			this->cbDOut_21->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_20
			// 
			this->cbDOut_20->AutoSize = true;
			this->cbDOut_20->Location = System::Drawing::Point(59, 80);
			this->cbDOut_20->Name = L"cbDOut_20";
			this->cbDOut_20->Size = System::Drawing::Size(38, 17);
			this->cbDOut_20->TabIndex = 19;
			this->cbDOut_20->Text = L"20";
			this->cbDOut_20->UseVisualStyleBackColor = true;
			this->cbDOut_20->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_19
			// 
			this->cbDOut_19->AutoSize = true;
			this->cbDOut_19->Location = System::Drawing::Point(59, 60);
			this->cbDOut_19->Name = L"cbDOut_19";
			this->cbDOut_19->Size = System::Drawing::Size(38, 17);
			this->cbDOut_19->TabIndex = 18;
			this->cbDOut_19->Text = L"19";
			this->cbDOut_19->UseVisualStyleBackColor = true;
			this->cbDOut_19->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_18
			// 
			this->cbDOut_18->AutoSize = true;
			this->cbDOut_18->Location = System::Drawing::Point(59, 40);
			this->cbDOut_18->Name = L"cbDOut_18";
			this->cbDOut_18->Size = System::Drawing::Size(38, 17);
			this->cbDOut_18->TabIndex = 17;
			this->cbDOut_18->Text = L"18";
			this->cbDOut_18->UseVisualStyleBackColor = true;
			this->cbDOut_18->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_17
			// 
			this->cbDOut_17->AutoSize = true;
			this->cbDOut_17->Location = System::Drawing::Point(59, 20);
			this->cbDOut_17->Name = L"cbDOut_17";
			this->cbDOut_17->Size = System::Drawing::Size(38, 17);
			this->cbDOut_17->TabIndex = 16;
			this->cbDOut_17->Text = L"17";
			this->cbDOut_17->UseVisualStyleBackColor = true;
			this->cbDOut_17->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_16
			// 
			this->cbDOut_16->AutoSize = true;
			this->cbDOut_16->Location = System::Drawing::Point(7, 336);
			this->cbDOut_16->Name = L"cbDOut_16";
			this->cbDOut_16->Size = System::Drawing::Size(38, 17);
			this->cbDOut_16->TabIndex = 15;
			this->cbDOut_16->Text = L"16";
			this->cbDOut_16->UseVisualStyleBackColor = true;
			this->cbDOut_16->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_15
			// 
			this->cbDOut_15->AutoSize = true;
			this->cbDOut_15->Location = System::Drawing::Point(7, 316);
			this->cbDOut_15->Name = L"cbDOut_15";
			this->cbDOut_15->Size = System::Drawing::Size(38, 17);
			this->cbDOut_15->TabIndex = 14;
			this->cbDOut_15->Text = L"15";
			this->cbDOut_15->UseVisualStyleBackColor = true;
			this->cbDOut_15->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_14
			// 
			this->cbDOut_14->AutoSize = true;
			this->cbDOut_14->Location = System::Drawing::Point(7, 296);
			this->cbDOut_14->Name = L"cbDOut_14";
			this->cbDOut_14->Size = System::Drawing::Size(38, 17);
			this->cbDOut_14->TabIndex = 13;
			this->cbDOut_14->Text = L"14";
			this->cbDOut_14->UseVisualStyleBackColor = true;
			this->cbDOut_14->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_13
			// 
			this->cbDOut_13->AutoSize = true;
			this->cbDOut_13->Location = System::Drawing::Point(7, 276);
			this->cbDOut_13->Name = L"cbDOut_13";
			this->cbDOut_13->Size = System::Drawing::Size(38, 17);
			this->cbDOut_13->TabIndex = 12;
			this->cbDOut_13->Text = L"13";
			this->cbDOut_13->UseVisualStyleBackColor = true;
			this->cbDOut_13->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_12
			// 
			this->cbDOut_12->AutoSize = true;
			this->cbDOut_12->Location = System::Drawing::Point(7, 256);
			this->cbDOut_12->Name = L"cbDOut_12";
			this->cbDOut_12->Size = System::Drawing::Size(38, 17);
			this->cbDOut_12->TabIndex = 11;
			this->cbDOut_12->Text = L"12";
			this->cbDOut_12->UseVisualStyleBackColor = true;
			this->cbDOut_12->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_11
			// 
			this->cbDOut_11->AutoSize = true;
			this->cbDOut_11->Location = System::Drawing::Point(7, 236);
			this->cbDOut_11->Name = L"cbDOut_11";
			this->cbDOut_11->Size = System::Drawing::Size(38, 17);
			this->cbDOut_11->TabIndex = 10;
			this->cbDOut_11->Text = L"11";
			this->cbDOut_11->UseVisualStyleBackColor = true;
			this->cbDOut_11->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_10
			// 
			this->cbDOut_10->AutoSize = true;
			this->cbDOut_10->Location = System::Drawing::Point(7, 216);
			this->cbDOut_10->Name = L"cbDOut_10";
			this->cbDOut_10->Size = System::Drawing::Size(38, 17);
			this->cbDOut_10->TabIndex = 9;
			this->cbDOut_10->Text = L"10";
			this->cbDOut_10->UseVisualStyleBackColor = true;
			this->cbDOut_10->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_9
			// 
			this->cbDOut_9->AutoSize = true;
			this->cbDOut_9->Location = System::Drawing::Point(7, 196);
			this->cbDOut_9->Name = L"cbDOut_9";
			this->cbDOut_9->Size = System::Drawing::Size(32, 17);
			this->cbDOut_9->TabIndex = 8;
			this->cbDOut_9->Text = L"9";
			this->cbDOut_9->UseVisualStyleBackColor = true;
			this->cbDOut_9->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_8
			// 
			this->cbDOut_8->AutoSize = true;
			this->cbDOut_8->Location = System::Drawing::Point(7, 160);
			this->cbDOut_8->Name = L"cbDOut_8";
			this->cbDOut_8->Size = System::Drawing::Size(32, 17);
			this->cbDOut_8->TabIndex = 7;
			this->cbDOut_8->Text = L"8";
			this->cbDOut_8->UseVisualStyleBackColor = true;
			this->cbDOut_8->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_7
			// 
			this->cbDOut_7->AutoSize = true;
			this->cbDOut_7->Location = System::Drawing::Point(7, 140);
			this->cbDOut_7->Name = L"cbDOut_7";
			this->cbDOut_7->Size = System::Drawing::Size(32, 17);
			this->cbDOut_7->TabIndex = 6;
			this->cbDOut_7->Text = L"7";
			this->cbDOut_7->UseVisualStyleBackColor = true;
			this->cbDOut_7->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_6
			// 
			this->cbDOut_6->AutoSize = true;
			this->cbDOut_6->Location = System::Drawing::Point(7, 120);
			this->cbDOut_6->Name = L"cbDOut_6";
			this->cbDOut_6->Size = System::Drawing::Size(32, 17);
			this->cbDOut_6->TabIndex = 5;
			this->cbDOut_6->Text = L"6";
			this->cbDOut_6->UseVisualStyleBackColor = true;
			this->cbDOut_6->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_5
			// 
			this->cbDOut_5->AutoSize = true;
			this->cbDOut_5->Location = System::Drawing::Point(7, 100);
			this->cbDOut_5->Name = L"cbDOut_5";
			this->cbDOut_5->Size = System::Drawing::Size(32, 17);
			this->cbDOut_5->TabIndex = 4;
			this->cbDOut_5->Text = L"5";
			this->cbDOut_5->UseVisualStyleBackColor = true;
			this->cbDOut_5->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_4
			// 
			this->cbDOut_4->AutoSize = true;
			this->cbDOut_4->Location = System::Drawing::Point(7, 80);
			this->cbDOut_4->Name = L"cbDOut_4";
			this->cbDOut_4->Size = System::Drawing::Size(32, 17);
			this->cbDOut_4->TabIndex = 3;
			this->cbDOut_4->Text = L"4";
			this->cbDOut_4->UseVisualStyleBackColor = true;
			this->cbDOut_4->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_3
			// 
			this->cbDOut_3->AutoSize = true;
			this->cbDOut_3->Location = System::Drawing::Point(7, 60);
			this->cbDOut_3->Name = L"cbDOut_3";
			this->cbDOut_3->Size = System::Drawing::Size(32, 17);
			this->cbDOut_3->TabIndex = 2;
			this->cbDOut_3->Text = L"3";
			this->cbDOut_3->UseVisualStyleBackColor = true;
			this->cbDOut_3->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_2
			// 
			this->cbDOut_2->AutoSize = true;
			this->cbDOut_2->Location = System::Drawing::Point(7, 40);
			this->cbDOut_2->Name = L"cbDOut_2";
			this->cbDOut_2->Size = System::Drawing::Size(32, 17);
			this->cbDOut_2->TabIndex = 1;
			this->cbDOut_2->Text = L"2";
			this->cbDOut_2->UseVisualStyleBackColor = true;
			this->cbDOut_2->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// cbDOut_1
			// 
			this->cbDOut_1->AutoSize = true;
			this->cbDOut_1->Location = System::Drawing::Point(7, 20);
			this->cbDOut_1->Name = L"cbDOut_1";
			this->cbDOut_1->Size = System::Drawing::Size(32, 17);
			this->cbDOut_1->TabIndex = 0;
			this->cbDOut_1->Text = L"1";
			this->cbDOut_1->UseVisualStyleBackColor = true;
			this->cbDOut_1->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDOut_1_CheckedChanged);
			// 
			// groupBox2
			// 
			this->groupBox2->Controls->Add(this->lbDIn_128);
			this->groupBox2->Controls->Add(this->lbDIn_127);
			this->groupBox2->Controls->Add(this->lbDIn_126);
			this->groupBox2->Controls->Add(this->lbDIn_125);
			this->groupBox2->Controls->Add(this->lbDIn_124);
			this->groupBox2->Controls->Add(this->lbDIn_123);
			this->groupBox2->Controls->Add(this->lbDIn_122);
			this->groupBox2->Controls->Add(this->lbDIn_121);
			this->groupBox2->Controls->Add(this->lbDIn_120);
			this->groupBox2->Controls->Add(this->lbDIn_119);
			this->groupBox2->Controls->Add(this->lbDIn_118);
			this->groupBox2->Controls->Add(this->lbDIn_117);
			this->groupBox2->Controls->Add(this->lbDIn_116);
			this->groupBox2->Controls->Add(this->lbDIn_115);
			this->groupBox2->Controls->Add(this->lbDIn_114);
			this->groupBox2->Controls->Add(this->lbDIn_113);
			this->groupBox2->Controls->Add(this->lbDIn_112);
			this->groupBox2->Controls->Add(this->lbDIn_111);
			this->groupBox2->Controls->Add(this->lbDIn_110);
			this->groupBox2->Controls->Add(this->lbDIn_109);
			this->groupBox2->Controls->Add(this->lbDIn_108);
			this->groupBox2->Controls->Add(this->lbDIn_107);
			this->groupBox2->Controls->Add(this->lbDIn_106);
			this->groupBox2->Controls->Add(this->lbDIn_105);
			this->groupBox2->Controls->Add(this->lbDIn_104);
			this->groupBox2->Controls->Add(this->lbDIn_103);
			this->groupBox2->Controls->Add(this->lbDIn_102);
			this->groupBox2->Controls->Add(this->lbDIn_101);
			this->groupBox2->Controls->Add(this->lbDIn_100);
			this->groupBox2->Controls->Add(this->lbDIn_99);
			this->groupBox2->Controls->Add(this->lbDIn_98);
			this->groupBox2->Controls->Add(this->lbDIn_97);
			this->groupBox2->Controls->Add(this->lbDIn_96);
			this->groupBox2->Controls->Add(this->lbDIn_95);
			this->groupBox2->Controls->Add(this->lbDIn_94);
			this->groupBox2->Controls->Add(this->lbDIn_93);
			this->groupBox2->Controls->Add(this->lbDIn_92);
			this->groupBox2->Controls->Add(this->lbDIn_91);
			this->groupBox2->Controls->Add(this->lbDIn_90);
			this->groupBox2->Controls->Add(this->lbDIn_89);
			this->groupBox2->Controls->Add(this->lbDIn_88);
			this->groupBox2->Controls->Add(this->lbDIn_87);
			this->groupBox2->Controls->Add(this->lbDIn_86);
			this->groupBox2->Controls->Add(this->lbDIn_85);
			this->groupBox2->Controls->Add(this->lbDIn_84);
			this->groupBox2->Controls->Add(this->lbDIn_83);
			this->groupBox2->Controls->Add(this->lbDIn_82);
			this->groupBox2->Controls->Add(this->lbDIn_81);
			this->groupBox2->Controls->Add(this->lbDIn_80);
			this->groupBox2->Controls->Add(this->lbDIn_79);
			this->groupBox2->Controls->Add(this->lbDIn_78);
			this->groupBox2->Controls->Add(this->lbDIn_77);
			this->groupBox2->Controls->Add(this->lbDIn_76);
			this->groupBox2->Controls->Add(this->lbDIn_75);
			this->groupBox2->Controls->Add(this->lbDIn_74);
			this->groupBox2->Controls->Add(this->lbDIn_73);
			this->groupBox2->Controls->Add(this->lbDIn_72);
			this->groupBox2->Controls->Add(this->lbDIn_71);
			this->groupBox2->Controls->Add(this->lbDIn_70);
			this->groupBox2->Controls->Add(this->lbDIn_69);
			this->groupBox2->Controls->Add(this->lbDIn_68);
			this->groupBox2->Controls->Add(this->lbDIn_67);
			this->groupBox2->Controls->Add(this->lbDIn_66);
			this->groupBox2->Controls->Add(this->lbDIn_65);
			this->groupBox2->Controls->Add(this->lbDIn_64);
			this->groupBox2->Controls->Add(this->lbDIn_63);
			this->groupBox2->Controls->Add(this->lbDIn_62);
			this->groupBox2->Controls->Add(this->lbDIn_61);
			this->groupBox2->Controls->Add(this->lbDIn_60);
			this->groupBox2->Controls->Add(this->lbDIn_59);
			this->groupBox2->Controls->Add(this->lbDIn_58);
			this->groupBox2->Controls->Add(this->lbDIn_57);
			this->groupBox2->Controls->Add(this->lbDIn_56);
			this->groupBox2->Controls->Add(this->lbDIn_55);
			this->groupBox2->Controls->Add(this->lbDIn_54);
			this->groupBox2->Controls->Add(this->lbDIn_53);
			this->groupBox2->Controls->Add(this->lbDIn_52);
			this->groupBox2->Controls->Add(this->lbDIn_51);
			this->groupBox2->Controls->Add(this->lbDIn_50);
			this->groupBox2->Controls->Add(this->lbDIn_49);
			this->groupBox2->Controls->Add(this->lbDIn_48);
			this->groupBox2->Controls->Add(this->lbDIn_47);
			this->groupBox2->Controls->Add(this->lbDIn_46);
			this->groupBox2->Controls->Add(this->lbDIn_45);
			this->groupBox2->Controls->Add(this->lbDIn_44);
			this->groupBox2->Controls->Add(this->lbDIn_43);
			this->groupBox2->Controls->Add(this->lbDIn_42);
			this->groupBox2->Controls->Add(this->lbDIn_41);
			this->groupBox2->Controls->Add(this->lbDIn_40);
			this->groupBox2->Controls->Add(this->lbDIn_39);
			this->groupBox2->Controls->Add(this->lbDIn_38);
			this->groupBox2->Controls->Add(this->lbDIn_37);
			this->groupBox2->Controls->Add(this->lbDIn_36);
			this->groupBox2->Controls->Add(this->lbDIn_35);
			this->groupBox2->Controls->Add(this->lbDIn_34);
			this->groupBox2->Controls->Add(this->lbDIn_33);
			this->groupBox2->Controls->Add(this->lbDIn_32);
			this->groupBox2->Controls->Add(this->lbDIn_31);
			this->groupBox2->Controls->Add(this->lbDIn_30);
			this->groupBox2->Controls->Add(this->lbDIn_29);
			this->groupBox2->Controls->Add(this->lbDIn_28);
			this->groupBox2->Controls->Add(this->lbDIn_27);
			this->groupBox2->Controls->Add(this->lbDIn_26);
			this->groupBox2->Controls->Add(this->lbDIn_25);
			this->groupBox2->Controls->Add(this->lbDIn_24);
			this->groupBox2->Controls->Add(this->lbDIn_23);
			this->groupBox2->Controls->Add(this->lbDIn_22);
			this->groupBox2->Controls->Add(this->lbDIn_21);
			this->groupBox2->Controls->Add(this->lbDIn_20);
			this->groupBox2->Controls->Add(this->lbDIn_19);
			this->groupBox2->Controls->Add(this->lbDIn_18);
			this->groupBox2->Controls->Add(this->lbDIn_17);
			this->groupBox2->Controls->Add(this->lbDIn_16);
			this->groupBox2->Controls->Add(this->lbDIn_15);
			this->groupBox2->Controls->Add(this->lbDIn_14);
			this->groupBox2->Controls->Add(this->lbDIn_13);
			this->groupBox2->Controls->Add(this->lbDIn_12);
			this->groupBox2->Controls->Add(this->lbDIn_11);
			this->groupBox2->Controls->Add(this->lbDIn_10);
			this->groupBox2->Controls->Add(this->lbDIn_9);
			this->groupBox2->Controls->Add(this->lbDIn_8);
			this->groupBox2->Controls->Add(this->lbDIn_7);
			this->groupBox2->Controls->Add(this->lbDIn_6);
			this->groupBox2->Controls->Add(this->lbDIn_5);
			this->groupBox2->Controls->Add(this->lbDIn_4);
			this->groupBox2->Controls->Add(this->lbDIn_3);
			this->groupBox2->Controls->Add(this->lbDIn_2);
			this->groupBox2->Controls->Add(this->lbDIn_1);
			this->groupBox2->Location = System::Drawing::Point(6, 6);
			this->groupBox2->Name = L"groupBox2";
			this->groupBox2->Size = System::Drawing::Size(424, 365);
			this->groupBox2->TabIndex = 0;
			this->groupBox2->TabStop = false;
			this->groupBox2->Text = L"Digital Inputs";
			// 
			// lbDIn_128
			// 
			this->lbDIn_128->AutoSize = true;
			this->lbDIn_128->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_128->Location = System::Drawing::Point(370, 336);
			this->lbDIn_128->Name = L"lbDIn_128";
			this->lbDIn_128->Size = System::Drawing::Size(25, 13);
			this->lbDIn_128->TabIndex = 127;
			this->lbDIn_128->Text = L"128";
			// 
			// lbDIn_127
			// 
			this->lbDIn_127->AutoSize = true;
			this->lbDIn_127->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_127->Location = System::Drawing::Point(370, 316);
			this->lbDIn_127->Name = L"lbDIn_127";
			this->lbDIn_127->Size = System::Drawing::Size(25, 13);
			this->lbDIn_127->TabIndex = 126;
			this->lbDIn_127->Text = L"127";
			// 
			// lbDIn_126
			// 
			this->lbDIn_126->AutoSize = true;
			this->lbDIn_126->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_126->Location = System::Drawing::Point(370, 296);
			this->lbDIn_126->Name = L"lbDIn_126";
			this->lbDIn_126->Size = System::Drawing::Size(25, 13);
			this->lbDIn_126->TabIndex = 125;
			this->lbDIn_126->Text = L"126";
			// 
			// lbDIn_125
			// 
			this->lbDIn_125->AutoSize = true;
			this->lbDIn_125->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_125->Location = System::Drawing::Point(370, 276);
			this->lbDIn_125->Name = L"lbDIn_125";
			this->lbDIn_125->Size = System::Drawing::Size(25, 13);
			this->lbDIn_125->TabIndex = 124;
			this->lbDIn_125->Text = L"125";
			// 
			// lbDIn_124
			// 
			this->lbDIn_124->AutoSize = true;
			this->lbDIn_124->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_124->Location = System::Drawing::Point(370, 256);
			this->lbDIn_124->Name = L"lbDIn_124";
			this->lbDIn_124->Size = System::Drawing::Size(25, 13);
			this->lbDIn_124->TabIndex = 123;
			this->lbDIn_124->Text = L"124";
			// 
			// lbDIn_123
			// 
			this->lbDIn_123->AutoSize = true;
			this->lbDIn_123->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_123->Location = System::Drawing::Point(370, 236);
			this->lbDIn_123->Name = L"lbDIn_123";
			this->lbDIn_123->Size = System::Drawing::Size(25, 13);
			this->lbDIn_123->TabIndex = 122;
			this->lbDIn_123->Text = L"123";
			// 
			// lbDIn_122
			// 
			this->lbDIn_122->AutoSize = true;
			this->lbDIn_122->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_122->Location = System::Drawing::Point(370, 216);
			this->lbDIn_122->Name = L"lbDIn_122";
			this->lbDIn_122->Size = System::Drawing::Size(25, 13);
			this->lbDIn_122->TabIndex = 121;
			this->lbDIn_122->Text = L"122";
			// 
			// lbDIn_121
			// 
			this->lbDIn_121->AutoSize = true;
			this->lbDIn_121->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_121->Location = System::Drawing::Point(370, 196);
			this->lbDIn_121->Name = L"lbDIn_121";
			this->lbDIn_121->Size = System::Drawing::Size(25, 13);
			this->lbDIn_121->TabIndex = 120;
			this->lbDIn_121->Text = L"121";
			// 
			// lbDIn_120
			// 
			this->lbDIn_120->AutoSize = true;
			this->lbDIn_120->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_120->Location = System::Drawing::Point(371, 160);
			this->lbDIn_120->Name = L"lbDIn_120";
			this->lbDIn_120->Size = System::Drawing::Size(25, 13);
			this->lbDIn_120->TabIndex = 119;
			this->lbDIn_120->Text = L"120";
			// 
			// lbDIn_119
			// 
			this->lbDIn_119->AutoSize = true;
			this->lbDIn_119->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_119->Location = System::Drawing::Point(371, 140);
			this->lbDIn_119->Name = L"lbDIn_119";
			this->lbDIn_119->Size = System::Drawing::Size(25, 13);
			this->lbDIn_119->TabIndex = 118;
			this->lbDIn_119->Text = L"119";
			// 
			// lbDIn_118
			// 
			this->lbDIn_118->AutoSize = true;
			this->lbDIn_118->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_118->Location = System::Drawing::Point(371, 120);
			this->lbDIn_118->Name = L"lbDIn_118";
			this->lbDIn_118->Size = System::Drawing::Size(25, 13);
			this->lbDIn_118->TabIndex = 117;
			this->lbDIn_118->Text = L"118";
			// 
			// lbDIn_117
			// 
			this->lbDIn_117->AutoSize = true;
			this->lbDIn_117->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_117->Location = System::Drawing::Point(371, 100);
			this->lbDIn_117->Name = L"lbDIn_117";
			this->lbDIn_117->Size = System::Drawing::Size(25, 13);
			this->lbDIn_117->TabIndex = 116;
			this->lbDIn_117->Text = L"117";
			// 
			// lbDIn_116
			// 
			this->lbDIn_116->AutoSize = true;
			this->lbDIn_116->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_116->Location = System::Drawing::Point(371, 80);
			this->lbDIn_116->Name = L"lbDIn_116";
			this->lbDIn_116->Size = System::Drawing::Size(25, 13);
			this->lbDIn_116->TabIndex = 115;
			this->lbDIn_116->Text = L"116";
			// 
			// lbDIn_115
			// 
			this->lbDIn_115->AutoSize = true;
			this->lbDIn_115->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_115->Location = System::Drawing::Point(371, 60);
			this->lbDIn_115->Name = L"lbDIn_115";
			this->lbDIn_115->Size = System::Drawing::Size(25, 13);
			this->lbDIn_115->TabIndex = 114;
			this->lbDIn_115->Text = L"115";
			// 
			// lbDIn_114
			// 
			this->lbDIn_114->AutoSize = true;
			this->lbDIn_114->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_114->Location = System::Drawing::Point(371, 40);
			this->lbDIn_114->Name = L"lbDIn_114";
			this->lbDIn_114->Size = System::Drawing::Size(25, 13);
			this->lbDIn_114->TabIndex = 113;
			this->lbDIn_114->Text = L"114";
			// 
			// lbDIn_113
			// 
			this->lbDIn_113->AutoSize = true;
			this->lbDIn_113->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_113->Location = System::Drawing::Point(371, 20);
			this->lbDIn_113->Name = L"lbDIn_113";
			this->lbDIn_113->Size = System::Drawing::Size(25, 13);
			this->lbDIn_113->TabIndex = 112;
			this->lbDIn_113->Text = L"113";
			// 
			// lbDIn_112
			// 
			this->lbDIn_112->AutoSize = true;
			this->lbDIn_112->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_112->Location = System::Drawing::Point(318, 336);
			this->lbDIn_112->Name = L"lbDIn_112";
			this->lbDIn_112->Size = System::Drawing::Size(25, 13);
			this->lbDIn_112->TabIndex = 111;
			this->lbDIn_112->Text = L"112";
			// 
			// lbDIn_111
			// 
			this->lbDIn_111->AutoSize = true;
			this->lbDIn_111->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_111->Location = System::Drawing::Point(318, 316);
			this->lbDIn_111->Name = L"lbDIn_111";
			this->lbDIn_111->Size = System::Drawing::Size(25, 13);
			this->lbDIn_111->TabIndex = 110;
			this->lbDIn_111->Text = L"111";
			// 
			// lbDIn_110
			// 
			this->lbDIn_110->AutoSize = true;
			this->lbDIn_110->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_110->Location = System::Drawing::Point(318, 296);
			this->lbDIn_110->Name = L"lbDIn_110";
			this->lbDIn_110->Size = System::Drawing::Size(25, 13);
			this->lbDIn_110->TabIndex = 109;
			this->lbDIn_110->Text = L"110";
			// 
			// lbDIn_109
			// 
			this->lbDIn_109->AutoSize = true;
			this->lbDIn_109->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_109->Location = System::Drawing::Point(318, 276);
			this->lbDIn_109->Name = L"lbDIn_109";
			this->lbDIn_109->Size = System::Drawing::Size(25, 13);
			this->lbDIn_109->TabIndex = 108;
			this->lbDIn_109->Text = L"109";
			// 
			// lbDIn_108
			// 
			this->lbDIn_108->AutoSize = true;
			this->lbDIn_108->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_108->Location = System::Drawing::Point(318, 256);
			this->lbDIn_108->Name = L"lbDIn_108";
			this->lbDIn_108->Size = System::Drawing::Size(25, 13);
			this->lbDIn_108->TabIndex = 107;
			this->lbDIn_108->Text = L"108";
			// 
			// lbDIn_107
			// 
			this->lbDIn_107->AutoSize = true;
			this->lbDIn_107->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_107->Location = System::Drawing::Point(318, 236);
			this->lbDIn_107->Name = L"lbDIn_107";
			this->lbDIn_107->Size = System::Drawing::Size(25, 13);
			this->lbDIn_107->TabIndex = 106;
			this->lbDIn_107->Text = L"107";
			// 
			// lbDIn_106
			// 
			this->lbDIn_106->AutoSize = true;
			this->lbDIn_106->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_106->Location = System::Drawing::Point(318, 216);
			this->lbDIn_106->Name = L"lbDIn_106";
			this->lbDIn_106->Size = System::Drawing::Size(25, 13);
			this->lbDIn_106->TabIndex = 105;
			this->lbDIn_106->Text = L"106";
			// 
			// lbDIn_105
			// 
			this->lbDIn_105->AutoSize = true;
			this->lbDIn_105->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_105->Location = System::Drawing::Point(318, 196);
			this->lbDIn_105->Name = L"lbDIn_105";
			this->lbDIn_105->Size = System::Drawing::Size(25, 13);
			this->lbDIn_105->TabIndex = 104;
			this->lbDIn_105->Text = L"105";
			// 
			// lbDIn_104
			// 
			this->lbDIn_104->AutoSize = true;
			this->lbDIn_104->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_104->Location = System::Drawing::Point(319, 160);
			this->lbDIn_104->Name = L"lbDIn_104";
			this->lbDIn_104->Size = System::Drawing::Size(25, 13);
			this->lbDIn_104->TabIndex = 103;
			this->lbDIn_104->Text = L"104";
			// 
			// lbDIn_103
			// 
			this->lbDIn_103->AutoSize = true;
			this->lbDIn_103->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_103->Location = System::Drawing::Point(319, 140);
			this->lbDIn_103->Name = L"lbDIn_103";
			this->lbDIn_103->Size = System::Drawing::Size(25, 13);
			this->lbDIn_103->TabIndex = 102;
			this->lbDIn_103->Text = L"103";
			// 
			// lbDIn_102
			// 
			this->lbDIn_102->AutoSize = true;
			this->lbDIn_102->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_102->Location = System::Drawing::Point(319, 120);
			this->lbDIn_102->Name = L"lbDIn_102";
			this->lbDIn_102->Size = System::Drawing::Size(25, 13);
			this->lbDIn_102->TabIndex = 101;
			this->lbDIn_102->Text = L"102";
			// 
			// lbDIn_101
			// 
			this->lbDIn_101->AutoSize = true;
			this->lbDIn_101->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_101->Location = System::Drawing::Point(319, 100);
			this->lbDIn_101->Name = L"lbDIn_101";
			this->lbDIn_101->Size = System::Drawing::Size(25, 13);
			this->lbDIn_101->TabIndex = 100;
			this->lbDIn_101->Text = L"101";
			// 
			// lbDIn_100
			// 
			this->lbDIn_100->AutoSize = true;
			this->lbDIn_100->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_100->Location = System::Drawing::Point(319, 80);
			this->lbDIn_100->Name = L"lbDIn_100";
			this->lbDIn_100->Size = System::Drawing::Size(25, 13);
			this->lbDIn_100->TabIndex = 99;
			this->lbDIn_100->Text = L"100";
			// 
			// lbDIn_99
			// 
			this->lbDIn_99->AutoSize = true;
			this->lbDIn_99->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_99->Location = System::Drawing::Point(319, 60);
			this->lbDIn_99->Name = L"lbDIn_99";
			this->lbDIn_99->Size = System::Drawing::Size(19, 13);
			this->lbDIn_99->TabIndex = 98;
			this->lbDIn_99->Text = L"99";
			// 
			// lbDIn_98
			// 
			this->lbDIn_98->AutoSize = true;
			this->lbDIn_98->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_98->Location = System::Drawing::Point(319, 40);
			this->lbDIn_98->Name = L"lbDIn_98";
			this->lbDIn_98->Size = System::Drawing::Size(19, 13);
			this->lbDIn_98->TabIndex = 97;
			this->lbDIn_98->Text = L"98";
			// 
			// lbDIn_97
			// 
			this->lbDIn_97->AutoSize = true;
			this->lbDIn_97->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_97->Location = System::Drawing::Point(319, 20);
			this->lbDIn_97->Name = L"lbDIn_97";
			this->lbDIn_97->Size = System::Drawing::Size(19, 13);
			this->lbDIn_97->TabIndex = 96;
			this->lbDIn_97->Text = L"97";
			// 
			// lbDIn_96
			// 
			this->lbDIn_96->AutoSize = true;
			this->lbDIn_96->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_96->Location = System::Drawing::Point(266, 336);
			this->lbDIn_96->Name = L"lbDIn_96";
			this->lbDIn_96->Size = System::Drawing::Size(19, 13);
			this->lbDIn_96->TabIndex = 95;
			this->lbDIn_96->Text = L"96";
			// 
			// lbDIn_95
			// 
			this->lbDIn_95->AutoSize = true;
			this->lbDIn_95->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_95->Location = System::Drawing::Point(266, 316);
			this->lbDIn_95->Name = L"lbDIn_95";
			this->lbDIn_95->Size = System::Drawing::Size(19, 13);
			this->lbDIn_95->TabIndex = 94;
			this->lbDIn_95->Text = L"95";
			// 
			// lbDIn_94
			// 
			this->lbDIn_94->AutoSize = true;
			this->lbDIn_94->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_94->Location = System::Drawing::Point(266, 296);
			this->lbDIn_94->Name = L"lbDIn_94";
			this->lbDIn_94->Size = System::Drawing::Size(19, 13);
			this->lbDIn_94->TabIndex = 93;
			this->lbDIn_94->Text = L"94";
			// 
			// lbDIn_93
			// 
			this->lbDIn_93->AutoSize = true;
			this->lbDIn_93->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_93->Location = System::Drawing::Point(266, 276);
			this->lbDIn_93->Name = L"lbDIn_93";
			this->lbDIn_93->Size = System::Drawing::Size(19, 13);
			this->lbDIn_93->TabIndex = 92;
			this->lbDIn_93->Text = L"93";
			// 
			// lbDIn_92
			// 
			this->lbDIn_92->AutoSize = true;
			this->lbDIn_92->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_92->Location = System::Drawing::Point(266, 256);
			this->lbDIn_92->Name = L"lbDIn_92";
			this->lbDIn_92->Size = System::Drawing::Size(19, 13);
			this->lbDIn_92->TabIndex = 91;
			this->lbDIn_92->Text = L"92";
			// 
			// lbDIn_91
			// 
			this->lbDIn_91->AutoSize = true;
			this->lbDIn_91->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_91->Location = System::Drawing::Point(266, 236);
			this->lbDIn_91->Name = L"lbDIn_91";
			this->lbDIn_91->Size = System::Drawing::Size(19, 13);
			this->lbDIn_91->TabIndex = 90;
			this->lbDIn_91->Text = L"91";
			// 
			// lbDIn_90
			// 
			this->lbDIn_90->AutoSize = true;
			this->lbDIn_90->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_90->Location = System::Drawing::Point(266, 216);
			this->lbDIn_90->Name = L"lbDIn_90";
			this->lbDIn_90->Size = System::Drawing::Size(19, 13);
			this->lbDIn_90->TabIndex = 89;
			this->lbDIn_90->Text = L"90";
			// 
			// lbDIn_89
			// 
			this->lbDIn_89->AutoSize = true;
			this->lbDIn_89->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_89->Location = System::Drawing::Point(266, 196);
			this->lbDIn_89->Name = L"lbDIn_89";
			this->lbDIn_89->Size = System::Drawing::Size(19, 13);
			this->lbDIn_89->TabIndex = 88;
			this->lbDIn_89->Text = L"89";
			// 
			// lbDIn_88
			// 
			this->lbDIn_88->AutoSize = true;
			this->lbDIn_88->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_88->Location = System::Drawing::Point(267, 160);
			this->lbDIn_88->Name = L"lbDIn_88";
			this->lbDIn_88->Size = System::Drawing::Size(19, 13);
			this->lbDIn_88->TabIndex = 87;
			this->lbDIn_88->Text = L"88";
			// 
			// lbDIn_87
			// 
			this->lbDIn_87->AutoSize = true;
			this->lbDIn_87->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_87->Location = System::Drawing::Point(267, 140);
			this->lbDIn_87->Name = L"lbDIn_87";
			this->lbDIn_87->Size = System::Drawing::Size(19, 13);
			this->lbDIn_87->TabIndex = 86;
			this->lbDIn_87->Text = L"87";
			// 
			// lbDIn_86
			// 
			this->lbDIn_86->AutoSize = true;
			this->lbDIn_86->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_86->Location = System::Drawing::Point(267, 120);
			this->lbDIn_86->Name = L"lbDIn_86";
			this->lbDIn_86->Size = System::Drawing::Size(19, 13);
			this->lbDIn_86->TabIndex = 85;
			this->lbDIn_86->Text = L"86";
			// 
			// lbDIn_85
			// 
			this->lbDIn_85->AutoSize = true;
			this->lbDIn_85->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_85->Location = System::Drawing::Point(267, 100);
			this->lbDIn_85->Name = L"lbDIn_85";
			this->lbDIn_85->Size = System::Drawing::Size(19, 13);
			this->lbDIn_85->TabIndex = 84;
			this->lbDIn_85->Text = L"85";
			// 
			// lbDIn_84
			// 
			this->lbDIn_84->AutoSize = true;
			this->lbDIn_84->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_84->Location = System::Drawing::Point(267, 80);
			this->lbDIn_84->Name = L"lbDIn_84";
			this->lbDIn_84->Size = System::Drawing::Size(19, 13);
			this->lbDIn_84->TabIndex = 83;
			this->lbDIn_84->Text = L"84";
			// 
			// lbDIn_83
			// 
			this->lbDIn_83->AutoSize = true;
			this->lbDIn_83->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_83->Location = System::Drawing::Point(267, 60);
			this->lbDIn_83->Name = L"lbDIn_83";
			this->lbDIn_83->Size = System::Drawing::Size(19, 13);
			this->lbDIn_83->TabIndex = 82;
			this->lbDIn_83->Text = L"83";
			// 
			// lbDIn_82
			// 
			this->lbDIn_82->AutoSize = true;
			this->lbDIn_82->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_82->Location = System::Drawing::Point(267, 40);
			this->lbDIn_82->Name = L"lbDIn_82";
			this->lbDIn_82->Size = System::Drawing::Size(19, 13);
			this->lbDIn_82->TabIndex = 81;
			this->lbDIn_82->Text = L"82";
			// 
			// lbDIn_81
			// 
			this->lbDIn_81->AutoSize = true;
			this->lbDIn_81->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_81->Location = System::Drawing::Point(267, 20);
			this->lbDIn_81->Name = L"lbDIn_81";
			this->lbDIn_81->Size = System::Drawing::Size(19, 13);
			this->lbDIn_81->TabIndex = 80;
			this->lbDIn_81->Text = L"81";
			// 
			// lbDIn_80
			// 
			this->lbDIn_80->AutoSize = true;
			this->lbDIn_80->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_80->Location = System::Drawing::Point(214, 336);
			this->lbDIn_80->Name = L"lbDIn_80";
			this->lbDIn_80->Size = System::Drawing::Size(19, 13);
			this->lbDIn_80->TabIndex = 79;
			this->lbDIn_80->Text = L"80";
			// 
			// lbDIn_79
			// 
			this->lbDIn_79->AutoSize = true;
			this->lbDIn_79->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_79->Location = System::Drawing::Point(214, 316);
			this->lbDIn_79->Name = L"lbDIn_79";
			this->lbDIn_79->Size = System::Drawing::Size(19, 13);
			this->lbDIn_79->TabIndex = 78;
			this->lbDIn_79->Text = L"79";
			// 
			// lbDIn_78
			// 
			this->lbDIn_78->AutoSize = true;
			this->lbDIn_78->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_78->Location = System::Drawing::Point(214, 296);
			this->lbDIn_78->Name = L"lbDIn_78";
			this->lbDIn_78->Size = System::Drawing::Size(19, 13);
			this->lbDIn_78->TabIndex = 77;
			this->lbDIn_78->Text = L"78";
			// 
			// lbDIn_77
			// 
			this->lbDIn_77->AutoSize = true;
			this->lbDIn_77->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_77->Location = System::Drawing::Point(214, 276);
			this->lbDIn_77->Name = L"lbDIn_77";
			this->lbDIn_77->Size = System::Drawing::Size(19, 13);
			this->lbDIn_77->TabIndex = 76;
			this->lbDIn_77->Text = L"77";
			// 
			// lbDIn_76
			// 
			this->lbDIn_76->AutoSize = true;
			this->lbDIn_76->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_76->Location = System::Drawing::Point(214, 256);
			this->lbDIn_76->Name = L"lbDIn_76";
			this->lbDIn_76->Size = System::Drawing::Size(19, 13);
			this->lbDIn_76->TabIndex = 75;
			this->lbDIn_76->Text = L"76";
			// 
			// lbDIn_75
			// 
			this->lbDIn_75->AutoSize = true;
			this->lbDIn_75->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_75->Location = System::Drawing::Point(214, 236);
			this->lbDIn_75->Name = L"lbDIn_75";
			this->lbDIn_75->Size = System::Drawing::Size(19, 13);
			this->lbDIn_75->TabIndex = 74;
			this->lbDIn_75->Text = L"75";
			// 
			// lbDIn_74
			// 
			this->lbDIn_74->AutoSize = true;
			this->lbDIn_74->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_74->Location = System::Drawing::Point(214, 216);
			this->lbDIn_74->Name = L"lbDIn_74";
			this->lbDIn_74->Size = System::Drawing::Size(19, 13);
			this->lbDIn_74->TabIndex = 73;
			this->lbDIn_74->Text = L"74";
			// 
			// lbDIn_73
			// 
			this->lbDIn_73->AutoSize = true;
			this->lbDIn_73->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_73->Location = System::Drawing::Point(214, 196);
			this->lbDIn_73->Name = L"lbDIn_73";
			this->lbDIn_73->Size = System::Drawing::Size(19, 13);
			this->lbDIn_73->TabIndex = 72;
			this->lbDIn_73->Text = L"73";
			// 
			// lbDIn_72
			// 
			this->lbDIn_72->AutoSize = true;
			this->lbDIn_72->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_72->Location = System::Drawing::Point(215, 160);
			this->lbDIn_72->Name = L"lbDIn_72";
			this->lbDIn_72->Size = System::Drawing::Size(19, 13);
			this->lbDIn_72->TabIndex = 71;
			this->lbDIn_72->Text = L"72";
			// 
			// lbDIn_71
			// 
			this->lbDIn_71->AutoSize = true;
			this->lbDIn_71->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_71->Location = System::Drawing::Point(215, 140);
			this->lbDIn_71->Name = L"lbDIn_71";
			this->lbDIn_71->Size = System::Drawing::Size(19, 13);
			this->lbDIn_71->TabIndex = 70;
			this->lbDIn_71->Text = L"71";
			// 
			// lbDIn_70
			// 
			this->lbDIn_70->AutoSize = true;
			this->lbDIn_70->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_70->Location = System::Drawing::Point(215, 120);
			this->lbDIn_70->Name = L"lbDIn_70";
			this->lbDIn_70->Size = System::Drawing::Size(19, 13);
			this->lbDIn_70->TabIndex = 69;
			this->lbDIn_70->Text = L"70";
			// 
			// lbDIn_69
			// 
			this->lbDIn_69->AutoSize = true;
			this->lbDIn_69->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_69->Location = System::Drawing::Point(215, 100);
			this->lbDIn_69->Name = L"lbDIn_69";
			this->lbDIn_69->Size = System::Drawing::Size(19, 13);
			this->lbDIn_69->TabIndex = 68;
			this->lbDIn_69->Text = L"69";
			// 
			// lbDIn_68
			// 
			this->lbDIn_68->AutoSize = true;
			this->lbDIn_68->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_68->Location = System::Drawing::Point(215, 80);
			this->lbDIn_68->Name = L"lbDIn_68";
			this->lbDIn_68->Size = System::Drawing::Size(19, 13);
			this->lbDIn_68->TabIndex = 67;
			this->lbDIn_68->Text = L"68";
			// 
			// lbDIn_67
			// 
			this->lbDIn_67->AutoSize = true;
			this->lbDIn_67->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_67->Location = System::Drawing::Point(215, 60);
			this->lbDIn_67->Name = L"lbDIn_67";
			this->lbDIn_67->Size = System::Drawing::Size(19, 13);
			this->lbDIn_67->TabIndex = 66;
			this->lbDIn_67->Text = L"67";
			// 
			// lbDIn_66
			// 
			this->lbDIn_66->AutoSize = true;
			this->lbDIn_66->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_66->Location = System::Drawing::Point(215, 40);
			this->lbDIn_66->Name = L"lbDIn_66";
			this->lbDIn_66->Size = System::Drawing::Size(19, 13);
			this->lbDIn_66->TabIndex = 65;
			this->lbDIn_66->Text = L"66";
			// 
			// lbDIn_65
			// 
			this->lbDIn_65->AutoSize = true;
			this->lbDIn_65->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_65->Location = System::Drawing::Point(215, 20);
			this->lbDIn_65->Name = L"lbDIn_65";
			this->lbDIn_65->Size = System::Drawing::Size(19, 13);
			this->lbDIn_65->TabIndex = 64;
			this->lbDIn_65->Text = L"65";
			// 
			// lbDIn_64
			// 
			this->lbDIn_64->AutoSize = true;
			this->lbDIn_64->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_64->Location = System::Drawing::Point(162, 336);
			this->lbDIn_64->Name = L"lbDIn_64";
			this->lbDIn_64->Size = System::Drawing::Size(19, 13);
			this->lbDIn_64->TabIndex = 63;
			this->lbDIn_64->Text = L"64";
			// 
			// lbDIn_63
			// 
			this->lbDIn_63->AutoSize = true;
			this->lbDIn_63->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_63->Location = System::Drawing::Point(162, 316);
			this->lbDIn_63->Name = L"lbDIn_63";
			this->lbDIn_63->Size = System::Drawing::Size(19, 13);
			this->lbDIn_63->TabIndex = 62;
			this->lbDIn_63->Text = L"63";
			// 
			// lbDIn_62
			// 
			this->lbDIn_62->AutoSize = true;
			this->lbDIn_62->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_62->Location = System::Drawing::Point(162, 296);
			this->lbDIn_62->Name = L"lbDIn_62";
			this->lbDIn_62->Size = System::Drawing::Size(19, 13);
			this->lbDIn_62->TabIndex = 61;
			this->lbDIn_62->Text = L"62";
			// 
			// lbDIn_61
			// 
			this->lbDIn_61->AutoSize = true;
			this->lbDIn_61->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_61->Location = System::Drawing::Point(162, 276);
			this->lbDIn_61->Name = L"lbDIn_61";
			this->lbDIn_61->Size = System::Drawing::Size(19, 13);
			this->lbDIn_61->TabIndex = 60;
			this->lbDIn_61->Text = L"61";
			// 
			// lbDIn_60
			// 
			this->lbDIn_60->AutoSize = true;
			this->lbDIn_60->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_60->Location = System::Drawing::Point(162, 256);
			this->lbDIn_60->Name = L"lbDIn_60";
			this->lbDIn_60->Size = System::Drawing::Size(19, 13);
			this->lbDIn_60->TabIndex = 59;
			this->lbDIn_60->Text = L"60";
			// 
			// lbDIn_59
			// 
			this->lbDIn_59->AutoSize = true;
			this->lbDIn_59->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_59->Location = System::Drawing::Point(162, 236);
			this->lbDIn_59->Name = L"lbDIn_59";
			this->lbDIn_59->Size = System::Drawing::Size(19, 13);
			this->lbDIn_59->TabIndex = 58;
			this->lbDIn_59->Text = L"59";
			// 
			// lbDIn_58
			// 
			this->lbDIn_58->AutoSize = true;
			this->lbDIn_58->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_58->Location = System::Drawing::Point(162, 216);
			this->lbDIn_58->Name = L"lbDIn_58";
			this->lbDIn_58->Size = System::Drawing::Size(19, 13);
			this->lbDIn_58->TabIndex = 57;
			this->lbDIn_58->Text = L"58";
			// 
			// lbDIn_57
			// 
			this->lbDIn_57->AutoSize = true;
			this->lbDIn_57->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_57->Location = System::Drawing::Point(162, 196);
			this->lbDIn_57->Name = L"lbDIn_57";
			this->lbDIn_57->Size = System::Drawing::Size(19, 13);
			this->lbDIn_57->TabIndex = 56;
			this->lbDIn_57->Text = L"57";
			// 
			// lbDIn_56
			// 
			this->lbDIn_56->AutoSize = true;
			this->lbDIn_56->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_56->Location = System::Drawing::Point(163, 160);
			this->lbDIn_56->Name = L"lbDIn_56";
			this->lbDIn_56->Size = System::Drawing::Size(19, 13);
			this->lbDIn_56->TabIndex = 55;
			this->lbDIn_56->Text = L"56";
			// 
			// lbDIn_55
			// 
			this->lbDIn_55->AutoSize = true;
			this->lbDIn_55->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_55->Location = System::Drawing::Point(163, 140);
			this->lbDIn_55->Name = L"lbDIn_55";
			this->lbDIn_55->Size = System::Drawing::Size(19, 13);
			this->lbDIn_55->TabIndex = 54;
			this->lbDIn_55->Text = L"55";
			// 
			// lbDIn_54
			// 
			this->lbDIn_54->AutoSize = true;
			this->lbDIn_54->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_54->Location = System::Drawing::Point(163, 120);
			this->lbDIn_54->Name = L"lbDIn_54";
			this->lbDIn_54->Size = System::Drawing::Size(19, 13);
			this->lbDIn_54->TabIndex = 53;
			this->lbDIn_54->Text = L"54";
			// 
			// lbDIn_53
			// 
			this->lbDIn_53->AutoSize = true;
			this->lbDIn_53->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_53->Location = System::Drawing::Point(163, 100);
			this->lbDIn_53->Name = L"lbDIn_53";
			this->lbDIn_53->Size = System::Drawing::Size(19, 13);
			this->lbDIn_53->TabIndex = 52;
			this->lbDIn_53->Text = L"53";
			// 
			// lbDIn_52
			// 
			this->lbDIn_52->AutoSize = true;
			this->lbDIn_52->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_52->Location = System::Drawing::Point(163, 80);
			this->lbDIn_52->Name = L"lbDIn_52";
			this->lbDIn_52->Size = System::Drawing::Size(19, 13);
			this->lbDIn_52->TabIndex = 51;
			this->lbDIn_52->Text = L"52";
			// 
			// lbDIn_51
			// 
			this->lbDIn_51->AutoSize = true;
			this->lbDIn_51->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_51->Location = System::Drawing::Point(163, 60);
			this->lbDIn_51->Name = L"lbDIn_51";
			this->lbDIn_51->Size = System::Drawing::Size(19, 13);
			this->lbDIn_51->TabIndex = 50;
			this->lbDIn_51->Text = L"51";
			// 
			// lbDIn_50
			// 
			this->lbDIn_50->AutoSize = true;
			this->lbDIn_50->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_50->Location = System::Drawing::Point(163, 40);
			this->lbDIn_50->Name = L"lbDIn_50";
			this->lbDIn_50->Size = System::Drawing::Size(19, 13);
			this->lbDIn_50->TabIndex = 49;
			this->lbDIn_50->Text = L"50";
			// 
			// lbDIn_49
			// 
			this->lbDIn_49->AutoSize = true;
			this->lbDIn_49->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_49->Location = System::Drawing::Point(163, 20);
			this->lbDIn_49->Name = L"lbDIn_49";
			this->lbDIn_49->Size = System::Drawing::Size(19, 13);
			this->lbDIn_49->TabIndex = 48;
			this->lbDIn_49->Text = L"49";
			// 
			// lbDIn_48
			// 
			this->lbDIn_48->AutoSize = true;
			this->lbDIn_48->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_48->Location = System::Drawing::Point(110, 336);
			this->lbDIn_48->Name = L"lbDIn_48";
			this->lbDIn_48->Size = System::Drawing::Size(19, 13);
			this->lbDIn_48->TabIndex = 47;
			this->lbDIn_48->Text = L"48";
			// 
			// lbDIn_47
			// 
			this->lbDIn_47->AutoSize = true;
			this->lbDIn_47->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_47->Location = System::Drawing::Point(110, 316);
			this->lbDIn_47->Name = L"lbDIn_47";
			this->lbDIn_47->Size = System::Drawing::Size(19, 13);
			this->lbDIn_47->TabIndex = 46;
			this->lbDIn_47->Text = L"47";
			// 
			// lbDIn_46
			// 
			this->lbDIn_46->AutoSize = true;
			this->lbDIn_46->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_46->Location = System::Drawing::Point(110, 296);
			this->lbDIn_46->Name = L"lbDIn_46";
			this->lbDIn_46->Size = System::Drawing::Size(19, 13);
			this->lbDIn_46->TabIndex = 45;
			this->lbDIn_46->Text = L"46";
			// 
			// lbDIn_45
			// 
			this->lbDIn_45->AutoSize = true;
			this->lbDIn_45->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_45->Location = System::Drawing::Point(110, 276);
			this->lbDIn_45->Name = L"lbDIn_45";
			this->lbDIn_45->Size = System::Drawing::Size(19, 13);
			this->lbDIn_45->TabIndex = 44;
			this->lbDIn_45->Text = L"45";
			// 
			// lbDIn_44
			// 
			this->lbDIn_44->AutoSize = true;
			this->lbDIn_44->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_44->Location = System::Drawing::Point(110, 256);
			this->lbDIn_44->Name = L"lbDIn_44";
			this->lbDIn_44->Size = System::Drawing::Size(19, 13);
			this->lbDIn_44->TabIndex = 43;
			this->lbDIn_44->Text = L"44";
			// 
			// lbDIn_43
			// 
			this->lbDIn_43->AutoSize = true;
			this->lbDIn_43->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_43->Location = System::Drawing::Point(110, 236);
			this->lbDIn_43->Name = L"lbDIn_43";
			this->lbDIn_43->Size = System::Drawing::Size(19, 13);
			this->lbDIn_43->TabIndex = 42;
			this->lbDIn_43->Text = L"43";
			// 
			// lbDIn_42
			// 
			this->lbDIn_42->AutoSize = true;
			this->lbDIn_42->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_42->Location = System::Drawing::Point(110, 216);
			this->lbDIn_42->Name = L"lbDIn_42";
			this->lbDIn_42->Size = System::Drawing::Size(19, 13);
			this->lbDIn_42->TabIndex = 41;
			this->lbDIn_42->Text = L"42";
			// 
			// lbDIn_41
			// 
			this->lbDIn_41->AutoSize = true;
			this->lbDIn_41->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_41->Location = System::Drawing::Point(110, 196);
			this->lbDIn_41->Name = L"lbDIn_41";
			this->lbDIn_41->Size = System::Drawing::Size(19, 13);
			this->lbDIn_41->TabIndex = 40;
			this->lbDIn_41->Text = L"41";
			// 
			// lbDIn_40
			// 
			this->lbDIn_40->AutoSize = true;
			this->lbDIn_40->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_40->Location = System::Drawing::Point(111, 160);
			this->lbDIn_40->Name = L"lbDIn_40";
			this->lbDIn_40->Size = System::Drawing::Size(19, 13);
			this->lbDIn_40->TabIndex = 39;
			this->lbDIn_40->Text = L"40";
			// 
			// lbDIn_39
			// 
			this->lbDIn_39->AutoSize = true;
			this->lbDIn_39->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_39->Location = System::Drawing::Point(111, 140);
			this->lbDIn_39->Name = L"lbDIn_39";
			this->lbDIn_39->Size = System::Drawing::Size(19, 13);
			this->lbDIn_39->TabIndex = 38;
			this->lbDIn_39->Text = L"39";
			// 
			// lbDIn_38
			// 
			this->lbDIn_38->AutoSize = true;
			this->lbDIn_38->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_38->Location = System::Drawing::Point(111, 120);
			this->lbDIn_38->Name = L"lbDIn_38";
			this->lbDIn_38->Size = System::Drawing::Size(19, 13);
			this->lbDIn_38->TabIndex = 37;
			this->lbDIn_38->Text = L"38";
			// 
			// lbDIn_37
			// 
			this->lbDIn_37->AutoSize = true;
			this->lbDIn_37->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_37->Location = System::Drawing::Point(111, 100);
			this->lbDIn_37->Name = L"lbDIn_37";
			this->lbDIn_37->Size = System::Drawing::Size(19, 13);
			this->lbDIn_37->TabIndex = 36;
			this->lbDIn_37->Text = L"37";
			// 
			// lbDIn_36
			// 
			this->lbDIn_36->AutoSize = true;
			this->lbDIn_36->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_36->Location = System::Drawing::Point(111, 80);
			this->lbDIn_36->Name = L"lbDIn_36";
			this->lbDIn_36->Size = System::Drawing::Size(19, 13);
			this->lbDIn_36->TabIndex = 35;
			this->lbDIn_36->Text = L"36";
			// 
			// lbDIn_35
			// 
			this->lbDIn_35->AutoSize = true;
			this->lbDIn_35->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_35->Location = System::Drawing::Point(111, 60);
			this->lbDIn_35->Name = L"lbDIn_35";
			this->lbDIn_35->Size = System::Drawing::Size(19, 13);
			this->lbDIn_35->TabIndex = 34;
			this->lbDIn_35->Text = L"35";
			// 
			// lbDIn_34
			// 
			this->lbDIn_34->AutoSize = true;
			this->lbDIn_34->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_34->Location = System::Drawing::Point(111, 40);
			this->lbDIn_34->Name = L"lbDIn_34";
			this->lbDIn_34->Size = System::Drawing::Size(19, 13);
			this->lbDIn_34->TabIndex = 33;
			this->lbDIn_34->Text = L"34";
			// 
			// lbDIn_33
			// 
			this->lbDIn_33->AutoSize = true;
			this->lbDIn_33->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_33->Location = System::Drawing::Point(111, 20);
			this->lbDIn_33->Name = L"lbDIn_33";
			this->lbDIn_33->Size = System::Drawing::Size(19, 13);
			this->lbDIn_33->TabIndex = 32;
			this->lbDIn_33->Text = L"33";
			// 
			// lbDIn_32
			// 
			this->lbDIn_32->AutoSize = true;
			this->lbDIn_32->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_32->Location = System::Drawing::Point(58, 336);
			this->lbDIn_32->Name = L"lbDIn_32";
			this->lbDIn_32->Size = System::Drawing::Size(19, 13);
			this->lbDIn_32->TabIndex = 31;
			this->lbDIn_32->Text = L"32";
			// 
			// lbDIn_31
			// 
			this->lbDIn_31->AutoSize = true;
			this->lbDIn_31->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_31->Location = System::Drawing::Point(58, 316);
			this->lbDIn_31->Name = L"lbDIn_31";
			this->lbDIn_31->Size = System::Drawing::Size(19, 13);
			this->lbDIn_31->TabIndex = 30;
			this->lbDIn_31->Text = L"31";
			// 
			// lbDIn_30
			// 
			this->lbDIn_30->AutoSize = true;
			this->lbDIn_30->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_30->Location = System::Drawing::Point(58, 296);
			this->lbDIn_30->Name = L"lbDIn_30";
			this->lbDIn_30->Size = System::Drawing::Size(19, 13);
			this->lbDIn_30->TabIndex = 29;
			this->lbDIn_30->Text = L"30";
			// 
			// lbDIn_29
			// 
			this->lbDIn_29->AutoSize = true;
			this->lbDIn_29->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_29->Location = System::Drawing::Point(58, 276);
			this->lbDIn_29->Name = L"lbDIn_29";
			this->lbDIn_29->Size = System::Drawing::Size(19, 13);
			this->lbDIn_29->TabIndex = 28;
			this->lbDIn_29->Text = L"29";
			// 
			// lbDIn_28
			// 
			this->lbDIn_28->AutoSize = true;
			this->lbDIn_28->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_28->Location = System::Drawing::Point(58, 256);
			this->lbDIn_28->Name = L"lbDIn_28";
			this->lbDIn_28->Size = System::Drawing::Size(19, 13);
			this->lbDIn_28->TabIndex = 27;
			this->lbDIn_28->Text = L"28";
			// 
			// lbDIn_27
			// 
			this->lbDIn_27->AutoSize = true;
			this->lbDIn_27->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_27->Location = System::Drawing::Point(58, 236);
			this->lbDIn_27->Name = L"lbDIn_27";
			this->lbDIn_27->Size = System::Drawing::Size(19, 13);
			this->lbDIn_27->TabIndex = 26;
			this->lbDIn_27->Text = L"27";
			// 
			// lbDIn_26
			// 
			this->lbDIn_26->AutoSize = true;
			this->lbDIn_26->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_26->Location = System::Drawing::Point(58, 216);
			this->lbDIn_26->Name = L"lbDIn_26";
			this->lbDIn_26->Size = System::Drawing::Size(19, 13);
			this->lbDIn_26->TabIndex = 25;
			this->lbDIn_26->Text = L"26";
			// 
			// lbDIn_25
			// 
			this->lbDIn_25->AutoSize = true;
			this->lbDIn_25->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_25->Location = System::Drawing::Point(58, 196);
			this->lbDIn_25->Name = L"lbDIn_25";
			this->lbDIn_25->Size = System::Drawing::Size(19, 13);
			this->lbDIn_25->TabIndex = 24;
			this->lbDIn_25->Text = L"25";
			// 
			// lbDIn_24
			// 
			this->lbDIn_24->AutoSize = true;
			this->lbDIn_24->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_24->Location = System::Drawing::Point(59, 160);
			this->lbDIn_24->Name = L"lbDIn_24";
			this->lbDIn_24->Size = System::Drawing::Size(19, 13);
			this->lbDIn_24->TabIndex = 23;
			this->lbDIn_24->Text = L"24";
			// 
			// lbDIn_23
			// 
			this->lbDIn_23->AutoSize = true;
			this->lbDIn_23->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_23->Location = System::Drawing::Point(59, 140);
			this->lbDIn_23->Name = L"lbDIn_23";
			this->lbDIn_23->Size = System::Drawing::Size(19, 13);
			this->lbDIn_23->TabIndex = 22;
			this->lbDIn_23->Text = L"23";
			// 
			// lbDIn_22
			// 
			this->lbDIn_22->AutoSize = true;
			this->lbDIn_22->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_22->Location = System::Drawing::Point(59, 120);
			this->lbDIn_22->Name = L"lbDIn_22";
			this->lbDIn_22->Size = System::Drawing::Size(19, 13);
			this->lbDIn_22->TabIndex = 21;
			this->lbDIn_22->Text = L"22";
			// 
			// lbDIn_21
			// 
			this->lbDIn_21->AutoSize = true;
			this->lbDIn_21->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_21->Location = System::Drawing::Point(59, 100);
			this->lbDIn_21->Name = L"lbDIn_21";
			this->lbDIn_21->Size = System::Drawing::Size(19, 13);
			this->lbDIn_21->TabIndex = 20;
			this->lbDIn_21->Text = L"21";
			// 
			// lbDIn_20
			// 
			this->lbDIn_20->AutoSize = true;
			this->lbDIn_20->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_20->Location = System::Drawing::Point(59, 80);
			this->lbDIn_20->Name = L"lbDIn_20";
			this->lbDIn_20->Size = System::Drawing::Size(19, 13);
			this->lbDIn_20->TabIndex = 19;
			this->lbDIn_20->Text = L"20";
			// 
			// lbDIn_19
			// 
			this->lbDIn_19->AutoSize = true;
			this->lbDIn_19->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_19->Location = System::Drawing::Point(59, 60);
			this->lbDIn_19->Name = L"lbDIn_19";
			this->lbDIn_19->Size = System::Drawing::Size(19, 13);
			this->lbDIn_19->TabIndex = 18;
			this->lbDIn_19->Text = L"19";
			// 
			// lbDIn_18
			// 
			this->lbDIn_18->AutoSize = true;
			this->lbDIn_18->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_18->Location = System::Drawing::Point(59, 40);
			this->lbDIn_18->Name = L"lbDIn_18";
			this->lbDIn_18->Size = System::Drawing::Size(19, 13);
			this->lbDIn_18->TabIndex = 17;
			this->lbDIn_18->Text = L"18";
			// 
			// lbDIn_17
			// 
			this->lbDIn_17->AutoSize = true;
			this->lbDIn_17->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_17->Location = System::Drawing::Point(59, 20);
			this->lbDIn_17->Name = L"lbDIn_17";
			this->lbDIn_17->Size = System::Drawing::Size(19, 13);
			this->lbDIn_17->TabIndex = 16;
			this->lbDIn_17->Text = L"17";
			// 
			// lbDIn_16
			// 
			this->lbDIn_16->AutoSize = true;
			this->lbDIn_16->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_16->Location = System::Drawing::Point(6, 336);
			this->lbDIn_16->Name = L"lbDIn_16";
			this->lbDIn_16->Size = System::Drawing::Size(19, 13);
			this->lbDIn_16->TabIndex = 15;
			this->lbDIn_16->Text = L"16";
			// 
			// lbDIn_15
			// 
			this->lbDIn_15->AutoSize = true;
			this->lbDIn_15->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_15->Location = System::Drawing::Point(6, 316);
			this->lbDIn_15->Name = L"lbDIn_15";
			this->lbDIn_15->Size = System::Drawing::Size(19, 13);
			this->lbDIn_15->TabIndex = 14;
			this->lbDIn_15->Text = L"15";
			// 
			// lbDIn_14
			// 
			this->lbDIn_14->AutoSize = true;
			this->lbDIn_14->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_14->Location = System::Drawing::Point(6, 296);
			this->lbDIn_14->Name = L"lbDIn_14";
			this->lbDIn_14->Size = System::Drawing::Size(19, 13);
			this->lbDIn_14->TabIndex = 13;
			this->lbDIn_14->Text = L"14";
			// 
			// lbDIn_13
			// 
			this->lbDIn_13->AutoSize = true;
			this->lbDIn_13->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_13->Location = System::Drawing::Point(6, 276);
			this->lbDIn_13->Name = L"lbDIn_13";
			this->lbDIn_13->Size = System::Drawing::Size(19, 13);
			this->lbDIn_13->TabIndex = 12;
			this->lbDIn_13->Text = L"13";
			// 
			// lbDIn_12
			// 
			this->lbDIn_12->AutoSize = true;
			this->lbDIn_12->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_12->Location = System::Drawing::Point(6, 256);
			this->lbDIn_12->Name = L"lbDIn_12";
			this->lbDIn_12->Size = System::Drawing::Size(19, 13);
			this->lbDIn_12->TabIndex = 11;
			this->lbDIn_12->Text = L"12";
			// 
			// lbDIn_11
			// 
			this->lbDIn_11->AutoSize = true;
			this->lbDIn_11->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_11->Location = System::Drawing::Point(6, 236);
			this->lbDIn_11->Name = L"lbDIn_11";
			this->lbDIn_11->Size = System::Drawing::Size(19, 13);
			this->lbDIn_11->TabIndex = 10;
			this->lbDIn_11->Text = L"11";
			// 
			// lbDIn_10
			// 
			this->lbDIn_10->AutoSize = true;
			this->lbDIn_10->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_10->Location = System::Drawing::Point(6, 216);
			this->lbDIn_10->Name = L"lbDIn_10";
			this->lbDIn_10->Size = System::Drawing::Size(19, 13);
			this->lbDIn_10->TabIndex = 9;
			this->lbDIn_10->Text = L"10";
			// 
			// lbDIn_9
			// 
			this->lbDIn_9->AutoSize = true;
			this->lbDIn_9->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_9->Location = System::Drawing::Point(6, 196);
			this->lbDIn_9->Name = L"lbDIn_9";
			this->lbDIn_9->Size = System::Drawing::Size(13, 13);
			this->lbDIn_9->TabIndex = 8;
			this->lbDIn_9->Text = L"9";
			// 
			// lbDIn_8
			// 
			this->lbDIn_8->AutoSize = true;
			this->lbDIn_8->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_8->Location = System::Drawing::Point(7, 160);
			this->lbDIn_8->Name = L"lbDIn_8";
			this->lbDIn_8->Size = System::Drawing::Size(13, 13);
			this->lbDIn_8->TabIndex = 7;
			this->lbDIn_8->Text = L"8";
			// 
			// lbDIn_7
			// 
			this->lbDIn_7->AutoSize = true;
			this->lbDIn_7->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_7->Location = System::Drawing::Point(7, 140);
			this->lbDIn_7->Name = L"lbDIn_7";
			this->lbDIn_7->Size = System::Drawing::Size(13, 13);
			this->lbDIn_7->TabIndex = 6;
			this->lbDIn_7->Text = L"7";
			// 
			// lbDIn_6
			// 
			this->lbDIn_6->AutoSize = true;
			this->lbDIn_6->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_6->Location = System::Drawing::Point(7, 120);
			this->lbDIn_6->Name = L"lbDIn_6";
			this->lbDIn_6->Size = System::Drawing::Size(13, 13);
			this->lbDIn_6->TabIndex = 5;
			this->lbDIn_6->Text = L"6";
			// 
			// lbDIn_5
			// 
			this->lbDIn_5->AutoSize = true;
			this->lbDIn_5->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_5->Location = System::Drawing::Point(7, 100);
			this->lbDIn_5->Name = L"lbDIn_5";
			this->lbDIn_5->Size = System::Drawing::Size(13, 13);
			this->lbDIn_5->TabIndex = 4;
			this->lbDIn_5->Text = L"5";
			// 
			// lbDIn_4
			// 
			this->lbDIn_4->AutoSize = true;
			this->lbDIn_4->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_4->Location = System::Drawing::Point(7, 80);
			this->lbDIn_4->Name = L"lbDIn_4";
			this->lbDIn_4->Size = System::Drawing::Size(13, 13);
			this->lbDIn_4->TabIndex = 3;
			this->lbDIn_4->Text = L"4";
			// 
			// lbDIn_3
			// 
			this->lbDIn_3->AutoSize = true;
			this->lbDIn_3->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_3->Location = System::Drawing::Point(7, 60);
			this->lbDIn_3->Name = L"lbDIn_3";
			this->lbDIn_3->Size = System::Drawing::Size(13, 13);
			this->lbDIn_3->TabIndex = 2;
			this->lbDIn_3->Text = L"3";
			// 
			// lbDIn_2
			// 
			this->lbDIn_2->AutoSize = true;
			this->lbDIn_2->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbDIn_2->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_2->Location = System::Drawing::Point(7, 40);
			this->lbDIn_2->Name = L"lbDIn_2";
			this->lbDIn_2->Size = System::Drawing::Size(13, 13);
			this->lbDIn_2->TabIndex = 1;
			this->lbDIn_2->Text = L"2";
			// 
			// lbDIn_1
			// 
			this->lbDIn_1->AutoSize = true;
			this->lbDIn_1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->lbDIn_1->ForeColor = System::Drawing::SystemColors::GrayText;
			this->lbDIn_1->Location = System::Drawing::Point(7, 20);
			this->lbDIn_1->Name = L"lbDIn_1";
			this->lbDIn_1->Size = System::Drawing::Size(13, 13);
			this->lbDIn_1->TabIndex = 0;
			this->lbDIn_1->Text = L"1";
			// 
			// tbSampling
			// 
			this->tbSampling->Controls->Add(this->label15);
			this->tbSampling->Controls->Add(this->label14);
			this->tbSampling->Controls->Add(this->label13);
			this->tbSampling->Controls->Add(this->label12);
			this->tbSampling->Controls->Add(this->label11);
			this->tbSampling->Controls->Add(this->label10);
			this->tbSampling->Controls->Add(this->label9);
			this->tbSampling->Controls->Add(this->label8);
			this->tbSampling->Controls->Add(this->btnSampling_AddDigitalOutputs);
			this->tbSampling->Controls->Add(this->btnSampling_AddDigitalInputs);
			this->tbSampling->Controls->Add(this->cblSampling_DigitalOutputs);
			this->tbSampling->Controls->Add(this->cblSampling_DigitalInputs);
			this->tbSampling->Controls->Add(this->cblSampling_MeasChannels);
			this->tbSampling->Controls->Add(this->groupBox7);
			this->tbSampling->Controls->Add(this->groupBox6);
			this->tbSampling->Controls->Add(this->groupBox5);
			this->tbSampling->Controls->Add(this->groupBox4);
			this->tbSampling->Controls->Add(this->btnSampling_AddChannels);
			this->tbSampling->Controls->Add(this->lbSampling_NElements);
			this->tbSampling->Controls->Add(this->btnSampling_AddOutputsAll);
			this->tbSampling->Controls->Add(this->btnSampling_AddInputsAll);
			this->tbSampling->Controls->Add(this->btnSamplingReset);
			this->tbSampling->Controls->Add(this->btnSamplingAddChannelsAll);
			this->tbSampling->Location = System::Drawing::Point(4, 22);
			this->tbSampling->Name = L"tbSampling";
			this->tbSampling->Padding = System::Windows::Forms::Padding(3);
			this->tbSampling->Size = System::Drawing::Size(865, 401);
			this->tbSampling->TabIndex = 5;
			this->tbSampling->Text = L"Sampling";
			this->tbSampling->UseVisualStyleBackColor = true;
			// 
			// label15
			// 
			this->label15->AutoSize = true;
			this->label15->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->label15->ForeColor = System::Drawing::Color::Coral;
			this->label15->Location = System::Drawing::Point(666, 184);
			this->label15->Name = L"label15";
			this->label15->Size = System::Drawing::Size(24, 20);
			this->label15->TabIndex = 35;
			this->label15->Text = L"5.";
			// 
			// label14
			// 
			this->label14->AutoSize = true;
			this->label14->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->label14->ForeColor = System::Drawing::Color::Coral;
			this->label14->Location = System::Drawing::Point(666, 138);
			this->label14->Name = L"label14";
			this->label14->Size = System::Drawing::Size(24, 20);
			this->label14->TabIndex = 34;
			this->label14->Text = L"4.";
			// 
			// label13
			// 
			this->label13->AutoSize = true;
			this->label13->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->label13->ForeColor = System::Drawing::Color::Coral;
			this->label13->Location = System::Drawing::Point(5, 303);
			this->label13->Name = L"label13";
			this->label13->Size = System::Drawing::Size(24, 20);
			this->label13->TabIndex = 33;
			this->label13->Text = L"3.";
			// 
			// label12
			// 
			this->label12->AutoSize = true;
			this->label12->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->label12->ForeColor = System::Drawing::Color::Coral;
			this->label12->Location = System::Drawing::Point(5, 46);
			this->label12->Name = L"label12";
			this->label12->Size = System::Drawing::Size(24, 20);
			this->label12->TabIndex = 32;
			this->label12->Text = L"2.";
			// 
			// label11
			// 
			this->label11->AutoSize = true;
			this->label11->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->label11->ForeColor = System::Drawing::Color::Coral;
			this->label11->Location = System::Drawing::Point(5, 12);
			this->label11->Name = L"label11";
			this->label11->Size = System::Drawing::Size(24, 20);
			this->label11->TabIndex = 31;
			this->label11->Text = L"1.";
			// 
			// label10
			// 
			this->label10->AutoSize = true;
			this->label10->Location = System::Drawing::Point(406, 327);
			this->label10->Name = L"label10";
			this->label10->Size = System::Drawing::Size(16, 13);
			this->label10->TabIndex = 30;
			this->label10->Text = L"or";
			// 
			// label9
			// 
			this->label9->AutoSize = true;
			this->label9->Location = System::Drawing::Point(256, 327);
			this->label9->Name = L"label9";
			this->label9->Size = System::Drawing::Size(16, 13);
			this->label9->TabIndex = 29;
			this->label9->Text = L"or";
			// 
			// label8
			// 
			this->label8->AutoSize = true;
			this->label8->Location = System::Drawing::Point(101, 327);
			this->label8->Name = L"label8";
			this->label8->Size = System::Drawing::Size(16, 13);
			this->label8->TabIndex = 28;
			this->label8->Text = L"or";
			// 
			// btnSampling_AddDigitalOutputs
			// 
			this->btnSampling_AddDigitalOutputs->Location = System::Drawing::Point(341, 300);
			this->btnSampling_AddDigitalOutputs->Name = L"btnSampling_AddDigitalOutputs";
			this->btnSampling_AddDigitalOutputs->Size = System::Drawing::Size(148, 23);
			this->btnSampling_AddDigitalOutputs->TabIndex = 27;
			this->btnSampling_AddDigitalOutputs->Text = L"Add selected digital outputs";
			this->btnSampling_AddDigitalOutputs->UseVisualStyleBackColor = true;
			this->btnSampling_AddDigitalOutputs->Click += gcnew System::EventHandler(this, &Form1::btnSampling_AddDigitalOutputs_Click);
			// 
			// btnSampling_AddDigitalInputs
			// 
			this->btnSampling_AddDigitalInputs->Location = System::Drawing::Point(188, 300);
			this->btnSampling_AddDigitalInputs->Name = L"btnSampling_AddDigitalInputs";
			this->btnSampling_AddDigitalInputs->Size = System::Drawing::Size(148, 23);
			this->btnSampling_AddDigitalInputs->TabIndex = 26;
			this->btnSampling_AddDigitalInputs->Text = L"Add selected digital inputs";
			this->btnSampling_AddDigitalInputs->UseVisualStyleBackColor = true;
			this->btnSampling_AddDigitalInputs->Click += gcnew System::EventHandler(this, &Form1::btnSampling_AddDigitalInputs_Click);
			// 
			// cblSampling_DigitalOutputs
			// 
			this->cblSampling_DigitalOutputs->FormattingEnabled = true;
			this->cblSampling_DigitalOutputs->Items->AddRange(gcnew cli::array< System::Object^  >(3) {
				L"Output Byte 0", L"Output Byte 1",
					L"Output Byte 2"
			});
			this->cblSampling_DigitalOutputs->Location = System::Drawing::Point(342, 46);
			this->cblSampling_DigitalOutputs->Name = L"cblSampling_DigitalOutputs";
			this->cblSampling_DigitalOutputs->Size = System::Drawing::Size(148, 244);
			this->cblSampling_DigitalOutputs->TabIndex = 25;
			// 
			// cblSampling_DigitalInputs
			// 
			this->cblSampling_DigitalInputs->FormattingEnabled = true;
			this->cblSampling_DigitalInputs->Items->AddRange(gcnew cli::array< System::Object^  >(3) {
				L"Input Byte 0", L"Input Byte 1",
					L"Input Byte 2"
			});
			this->cblSampling_DigitalInputs->Location = System::Drawing::Point(188, 46);
			this->cblSampling_DigitalInputs->Name = L"cblSampling_DigitalInputs";
			this->cblSampling_DigitalInputs->Size = System::Drawing::Size(148, 244);
			this->cblSampling_DigitalInputs->TabIndex = 24;
			// 
			// cblSampling_MeasChannels
			// 
			this->cblSampling_MeasChannels->FormattingEnabled = true;
			this->cblSampling_MeasChannels->Items->AddRange(gcnew cli::array< System::Object^  >(3) { L"P1", L"P2", L"P3" });
			this->cblSampling_MeasChannels->Location = System::Drawing::Point(34, 46);
			this->cblSampling_MeasChannels->Name = L"cblSampling_MeasChannels";
			this->cblSampling_MeasChannels->Size = System::Drawing::Size(148, 244);
			this->cblSampling_MeasChannels->TabIndex = 23;
			// 
			// groupBox7
			// 
			this->groupBox7->Controls->Add(this->rbSampling_TimeStandard);
			this->groupBox7->Controls->Add(this->rbSampling_TimeMid);
			this->groupBox7->Controls->Add(this->rbSampling_TimeHigh);
			this->groupBox7->Location = System::Drawing::Point(497, 6);
			this->groupBox7->Name = L"groupBox7";
			this->groupBox7->Size = System::Drawing::Size(362, 69);
			this->groupBox7->TabIndex = 22;
			this->groupBox7->TabStop = false;
			this->groupBox7->Text = L"Sampling speed";
			// 
			// rbSampling_TimeStandard
			// 
			this->rbSampling_TimeStandard->AutoSize = true;
			this->rbSampling_TimeStandard->Location = System::Drawing::Point(9, 42);
			this->rbSampling_TimeStandard->Name = L"rbSampling_TimeStandard";
			this->rbSampling_TimeStandard->Size = System::Drawing::Size(112, 17);
			this->rbSampling_TimeStandard->TabIndex = 28;
			this->rbSampling_TimeStandard->Text = L"Standard sampling";
			this->rbSampling_TimeStandard->UseVisualStyleBackColor = true;
			// 
			// rbSampling_TimeMid
			// 
			this->rbSampling_TimeMid->AutoSize = true;
			this->rbSampling_TimeMid->Checked = true;
			this->rbSampling_TimeMid->Location = System::Drawing::Point(9, 19);
			this->rbSampling_TimeMid->Name = L"rbSampling_TimeMid";
			this->rbSampling_TimeMid->Size = System::Drawing::Size(89, 17);
			this->rbSampling_TimeMid->TabIndex = 27;
			this->rbSampling_TimeMid->TabStop = true;
			this->rbSampling_TimeMid->Text = L"Fast sampling";
			this->rbSampling_TimeMid->UseVisualStyleBackColor = true;
			// 
			// rbSampling_TimeHigh
			// 
			this->rbSampling_TimeHigh->AutoSize = true;
			this->rbSampling_TimeHigh->Location = System::Drawing::Point(194, 19);
			this->rbSampling_TimeHigh->Name = L"rbSampling_TimeHigh";
			this->rbSampling_TimeHigh->Size = System::Drawing::Size(114, 17);
			this->rbSampling_TimeHigh->TabIndex = 26;
			this->rbSampling_TimeHigh->Text = L"Ultra-Fast sampling";
			this->rbSampling_TimeHigh->UseVisualStyleBackColor = true;
			// 
			// groupBox6
			// 
			this->groupBox6->Controls->Add(this->label17);
			this->groupBox6->Controls->Add(this->rbSampling_TEndlessReadRows);
			this->groupBox6->Controls->Add(this->rbSampling_TEndlessReadCols);
			this->groupBox6->Controls->Add(this->label7);
			this->groupBox6->Controls->Add(this->btnSampling_EndlessStop);
			this->groupBox6->Controls->Add(this->btnSampling_EndlessStore);
			this->groupBox6->Controls->Add(this->btnSampling_TEndlessStart);
			this->groupBox6->Controls->Add(this->btnSampling_PrepareEndlessT);
			this->groupBox6->Controls->Add(this->nuSampling_TimeKeepSamples);
			this->groupBox6->Controls->Add(this->label6);
			this->groupBox6->Location = System::Drawing::Point(696, 81);
			this->groupBox6->Name = L"groupBox6";
			this->groupBox6->Size = System::Drawing::Size(163, 208);
			this->groupBox6->TabIndex = 13;
			this->groupBox6->TabStop = false;
			this->groupBox6->Text = L"Endless sampling";
			// 
			// label17
			// 
			this->label17->AutoSize = true;
			this->label17->Location = System::Drawing::Point(9, 85);
			this->label17->Name = L"label17";
			this->label17->Size = System::Drawing::Size(33, 13);
			this->label17->TabIndex = 29;
			this->label17->Text = L"Read";
			// 
			// rbSampling_TEndlessReadRows
			// 
			this->rbSampling_TEndlessReadRows->AutoSize = true;
			this->rbSampling_TEndlessReadRows->Checked = true;
			this->rbSampling_TEndlessReadRows->Location = System::Drawing::Point(100, 83);
			this->rbSampling_TEndlessReadRows->Name = L"rbSampling_TEndlessReadRows";
			this->rbSampling_TEndlessReadRows->Size = System::Drawing::Size(52, 17);
			this->rbSampling_TEndlessReadRows->TabIndex = 28;
			this->rbSampling_TEndlessReadRows->TabStop = true;
			this->rbSampling_TEndlessReadRows->Text = L"Rows";
			this->rbSampling_TEndlessReadRows->UseVisualStyleBackColor = true;
			// 
			// rbSampling_TEndlessReadCols
			// 
			this->rbSampling_TEndlessReadCols->AutoSize = true;
			this->rbSampling_TEndlessReadCols->Location = System::Drawing::Point(47, 83);
			this->rbSampling_TEndlessReadCols->Name = L"rbSampling_TEndlessReadCols";
			this->rbSampling_TEndlessReadCols->Size = System::Drawing::Size(47, 17);
			this->rbSampling_TEndlessReadCols->TabIndex = 27;
			this->rbSampling_TEndlessReadCols->Text = L"Col\'s";
			this->rbSampling_TEndlessReadCols->UseVisualStyleBackColor = true;
			// 
			// label7
			// 
			this->label7->AutoSize = true;
			this->label7->Location = System::Drawing::Point(106, 27);
			this->label7->Name = L"label7";
			this->label7->Size = System::Drawing::Size(47, 13);
			this->label7->TabIndex = 26;
			this->label7->Text = L"Samples";
			// 
			// btnSampling_EndlessStop
			// 
			this->btnSampling_EndlessStop->Location = System::Drawing::Point(10, 132);
			this->btnSampling_EndlessStop->Name = L"btnSampling_EndlessStop";
			this->btnSampling_EndlessStop->Size = System::Drawing::Size(143, 23);
			this->btnSampling_EndlessStop->TabIndex = 25;
			this->btnSampling_EndlessStop->Text = L"Stop";
			this->btnSampling_EndlessStop->UseVisualStyleBackColor = true;
			this->btnSampling_EndlessStop->Click += gcnew System::EventHandler(this, &Form1::btnSampling_Stop_Click);
			// 
			// btnSampling_EndlessStore
			// 
			this->btnSampling_EndlessStore->Enabled = false;
			this->btnSampling_EndlessStore->Location = System::Drawing::Point(10, 179);
			this->btnSampling_EndlessStore->Name = L"btnSampling_EndlessStore";
			this->btnSampling_EndlessStore->Size = System::Drawing::Size(143, 23);
			this->btnSampling_EndlessStore->TabIndex = 24;
			this->btnSampling_EndlessStore->Text = L"Store newest to CSV file";
			this->btnSampling_EndlessStore->UseVisualStyleBackColor = true;
			this->btnSampling_EndlessStore->Click += gcnew System::EventHandler(this, &Form1::btnSampling_EndlessStore_Click);
			// 
			// btnSampling_TEndlessStart
			// 
			this->btnSampling_TEndlessStart->Enabled = false;
			this->btnSampling_TEndlessStart->Location = System::Drawing::Point(10, 103);
			this->btnSampling_TEndlessStart->Name = L"btnSampling_TEndlessStart";
			this->btnSampling_TEndlessStart->Size = System::Drawing::Size(143, 23);
			this->btnSampling_TEndlessStart->TabIndex = 23;
			this->btnSampling_TEndlessStart->Text = L"Start";
			this->btnSampling_TEndlessStart->UseVisualStyleBackColor = true;
			this->btnSampling_TEndlessStart->Click += gcnew System::EventHandler(this, &Form1::btnSampling_TEndlessStart_Click);
			// 
			// btnSampling_PrepareEndlessT
			// 
			this->btnSampling_PrepareEndlessT->Enabled = false;
			this->btnSampling_PrepareEndlessT->Location = System::Drawing::Point(10, 57);
			this->btnSampling_PrepareEndlessT->Name = L"btnSampling_PrepareEndlessT";
			this->btnSampling_PrepareEndlessT->Size = System::Drawing::Size(143, 23);
			this->btnSampling_PrepareEndlessT->TabIndex = 22;
			this->btnSampling_PrepareEndlessT->Text = L"Prepare Endless";
			this->btnSampling_PrepareEndlessT->UseVisualStyleBackColor = true;
			this->btnSampling_PrepareEndlessT->Click += gcnew System::EventHandler(this, &Form1::btnSampling_PrepareEndlessT_Click);
			// 
			// nuSampling_TimeKeepSamples
			// 
			this->nuSampling_TimeKeepSamples->Location = System::Drawing::Point(36, 25);
			this->nuSampling_TimeKeepSamples->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1000000, 0, 0, 0 });
			this->nuSampling_TimeKeepSamples->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1000, 0, 0, 0 });
			this->nuSampling_TimeKeepSamples->Name = L"nuSampling_TimeKeepSamples";
			this->nuSampling_TimeKeepSamples->Size = System::Drawing::Size(70, 20);
			this->nuSampling_TimeKeepSamples->TabIndex = 21;
			this->nuSampling_TimeKeepSamples->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) { 10000, 0, 0, 0 });
			// 
			// label6
			// 
			this->label6->AutoSize = true;
			this->label6->Location = System::Drawing::Point(7, 27);
			this->label6->Name = L"label6";
			this->label6->Size = System::Drawing::Size(32, 13);
			this->label6->TabIndex = 20;
			this->label6->Text = L"Keep";
			// 
			// groupBox5
			// 
			this->groupBox5->Controls->Add(this->lbSampling_NotificationTimeout);
			this->groupBox5->Controls->Add(this->lbSampling_NotificationBufOverflow);
			this->groupBox5->Controls->Add(this->lbSampling_NotificationError);
			this->groupBox5->Controls->Add(this->lbSampling_NotificationFinished);
			this->groupBox5->Controls->Add(this->lbSampling_NotificationAllReceived);
			this->groupBox5->Controls->Add(this->lbSampling_NotificationsNewData);
			this->groupBox5->Controls->Add(this->lbSampling_MaxSamples);
			this->groupBox5->Controls->Add(this->lbSampling_NSamplesReceived);
			this->groupBox5->Location = System::Drawing::Point(497, 295);
			this->groupBox5->Name = L"groupBox5";
			this->groupBox5->Size = System::Drawing::Size(362, 100);
			this->groupBox5->TabIndex = 12;
			this->groupBox5->TabStop = false;
			this->groupBox5->Text = L"Status";
			// 
			// lbSampling_NotificationTimeout
			// 
			this->lbSampling_NotificationTimeout->AutoSize = true;
			this->lbSampling_NotificationTimeout->Location = System::Drawing::Point(179, 79);
			this->lbSampling_NotificationTimeout->Name = L"lbSampling_NotificationTimeout";
			this->lbSampling_NotificationTimeout->Size = System::Drawing::Size(109, 13);
			this->lbSampling_NotificationTimeout->TabIndex = 29;
			this->lbSampling_NotificationTimeout->Text = L"0 timeout notifications";
			// 
			// lbSampling_NotificationBufOverflow
			// 
			this->lbSampling_NotificationBufOverflow->AutoSize = true;
			this->lbSampling_NotificationBufOverflow->Location = System::Drawing::Point(179, 59);
			this->lbSampling_NotificationBufOverflow->Name = L"lbSampling_NotificationBufOverflow";
			this->lbSampling_NotificationBufOverflow->Size = System::Drawing::Size(168, 13);
			this->lbSampling_NotificationBufOverflow->TabIndex = 28;
			this->lbSampling_NotificationBufOverflow->Text = L"0 DLL buffer-overflow notifications";
			// 
			// lbSampling_NotificationError
			// 
			this->lbSampling_NotificationError->AutoSize = true;
			this->lbSampling_NotificationError->Location = System::Drawing::Point(179, 39);
			this->lbSampling_NotificationError->Name = L"lbSampling_NotificationError";
			this->lbSampling_NotificationError->Size = System::Drawing::Size(96, 13);
			this->lbSampling_NotificationError->TabIndex = 27;
			this->lbSampling_NotificationError->Text = L"0 error notifications";
			// 
			// lbSampling_NotificationFinished
			// 
			this->lbSampling_NotificationFinished->AutoSize = true;
			this->lbSampling_NotificationFinished->Location = System::Drawing::Point(6, 79);
			this->lbSampling_NotificationFinished->Name = L"lbSampling_NotificationFinished";
			this->lbSampling_NotificationFinished->Size = System::Drawing::Size(111, 13);
			this->lbSampling_NotificationFinished->TabIndex = 26;
			this->lbSampling_NotificationFinished->Text = L"0 finished notifications";
			// 
			// lbSampling_NotificationAllReceived
			// 
			this->lbSampling_NotificationAllReceived->AutoSize = true;
			this->lbSampling_NotificationAllReceived->Location = System::Drawing::Point(179, 20);
			this->lbSampling_NotificationAllReceived->Name = L"lbSampling_NotificationAllReceived";
			this->lbSampling_NotificationAllReceived->Size = System::Drawing::Size(129, 13);
			this->lbSampling_NotificationAllReceived->TabIndex = 25;
			this->lbSampling_NotificationAllReceived->Text = L"0 all-received notifications";
			// 
			// lbSampling_NotificationsNewData
			// 
			this->lbSampling_NotificationsNewData->AutoSize = true;
			this->lbSampling_NotificationsNewData->Location = System::Drawing::Point(6, 59);
			this->lbSampling_NotificationsNewData->Name = L"lbSampling_NotificationsNewData";
			this->lbSampling_NotificationsNewData->Size = System::Drawing::Size(119, 13);
			this->lbSampling_NotificationsNewData->TabIndex = 24;
			this->lbSampling_NotificationsNewData->Text = L"0 new-data notifications";
			// 
			// lbSampling_MaxSamples
			// 
			this->lbSampling_MaxSamples->AutoSize = true;
			this->lbSampling_MaxSamples->Location = System::Drawing::Point(6, 39);
			this->lbSampling_MaxSamples->Name = L"lbSampling_MaxSamples";
			this->lbSampling_MaxSamples->Size = System::Drawing::Size(100, 13);
			this->lbSampling_MaxSamples->TabIndex = 23;
			this->lbSampling_MaxSamples->Text = L"0 samples maximum";
			// 
			// lbSampling_NSamplesReceived
			// 
			this->lbSampling_NSamplesReceived->AutoSize = true;
			this->lbSampling_NSamplesReceived->Location = System::Drawing::Point(6, 20);
			this->lbSampling_NSamplesReceived->Name = L"lbSampling_NSamplesReceived";
			this->lbSampling_NSamplesReceived->Size = System::Drawing::Size(98, 13);
			this->lbSampling_NSamplesReceived->TabIndex = 22;
			this->lbSampling_NSamplesReceived->Text = L"0 samples received";
			// 
			// groupBox4
			// 
			this->groupBox4->Controls->Add(this->label16);
			this->groupBox4->Controls->Add(this->rbSampling_TLimitedReadRows);
			this->groupBox4->Controls->Add(this->rbSampling_TLimitedReadCols);
			this->groupBox4->Controls->Add(this->btnSampling_Stop);
			this->groupBox4->Controls->Add(this->btnSampling_Store);
			this->groupBox4->Controls->Add(this->btnSampling_TLimitedStart);
			this->groupBox4->Controls->Add(this->btnSampling_PrepareFiniteT);
			this->groupBox4->Controls->Add(this->nuSampling_TimeNSamples);
			this->groupBox4->Controls->Add(this->label5);
			this->groupBox4->Location = System::Drawing::Point(497, 81);
			this->groupBox4->Name = L"groupBox4";
			this->groupBox4->Size = System::Drawing::Size(163, 208);
			this->groupBox4->TabIndex = 11;
			this->groupBox4->TabStop = false;
			this->groupBox4->Text = L"Time-Limited sampling";
			// 
			// label16
			// 
			this->label16->AutoSize = true;
			this->label16->Location = System::Drawing::Point(9, 161);
			this->label16->Name = L"label16";
			this->label16->Size = System::Drawing::Size(33, 13);
			this->label16->TabIndex = 22;
			this->label16->Text = L"Read";
			// 
			// rbSampling_TLimitedReadRows
			// 
			this->rbSampling_TLimitedReadRows->AutoSize = true;
			this->rbSampling_TLimitedReadRows->Location = System::Drawing::Point(100, 159);
			this->rbSampling_TLimitedReadRows->Name = L"rbSampling_TLimitedReadRows";
			this->rbSampling_TLimitedReadRows->Size = System::Drawing::Size(52, 17);
			this->rbSampling_TLimitedReadRows->TabIndex = 21;
			this->rbSampling_TLimitedReadRows->Text = L"Rows";
			this->rbSampling_TLimitedReadRows->UseVisualStyleBackColor = true;
			// 
			// rbSampling_TLimitedReadCols
			// 
			this->rbSampling_TLimitedReadCols->AutoSize = true;
			this->rbSampling_TLimitedReadCols->Checked = true;
			this->rbSampling_TLimitedReadCols->Location = System::Drawing::Point(47, 159);
			this->rbSampling_TLimitedReadCols->Name = L"rbSampling_TLimitedReadCols";
			this->rbSampling_TLimitedReadCols->Size = System::Drawing::Size(47, 17);
			this->rbSampling_TLimitedReadCols->TabIndex = 20;
			this->rbSampling_TLimitedReadCols->TabStop = true;
			this->rbSampling_TLimitedReadCols->Text = L"Col\'s";
			this->rbSampling_TLimitedReadCols->UseVisualStyleBackColor = true;
			// 
			// btnSampling_Stop
			// 
			this->btnSampling_Stop->Location = System::Drawing::Point(9, 132);
			this->btnSampling_Stop->Name = L"btnSampling_Stop";
			this->btnSampling_Stop->Size = System::Drawing::Size(143, 23);
			this->btnSampling_Stop->TabIndex = 19;
			this->btnSampling_Stop->Text = L"Stop";
			this->btnSampling_Stop->UseVisualStyleBackColor = true;
			this->btnSampling_Stop->Click += gcnew System::EventHandler(this, &Form1::btnSampling_Stop_Click);
			// 
			// btnSampling_Store
			// 
			this->btnSampling_Store->Enabled = false;
			this->btnSampling_Store->Location = System::Drawing::Point(9, 179);
			this->btnSampling_Store->Name = L"btnSampling_Store";
			this->btnSampling_Store->Size = System::Drawing::Size(143, 23);
			this->btnSampling_Store->TabIndex = 15;
			this->btnSampling_Store->Text = L"Store all to CSV file";
			this->btnSampling_Store->UseVisualStyleBackColor = true;
			this->btnSampling_Store->Click += gcnew System::EventHandler(this, &Form1::btnSampling_Store_Click);
			// 
			// btnSampling_TLimitedStart
			// 
			this->btnSampling_TLimitedStart->Enabled = false;
			this->btnSampling_TLimitedStart->Location = System::Drawing::Point(9, 103);
			this->btnSampling_TLimitedStart->Name = L"btnSampling_TLimitedStart";
			this->btnSampling_TLimitedStart->Size = System::Drawing::Size(143, 23);
			this->btnSampling_TLimitedStart->TabIndex = 14;
			this->btnSampling_TLimitedStart->Text = L"Start";
			this->btnSampling_TLimitedStart->UseVisualStyleBackColor = true;
			this->btnSampling_TLimitedStart->Click += gcnew System::EventHandler(this, &Form1::btnSampling_Start_Click);
			// 
			// btnSampling_PrepareFiniteT
			// 
			this->btnSampling_PrepareFiniteT->Enabled = false;
			this->btnSampling_PrepareFiniteT->Location = System::Drawing::Point(9, 57);
			this->btnSampling_PrepareFiniteT->Name = L"btnSampling_PrepareFiniteT";
			this->btnSampling_PrepareFiniteT->Size = System::Drawing::Size(143, 23);
			this->btnSampling_PrepareFiniteT->TabIndex = 13;
			this->btnSampling_PrepareFiniteT->Text = L"Prepare Time-Limited";
			this->btnSampling_PrepareFiniteT->UseVisualStyleBackColor = true;
			this->btnSampling_PrepareFiniteT->Click += gcnew System::EventHandler(this, &Form1::btnSampling_PrepareFiniteT_Click);
			// 
			// nuSampling_TimeNSamples
			// 
			this->nuSampling_TimeNSamples->Location = System::Drawing::Point(54, 25);
			this->nuSampling_TimeNSamples->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1000000, 0, 0, 0 });
			this->nuSampling_TimeNSamples->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1, 0, 0, 0 });
			this->nuSampling_TimeNSamples->Name = L"nuSampling_TimeNSamples";
			this->nuSampling_TimeNSamples->Size = System::Drawing::Size(98, 20);
			this->nuSampling_TimeNSamples->TabIndex = 12;
			this->nuSampling_TimeNSamples->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) { 10000, 0, 0, 0 });
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->Location = System::Drawing::Point(6, 27);
			this->label5->Name = L"label5";
			this->label5->Size = System::Drawing::Size(47, 13);
			this->label5->TabIndex = 11;
			this->label5->Text = L"Samples";
			// 
			// btnSampling_AddChannels
			// 
			this->btnSampling_AddChannels->Location = System::Drawing::Point(34, 300);
			this->btnSampling_AddChannels->Name = L"btnSampling_AddChannels";
			this->btnSampling_AddChannels->Size = System::Drawing::Size(148, 23);
			this->btnSampling_AddChannels->TabIndex = 6;
			this->btnSampling_AddChannels->Text = L"Add selected channels";
			this->btnSampling_AddChannels->UseVisualStyleBackColor = true;
			this->btnSampling_AddChannels->Click += gcnew System::EventHandler(this, &Form1::btnSampling_AddChannels_Click);
			// 
			// lbSampling_NElements
			// 
			this->lbSampling_NElements->AutoSize = true;
			this->lbSampling_NElements->Location = System::Drawing::Point(34, 376);
			this->lbSampling_NElements->Name = L"lbSampling_NElements";
			this->lbSampling_NElements->Size = System::Drawing::Size(135, 13);
			this->lbSampling_NElements->TabIndex = 5;
			this->lbSampling_NElements->Text = L"0 sampling elements added";
			// 
			// btnSampling_AddOutputsAll
			// 
			this->btnSampling_AddOutputsAll->Location = System::Drawing::Point(341, 349);
			this->btnSampling_AddOutputsAll->Name = L"btnSampling_AddOutputsAll";
			this->btnSampling_AddOutputsAll->Size = System::Drawing::Size(147, 23);
			this->btnSampling_AddOutputsAll->TabIndex = 4;
			this->btnSampling_AddOutputsAll->Text = L"Add all digital outputs";
			this->btnSampling_AddOutputsAll->UseVisualStyleBackColor = true;
			this->btnSampling_AddOutputsAll->Click += gcnew System::EventHandler(this, &Form1::btnSampling_AddOutputsAll_Click);
			// 
			// btnSampling_AddInputsAll
			// 
			this->btnSampling_AddInputsAll->Location = System::Drawing::Point(188, 349);
			this->btnSampling_AddInputsAll->Name = L"btnSampling_AddInputsAll";
			this->btnSampling_AddInputsAll->Size = System::Drawing::Size(148, 23);
			this->btnSampling_AddInputsAll->TabIndex = 3;
			this->btnSampling_AddInputsAll->Text = L"Add all digital inputs";
			this->btnSampling_AddInputsAll->UseVisualStyleBackColor = true;
			this->btnSampling_AddInputsAll->Click += gcnew System::EventHandler(this, &Form1::btnSampling_AddInputsAll_Click);
			// 
			// btnSamplingReset
			// 
			this->btnSamplingReset->Location = System::Drawing::Point(34, 12);
			this->btnSamplingReset->Name = L"btnSamplingReset";
			this->btnSamplingReset->Size = System::Drawing::Size(455, 23);
			this->btnSamplingReset->TabIndex = 1;
			this->btnSamplingReset->Text = L"Reset list of sampling elements in DLL (checkboxes below remain unchanged)";
			this->btnSamplingReset->UseVisualStyleBackColor = true;
			this->btnSamplingReset->Click += gcnew System::EventHandler(this, &Form1::btnSamplingReset_Click);
			// 
			// btnSamplingAddChannelsAll
			// 
			this->btnSamplingAddChannelsAll->Location = System::Drawing::Point(34, 349);
			this->btnSamplingAddChannelsAll->Name = L"btnSamplingAddChannelsAll";
			this->btnSamplingAddChannelsAll->Size = System::Drawing::Size(148, 23);
			this->btnSamplingAddChannelsAll->TabIndex = 0;
			this->btnSamplingAddChannelsAll->Text = L"Add all Channels";
			this->btnSamplingAddChannelsAll->UseVisualStyleBackColor = true;
			this->btnSamplingAddChannelsAll->Click += gcnew System::EventHandler(this, &Form1::btnSamplingAddChannelsAll_Click);
			// 
			// tbSamplingAddOn
			// 
			this->tbSamplingAddOn->Controls->Add(this->groupBox11);
			this->tbSamplingAddOn->Controls->Add(this->groupBox9);
			this->tbSamplingAddOn->Controls->Add(this->groupBox8);
			this->tbSamplingAddOn->Controls->Add(this->textBox1);
			this->tbSamplingAddOn->Location = System::Drawing::Point(4, 22);
			this->tbSamplingAddOn->Name = L"tbSamplingAddOn";
			this->tbSamplingAddOn->Padding = System::Windows::Forms::Padding(3);
			this->tbSamplingAddOn->Size = System::Drawing::Size(865, 401);
			this->tbSamplingAddOn->TabIndex = 7;
			this->tbSamplingAddOn->Text = L"Sampling AddOns";
			this->tbSamplingAddOn->UseVisualStyleBackColor = true;
			// 
			// groupBox11
			// 
			this->groupBox11->Controls->Add(this->label53);
			this->groupBox11->Controls->Add(this->label52);
			this->groupBox11->Controls->Add(this->nuSamplingPositionDistance);
			this->groupBox11->Controls->Add(this->label51);
			this->groupBox11->Controls->Add(this->nuSamplingPositionStart);
			this->groupBox11->Controls->Add(this->label50);
			this->groupBox11->Controls->Add(this->textBox6);
			this->groupBox11->Controls->Add(this->groupBox12);
			this->groupBox11->Controls->Add(this->btnSamplingPreparePosition);
			this->groupBox11->Controls->Add(this->nuSamplingPositionScale);
			this->groupBox11->Controls->Add(this->label49);
			this->groupBox11->Controls->Add(this->label48);
			this->groupBox11->Controls->Add(this->cbSamplingPositionTriggerChannel);
			this->groupBox11->Controls->Add(this->nuSamplingPositionNSamples);
			this->groupBox11->Controls->Add(this->label47);
			this->groupBox11->Controls->Add(this->textBox5);
			this->groupBox11->Location = System::Drawing::Point(6, 130);
			this->groupBox11->Name = L"groupBox11";
			this->groupBox11->Size = System::Drawing::Size(853, 117);
			this->groupBox11->TabIndex = 3;
			this->groupBox11->TabStop = false;
			this->groupBox11->Text = L"Position-Triggered Sampling";
			// 
			// label53
			// 
			this->label53->AutoSize = true;
			this->label53->Location = System::Drawing::Point(525, 92);
			this->label53->Name = L"label53";
			this->label53->Size = System::Drawing::Size(75, 13);
			this->label53->TabIndex = 37;
			this->label53->Text = L"Must be != 0.0";
			// 
			// label52
			// 
			this->label52->AutoSize = true;
			this->label52->Location = System::Drawing::Point(299, 91);
			this->label52->Name = L"label52";
			this->label52->Size = System::Drawing::Size(75, 13);
			this->label52->TabIndex = 36;
			this->label52->Text = L"Must be != 0.0";
			// 
			// nuSamplingPositionDistance
			// 
			this->nuSamplingPositionDistance->DecimalPlaces = 5;
			this->nuSamplingPositionDistance->Location = System::Drawing::Point(528, 64);
			this->nuSamplingPositionDistance->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 2147483647, 0, 0, 0 });
			this->nuSamplingPositionDistance->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 2147483647, 0, 0, System::Int32::MinValue });
			this->nuSamplingPositionDistance->Name = L"nuSamplingPositionDistance";
			this->nuSamplingPositionDistance->Size = System::Drawing::Size(98, 20);
			this->nuSamplingPositionDistance->TabIndex = 35;
			this->nuSamplingPositionDistance->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1, 0, 0, 0 });
			// 
			// label51
			// 
			this->label51->AutoSize = true;
			this->label51->Location = System::Drawing::Point(525, 48);
			this->label51->Name = L"label51";
			this->label51->Size = System::Drawing::Size(49, 13);
			this->label51->TabIndex = 34;
			this->label51->Text = L"Distance";
			// 
			// nuSamplingPositionStart
			// 
			this->nuSamplingPositionStart->DecimalPlaces = 5;
			this->nuSamplingPositionStart->Location = System::Drawing::Point(412, 64);
			this->nuSamplingPositionStart->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 2147483647, 0, 0, 0 });
			this->nuSamplingPositionStart->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 2147483647, 0, 0, System::Int32::MinValue });
			this->nuSamplingPositionStart->Name = L"nuSamplingPositionStart";
			this->nuSamplingPositionStart->Size = System::Drawing::Size(98, 20);
			this->nuSamplingPositionStart->TabIndex = 33;
			// 
			// label50
			// 
			this->label50->AutoSize = true;
			this->label50->Location = System::Drawing::Point(409, 48);
			this->label50->Name = L"label50";
			this->label50->Size = System::Drawing::Size(69, 13);
			this->label50->TabIndex = 32;
			this->label50->Text = L"Start Position";
			// 
			// textBox6
			// 
			this->textBox6->BorderStyle = System::Windows::Forms::BorderStyle::None;
			this->textBox6->Location = System::Drawing::Point(704, 7);
			this->textBox6->Multiline = true;
			this->textBox6->Name = L"textBox6";
			this->textBox6->Size = System::Drawing::Size(143, 79);
			this->textBox6->TabIndex = 31;
			this->textBox6->Text = L"Use this button instead of \"Prepare time-limited\" in the general sampling page. T"
				L"hen use the buttons \"Start / Stop / Write to CSV\" as with time-limited sampling."
				L"";
			this->textBox6->TextAlign = System::Windows::Forms::HorizontalAlignment::Center;
			// 
			// groupBox12
			// 
			this->groupBox12->Location = System::Drawing::Point(688, 3);
			this->groupBox12->Name = L"groupBox12";
			this->groupBox12->Size = System::Drawing::Size(10, 108);
			this->groupBox12->TabIndex = 30;
			this->groupBox12->TabStop = false;
			// 
			// btnSamplingPreparePosition
			// 
			this->btnSamplingPreparePosition->Enabled = false;
			this->btnSamplingPreparePosition->Location = System::Drawing::Point(704, 87);
			this->btnSamplingPreparePosition->Name = L"btnSamplingPreparePosition";
			this->btnSamplingPreparePosition->Size = System::Drawing::Size(143, 23);
			this->btnSamplingPreparePosition->TabIndex = 29;
			this->btnSamplingPreparePosition->Text = L"Prepare Position Sampling";
			this->btnSamplingPreparePosition->UseVisualStyleBackColor = true;
			this->btnSamplingPreparePosition->Click += gcnew System::EventHandler(this, &Form1::btnSamplingPreparePosition_Click);
			// 
			// nuSamplingPositionScale
			// 
			this->nuSamplingPositionScale->DecimalPlaces = 5;
			this->nuSamplingPositionScale->Location = System::Drawing::Point(299, 64);
			this->nuSamplingPositionScale->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1000000, 0, 0, 0 });
			this->nuSamplingPositionScale->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1000000, 0, 0, System::Int32::MinValue });
			this->nuSamplingPositionScale->Name = L"nuSamplingPositionScale";
			this->nuSamplingPositionScale->Size = System::Drawing::Size(98, 20);
			this->nuSamplingPositionScale->TabIndex = 22;
			this->nuSamplingPositionScale->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1, 0, 0, 0 });
			// 
			// label49
			// 
			this->label49->AutoSize = true;
			this->label49->Location = System::Drawing::Point(296, 48);
			this->label49->Name = L"label49";
			this->label49->Size = System::Drawing::Size(67, 13);
			this->label49->TabIndex = 21;
			this->label49->Text = L"Scale Factor";
			// 
			// label48
			// 
			this->label48->AutoSize = true;
			this->label48->Location = System::Drawing::Point(120, 48);
			this->label48->Name = L"label48";
			this->label48->Size = System::Drawing::Size(82, 13);
			this->label48->TabIndex = 20;
			this->label48->Text = L"Trigger Channel";
			// 
			// cbSamplingPositionTriggerChannel
			// 
			this->cbSamplingPositionTriggerChannel->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbSamplingPositionTriggerChannel->FormattingEnabled = true;
			this->cbSamplingPositionTriggerChannel->Location = System::Drawing::Point(120, 64);
			this->cbSamplingPositionTriggerChannel->Name = L"cbSamplingPositionTriggerChannel";
			this->cbSamplingPositionTriggerChannel->Size = System::Drawing::Size(162, 21);
			this->cbSamplingPositionTriggerChannel->TabIndex = 19;
			// 
			// nuSamplingPositionNSamples
			// 
			this->nuSamplingPositionNSamples->Location = System::Drawing::Point(9, 64);
			this->nuSamplingPositionNSamples->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1000000, 0, 0, 0 });
			this->nuSamplingPositionNSamples->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1, 0, 0, 0 });
			this->nuSamplingPositionNSamples->Name = L"nuSamplingPositionNSamples";
			this->nuSamplingPositionNSamples->Size = System::Drawing::Size(98, 20);
			this->nuSamplingPositionNSamples->TabIndex = 16;
			this->nuSamplingPositionNSamples->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) { 3600, 0, 0, 0 });
			// 
			// label47
			// 
			this->label47->AutoSize = true;
			this->label47->Location = System::Drawing::Point(6, 48);
			this->label47->Name = L"label47";
			this->label47->Size = System::Drawing::Size(47, 13);
			this->label47->TabIndex = 15;
			this->label47->Text = L"Samples";
			// 
			// textBox5
			// 
			this->textBox5->BorderStyle = System::Windows::Forms::BorderStyle::None;
			this->textBox5->Location = System::Drawing::Point(6, 19);
			this->textBox5->Name = L"textBox5";
			this->textBox5->Size = System::Drawing::Size(841, 13);
			this->textBox5->TabIndex = 1;
			this->textBox5->Text = L"Use these settings instead of time-based sampling (-> instead of steps 4 & 5).";
			// 
			// groupBox9
			// 
			this->groupBox9->Controls->Add(this->textBox4);
			this->groupBox9->Controls->Add(this->groupBox10);
			this->groupBox9->Controls->Add(this->btnSamplingPrepareCustomTft);
			this->groupBox9->Controls->Add(this->label43);
			this->groupBox9->Controls->Add(this->cbSamplingTftTriggerPolarity);
			this->groupBox9->Controls->Add(this->label44);
			this->groupBox9->Controls->Add(this->cbSamplingTftTriggerMode);
			this->groupBox9->Controls->Add(this->label45);
			this->groupBox9->Controls->Add(this->cbSamplingTftTriggerBit);
			this->groupBox9->Controls->Add(this->label46);
			this->groupBox9->Controls->Add(this->cbSamplingTftTriggerByte);
			this->groupBox9->Controls->Add(this->label42);
			this->groupBox9->Controls->Add(this->nuSamplingTftNTailSamples);
			this->groupBox9->Controls->Add(this->nuSamplingTftNSamples);
			this->groupBox9->Controls->Add(this->label41);
			this->groupBox9->Controls->Add(this->nuSamplingTftFilterPeriod);
			this->groupBox9->Controls->Add(this->label40);
			this->groupBox9->Controls->Add(this->textBox3);
			this->groupBox9->Location = System::Drawing::Point(6, 253);
			this->groupBox9->Name = L"groupBox9";
			this->groupBox9->Size = System::Drawing::Size(853, 142);
			this->groupBox9->TabIndex = 2;
			this->groupBox9->TabStop = false;
			this->groupBox9->Text = L"Customized Sampling TFT (Trigger-Filter-Tail)";
			// 
			// textBox4
			// 
			this->textBox4->BorderStyle = System::Windows::Forms::BorderStyle::None;
			this->textBox4->Location = System::Drawing::Point(704, 27);
			this->textBox4->Multiline = true;
			this->textBox4->Name = L"textBox4";
			this->textBox4->Size = System::Drawing::Size(143, 79);
			this->textBox4->TabIndex = 28;
			this->textBox4->Text = L"Use this button instead of \"Prepare time-limited\" in the general sampling page. T"
				L"hen use the buttons \"Start / Stop / Write to CSV\" as with time-limited sampling."
				L"";
			this->textBox4->TextAlign = System::Windows::Forms::HorizontalAlignment::Center;
			// 
			// groupBox10
			// 
			this->groupBox10->Location = System::Drawing::Point(688, 19);
			this->groupBox10->Name = L"groupBox10";
			this->groupBox10->Size = System::Drawing::Size(10, 114);
			this->groupBox10->TabIndex = 27;
			this->groupBox10->TabStop = false;
			// 
			// btnSamplingPrepareCustomTft
			// 
			this->btnSamplingPrepareCustomTft->Enabled = false;
			this->btnSamplingPrepareCustomTft->Location = System::Drawing::Point(704, 107);
			this->btnSamplingPrepareCustomTft->Name = L"btnSamplingPrepareCustomTft";
			this->btnSamplingPrepareCustomTft->Size = System::Drawing::Size(143, 23);
			this->btnSamplingPrepareCustomTft->TabIndex = 25;
			this->btnSamplingPrepareCustomTft->Text = L"Prepare TFT Sampling";
			this->btnSamplingPrepareCustomTft->UseVisualStyleBackColor = true;
			this->btnSamplingPrepareCustomTft->Click += gcnew System::EventHandler(this, &Form1::btnSamplingPrepareCustomTft_Click);
			// 
			// label43
			// 
			this->label43->AutoSize = true;
			this->label43->Location = System::Drawing::Point(431, 93);
			this->label43->Name = L"label43";
			this->label43->Size = System::Drawing::Size(77, 13);
			this->label43->TabIndex = 24;
			this->label43->Text = L"Trigger Polarity";
			// 
			// cbSamplingTftTriggerPolarity
			// 
			this->cbSamplingTftTriggerPolarity->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbSamplingTftTriggerPolarity->FormattingEnabled = true;
			this->cbSamplingTftTriggerPolarity->Items->AddRange(gcnew cli::array< System::Object^  >(2) { L"Falling / Low", L"Rising / High" });
			this->cbSamplingTftTriggerPolarity->Location = System::Drawing::Point(431, 109);
			this->cbSamplingTftTriggerPolarity->Name = L"cbSamplingTftTriggerPolarity";
			this->cbSamplingTftTriggerPolarity->Size = System::Drawing::Size(119, 21);
			this->cbSamplingTftTriggerPolarity->TabIndex = 23;
			// 
			// label44
			// 
			this->label44->AutoSize = true;
			this->label44->Location = System::Drawing::Point(302, 93);
			this->label44->Name = L"label44";
			this->label44->Size = System::Drawing::Size(70, 13);
			this->label44->TabIndex = 22;
			this->label44->Text = L"Trigger Mode";
			// 
			// cbSamplingTftTriggerMode
			// 
			this->cbSamplingTftTriggerMode->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbSamplingTftTriggerMode->FormattingEnabled = true;
			this->cbSamplingTftTriggerMode->Items->AddRange(gcnew cli::array< System::Object^  >(5) {
				L"Trigger Disabled", L"Edge-Triggered",
					L"Level-Triggered", L"Start at first edge", L"Level-Triggered / Once"
			});
			this->cbSamplingTftTriggerMode->Location = System::Drawing::Point(302, 109);
			this->cbSamplingTftTriggerMode->Name = L"cbSamplingTftTriggerMode";
			this->cbSamplingTftTriggerMode->Size = System::Drawing::Size(119, 21);
			this->cbSamplingTftTriggerMode->TabIndex = 21;
			// 
			// label45
			// 
			this->label45->AutoSize = true;
			this->label45->Location = System::Drawing::Point(180, 93);
			this->label45->Name = L"label45";
			this->label45->Size = System::Drawing::Size(39, 13);
			this->label45->TabIndex = 20;
			this->label45->Text = L"Bit No.";
			// 
			// cbSamplingTftTriggerBit
			// 
			this->cbSamplingTftTriggerBit->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbSamplingTftTriggerBit->FormattingEnabled = true;
			this->cbSamplingTftTriggerBit->Items->AddRange(gcnew cli::array< System::Object^  >(8) {
				L"0", L"1", L"2", L"3", L"4", L"5",
					L"6", L"7"
			});
			this->cbSamplingTftTriggerBit->Location = System::Drawing::Point(180, 109);
			this->cbSamplingTftTriggerBit->Name = L"cbSamplingTftTriggerBit";
			this->cbSamplingTftTriggerBit->Size = System::Drawing::Size(90, 21);
			this->cbSamplingTftTriggerBit->TabIndex = 19;
			// 
			// label46
			// 
			this->label46->AutoSize = true;
			this->label46->Location = System::Drawing::Point(9, 93);
			this->label46->Name = L"label46";
			this->label46->Size = System::Drawing::Size(87, 13);
			this->label46->TabIndex = 18;
			this->label46->Text = L"Digital Input Byte";
			// 
			// cbSamplingTftTriggerByte
			// 
			this->cbSamplingTftTriggerByte->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbSamplingTftTriggerByte->FormattingEnabled = true;
			this->cbSamplingTftTriggerByte->Location = System::Drawing::Point(9, 109);
			this->cbSamplingTftTriggerByte->Name = L"cbSamplingTftTriggerByte";
			this->cbSamplingTftTriggerByte->Size = System::Drawing::Size(162, 21);
			this->cbSamplingTftTriggerByte->TabIndex = 17;
			// 
			// label42
			// 
			this->label42->AutoSize = true;
			this->label42->Location = System::Drawing::Point(224, 44);
			this->label42->Name = L"label42";
			this->label42->Size = System::Drawing::Size(67, 13);
			this->label42->TabIndex = 16;
			this->label42->Text = L"Tail Samples";
			// 
			// nuSamplingTftNTailSamples
			// 
			this->nuSamplingTftNTailSamples->Location = System::Drawing::Point(227, 60);
			this->nuSamplingTftNTailSamples->Name = L"nuSamplingTftNTailSamples";
			this->nuSamplingTftNTailSamples->Size = System::Drawing::Size(98, 20);
			this->nuSamplingTftNTailSamples->TabIndex = 15;
			this->nuSamplingTftNTailSamples->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) { 10, 0, 0, 0 });
			// 
			// nuSamplingTftNSamples
			// 
			this->nuSamplingTftNSamples->Location = System::Drawing::Point(109, 60);
			this->nuSamplingTftNSamples->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1000000, 0, 0, 0 });
			this->nuSamplingTftNSamples->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1, 0, 0, 0 });
			this->nuSamplingTftNSamples->Name = L"nuSamplingTftNSamples";
			this->nuSamplingTftNSamples->Size = System::Drawing::Size(98, 20);
			this->nuSamplingTftNSamples->TabIndex = 14;
			this->nuSamplingTftNSamples->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1000, 0, 0, 0 });
			// 
			// label41
			// 
			this->label41->AutoSize = true;
			this->label41->Location = System::Drawing::Point(106, 44);
			this->label41->Name = L"label41";
			this->label41->Size = System::Drawing::Size(47, 13);
			this->label41->TabIndex = 13;
			this->label41->Text = L"Samples";
			// 
			// nuSamplingTftFilterPeriod
			// 
			this->nuSamplingTftFilterPeriod->Location = System::Drawing::Point(9, 60);
			this->nuSamplingTftFilterPeriod->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1, 0, 0, 0 });
			this->nuSamplingTftFilterPeriod->Name = L"nuSamplingTftFilterPeriod";
			this->nuSamplingTftFilterPeriod->Size = System::Drawing::Size(84, 20);
			this->nuSamplingTftFilterPeriod->TabIndex = 7;
			this->nuSamplingTftFilterPeriod->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) { 5, 0, 0, 0 });
			// 
			// label40
			// 
			this->label40->AutoSize = true;
			this->label40->Location = System::Drawing::Point(6, 44);
			this->label40->Name = L"label40";
			this->label40->Size = System::Drawing::Size(87, 13);
			this->label40->TabIndex = 6;
			this->label40->Text = L"Filter period* [ms]";
			// 
			// textBox3
			// 
			this->textBox3->BorderStyle = System::Windows::Forms::BorderStyle::None;
			this->textBox3->Location = System::Drawing::Point(6, 19);
			this->textBox3->Name = L"textBox3";
			this->textBox3->Size = System::Drawing::Size(841, 13);
			this->textBox3->TabIndex = 0;
			this->textBox3->Text = L"Use these settings instead of time-based sampling (-> instead of steps 4 & 5).   "
				L"                 *Filter period must be a multiple of the sampling speed.";
			// 
			// groupBox8
			// 
			this->groupBox8->Controls->Add(this->btnSamplingDInTrgSet);
			this->groupBox8->Controls->Add(this->label36);
			this->groupBox8->Controls->Add(this->cbSamplingDInTrgPol);
			this->groupBox8->Controls->Add(this->label35);
			this->groupBox8->Controls->Add(this->cbSamplingDInTrgMode);
			this->groupBox8->Controls->Add(this->label34);
			this->groupBox8->Controls->Add(this->cbSamplingDInTrgBit);
			this->groupBox8->Controls->Add(this->label33);
			this->groupBox8->Controls->Add(this->cbSamplingDInTrgByte);
			this->groupBox8->Controls->Add(this->textBox2);
			this->groupBox8->Location = System::Drawing::Point(6, 31);
			this->groupBox8->Name = L"groupBox8";
			this->groupBox8->Size = System::Drawing::Size(853, 93);
			this->groupBox8->TabIndex = 1;
			this->groupBox8->TabStop = false;
			this->groupBox8->Text = L"Digital Input Trigger";
			// 
			// btnSamplingDInTrgSet
			// 
			this->btnSamplingDInTrgSet->Location = System::Drawing::Point(585, 61);
			this->btnSamplingDInTrgSet->Name = L"btnSamplingDInTrgSet";
			this->btnSamplingDInTrgSet->Size = System::Drawing::Size(143, 23);
			this->btnSamplingDInTrgSet->TabIndex = 14;
			this->btnSamplingDInTrgSet->Text = L"Set Trigger";
			this->btnSamplingDInTrgSet->UseVisualStyleBackColor = true;
			this->btnSamplingDInTrgSet->Click += gcnew System::EventHandler(this, &Form1::btnSamplingDInTrgSet_Click);
			// 
			// label36
			// 
			this->label36->AutoSize = true;
			this->label36->Location = System::Drawing::Point(428, 47);
			this->label36->Name = L"label36";
			this->label36->Size = System::Drawing::Size(77, 13);
			this->label36->TabIndex = 8;
			this->label36->Text = L"Trigger Polarity";
			// 
			// cbSamplingDInTrgPol
			// 
			this->cbSamplingDInTrgPol->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbSamplingDInTrgPol->FormattingEnabled = true;
			this->cbSamplingDInTrgPol->Items->AddRange(gcnew cli::array< System::Object^  >(2) { L"Falling / Low", L"Rising / High" });
			this->cbSamplingDInTrgPol->Location = System::Drawing::Point(428, 63);
			this->cbSamplingDInTrgPol->Name = L"cbSamplingDInTrgPol";
			this->cbSamplingDInTrgPol->Size = System::Drawing::Size(119, 21);
			this->cbSamplingDInTrgPol->TabIndex = 7;
			// 
			// label35
			// 
			this->label35->AutoSize = true;
			this->label35->Location = System::Drawing::Point(299, 47);
			this->label35->Name = L"label35";
			this->label35->Size = System::Drawing::Size(70, 13);
			this->label35->TabIndex = 6;
			this->label35->Text = L"Trigger Mode";
			// 
			// cbSamplingDInTrgMode
			// 
			this->cbSamplingDInTrgMode->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbSamplingDInTrgMode->FormattingEnabled = true;
			this->cbSamplingDInTrgMode->Items->AddRange(gcnew cli::array< System::Object^  >(2) { L"Edge-Triggered", L"Level-Triggered" });
			this->cbSamplingDInTrgMode->Location = System::Drawing::Point(299, 63);
			this->cbSamplingDInTrgMode->Name = L"cbSamplingDInTrgMode";
			this->cbSamplingDInTrgMode->Size = System::Drawing::Size(119, 21);
			this->cbSamplingDInTrgMode->TabIndex = 5;
			// 
			// label34
			// 
			this->label34->AutoSize = true;
			this->label34->Location = System::Drawing::Point(177, 47);
			this->label34->Name = L"label34";
			this->label34->Size = System::Drawing::Size(39, 13);
			this->label34->TabIndex = 4;
			this->label34->Text = L"Bit No.";
			// 
			// cbSamplingDInTrgBit
			// 
			this->cbSamplingDInTrgBit->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbSamplingDInTrgBit->FormattingEnabled = true;
			this->cbSamplingDInTrgBit->Items->AddRange(gcnew cli::array< System::Object^  >(8) {
				L"0", L"1", L"2", L"3", L"4", L"5", L"6",
					L"7"
			});
			this->cbSamplingDInTrgBit->Location = System::Drawing::Point(177, 63);
			this->cbSamplingDInTrgBit->Name = L"cbSamplingDInTrgBit";
			this->cbSamplingDInTrgBit->Size = System::Drawing::Size(90, 21);
			this->cbSamplingDInTrgBit->TabIndex = 3;
			// 
			// label33
			// 
			this->label33->AutoSize = true;
			this->label33->Location = System::Drawing::Point(6, 47);
			this->label33->Name = L"label33";
			this->label33->Size = System::Drawing::Size(87, 13);
			this->label33->TabIndex = 2;
			this->label33->Text = L"Digital Input Byte";
			// 
			// cbSamplingDInTrgByte
			// 
			this->cbSamplingDInTrgByte->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbSamplingDInTrgByte->FormattingEnabled = true;
			this->cbSamplingDInTrgByte->Location = System::Drawing::Point(6, 63);
			this->cbSamplingDInTrgByte->Name = L"cbSamplingDInTrgByte";
			this->cbSamplingDInTrgByte->Size = System::Drawing::Size(162, 21);
			this->cbSamplingDInTrgByte->TabIndex = 1;
			// 
			// textBox2
			// 
			this->textBox2->BorderStyle = System::Windows::Forms::BorderStyle::None;
			this->textBox2->Location = System::Drawing::Point(6, 19);
			this->textBox2->Name = L"textBox2";
			this->textBox2->Size = System::Drawing::Size(841, 13);
			this->textBox2->TabIndex = 0;
			this->textBox2->Text = L"Set the digital input trigger after adding sampling elements (step 3) and before "
				L"preparing the sampling (step 4). It is recommended to use triggering only with e"
				L"ndless sampling.";
			// 
			// textBox1
			// 
			this->textBox1->BorderStyle = System::Windows::Forms::BorderStyle::None;
			this->textBox1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->textBox1->Location = System::Drawing::Point(6, 6);
			this->textBox1->Name = L"textBox1";
			this->textBox1->Size = System::Drawing::Size(853, 19);
			this->textBox1->TabIndex = 0;
			this->textBox1->Text = L"Using the add-on functions is optional!";
			this->textBox1->TextAlign = System::Windows::Forms::HorizontalAlignment::Center;
			// 
			// tbMisc1
			// 
			this->tbMisc1->Controls->Add(this->label32);
			this->tbMisc1->Controls->Add(this->label31);
			this->tbMisc1->Controls->Add(this->label30);
			this->tbMisc1->Controls->Add(this->label29);
			this->tbMisc1->Controls->Add(this->label24);
			this->tbMisc1->Controls->Add(this->nuChannelSetConfigNo);
			this->tbMisc1->Controls->Add(this->label25);
			this->tbMisc1->Controls->Add(this->btnChannelSetConfig);
			this->tbMisc1->Controls->Add(this->tbChannelSetConfigRx);
			this->tbMisc1->Controls->Add(this->label26);
			this->tbMisc1->Controls->Add(this->label27);
			this->tbMisc1->Controls->Add(this->tbChannelSetConfigTx);
			this->tbMisc1->Controls->Add(this->label28);
			this->tbMisc1->Controls->Add(this->label23);
			this->tbMisc1->Controls->Add(this->nuChannelSetParameterNo);
			this->tbMisc1->Controls->Add(this->label22);
			this->tbMisc1->Controls->Add(this->btnChannelSetParameter);
			this->tbMisc1->Controls->Add(this->tbChannelSetParameterRx);
			this->tbMisc1->Controls->Add(this->label21);
			this->tbMisc1->Controls->Add(this->label20);
			this->tbMisc1->Controls->Add(this->tbChannelSetParameterTx);
			this->tbMisc1->Controls->Add(this->label19);
			this->tbMisc1->Location = System::Drawing::Point(4, 22);
			this->tbMisc1->Name = L"tbMisc1";
			this->tbMisc1->Padding = System::Windows::Forms::Padding(3);
			this->tbMisc1->Size = System::Drawing::Size(865, 401);
			this->tbMisc1->TabIndex = 6;
			this->tbMisc1->Text = L"Miscalleneous";
			this->tbMisc1->UseVisualStyleBackColor = true;
			// 
			// label32
			// 
			this->label32->AutoSize = true;
			this->label32->Location = System::Drawing::Point(233, 129);
			this->label32->Name = L"label32";
			this->label32->Size = System::Drawing::Size(313, 13);
			this->label32->TabIndex = 53;
			this->label32->Text = L"Supported by some channel types, e.g. for incremental encoders.";
			// 
			// label31
			// 
			this->label31->AutoSize = true;
			this->label31->Location = System::Drawing::Point(233, 18);
			this->label31->Name = L"label31";
			this->label31->Size = System::Drawing::Size(313, 13);
			this->label31->TabIndex = 52;
			this->label31->Text = L"Supported by some channel types, e.g. for incremental encoders.";
			// 
			// label30
			// 
			this->label30->AutoSize = true;
			this->label30->Location = System::Drawing::Point(574, 173);
			this->label30->Name = L"label30";
			this->label30->Size = System::Drawing::Size(103, 13);
			this->label30->TabIndex = 51;
			this->label30->Text = L"Example: #1VSS;1#";
			// 
			// label29
			// 
			this->label29->AutoSize = true;
			this->label29->Location = System::Drawing::Point(574, 62);
			this->label29->Name = L"label29";
			this->label29->Size = System::Drawing::Size(117, 13);
			this->label29->TabIndex = 50;
			this->label29->Text = L"Example: #0;REFOFF#";
			// 
			// label24
			// 
			this->label24->AutoSize = true;
			this->label24->Location = System::Drawing::Point(233, 149);
			this->label24->Name = L"label24";
			this->label24->Size = System::Drawing::Size(118, 13);
			this->label24->TabIndex = 49;
			this->label24->Text = L"(No of first channel is 0)";
			// 
			// nuChannelSetConfigNo
			// 
			this->nuChannelSetConfigNo->Location = System::Drawing::Point(93, 147);
			this->nuChannelSetConfigNo->Name = L"nuChannelSetConfigNo";
			this->nuChannelSetConfigNo->Size = System::Drawing::Size(120, 20);
			this->nuChannelSetConfigNo->TabIndex = 48;
			// 
			// label25
			// 
			this->label25->AutoSize = true;
			this->label25->Location = System::Drawing::Point(7, 149);
			this->label25->Name = L"label25";
			this->label25->Size = System::Drawing::Size(63, 13);
			this->label25->TabIndex = 47;
			this->label25->Text = L"Channel No";
			// 
			// btnChannelSetConfig
			// 
			this->btnChannelSetConfig->Location = System::Drawing::Point(703, 170);
			this->btnChannelSetConfig->Name = L"btnChannelSetConfig";
			this->btnChannelSetConfig->Size = System::Drawing::Size(148, 43);
			this->btnChannelSetConfig->TabIndex = 46;
			this->btnChannelSetConfig->Text = L"Exchange String";
			this->btnChannelSetConfig->UseVisualStyleBackColor = true;
			this->btnChannelSetConfig->Click += gcnew System::EventHandler(this, &Form1::btnChannelSetConfig_Click);
			// 
			// tbChannelSetConfigRx
			// 
			this->tbChannelSetConfigRx->Location = System::Drawing::Point(93, 193);
			this->tbChannelSetConfigRx->Name = L"tbChannelSetConfigRx";
			this->tbChannelSetConfigRx->Size = System::Drawing::Size(604, 20);
			this->tbChannelSetConfigRx->TabIndex = 45;
			// 
			// label26
			// 
			this->label26->AutoSize = true;
			this->label26->Location = System::Drawing::Point(7, 196);
			this->label26->Name = L"label26";
			this->label26->Size = System::Drawing::Size(83, 13);
			this->label26->TabIndex = 44;
			this->label26->Text = L"Received String";
			// 
			// label27
			// 
			this->label27->AutoSize = true;
			this->label27->Location = System::Drawing::Point(7, 173);
			this->label27->Name = L"label27";
			this->label27->Size = System::Drawing::Size(62, 13);
			this->label27->TabIndex = 43;
			this->label27->Text = L"Send String";
			// 
			// tbChannelSetConfigTx
			// 
			this->tbChannelSetConfigTx->Location = System::Drawing::Point(93, 170);
			this->tbChannelSetConfigTx->Name = L"tbChannelSetConfigTx";
			this->tbChannelSetConfigTx->Size = System::Drawing::Size(475, 20);
			this->tbChannelSetConfigTx->TabIndex = 42;
			// 
			// label28
			// 
			this->label28->AutoSize = true;
			this->label28->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->label28->ForeColor = System::Drawing::Color::Coral;
			this->label28->Location = System::Drawing::Point(6, 124);
			this->label28->Name = L"label28";
			this->label28->Size = System::Drawing::Size(221, 20);
			this->label28->TabIndex = 41;
			this->label28->Text = L"Set Channel Configuration";
			// 
			// label23
			// 
			this->label23->AutoSize = true;
			this->label23->Location = System::Drawing::Point(233, 38);
			this->label23->Name = L"label23";
			this->label23->Size = System::Drawing::Size(118, 13);
			this->label23->TabIndex = 40;
			this->label23->Text = L"(No of first channel is 0)";
			// 
			// nuChannelSetParameterNo
			// 
			this->nuChannelSetParameterNo->Location = System::Drawing::Point(93, 36);
			this->nuChannelSetParameterNo->Name = L"nuChannelSetParameterNo";
			this->nuChannelSetParameterNo->Size = System::Drawing::Size(120, 20);
			this->nuChannelSetParameterNo->TabIndex = 39;
			// 
			// label22
			// 
			this->label22->AutoSize = true;
			this->label22->Location = System::Drawing::Point(7, 38);
			this->label22->Name = L"label22";
			this->label22->Size = System::Drawing::Size(63, 13);
			this->label22->TabIndex = 38;
			this->label22->Text = L"Channel No";
			// 
			// btnChannelSetParameter
			// 
			this->btnChannelSetParameter->Location = System::Drawing::Point(703, 59);
			this->btnChannelSetParameter->Name = L"btnChannelSetParameter";
			this->btnChannelSetParameter->Size = System::Drawing::Size(148, 43);
			this->btnChannelSetParameter->TabIndex = 37;
			this->btnChannelSetParameter->Text = L"Exchange String";
			this->btnChannelSetParameter->UseVisualStyleBackColor = true;
			this->btnChannelSetParameter->Click += gcnew System::EventHandler(this, &Form1::btnChannelSetParameter_Click);
			// 
			// tbChannelSetParameterRx
			// 
			this->tbChannelSetParameterRx->Location = System::Drawing::Point(93, 82);
			this->tbChannelSetParameterRx->Name = L"tbChannelSetParameterRx";
			this->tbChannelSetParameterRx->Size = System::Drawing::Size(604, 20);
			this->tbChannelSetParameterRx->TabIndex = 36;
			// 
			// label21
			// 
			this->label21->AutoSize = true;
			this->label21->Location = System::Drawing::Point(7, 85);
			this->label21->Name = L"label21";
			this->label21->Size = System::Drawing::Size(83, 13);
			this->label21->TabIndex = 35;
			this->label21->Text = L"Received String";
			// 
			// label20
			// 
			this->label20->AutoSize = true;
			this->label20->Location = System::Drawing::Point(7, 62);
			this->label20->Name = L"label20";
			this->label20->Size = System::Drawing::Size(62, 13);
			this->label20->TabIndex = 34;
			this->label20->Text = L"Send String";
			// 
			// tbChannelSetParameterTx
			// 
			this->tbChannelSetParameterTx->Location = System::Drawing::Point(93, 59);
			this->tbChannelSetParameterTx->Name = L"tbChannelSetParameterTx";
			this->tbChannelSetParameterTx->Size = System::Drawing::Size(475, 20);
			this->tbChannelSetParameterTx->TabIndex = 33;
			// 
			// label19
			// 
			this->label19->AutoSize = true;
			this->label19->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point,
				static_cast<System::Byte>(0)));
			this->label19->ForeColor = System::Drawing::Color::Coral;
			this->label19->Location = System::Drawing::Point(6, 13);
			this->label19->Name = L"label19";
			this->label19->Size = System::Drawing::Size(196, 20);
			this->label19->TabIndex = 32;
			this->label19->Text = L"Set Channel Parameter";
			// 
			// tmrStatic
			// 
			this->tmrStatic->Enabled = true;
			this->tmrStatic->Interval = 10;
			this->tmrStatic->Tick += gcnew System::EventHandler(this, &Form1::tmrStatic_Tick);
			// 
			// tmrUpdateDateTime
			// 
			this->tmrUpdateDateTime->Enabled = true;
			this->tmrUpdateDateTime->Interval = 3600000;
			this->tmrUpdateDateTime->Tick += gcnew System::EventHandler(this, &Form1::tmrUpdateDateTime_Tick);
			// 
			// tmrSampling
			// 
			this->tmrSampling->Tick += gcnew System::EventHandler(this, &Form1::tmrSampling_Tick);
			// 
			// tmrSamplingEndlessReadData
			// 
			this->tmrSamplingEndlessReadData->Tick += gcnew System::EventHandler(this, &Form1::tmrSamplingEndlessReadData_Tick);
			// 
			// lbConnectionStatus
			// 
			this->lbConnectionStatus->AutoSize = true;
			this->lbConnectionStatus->Location = System::Drawing::Point(5, 437);
			this->lbConnectionStatus->Name = L"lbConnectionStatus";
			this->lbConnectionStatus->Size = System::Drawing::Size(114, 13);
			this->lbConnectionStatus->TabIndex = 3;
			this->lbConnectionStatus->Text = L"Status: Not connected";
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(884, 526);
			this->Controls->Add(this->lbConnectionStatus);
			this->Controls->Add(this->tabControlMain);
			this->Controls->Add(this->lbHistory);
			this->Controls->Add(this->btnConnect);
			this->DoubleBuffered = true;
			this->Name = L"Form1";
			this->Text = L"Form1";
			this->FormClosed += gcnew System::Windows::Forms::FormClosedEventHandler(this, &Form1::Form1_FormClosed);
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->tabControlMain->ResumeLayout(false);
			this->tbReadme->ResumeLayout(false);
			this->tbReadme->PerformLayout();
			this->tbBoxInfo->ResumeLayout(false);
			this->tbBoxInfo->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->dataGridViewBoxInfo))->EndInit();
			this->tbChannelInfo->ResumeLayout(false);
			this->tbChannelInfo->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->dataGridViewChInfo))->EndInit();
			this->tbStatic->ResumeLayout(false);
			this->tbStatic->PerformLayout();
			this->tbDigi->ResumeLayout(false);
			this->tbDigi->PerformLayout();
			this->groupBox3->ResumeLayout(false);
			this->groupBox3->PerformLayout();
			this->groupBox2->ResumeLayout(false);
			this->groupBox2->PerformLayout();
			this->tbSampling->ResumeLayout(false);
			this->tbSampling->PerformLayout();
			this->groupBox7->ResumeLayout(false);
			this->groupBox7->PerformLayout();
			this->groupBox6->ResumeLayout(false);
			this->groupBox6->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuSampling_TimeKeepSamples))->EndInit();
			this->groupBox5->ResumeLayout(false);
			this->groupBox5->PerformLayout();
			this->groupBox4->ResumeLayout(false);
			this->groupBox4->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuSampling_TimeNSamples))->EndInit();
			this->tbSamplingAddOn->ResumeLayout(false);
			this->tbSamplingAddOn->PerformLayout();
			this->groupBox11->ResumeLayout(false);
			this->groupBox11->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuSamplingPositionDistance))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuSamplingPositionStart))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuSamplingPositionScale))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuSamplingPositionNSamples))->EndInit();
			this->groupBox9->ResumeLayout(false);
			this->groupBox9->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuSamplingTftNTailSamples))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuSamplingTftNSamples))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuSamplingTftFilterPeriod))->EndInit();
			this->groupBox8->ResumeLayout(false);
			this->groupBox8->PerformLayout();
			this->tbMisc1->ResumeLayout(false);
			this->tbMisc1->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuChannelSetConfigNo))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nuChannelSetParameterNo))->EndInit();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion



	/******************************************************************************
	* FUNCTION: Form1_Load
	*-----------------------------------------------------------------------------
	* Called after the form is loaded. Do several initializations.
	******************************************************************************/
	private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e) {
		unsigned long ulI = 0;
		String^ str = "";
		String^ strHeader = "";

		bConnected = false;
		ulBoxInfoUpdates = 0;
		ulChannelInfoUpdates = 0;
		ulStatic1stCh = 1;
		bNewStatic = false;
		bNewSamplingData = false;
		bNewReconnected = false;
		SamplingClearNotificationCtrs();
		aclChannelData = gcnew array<ChannelData^>(N_STATIC_CH_DISPLAY);
		for (ulI = 0; ulI < N_STATIC_CH_DISPLAY; ulI++) {
			aclChannelData[ulI] = gcnew ChannelData;
		}
		ulNSamplingElements = 0;
		ulSamplingEndlessArrayLength = 0;
		ulSamplingArrayRowNewest = 0;
		udSamplingCtrNewest = 0;
		ulSamplePeriodUltraFast = 1000;
		ulSamplePeriodFast = 500;
		ulSamplePeriodStandard = 100;
		for (ulI = 0; ulI < N_MAX_SAMPLING_CHANNELS; ulI++) {
			paaslRingBuf[ulI] = NULL;
		}
		bSamplingReadRows = false;
		ulCtrReconnects = 0;
		bWriteDigitalOutputData = false;

		cblSampling_MeasChannels->Items->Clear();
		cblSampling_DigitalInputs->Items->Clear();
		cblSampling_DigitalOutputs->Items->Clear();

		cbSamplingDInTrgBit->SelectedIndex = 0;
		cbSamplingDInTrgMode->SelectedIndex = 0;
		cbSamplingDInTrgPol->SelectedIndex = 0;
		cbSamplingTftTriggerBit->SelectedIndex = 0;
		cbSamplingTftTriggerMode->SelectedIndex = 0;
		cbSamplingTftTriggerPolarity->SelectedIndex = 0;

		/* Set Readme text */
		str = "This is a demo for the Nmx-DLL. Please note:\r\n\r\n" +
			"The purpose of this demo is helping software developers to integrate the measurement system into their software.\r\n" +
			"Focus has been put on demonstrating how to use the Nmx-DLL. User interface design an error handling are very basic. " +
			"Integration into your own software probably requires a more sophisticated user interface and extended error handling.\r\n\r\n" +
			"THIS DEMO COMES WITHOUT ANY WARRANTY OR LIABILITY.\r\n\r\n" +
			"We strongly recomment to separate the GUI-update and the DLL into different Windows-threads. " +
			"One way to do this is using Windows messages in combination with a timer, that runs in the GUI thread. " +
			"In this example this is demonstrated by the combination of WndProc and tmrStatic_Tick.\r\n" +
			"In this demo the NmxDLL.dll file must be placed in the same directory as the Exe.\r\n" +
			"By default the IP-Adress 192.168.3.99 is used for the system. Change it, if required.\r\n\r\n" +
			"Messtechnik Sachs GmbH\r\nwww.messtechnik-sachs.de\r\nPhone: +49 7181 26935 0";
		tBoxReadme->Text = str;

		/* Try to load the DLL */
		clNmx = new CNmx();
		if (clNmx->Load() == true)
		{
			/* Dll loaded successfully. Get version info. */
			unsigned short usMajor = 0;
			unsigned short usMinor = 0;
			unsigned short usPatch = 0;
			unsigned short usBuild = 0;
			clNmx->GetDllVersion_1(&usMajor, &usMinor, &usPatch, &usBuild);
			str = String::Format("NmxDll loaded successfully: V{0}.{1}.{2}.{3}", usMajor, usMinor, usPatch, usBuild);
			strHeader = String::Format("NmxDLL V{0}.{1}.{2}.{3}", usMajor, usMinor, usPatch, usBuild);
			AddHistoryEntry(str, false);
		}
		else
		{
			/* Failed to load the Dll */
			AddHistoryEntry("Failed to load the NmxDll. In same directory as the exe?", true);
		}

		Form1::Text = "Nmx Demo for VCpp # " + strHeader;
	}


	/******************************************************************************
	* FUNCTION: Form1_FormClosed
	*-----------------------------------------------------------------------------
	* Called after the form has been closed. Do some cleanup.
	******************************************************************************/
private: System::Void Form1_FormClosed(System::Object^  sender, System::Windows::Forms::FormClosedEventArgs^  e) {
	unsigned long ulI = 0;

	clNmx->DeviceClose_1(&pHandleNmx);

	for (ulI = 0; ulI < N_MAX_SAMPLING_CHANNELS; ulI++) {
		if (paaslRingBuf[ulI] != NULL) {
			delete paaslRingBuf[ulI];
		}
	}
}



	/******************************************************************************
	* FUNCTION: AddHistoryEntry
	*-----------------------------------------------------------------------------
	* Add a new line with information for the user in the history-Listbox.
	*-----------------------------------------------------------------------------
	* PARAMETERS:
	* str: String to display in the new line
	* bError: false -> "only" information
	*         true -> an error occured
	*         So far this parameter is not used. It is intended future
	*         extension of this function. However, when calling this function,
	*         this parameter should be used as intended.
	*-----------------------------------------------------------------------------
	* Return: none
	******************************************************************************/
	private: System::Void AddHistoryEntry(String^ str, bool bError) {
		if (bError == false) {
			lbHistory->Items->Insert(0, str);
		}
		else {
			lbHistory->Items->Insert(0, "[Error] " + str);
		}
	}


	/******************************************************************************
	* FUNCTION: SamplingClearNotificationCtrs
	*-----------------------------------------------------------------------------
	* Clear all notification counters for sampling.
	*-----------------------------------------------------------------------------
	* PARAMETERS: none
	*-----------------------------------------------------------------------------
	* Return: none
	******************************************************************************/
	private: System::Void SamplingClearNotificationCtrs(void) {
		ulCtrSamplingNotificationsNewData = 0;
		ulCtrSamplingNotificationsFinished = 0;
		ulCtrSamplingNotificationsAllReceived = 0;
		ulCtrSamplingNotificationsError = 0;
		ulCtrSamplingNotificationsBufferOverflow = 0;
		ulCtrSamplingNotificationTimeout = 0;
	}


	/******************************************************************************
	* FUNCTION: btnConnect_Click
	*-----------------------------------------------------------------------------
	* Connect / Disconnect the NMX device.
	******************************************************************************/
private: System::Void btnConnect_Click(System::Object^  sender, System::EventArgs^  e) {
		if (bConnected == false)
		{
			ulCtrReconnects = 0;

			NMX_STATUS tStatus = clNmx->DeviceIPv4Open_1(192, 168, 3, 99, 22517, 22516, &pHandleNmx);
			if (tStatus == NST_SUCCESS) {
				AddHistoryEntry("Device connected successfully", false);
				bConnected = true;
				lbConnectionStatus->Text = "Status: Connected";
				lbConnectionStatus->ForeColor = Color::Green;
				btnConnect->Text = "Disconnect";

				btnChannelInfoUpdate_Click(sender, e);

				/* Update lists of measurement channels / DIO for sampling */
				cblSampling_MeasChannels->Items->Clear();
				cblSampling_DigitalInputs->Items->Clear();
				cblSampling_DigitalOutputs->Items->Clear();
				cbSamplingDInTrgByte->Items->Clear();
				
				unsigned long ulNChannels = 0;
				unsigned long ulNInputs = 0;
				unsigned long ulNOutputs = 0;
				clNmx->GetChannelCount_1(pHandleNmx, &ulNChannels, &ulNInputs, &ulNOutputs);

				BOOL bChecked = true;	// Set first check box to enabled
				for (unsigned long ulI = 0; ulI < ulNChannels; ulI++) {
					unsigned long ulBoxNo = 0xFF;
					unsigned long ulChannelNo = 0xFF;
					clNmx->GetChannelInfo_1(pHandleNmx, ulI, NULL, NULL, &ulBoxNo, NULL, &ulChannelNo, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
					cblSampling_MeasChannels->Items->Add(gcnew  System::Windows::Forms::CheckBox, bChecked);
					bChecked = false;
					cblSampling_MeasChannels->Items[ulI] = String::Format("P{0} - Box {1} . Ch {2}", ulI+1, ulBoxNo, ulChannelNo);
					cbSamplingPositionTriggerChannel->Items->Add(String::Format("P{0} - Box {1} . Ch {2}", ulI + 1, ulBoxNo, ulChannelNo));
				}
				if (cbSamplingPositionTriggerChannel->Items->Count > 0) {
					cbSamplingPositionTriggerChannel->SelectedIndex = 0;
				}

				for (unsigned long ulI = 0; ulI < ulNInputs; ulI++) {
					unsigned long ulBoxNo = 0xFF;
					unsigned long ulByteNo = 0xFF;
					clNmx->GetDigitalInputInfo_1(pHandleNmx, ulI, &ulBoxNo, &ulByteNo);
					cblSampling_DigitalInputs->Items->Add(gcnew System::Windows::Forms::CheckBox, false);
					cblSampling_DigitalInputs->Items[ulI] = String::Format("In Byte {0} - Box {1} : {2}..{3}", ulI + 1, ulBoxNo, (ulByteNo-1)*8+1, (ulByteNo-1)*8+8);
					cbSamplingDInTrgByte->Items->Add(String::Format("In Byte {0} - Box {1} : {2}..{3}", ulI + 1, ulBoxNo, (ulByteNo - 1) * 8 + 1, (ulByteNo - 1) * 8 + 8));
					cbSamplingTftTriggerByte->Items->Add(String::Format("In Byte {0} - Box {1} : {2}..{3}", ulI + 1, ulBoxNo, (ulByteNo - 1) * 8 + 1, (ulByteNo - 1) * 8 + 8));
				}
				if (cbSamplingDInTrgByte->Items->Count > 0) {
					cbSamplingDInTrgByte->SelectedIndex = 0;
				}
				if (cbSamplingTftTriggerByte->Items->Count > 0) {
					cbSamplingTftTriggerByte->SelectedIndex = 0;
				}

				for (unsigned long ulI = 0; ulI < ulNOutputs; ulI++) {
					unsigned long ulBoxNo = 0xFF;
					unsigned long ulByteNo = 0xFF;
					clNmx->GetDigitalOutputInfo_1(pHandleNmx, ulI, &ulBoxNo, &ulByteNo);
					cblSampling_DigitalOutputs->Items->Add(gcnew System::Windows::Forms::CheckBox, false);
					cblSampling_DigitalOutputs->Items[ulI] = String::Format("Out Byte {0} - Box {1} : {2}..{3}", ulI + 1, ulBoxNo, (ulByteNo - 1) * 8 + 1, (ulByteNo - 1) * 8 + 8);
				}


				nuChannelSetParameterNo->Value = 0;
				if (ulNChannels > 0) {
					unsigned int ulTemp = ulNChannels - 1;
					nuChannelSetParameterNo->Maximum = System::Convert::ToDecimal(ulTemp);
					nuChannelSetConfigNo->Maximum = System::Convert::ToDecimal(ulTemp);
				}


				/* Register Windows messages to receive notifications from the NMX-DLL. 
				 * The messages will be received by the message handler WndProc (see below). */					
				tStatus = clNmx->RegisterMessage_1(pHandleNmx, NMXNOTIFY_DISCONNECTED, static_cast<HWND>(Handle.ToPointer()), WM_MESSAGE_DISCONNECTED, 0, 0);
				if (tStatus != NST_SUCCESS) { AddHistoryEntry("Registering message for disconnect failed.", true); }
				tStatus = clNmx->RegisterMessage_1(pHandleNmx, NMXNOTIFY_FAILURE_DATA_EXCHANGE, static_cast<HWND>(Handle.ToPointer()), WM_MESSAGE_FAILURE_DATA_EXCHANGE, 0, 0);
				if (tStatus != NST_SUCCESS) { AddHistoryEntry("Registering message for data exchange failure failed.", true); }
				tStatus = clNmx->RegisterMessage_1(pHandleNmx, NMXNOTIFY_RECONNECTED, static_cast<HWND>(Handle.ToPointer()), WM_MESSAGE_RECONNECTED, 0, 0);
				if (tStatus != NST_SUCCESS) { AddHistoryEntry("Registering message for reconnected failed.", true); }
				tStatus = clNmx->RegisterMessage_1(pHandleNmx, NMXNOTIFY_NEW_STATIC32, static_cast<HWND>(Handle.ToPointer()), WM_MESSAGE_NEW_STATIC32, 0, 0);
				if (tStatus != NST_SUCCESS) {AddHistoryEntry("Registering message for new static data failed.", true);}
				tStatus = clNmx->RegisterMessage_1(pHandleNmx, NMXNOTIFY_SAMPLING_NEW_DATA, static_cast<HWND>(Handle.ToPointer()), WM_MESSAGE_SAMPLING_NEWDATA, 0, 0);
				if (tStatus != NST_SUCCESS) { AddHistoryEntry("Registering message for new sampling data failed.", true); }
				tStatus = clNmx->RegisterMessage_1(pHandleNmx, NMXNOTIFY_SAMPLING_ALL_DATA_RECEIVED, static_cast<HWND>(Handle.ToPointer()), WM_MESSAGE_SAMPLING_ALLRECEIVED, 0, 0);
				if (tStatus != NST_SUCCESS) { AddHistoryEntry("Registering message for 'all sampling data received' failed.", true); }
				tStatus = clNmx->RegisterMessage_1(pHandleNmx, NMXNOTIFY_SAMPLING_FINISHED, static_cast<HWND>(Handle.ToPointer()), WM_MESSAGE_SAMPLING_FINISHED, 0, 0);
				if (tStatus != NST_SUCCESS) { AddHistoryEntry("Registering message for 'sampling finished' failed.", true); }
				tStatus = clNmx->RegisterMessage_1(pHandleNmx, NMXNOTIFY_SAMPLING_ERROR, static_cast<HWND>(Handle.ToPointer()), WM_MESSAGE_SAMPLING_ERROR, 0, 0);
				if (tStatus != NST_SUCCESS) { AddHistoryEntry("Registering message for 'sampling error' failed.", true); }
				tStatus = clNmx->RegisterMessage_1(pHandleNmx, NMXNOTIFY_SAMPLING_BUFFER_OVERFLOW, static_cast<HWND>(Handle.ToPointer()), WM_MESSAGE_SAMPLING_BUFFER_OVERFLOW, 0, 0);
				if (tStatus != NST_SUCCESS) { AddHistoryEntry("Registering message for 'sampling buffer overflow' failed.", true); }
				tStatus = clNmx->RegisterMessage_1(pHandleNmx, NMXNOTIFY_SAMPLING_TIMEOUT, static_cast<HWND>(Handle.ToPointer()), WM_MESSAGE_SAMPLING_TIMEOUT, 0, 0);
				if (tStatus != NST_SUCCESS) { AddHistoryEntry("Registering message for 'sampling timeout' failed.", true); }

				/* Demo for a callback notification.
				 * This is just for demonstration in case you prefer callbacks. The callback is not used in this example! */
				tStatus = clNmx->RegisterCallback_1(pHandleNmx, NMXNOTIFY_NEW_STATIC32, &Callback_NewStatic32, (void*)&ulCallbackContext);
				if (tStatus != NST_SUCCESS) { AddHistoryEntry("Registering demo callback for new static data failed.", true); }

				/* Get min sample period and determine different speed levels for the demo.
				* In your measurement application you do not need to have different speed levels.
				* This is just for the demo! */
				SamplingUpdateSpeedLevels();
			}
			else {
				AddHistoryEntry("Failed connecting the device", true);
			}
		}
		else
		{
			NMX_STATUS tStatus = clNmx->DeviceClose_1(&pHandleNmx);
			if (tStatus == NST_SUCCESS)	{
				AddHistoryEntry("Device disconnected successfully", false);
			}
			else {
				AddHistoryEntry("Failed disconnecting the device", true);
			}
			bConnected = false;
			btnConnect->Text = "Connect";
		}
	}

	/******************************************************************************
	* FUNCTION: btnBoxInfoUpdate_Click
	*-----------------------------------------------------------------------------
	* Update box information.
	******************************************************************************/
	private: System::Void btnBoxInfoUpdate_Click(System::Object^  sender, System::EventArgs^  e) {
		unsigned long ulBoxCount = 0;
		unsigned long ulBoxNo = 0;
		unsigned long aulInfoData[20] = { 0 };
		unsigned long long udMacAddress = 0;
		char acSerNo[16+1] = { 0 };
		char acProdCode[16+1] = { 0 };
		char acOrderNo[32+1] = { 0 };
		char acName[128+1] = { 0 };
		String ^str;

		if (clNmx->GetBoxCount_1(pHandleNmx, &ulBoxCount) != NST_SUCCESS)
		{
			AddHistoryEntry("Reading box count failed.", true);
			return;
		}

		dataGridViewBoxInfo->Rows->Clear();
		for (ulBoxNo = 0; ulBoxNo < ulBoxCount; ulBoxNo++)
		{
			if (clNmx->GetBoxInfo_1(pHandleNmx, ulBoxNo, aulInfoData, sizeof(aulInfoData) / 4, &udMacAddress, acSerNo, sizeof(acSerNo), acProdCode, sizeof(acProdCode), acOrderNo, sizeof(acOrderNo), acName, sizeof(acName)) != NST_SUCCESS)
			{
				AddHistoryEntry("Reading box info failed.", true);
			}
			else
			{
				dataGridViewBoxInfo->Rows->Add();
				dataGridViewBoxInfo[0, dataGridViewBoxInfo->Rows->Count - 1]->Value = String::Format("{0}", aulInfoData[0]);		/* Box-No */
				str = gcnew String(acName);
				dataGridViewBoxInfo[1, dataGridViewBoxInfo->Rows->Count - 1]->Value = str;											/* Name */
				delete str;
				str = gcnew String(acSerNo);
				dataGridViewBoxInfo[2, dataGridViewBoxInfo->Rows->Count - 1]->Value = str;											/* Serial number */
				delete str;
				dataGridViewBoxInfo[3, dataGridViewBoxInfo->Rows->Count - 1]->Value = String::Format("{0:X2}-{1:X2}-{2:X2}-{3:X2}-{4:X2}-{5:X2}",	/* MAC-Address */
					(udMacAddress >> 40) & 0xFF,
					(udMacAddress >> 32) & 0xFF,
					(udMacAddress >> 24) & 0xFF,
					(udMacAddress >> 16) & 0xFF,
					(udMacAddress << 8) & 0xFF,
					udMacAddress & 0xFF);
				dataGridViewBoxInfo[4, dataGridViewBoxInfo->Rows->Count - 1]->Value = String::Format("V{0}.{1}.{2}.{3}",			/* Firmware-Version */
					aulInfoData[4],
					aulInfoData[5],
					aulInfoData[6],
					aulInfoData[7]);
				dataGridViewBoxInfo[5, dataGridViewBoxInfo->Rows->Count - 1]->Value = String::Format("V{0}.{1} Rev {2}",			/* Hardware-Version / -Revision */
					aulInfoData[1],
					aulInfoData[2],
					aulInfoData[3]);
				dataGridViewBoxInfo[6, dataGridViewBoxInfo->Rows->Count - 1]->Value = String::Format("{0}", aulInfoData[8]);		/* Number of measurement channels */
				dataGridViewBoxInfo[7, dataGridViewBoxInfo->Rows->Count - 1]->Value = String::Format("{0}", aulInfoData[13]);		/* Number of digital inputs */
				dataGridViewBoxInfo[8, dataGridViewBoxInfo->Rows->Count - 1]->Value = String::Format("{0}", aulInfoData[14]);		/* Number of digital outputs */
				str = gcnew String(acProdCode);
				dataGridViewBoxInfo[9, dataGridViewBoxInfo->Rows->Count - 1]->Value = str;											/* Production code */
				delete str;
			}
		}

		ulBoxInfoUpdates++;
		lbBoxInfoUpdates->Text = String::Format("{0} update", ulBoxInfoUpdates);
		if (ulBoxInfoUpdates > 1) {
			lbBoxInfoUpdates->Text += "s";
		}
	}

	/******************************************************************************
	* FUNCTION: btnChannelInfoUpdate_Click
	*-----------------------------------------------------------------------------
	* Update channel information.
	******************************************************************************/
private: System::Void btnChannelInfoUpdate_Click(System::Object^  sender, System::EventArgs^  e) {
	unsigned long ulChannelCount = 0;
	unsigned long ulChannel = 0;

	unsigned long ulChannelType = 0;
	unsigned long ulNDigits = 1;
	unsigned long ulBoxNo = 0;
	unsigned long ulBoxChannelNo = 0;
	signed long slRawDataType = 0;
	signed long slFactNumerator = 1;
	signed long slFactDenominator = 1;
	float flFactDigitsToUnit = 1.0f;
	char acUnit[8 + 1] = { 0 };
	char acOrderNo[16 + 1] = { 0 };
	char acSerialNo[16 + 1] = { 0 };
	String ^str;

	if (clNmx->UpdateChannelInfo_1(pHandleNmx) != NST_SUCCESS) {
		AddHistoryEntry("Updating channel information failed.", true);
		return;
	}

	if (clNmx->GetChannelCount_1(pHandleNmx, &ulChannelCount, NULL, NULL) != NST_SUCCESS) {
		AddHistoryEntry("Reading channel count failed.", true);
	}

	dataGridViewChInfo->Rows->Clear();
	for (ulChannel = 0; ulChannel < ulChannelCount; ulChannel++)
	{
		if (clNmx->GetChannelInfo_1(pHandleNmx, ulChannel,
			&ulChannelType, &ulNDigits, &ulBoxNo, NULL, &ulBoxChannelNo, &slRawDataType,
			&slFactNumerator, &slFactDenominator, &flFactDigitsToUnit, acUnit, sizeof(acUnit),
			acOrderNo, sizeof(acOrderNo), acSerialNo, sizeof(acSerialNo)) != NST_SUCCESS)
		{
			AddHistoryEntry("Reading channel info failed.", true);
		}
		else
		{
			dataGridViewChInfo->Rows->Add();
			dataGridViewChInfo[0, dataGridViewChInfo->Rows->Count - 1]->Value = String::Format("{0}", ulChannel);			/* Channel-No */
			dataGridViewChInfo[1, dataGridViewChInfo->Rows->Count - 1]->Value = String::Format("Box {0} # Ch. {1}", ulBoxNo, ulBoxChannelNo);		/* Location */
			dataGridViewChInfo[2, dataGridViewChInfo->Rows->Count - 1]->Value = String::Format("0x{0:X4}", ulChannelType);	/* Channel-type */
			str = gcnew String(acUnit);
			dataGridViewChInfo[3, dataGridViewChInfo->Rows->Count - 1]->Value = str;	/* Unit */
			dataGridViewChInfo[4, dataGridViewChInfo->Rows->Count - 1]->Value = String::Format("{0} {1}/digit\n{2}/{3}", flFactDigitsToUnit, str, slFactNumerator, slFactDenominator); /* Factor to Unit */
			if (ulChannel < N_STATIC_CH_DISPLAY) {
				aclChannelData[ulChannel]->fdFactor = flFactDigitsToUnit;
				aclChannelData[ulChannel]->ulNDigits = ulNDigits;
				aclChannelData[ulChannel]->strUnit = str;
			}
			delete str;
			dataGridViewChInfo[5, dataGridViewChInfo->Rows->Count - 1]->Value = String::Format("{0}", ulNDigits);	/* Decimal Digits */
			str = gcnew String(acOrderNo);
			dataGridViewChInfo[6, dataGridViewChInfo->Rows->Count - 1]->Value = str;	/* Ordern-No */
			delete str;
			str = gcnew String(acSerialNo);
			dataGridViewChInfo[7, dataGridViewChInfo->Rows->Count - 1]->Value = str;	/* Serial-No */
			delete str;
		}
	}

	ulChannelInfoUpdates++;
	lbChInfoUpdates->Text = String::Format("{0} update", ulChannelInfoUpdates);
	if (ulChannelInfoUpdates > 1) {
		lbChInfoUpdates->Text += "s";
	}
}

	/******************************************************************************
	* FUNCTION: WndProc
	*-----------------------------------------------------------------------------
	* This function is called when the form receives a new windows message.
	* All messages from the MscDll are filtered out and processed. All other
	* messages are forwarded to the respective form message function
	* (Form::WndProc).
	******************************************************************************/
	protected:	virtual void WndProc(Message% m) override
	{
		/* Listen for operating system messages. */
		switch (m.Msg)
		{
		case WM_MESSAGE_DISCONNECTED:
			bConnected = false;
			btnConnect->Text = "Connect";
			lbConnectionStatus->Text = "Status: Disconnected";
			lbConnectionStatus->ForeColor = Color::Black;
			break;

		case WM_MESSAGE_FAILURE_DATA_EXCHANGE:
			lbConnectionStatus->Text = "Status: Timeout";
			lbConnectionStatus->ForeColor = Color::Red;
			break;

		case WM_MESSAGE_RECONNECTED:
			bConnected = true;
			ulCtrReconnects++;
			btnConnect->Text = "Disconnect";
			lbConnectionStatus->Text = String::Format("Status: Reconnected ({0})", ulCtrReconnects);
			lbConnectionStatus->ForeColor = Color::Purple;
			bNewReconnected = true;
			break;

		case WM_MESSAGE_NEW_STATIC32:
			bNewStatic = true;
			break;

		case WM_MESSAGE_SAMPLING_NEWDATA:
			bNewSamplingData = true;
			ulCtrSamplingNotificationsNewData++;
			break;

		case WM_MESSAGE_SAMPLING_ALLRECEIVED:
			ulCtrSamplingNotificationsAllReceived++;
			break;

		case WM_MESSAGE_SAMPLING_FINISHED:
			ulCtrSamplingNotificationsFinished++;
			break;

		case WM_MESSAGE_SAMPLING_ERROR:
			ulCtrSamplingNotificationsError++;
			break;

		case WM_MESSAGE_SAMPLING_BUFFER_OVERFLOW:
			ulCtrSamplingNotificationsBufferOverflow++;
			break;

		case WM_MESSAGE_SAMPLING_TIMEOUT:
			ulCtrSamplingNotificationTimeout++;
			break;

		default:
			/* Pass all standard messages to the GUI form. */
			Form::WndProc(m);
			break;
		}
	}

	/******************************************************************************
	* FUNCTION: rbStaticCH1_8_CheckedChanged
	*-----------------------------------------------------------------------------
	* Static measurement: The channel selection has been changed (e.g. from 1..8
	* to 9..16). Update GUI.
	******************************************************************************/
private: System::Void rbStaticCH1_8_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
	if (sender == rbStaticCH9_16) {
		ulStatic1stCh = 9;
	}
	else if (sender == rbStaticCH17_24) {
		ulStatic1stCh = 17;
	}
	else if (sender == rbStaticCH25_32) {
		ulStatic1stCh = 25;
	}
	else if (sender == rbStaticCH33_40) {
		ulStatic1stCh = 33;
	}
	else if (sender == rbStaticCH41_48) {
		ulStatic1stCh = 41;
	}
	else if (sender == rbStaticCH49_56) {
		ulStatic1stCh = 49;
	}
	else if (sender == rbStaticCH57_64) {
		ulStatic1stCh = 57;
	}
	else {
		ulStatic1stCh = 1;
	}
	lbStaticCh1->Text = (ulStatic1stCh + 0).ToString();
	lbStaticCh2->Text = (ulStatic1stCh + 1).ToString();
	lbStaticCh3->Text = (ulStatic1stCh + 2).ToString();
	lbStaticCh4->Text = (ulStatic1stCh + 3).ToString();
	lbStaticCh5->Text = (ulStatic1stCh + 4).ToString();
	lbStaticCh6->Text = (ulStatic1stCh + 5).ToString();
	lbStaticCh7->Text = (ulStatic1stCh + 6).ToString();
	lbStaticCh8->Text = (ulStatic1stCh + 7).ToString();
	lbStaticDigits1->Text = "*";
	lbStaticDigits2->Text = "*";
	lbStaticDigits3->Text = "*";
	lbStaticDigits4->Text = "*";
	lbStaticDigits5->Text = "*";
	lbStaticDigits6->Text = "*";
	lbStaticDigits7->Text = "*";
	lbStaticDigits8->Text = "*";
	lbStaticUnit1->Text = "*";
	lbStaticUnit2->Text = "*";
	lbStaticUnit3->Text = "*";
	lbStaticUnit4->Text = "*";
	lbStaticUnit5->Text = "*";
	lbStaticUnit6->Text = "*";
	lbStaticUnit7->Text = "*";
	lbStaticUnit8->Text = "*";
	lbStaticHwStat1->Text = "*";
	lbStaticHwStat2->Text = "*";
	lbStaticHwStat3->Text = "*";
	lbStaticHwStat4->Text = "*";
	lbStaticHwStat5->Text = "*";
	lbStaticHwStat6->Text = "*";
	lbStaticHwStat7->Text = "*";
	lbStaticHwStat8->Text = "*";
	lbStaticMin1->Text = "*";
	lbStaticMin2->Text = "*";
	lbStaticMin3->Text = "*";
	lbStaticMin4->Text = "*";
	lbStaticMin5->Text = "*";
	lbStaticMin6->Text = "*";
	lbStaticMin7->Text = "*";
	lbStaticMin8->Text = "*";
	lbStaticMax1->Text = "*";
	lbStaticMax2->Text = "*";
	lbStaticMax3->Text = "*";
	lbStaticMax4->Text = "*";
	lbStaticMax5->Text = "*";
	lbStaticMax6->Text = "*";
	lbStaticMax7->Text = "*";
	lbStaticMax8->Text = "*";
	lbStaticDiff1->Text = "*";
	lbStaticDiff2->Text = "*";
	lbStaticDiff3->Text = "*";
	lbStaticDiff4->Text = "*";
	lbStaticDiff5->Text = "*";
	lbStaticDiff6->Text = "*";
	lbStaticDiff7->Text = "*";
	lbStaticDiff8->Text = "*";
}

	/******************************************************************************
	* FUNCTION: tmrStatic_Tick
	*-----------------------------------------------------------------------------
	* Timer for update of static data.
	******************************************************************************/
private: System::Void tmrStatic_Tick(System::Object^  sender, System::EventArgs^  e) {

	array<System::Windows::Forms::Label^, 1>^ albDIn = gcnew array<System::Windows::Forms::Label^>{
		lbDIn_1, lbDIn_2, lbDIn_3, lbDIn_4, lbDIn_5, lbDIn_6, lbDIn_7, lbDIn_8,
		lbDIn_9, lbDIn_10, lbDIn_11, lbDIn_12, lbDIn_13, lbDIn_14, lbDIn_15, lbDIn_16,
		lbDIn_17, lbDIn_18, lbDIn_19, lbDIn_20, lbDIn_21, lbDIn_22, lbDIn_23, lbDIn_24,
		lbDIn_25, lbDIn_26, lbDIn_27, lbDIn_28, lbDIn_29, lbDIn_30, lbDIn_31, lbDIn_32,
		lbDIn_33, lbDIn_34, lbDIn_35, lbDIn_36, lbDIn_37, lbDIn_38, lbDIn_39, lbDIn_40,
		lbDIn_41, lbDIn_42, lbDIn_43, lbDIn_44, lbDIn_45, lbDIn_46, lbDIn_47, lbDIn_48,
		lbDIn_49, lbDIn_50, lbDIn_51, lbDIn_52, lbDIn_53, lbDIn_54, lbDIn_55, lbDIn_56,
		lbDIn_57, lbDIn_58, lbDIn_59, lbDIn_60, lbDIn_61, lbDIn_62, lbDIn_63, lbDIn_64,
		lbDIn_65, lbDIn_66, lbDIn_67, lbDIn_68, lbDIn_69, lbDIn_70, lbDIn_71, lbDIn_72,
		lbDIn_73, lbDIn_74, lbDIn_75, lbDIn_76, lbDIn_77, lbDIn_78, lbDIn_79, lbDIn_80,
		lbDIn_81, lbDIn_82, lbDIn_83, lbDIn_84, lbDIn_85, lbDIn_86, lbDIn_87, lbDIn_88,
		lbDIn_89, lbDIn_90, lbDIn_91, lbDIn_92, lbDIn_93, lbDIn_94, lbDIn_95, lbDIn_96,
		lbDIn_97, lbDIn_98, lbDIn_99, lbDIn_100, lbDIn_101, lbDIn_102, lbDIn_103, lbDIn_104,
		lbDIn_105, lbDIn_106, lbDIn_107, lbDIn_108, lbDIn_109, lbDIn_110, lbDIn_111, lbDIn_112,
		lbDIn_113, lbDIn_114, lbDIn_115, lbDIn_116, lbDIn_117, lbDIn_118, lbDIn_119, lbDIn_120,
		lbDIn_121, lbDIn_122, lbDIn_123, lbDIn_124, lbDIn_125, lbDIn_126, lbDIn_127, lbDIn_128
	};
		 
	/* Disable this timer */
	tmrStatic->Enabled = false;

	cbStaticFastUpdate->Enabled = bConnected;
	btnDigiEnableOutputWrite->Enabled = bConnected;

	if (bNewStatic != false)
	{
		bNewStatic = false;
		signed long aslMeasVal[N_STATIC_CH_DISPLAY];
		unsigned char aucHardStat[N_STATIC_CH_DISPLAY];
		unsigned char aucDigiIn[N_DIGIIO_DISPLAY / 8];
		unsigned long ulNUpdates = 0;
		memset(aslMeasVal, 0, sizeof(aslMeasVal));
		memset(aucHardStat, 0, sizeof(aucHardStat));
		memset(aucDigiIn, 0, sizeof(aucDigiIn));
		if (clNmx->StaticGet32_1(pHandleNmx, aslMeasVal, N_STATIC_CH_DISPLAY, aucHardStat, sizeof(aucHardStat), aucDigiIn, sizeof(aucDigiIn), NULL, 0, &ulNUpdates) == NST_SUCCESS)
		{
			if ((ulStatic1stCh > 0) && (ulStatic1stCh <= (N_STATIC_CH_DISPLAY - 7))) {
				UINT32 ul1stCh = ulStatic1stCh - 1;

				for (unsigned long ulI = 0; ulI < 8; ulI++) {
					aclChannelData[ul1stCh + ulI]->NewStaticValue(aslMeasVal[ul1stCh + ulI]);
				}

				lbStaticDigits1->Text = aclChannelData[ul1stCh + 0]->GetNewestValue().ToString();
				lbStaticDigits2->Text = aclChannelData[ul1stCh + 1]->GetNewestValue().ToString();
				lbStaticDigits3->Text = aclChannelData[ul1stCh + 2]->GetNewestValue().ToString();
				lbStaticDigits4->Text = aclChannelData[ul1stCh + 3]->GetNewestValue().ToString();
				lbStaticDigits5->Text = aclChannelData[ul1stCh + 4]->GetNewestValue().ToString();
				lbStaticDigits6->Text = aclChannelData[ul1stCh + 5]->GetNewestValue().ToString();
				lbStaticDigits7->Text = aclChannelData[ul1stCh + 6]->GetNewestValue().ToString();
				lbStaticDigits8->Text = aclChannelData[ul1stCh + 7]->GetNewestValue().ToString();

				lbStaticHwStat1->Text = String::Format("0x{0:X2}", aucHardStat[ul1stCh + 0]);
				lbStaticHwStat2->Text = String::Format("0x{0:X2}", aucHardStat[ul1stCh + 1]);
				lbStaticHwStat3->Text = String::Format("0x{0:X2}", aucHardStat[ul1stCh + 2]);
				lbStaticHwStat4->Text = String::Format("0x{0:X2}", aucHardStat[ul1stCh + 3]);
				lbStaticHwStat5->Text = String::Format("0x{0:X2}", aucHardStat[ul1stCh + 4]);
				lbStaticHwStat6->Text = String::Format("0x{0:X2}", aucHardStat[ul1stCh + 5]);
				lbStaticHwStat7->Text = String::Format("0x{0:X2}", aucHardStat[ul1stCh + 6]);
				lbStaticHwStat8->Text = String::Format("0x{0:X2}", aucHardStat[ul1stCh + 7]);

				lbStaticUnit1->Text = aclChannelData[ul1stCh + 0]->GetStaticUnitValue();
				lbStaticUnit2->Text = aclChannelData[ul1stCh + 1]->GetStaticUnitValue();
				lbStaticUnit3->Text = aclChannelData[ul1stCh + 2]->GetStaticUnitValue();
				lbStaticUnit4->Text = aclChannelData[ul1stCh + 3]->GetStaticUnitValue();
				lbStaticUnit5->Text = aclChannelData[ul1stCh + 4]->GetStaticUnitValue();
				lbStaticUnit6->Text = aclChannelData[ul1stCh + 5]->GetStaticUnitValue();
				lbStaticUnit7->Text = aclChannelData[ul1stCh + 6]->GetStaticUnitValue();
				lbStaticUnit8->Text = aclChannelData[ul1stCh + 7]->GetStaticUnitValue();

				lbStaticMin1->Text = aclChannelData[ul1stCh + 0]->GetStaticUnitMin();
				lbStaticMin2->Text = aclChannelData[ul1stCh + 1]->GetStaticUnitMin();
				lbStaticMin3->Text = aclChannelData[ul1stCh + 2]->GetStaticUnitMin();
				lbStaticMin4->Text = aclChannelData[ul1stCh + 3]->GetStaticUnitMin();
				lbStaticMin5->Text = aclChannelData[ul1stCh + 4]->GetStaticUnitMin();
				lbStaticMin6->Text = aclChannelData[ul1stCh + 5]->GetStaticUnitMin();
				lbStaticMin7->Text = aclChannelData[ul1stCh + 6]->GetStaticUnitMin();
				lbStaticMin8->Text = aclChannelData[ul1stCh + 7]->GetStaticUnitMin();

				lbStaticMax1->Text = aclChannelData[ul1stCh + 0]->GetStaticUnitMax();
				lbStaticMax2->Text = aclChannelData[ul1stCh + 1]->GetStaticUnitMax();
				lbStaticMax3->Text = aclChannelData[ul1stCh + 2]->GetStaticUnitMax();
				lbStaticMax4->Text = aclChannelData[ul1stCh + 3]->GetStaticUnitMax();
				lbStaticMax5->Text = aclChannelData[ul1stCh + 4]->GetStaticUnitMax();
				lbStaticMax6->Text = aclChannelData[ul1stCh + 5]->GetStaticUnitMax();
				lbStaticMax7->Text = aclChannelData[ul1stCh + 6]->GetStaticUnitMax();
				lbStaticMax8->Text = aclChannelData[ul1stCh + 7]->GetStaticUnitMax();

				lbStaticDiff1->Text = aclChannelData[ul1stCh + 0]->GetStaticUnitDiff();
				lbStaticDiff2->Text = aclChannelData[ul1stCh + 1]->GetStaticUnitDiff();
				lbStaticDiff3->Text = aclChannelData[ul1stCh + 2]->GetStaticUnitDiff();
				lbStaticDiff4->Text = aclChannelData[ul1stCh + 3]->GetStaticUnitDiff();
				lbStaticDiff5->Text = aclChannelData[ul1stCh + 4]->GetStaticUnitDiff();
				lbStaticDiff6->Text = aclChannelData[ul1stCh + 5]->GetStaticUnitDiff();
				lbStaticDiff7->Text = aclChannelData[ul1stCh + 6]->GetStaticUnitDiff();
				lbStaticDiff8->Text = aclChannelData[ul1stCh + 7]->GetStaticUnitDiff();
			}

			lbStaticUpdates->Text = String::Format("{0} Updates", ulNUpdates);
			lbDInUpdates->Text = lbStaticUpdates->Text;

			for (unsigned long ulI = 0; ulI < N_DIGIIO_DISPLAY; ulI++) {
				if (aucDigiIn[ulI / 8] & (1 << (ulI % 8))) {
					albDIn[ulI]->ForeColor = Color::Blue;
					albDIn[ulI]->Font = gcnew System::Drawing::Font(albDIn[ulI]->Font, FontStyle::Bold);
				}
				else {
					albDIn[ulI]->ForeColor = Color::Gray;
					albDIn[ulI]->Font = gcnew System::Drawing::Font(albDIn[ulI]->Font, FontStyle::Regular);
				}
			}
		}
	}

	/* Update system time in case of a reconnect */
	if (bNewReconnected != false) {
		bNewReconnected = false;
		clNmx->SetDateTime_1(pHandleNmx);
	}

	/* Re-enable this timer */
	tmrStatic->Enabled = true;
}


	/******************************************************************************
	* FUNCTION: btnStaticResetMinMax_Click
	*-----------------------------------------------------------------------------
	* Reset all Min/Max - values of static measurement data.
	******************************************************************************/
private: System::Void btnStaticResetMinMax_Click(System::Object^  sender, System::EventArgs^  e) {
	unsigned long ulI = 0;

	for (ulI = 0; ulI < N_STATIC_CH_DISPLAY; ulI++) {
		aclChannelData[ulI]->ResetStaticMinMax();
	}
}


	/******************************************************************************
	* FUNCTION: cbDOut_1_CheckedChanged
	*-----------------------------------------------------------------------------
	* Transfer digital output data from GUI to device.
	******************************************************************************/
private: System::Void cbDOut_1_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
	unsigned char aucDigiOut[N_DIGIIO_DISPLAY / 8];
	if (bWriteDigitalOutputData != false) {
		memset(aucDigiOut, 0, sizeof(aucDigiOut));

		if (cbDOut_1->Checked != false) aucDigiOut[0] |= (1 << 0);
		if (cbDOut_2->Checked != false) aucDigiOut[0] |= (1 << 1);
		if (cbDOut_3->Checked != false) aucDigiOut[0] |= (1 << 2);
		if (cbDOut_4->Checked != false) aucDigiOut[0] |= (1 << 3);
		if (cbDOut_5->Checked != false) aucDigiOut[0] |= (1 << 4);
		if (cbDOut_6->Checked != false) aucDigiOut[0] |= (1 << 5);
		if (cbDOut_7->Checked != false) aucDigiOut[0] |= (1 << 6);
		if (cbDOut_8->Checked != false) aucDigiOut[0] |= (1 << 7);

		if (cbDOut_9->Checked != false) aucDigiOut[1] |= (1 << 0);
		if (cbDOut_10->Checked != false) aucDigiOut[1] |= (1 << 1);
		if (cbDOut_11->Checked != false) aucDigiOut[1] |= (1 << 2);
		if (cbDOut_12->Checked != false) aucDigiOut[1] |= (1 << 3);
		if (cbDOut_13->Checked != false) aucDigiOut[1] |= (1 << 4);
		if (cbDOut_14->Checked != false) aucDigiOut[1] |= (1 << 5);
		if (cbDOut_15->Checked != false) aucDigiOut[1] |= (1 << 6);
		if (cbDOut_16->Checked != false) aucDigiOut[1] |= (1 << 7);

		if (cbDOut_17->Checked != false) aucDigiOut[2] |= (1 << 0);
		if (cbDOut_18->Checked != false) aucDigiOut[2] |= (1 << 1);
		if (cbDOut_19->Checked != false) aucDigiOut[2] |= (1 << 2);
		if (cbDOut_20->Checked != false) aucDigiOut[2] |= (1 << 3);
		if (cbDOut_21->Checked != false) aucDigiOut[2] |= (1 << 4);
		if (cbDOut_22->Checked != false) aucDigiOut[2] |= (1 << 5);
		if (cbDOut_23->Checked != false) aucDigiOut[2] |= (1 << 6);
		if (cbDOut_24->Checked != false) aucDigiOut[2] |= (1 << 7);

		if (cbDOut_25->Checked != false) aucDigiOut[3] |= (1 << 0);
		if (cbDOut_26->Checked != false) aucDigiOut[3] |= (1 << 1);
		if (cbDOut_27->Checked != false) aucDigiOut[3] |= (1 << 2);
		if (cbDOut_28->Checked != false) aucDigiOut[3] |= (1 << 3);
		if (cbDOut_29->Checked != false) aucDigiOut[3] |= (1 << 4);
		if (cbDOut_30->Checked != false) aucDigiOut[3] |= (1 << 5);
		if (cbDOut_31->Checked != false) aucDigiOut[3] |= (1 << 6);
		if (cbDOut_32->Checked != false) aucDigiOut[3] |= (1 << 7);

		if (cbDOut_33->Checked != false) aucDigiOut[4] |= (1 << 0);
		if (cbDOut_34->Checked != false) aucDigiOut[4] |= (1 << 1);
		if (cbDOut_35->Checked != false) aucDigiOut[4] |= (1 << 2);
		if (cbDOut_36->Checked != false) aucDigiOut[4] |= (1 << 3);
		if (cbDOut_37->Checked != false) aucDigiOut[4] |= (1 << 4);
		if (cbDOut_38->Checked != false) aucDigiOut[4] |= (1 << 5);
		if (cbDOut_39->Checked != false) aucDigiOut[4] |= (1 << 6);
		if (cbDOut_40->Checked != false) aucDigiOut[4] |= (1 << 7);

		if (cbDOut_41->Checked != false) aucDigiOut[5] |= (1 << 0);
		if (cbDOut_42->Checked != false) aucDigiOut[5] |= (1 << 1);
		if (cbDOut_43->Checked != false) aucDigiOut[5] |= (1 << 2);
		if (cbDOut_44->Checked != false) aucDigiOut[5] |= (1 << 3);
		if (cbDOut_45->Checked != false) aucDigiOut[5] |= (1 << 4);
		if (cbDOut_46->Checked != false) aucDigiOut[5] |= (1 << 5);
		if (cbDOut_47->Checked != false) aucDigiOut[5] |= (1 << 6);
		if (cbDOut_48->Checked != false) aucDigiOut[5] |= (1 << 7);

		if (cbDOut_49->Checked != false) aucDigiOut[6] |= (1 << 0);
		if (cbDOut_50->Checked != false) aucDigiOut[6] |= (1 << 1);
		if (cbDOut_51->Checked != false) aucDigiOut[6] |= (1 << 2);
		if (cbDOut_52->Checked != false) aucDigiOut[6] |= (1 << 3);
		if (cbDOut_53->Checked != false) aucDigiOut[6] |= (1 << 4);
		if (cbDOut_54->Checked != false) aucDigiOut[6] |= (1 << 5);
		if (cbDOut_55->Checked != false) aucDigiOut[6] |= (1 << 6);
		if (cbDOut_56->Checked != false) aucDigiOut[6] |= (1 << 7);

		if (cbDOut_57->Checked != false) aucDigiOut[7] |= (1 << 0);
		if (cbDOut_58->Checked != false) aucDigiOut[7] |= (1 << 1);
		if (cbDOut_59->Checked != false) aucDigiOut[7] |= (1 << 2);
		if (cbDOut_60->Checked != false) aucDigiOut[7] |= (1 << 3);
		if (cbDOut_61->Checked != false) aucDigiOut[7] |= (1 << 4);
		if (cbDOut_62->Checked != false) aucDigiOut[7] |= (1 << 5);
		if (cbDOut_63->Checked != false) aucDigiOut[7] |= (1 << 6);
		if (cbDOut_64->Checked != false) aucDigiOut[7] |= (1 << 7);

		if (cbDOut_65->Checked != false) aucDigiOut[8] |= (1 << 0);
		if (cbDOut_66->Checked != false) aucDigiOut[8] |= (1 << 1);
		if (cbDOut_67->Checked != false) aucDigiOut[8] |= (1 << 2);
		if (cbDOut_68->Checked != false) aucDigiOut[8] |= (1 << 3);
		if (cbDOut_69->Checked != false) aucDigiOut[8] |= (1 << 4);
		if (cbDOut_70->Checked != false) aucDigiOut[8] |= (1 << 5);
		if (cbDOut_71->Checked != false) aucDigiOut[8] |= (1 << 6);
		if (cbDOut_72->Checked != false) aucDigiOut[8] |= (1 << 7);

		if (cbDOut_73->Checked != false) aucDigiOut[9] |= (1 << 0);
		if (cbDOut_74->Checked != false) aucDigiOut[9] |= (1 << 1);
		if (cbDOut_75->Checked != false) aucDigiOut[9] |= (1 << 2);
		if (cbDOut_76->Checked != false) aucDigiOut[9] |= (1 << 3);
		if (cbDOut_77->Checked != false) aucDigiOut[9] |= (1 << 4);
		if (cbDOut_78->Checked != false) aucDigiOut[9] |= (1 << 5);
		if (cbDOut_79->Checked != false) aucDigiOut[9] |= (1 << 6);
		if (cbDOut_80->Checked != false) aucDigiOut[9] |= (1 << 7);

		if (cbDOut_81->Checked != false) aucDigiOut[10] |= (1 << 0);
		if (cbDOut_82->Checked != false) aucDigiOut[10] |= (1 << 1);
		if (cbDOut_83->Checked != false) aucDigiOut[10] |= (1 << 2);
		if (cbDOut_84->Checked != false) aucDigiOut[10] |= (1 << 3);
		if (cbDOut_85->Checked != false) aucDigiOut[10] |= (1 << 4);
		if (cbDOut_86->Checked != false) aucDigiOut[10] |= (1 << 5);
		if (cbDOut_87->Checked != false) aucDigiOut[10] |= (1 << 6);
		if (cbDOut_88->Checked != false) aucDigiOut[10] |= (1 << 7);

		if (cbDOut_89->Checked != false) aucDigiOut[11] |= (1 << 0);
		if (cbDOut_90->Checked != false) aucDigiOut[11] |= (1 << 1);
		if (cbDOut_91->Checked != false) aucDigiOut[11] |= (1 << 2);
		if (cbDOut_92->Checked != false) aucDigiOut[11] |= (1 << 3);
		if (cbDOut_93->Checked != false) aucDigiOut[11] |= (1 << 4);
		if (cbDOut_94->Checked != false) aucDigiOut[11] |= (1 << 5);
		if (cbDOut_95->Checked != false) aucDigiOut[11] |= (1 << 6);
		if (cbDOut_96->Checked != false) aucDigiOut[11] |= (1 << 7);

		if (cbDOut_97->Checked != false) aucDigiOut[12] |= (1 << 0);
		if (cbDOut_98->Checked != false) aucDigiOut[12] |= (1 << 1);
		if (cbDOut_99->Checked != false) aucDigiOut[12] |= (1 << 2);
		if (cbDOut_100->Checked != false) aucDigiOut[12] |= (1 << 3);
		if (cbDOut_101->Checked != false) aucDigiOut[12] |= (1 << 4);
		if (cbDOut_102->Checked != false) aucDigiOut[12] |= (1 << 5);
		if (cbDOut_103->Checked != false) aucDigiOut[12] |= (1 << 6);
		if (cbDOut_104->Checked != false) aucDigiOut[12] |= (1 << 7);

		if (cbDOut_105->Checked != false) aucDigiOut[13] |= (1 << 0);
		if (cbDOut_106->Checked != false) aucDigiOut[13] |= (1 << 1);
		if (cbDOut_107->Checked != false) aucDigiOut[13] |= (1 << 2);
		if (cbDOut_108->Checked != false) aucDigiOut[13] |= (1 << 3);
		if (cbDOut_109->Checked != false) aucDigiOut[13] |= (1 << 4);
		if (cbDOut_110->Checked != false) aucDigiOut[13] |= (1 << 5);
		if (cbDOut_111->Checked != false) aucDigiOut[13] |= (1 << 6);
		if (cbDOut_112->Checked != false) aucDigiOut[13] |= (1 << 7);

		if (cbDOut_113->Checked != false) aucDigiOut[14] |= (1 << 0);
		if (cbDOut_114->Checked != false) aucDigiOut[14] |= (1 << 1);
		if (cbDOut_115->Checked != false) aucDigiOut[14] |= (1 << 2);
		if (cbDOut_116->Checked != false) aucDigiOut[14] |= (1 << 3);
		if (cbDOut_117->Checked != false) aucDigiOut[14] |= (1 << 4);
		if (cbDOut_118->Checked != false) aucDigiOut[14] |= (1 << 5);
		if (cbDOut_119->Checked != false) aucDigiOut[14] |= (1 << 6);
		if (cbDOut_120->Checked != false) aucDigiOut[14] |= (1 << 7);

		if (cbDOut_121->Checked != false) aucDigiOut[15] |= (1 << 0);
		if (cbDOut_122->Checked != false) aucDigiOut[15] |= (1 << 1);
		if (cbDOut_123->Checked != false) aucDigiOut[15] |= (1 << 2);
		if (cbDOut_124->Checked != false) aucDigiOut[15] |= (1 << 3);
		if (cbDOut_125->Checked != false) aucDigiOut[15] |= (1 << 4);
		if (cbDOut_126->Checked != false) aucDigiOut[15] |= (1 << 5);
		if (cbDOut_127->Checked != false) aucDigiOut[15] |= (1 << 6);
		if (cbDOut_128->Checked != false) aucDigiOut[15] |= (1 << 7);

		clNmx->SetOutputs_1(pHandleNmx, aucDigiOut, sizeof(aucDigiOut), 0);
	}
}

private: System::Void button1_Click(System::Object^  sender, System::EventArgs^  e) {
}

private: System::Void tmrUpdateDateTime_Tick(System::Object^  sender, System::EventArgs^  e) {
	tmrUpdateDateTime->Enabled = false;
	if (bConnected != false) {
		NMX_STATUS tStatus = clNmx->SetDateTime_1(pHandleNmx);
	}

	tmrUpdateDateTime->Enabled = true;
}


	/******************************************************************************
	* FUNCTION: SamplingUpdateSpeedLevels
	*-----------------------------------------------------------------------------
	* Retrieve the maximum speed from the system and set speed levels
	* accordingly.
	* Using different speed levels is not required for your measurement application.
	* It is just for demonstration purposes here.
	******************************************************************************/
private: System::Void SamplingUpdateSpeedLevels(void) {
	unsigned long ulPeriodMin = 1000;
	if (clNmx->Sampling_GetMaxSpeed_1(pHandleNmx, &ulPeriodMin) == NST_SUCCESS) {
		ulSamplePeriodUltraFast = ulPeriodMin;
		if (ulPeriodMin < 1000) {
			ulSamplePeriodFast = 1000;
			ulSamplePeriodStandard = 10000;
		}
		else {
			ulSamplePeriodFast = 500;
			ulSamplePeriodStandard = 10000;
		}
		double flTime = (double)ulSamplePeriodUltraFast / 1000.0f;
		double flSpeed = 1000000.0f / (double)ulSamplePeriodUltraFast;
		rbSampling_TimeHigh->Text = String::Format("{0}ms / {1} samples/s", flTime, (UINT32)flSpeed);
		flTime = (double)ulSamplePeriodFast / 1000.0f;
		flSpeed = 1000000.0f / (double)ulSamplePeriodFast;
		rbSampling_TimeMid->Text = String::Format("{0}ms / {1} samples/s", flTime, (UINT32)flSpeed);
		flTime = (double)ulSamplePeriodStandard / 1000.0f;
		flSpeed = 1000000.0f / (double)ulSamplePeriodStandard;
		rbSampling_TimeStandard->Text = String::Format("{0}ms / {1} samples/s", flTime, (UINT32)flSpeed);
	}
	else {
		AddHistoryEntry("Failed reading minimum sample period.", true);
	}
}


	/******************************************************************************
	* FUNCTION: btnSamplingAddChannelsAll_Click
	*-----------------------------------------------------------------------------
	* Add all measurement channels to the list of sampled data.
	******************************************************************************/
private: System::Void btnSamplingAddChannelsAll_Click(System::Object^  sender, System::EventArgs^  e) {
	unsigned long ulNElements = 0;
	if (clNmx->Sampling_AddChannelsAll_1(pHandleNmx, &ulNElements) == NST_SUCCESS) {
		AddHistoryEntry("All measurement channels successfully added to the sampling list.", false);
		lbSampling_NElements->Text = String::Format("{0} sampling elements added.", ulNElements);
		ulNSamplingElements = ulNElements;
	}
	else {
		AddHistoryEntry("Failed adding all measurement channels to the sampling list.", true);
	}

	btnSamplingAddChannelsAll->Enabled = false;
	btnSampling_AddChannels->Enabled = false;

	if (ulNElements > 0) {
		btnSampling_PrepareFiniteT->Enabled = true;
		btnSampling_PrepareEndlessT->Enabled = true;
		btnSamplingPrepareCustomTft->Enabled = true;
		btnSamplingPreparePosition->Enabled = true;
	}
}


	/******************************************************************************
	* FUNCTION: btnSampling_AddChannels_Click
	*-----------------------------------------------------------------------------
	* Add selected measurement channels (checkboxes) to the list of sampled data.
	******************************************************************************/
private: System::Void btnSampling_AddChannels_Click(System::Object^  sender, System::EventArgs^  e) {
	unsigned long ulNTotal = 0;
	unsigned long ulCtr = 0;
	BOOL bOk = true;

	for (signed long slI = 0; slI < cblSampling_MeasChannels->Items->Count; slI++) {
		if (cblSampling_MeasChannels->GetItemChecked(slI) != false) {
			if (clNmx->Sampling_AddChannel_1(pHandleNmx, slI, &ulNTotal) != NST_SUCCESS) {
				AddHistoryEntry(String::Format("Failed adding P{0} to the list of sampled elements.", slI+1), true);
				bOk = false;
			}
			ulCtr++;
		}
	}

	if (bOk != false) {
		AddHistoryEntry(String::Format("Successfully added {0} MEASUREMENT CHANNELS to sampling list.", ulCtr), false);
	}

	lbSampling_NElements->Text = String::Format("{0} sampling elements added.", ulNTotal);
	ulNSamplingElements = ulNTotal;

	btnSamplingAddChannelsAll->Enabled = false;
	btnSampling_AddChannels->Enabled = false;

	if (ulNTotal > 0) {
		btnSampling_PrepareFiniteT->Enabled = true;
		btnSampling_PrepareEndlessT->Enabled = true;
		btnSamplingPrepareCustomTft->Enabled = true;
		btnSamplingPreparePosition->Enabled = true;
	}
}


		 
	/******************************************************************************
	* FUNCTION: btnSampling_AddInputsAll_Click
	*-----------------------------------------------------------------------------
	* Add all digital input bytes to the list of sampled data.
	******************************************************************************/
private: System::Void btnSampling_AddInputsAll_Click(System::Object^  sender, System::EventArgs^  e) {
	unsigned long ulNElements = 0;
	if (clNmx->Sampling_AddDigiInAll_1(pHandleNmx, &ulNElements) == NST_SUCCESS) {
		AddHistoryEntry("All digital inputs successfully added to the sampling list.", false);
		lbSampling_NElements->Text = String::Format("{0} sampling elements added.", ulNElements);
		ulNSamplingElements = ulNElements;
	}
	else {
		AddHistoryEntry("Failed adding all digital inputs to the sampling list.", true);
	}

	btnSampling_AddInputsAll->Enabled = false;
	btnSampling_AddDigitalInputs->Enabled = false;

	if (ulNElements > 0) {
		btnSampling_PrepareFiniteT->Enabled = true;
		btnSampling_PrepareEndlessT->Enabled = true;
		btnSamplingPrepareCustomTft->Enabled = true;
		btnSamplingPreparePosition->Enabled = true;
	}
}


	/******************************************************************************
	* FUNCTION: btnSampling_AddDigitalInputs_Click
	*-----------------------------------------------------------------------------
	* Add selected digital input bytes (checkboxes) to the list of sampled data.
	******************************************************************************/
private: System::Void btnSampling_AddDigitalInputs_Click(System::Object^  sender, System::EventArgs^  e) {
	unsigned long ulNTotal = 0;
	unsigned long ulCtr = 0;
	BOOL bOk = true;

	for (signed long slI = 0; slI < cblSampling_DigitalInputs->Items->Count; slI++) {
		if (cblSampling_DigitalInputs->GetItemChecked(slI) != false) {
			if (clNmx->Sampling_AddDigiInByte_1(pHandleNmx, slI, &ulNTotal) != NST_SUCCESS) {
				AddHistoryEntry(String::Format("Failed adding Digital Input byte {0} to the list of sampled elements.", slI+1), true);
				bOk = false;
			}
			ulCtr++;
		}
	}

	if (bOk != false) {
		AddHistoryEntry(String::Format("Successfully added {0} digital INPUT bytes to sampling list.", ulCtr), false);
	}

	lbSampling_NElements->Text = String::Format("{0} sampling elements added.", ulNTotal);
	ulNSamplingElements = ulNTotal;

	btnSampling_AddInputsAll->Enabled = false;
	btnSampling_AddDigitalInputs->Enabled = false;


	if (ulNTotal > 0) {
		btnSampling_PrepareFiniteT->Enabled = true;
		btnSampling_PrepareEndlessT->Enabled = true;
		btnSamplingPrepareCustomTft->Enabled = true;
		btnSamplingPreparePosition->Enabled = true;
	}
}


	/******************************************************************************
	* FUNCTION: btnSampling_AddOutputsAll_Click
	*-----------------------------------------------------------------------------
	* Add all digital output bytes to the list of sampled data.
	******************************************************************************/
private: System::Void btnSampling_AddOutputsAll_Click(System::Object^  sender, System::EventArgs^  e) {
	unsigned long ulNElements = 0;
	if (clNmx->Sampling_AddDigiOutAll_1(pHandleNmx, &ulNElements) == NST_SUCCESS) {
		AddHistoryEntry("All digital outputs successfully added to the sampling list.", false);
		lbSampling_NElements->Text = String::Format("{0} sampling elements added.", ulNElements);
		ulNSamplingElements = ulNElements;
	}
	else {
		AddHistoryEntry("Failed adding all digital outputs to the sampling list.", true);
	}

	btnSampling_AddOutputsAll->Enabled = false;
	btnSampling_AddDigitalOutputs->Enabled = false;


	if (ulNElements > 0) {
		btnSampling_PrepareFiniteT->Enabled = true;
		btnSampling_PrepareEndlessT->Enabled = true;
		btnSamplingPrepareCustomTft->Enabled = true;
		btnSamplingPreparePosition->Enabled = true;
	}
}
		 

	/******************************************************************************
	* FUNCTION: btnSampling_AddDigitalOutputs_Click
	*-----------------------------------------------------------------------------
	* Add selected digital output bytes (checkboxes) to the list of sampled data.
	******************************************************************************/
private: System::Void btnSampling_AddDigitalOutputs_Click(System::Object^  sender, System::EventArgs^  e) {
	unsigned long ulNTotal = 0;
	unsigned long ulCtr = 0;
	BOOL bOk = true;

	for (signed long slI = 0; slI < cblSampling_DigitalOutputs->Items->Count; slI++) {
		if (cblSampling_DigitalOutputs->GetItemChecked(slI) != false) {
			if (clNmx->Sampling_AddDigiOutByte_1(pHandleNmx, slI, &ulNTotal) != NST_SUCCESS) {
				AddHistoryEntry(String::Format("Failed adding Digital Output byte {0} to the list of sampled elements.", slI+1), true);
				bOk = false;
			}
			ulCtr++;
		}
	}

	if (bOk != false) {
		AddHistoryEntry(String::Format("Successfully added {0} digital OUTPUT bytes to sampling list.", ulCtr), false);
	}

	lbSampling_NElements->Text = String::Format("{0} sampling elements added.", ulNTotal);
	ulNSamplingElements = ulNTotal;

	btnSampling_AddOutputsAll->Enabled = false;
	btnSampling_AddDigitalOutputs->Enabled = false;

	if (ulNTotal > 0) {
		btnSampling_PrepareFiniteT->Enabled = true;
		btnSampling_PrepareEndlessT->Enabled = true;
		btnSamplingPrepareCustomTft->Enabled = true;
		btnSamplingPreparePosition->Enabled = true;
	}
}


	/******************************************************************************
	* FUNCTION: btnSamplingReset_Click
	*-----------------------------------------------------------------------------
	* Resets the current sampling configuration (and stop sampling if running).
	******************************************************************************/
private: System::Void btnSamplingReset_Click(System::Object^  sender, System::EventArgs^  e) {
	if (clNmx->Sampling_Reset_1(pHandleNmx) == NST_SUCCESS) {
		AddHistoryEntry("Sampling reset successfully.", false);
		lbSampling_NElements->Text = "No sampling elements added.";

		btnSamplingAddChannelsAll->Enabled = true;
		btnSampling_AddChannels->Enabled = true;
		btnSampling_AddInputsAll->Enabled = true;
		btnSampling_AddDigitalInputs->Enabled = true;
		btnSampling_AddOutputsAll->Enabled = true;
		btnSampling_AddDigitalOutputs->Enabled = true;

		btnSampling_PrepareFiniteT->Enabled = false;
		btnSampling_PrepareEndlessT->Enabled = false;
		btnSamplingPrepareCustomTft->Enabled = false;
		btnSamplingPreparePosition->Enabled = false;

		SamplingClearNotificationCtrs();
	}
	else {
		AddHistoryEntry("Failed to reset sampling.", true);
	}
}



	/******************************************************************************
	* FUNCTION: btnSampling_PrepareFiniteT_Click
	*-----------------------------------------------------------------------------
	* Prepare time-based & time-limited measurement.
	******************************************************************************/
private: System::Void btnSampling_PrepareFiniteT_Click(System::Object^  sender, System::EventArgs^  e) {
	tmrSampling->Enabled = false;
	tmrSamplingEndlessReadData->Enabled = false;

	/* Get sample period from radio buttons */
	unsigned long ulSamplePeriod = ulSamplePeriodFast;
	if (rbSampling_TimeHigh->Checked == true) {
		ulSamplePeriod = ulSamplePeriodUltraFast;
	}
	else if (rbSampling_TimeStandard->Checked == true) {
		ulSamplePeriod = ulSamplePeriodStandard;
	}

	/* --> In this example with time-limited sampling, the DLL-internal buffer has enough space for
	*      storing all the sample values in the DLL (Sampling_PrepareTime_1 function parameters
	*      ulDLLArrayLength = udMaxSamples). This is possible, if the sampling-time is limited
	*      to a few seconds, since then only a small amount of memory is required. */
	if (clNmx->Sampling_PrepareTime_1(pHandleNmx, ulSamplePeriod, (UInt32)nuSampling_TimeNSamples->Value, (UInt32)nuSampling_TimeNSamples->Value) == NST_SUCCESS) {
		AddHistoryEntry("Time-limited sampling prepared successfully.", false);
		btnSampling_TEndlessStart->Enabled = false;
		btnSampling_TLimitedStart->Enabled = true;
		btnSampling_Store->Enabled = false;
		btnSampling_EndlessStore->Enabled = false;

		btnSamplingAddChannelsAll->Enabled = false;
		btnSampling_AddChannels->Enabled = false;
		btnSampling_AddInputsAll->Enabled = false;
		btnSampling_AddDigitalInputs->Enabled = false;
		btnSampling_AddOutputsAll->Enabled = false;
		btnSampling_AddDigitalOutputs->Enabled = false;
	}
	else {
		AddHistoryEntry("Failed preparing time-limited sampling.", true);
	}

	SamplingClearNotificationCtrs();
}


	/******************************************************************************
	* FUNCTION: btnSampling_PrepareEndlessT_Click
	*-----------------------------------------------------------------------------
	* Prepare endless time-based measurement.
	******************************************************************************/
private: System::Void btnSampling_PrepareEndlessT_Click(System::Object^  sender, System::EventArgs^  e) {
	unsigned long ulColumn = 0;
	unsigned long ulRow = 0;

	tmrSampling->Enabled = false;
	tmrSamplingEndlessReadData->Enabled = false;

	/* Get sample period from radio buttons */
	unsigned long ulSamplePeriod = ulSamplePeriodFast;
	if (rbSampling_TimeHigh->Checked == true) {
		ulSamplePeriod = ulSamplePeriodUltraFast;
	}
	else if (rbSampling_TimeStandard->Checked == true) {
		ulSamplePeriod = ulSamplePeriodStandard;
	}

	/* Specify DLL internal array size for buffering the samples. An array, which is large enough for
	 * a few seconds, e.g. 10s, is good practice. */
	unsigned long ulSamplesPer10s = (10 * 1000000) / ulSamplePeriod;

	/* Create buffers for sample values */
	ulSamplingEndlessArrayLength = (UINT32)nuSampling_TimeKeepSamples->Value;
	for (ulColumn = 0; ulColumn < ulNSamplingElements; ulColumn++) {
		if (paaslRingBuf[ulColumn] != NULL) {
			delete paaslRingBuf[ulColumn];
		}

		paaslRingBuf[ulColumn] = new signed long[ulSamplingEndlessArrayLength];
		for (ulRow = 0; ulRow < ulSamplingEndlessArrayLength; ulRow++) {
			paaslRingBuf[ulColumn][ulRow] = -2147483647;
		}
	}
	ulSamplingArrayRowNewest = 0;
	udSamplingCtrNewest = 0;

	/* --> Since it is impossible having an endless buffer for the sampled data, using a ring-buffer is required.
	 *     The Nmx-DLL uses an internal ring-buffer; its size if specified by ulSamplesPer10s. 
	 *     Using 0 as the last function parameter tells the DLL/measurement system, that the sampling is endless.
	 *     Please note: this demo application also uses a ringbuffer for storing the last sampled data. It
	 *     is optional and independent of the DLLs ringbuffer. Feel free to store the sampled data as you prefer it. */
	if (clNmx->Sampling_PrepareTime_1(pHandleNmx, ulSamplePeriod, ulSamplesPer10s, 0/*0=NoLimit*/) == NST_SUCCESS) {
		AddHistoryEntry("Endless sampling prepared successfully.", false);
		tmrSamplingEndlessReadData->Enabled = true;

		btnSampling_TLimitedStart->Enabled = false;
		btnSampling_TEndlessStart->Enabled = true;
		btnSampling_Store->Enabled = false;
		btnSampling_EndlessStore->Enabled = false;

		btnSamplingAddChannelsAll->Enabled = false;
		btnSampling_AddChannels->Enabled = false;
		btnSampling_AddInputsAll->Enabled = false;
		btnSampling_AddDigitalInputs->Enabled = false;
		btnSampling_AddOutputsAll->Enabled = false;
		btnSampling_AddDigitalOutputs->Enabled = false;
	}
	else {
		AddHistoryEntry("Failed preparing endless sampling.", true);
	}

	SamplingClearNotificationCtrs();
}




	/******************************************************************************
	* FUNCTION: btnSamplingPrepareCustomTft_Click
	*-----------------------------------------------------------------------------
	* Prepare custom sampling, type TFT.
	******************************************************************************/
private: System::Void btnSamplingPrepareCustomTft_Click(System::Object^  sender, System::EventArgs^  e) {
	unsigned long ulFilterPeriod = (UINT32)nuSamplingTftFilterPeriod->Value * 1000;
	unsigned long ulMod = 0;
	unsigned long ulDiv = 0;
	unsigned long ulNSamples = (UINT32)nuSamplingTftNSamples->Value;
	unsigned long ulNTailSamples = (UINT32)nuSamplingTftNTailSamples->Value;
	unsigned long ulTriggerByteNo = cbSamplingTftTriggerByte->SelectedIndex;
	unsigned long ulTriggerBitNo = cbSamplingTftTriggerBit->SelectedIndex;
	unsigned long ulTriggerMode = cbSamplingTftTriggerMode->SelectedIndex;
	unsigned long ulTriggerPolarity = cbSamplingTftTriggerPolarity->SelectedIndex + 1;


	tmrSampling->Enabled = false;
	tmrSamplingEndlessReadData->Enabled = false;

	/* Get sample period from radio buttons */
	unsigned long ulSamplePeriod = ulSamplePeriodFast;
	if (rbSampling_TimeHigh->Checked == true) {
		ulSamplePeriod = ulSamplePeriodUltraFast;
	}
	else if (rbSampling_TimeStandard->Checked == true) {
		ulSamplePeriod = ulSamplePeriodStandard;
	}

	ulMod = ulFilterPeriod % ulSamplePeriod;
	ulDiv = ulFilterPeriod / ulSamplePeriod;
	if ((ulMod != 0) || (ulDiv < 1)) {
		MessageBox::Show("Invalid filter period. Must be >= sample period and a multiple of the sample period. Example: sample period = 1ms, filter period = 5ms.");
		AddHistoryEntry("Failed preparing TFT sampling: filter period invalid", true);
		return;
	}


	/* --> In this example, a few assumptions are made for simplicity: 
	 *     - It is assumed that number of samples is limited (e.g. < 100000 per sampling element),
	 *       therefore the size of the internal DLL array length is selected to have enough
	 *       space for all samples.
	 *     - Endless sampling is not implemented in this example, but could be used. */
	NMX_STATUS eStat = clNmx->Sampling_PrepareCustomTFT_1(pHandleNmx,
		ulSamplePeriod,
		ulFilterPeriod,
		ulNSamples + ulNTailSamples,
		(unsigned long long)ulNSamples,
		ulNTailSamples,
		ulTriggerByteNo,
		ulTriggerBitNo,
		ulTriggerMode,
		ulTriggerPolarity);
	if (eStat == NST_SUCCESS) {
		AddHistoryEntry("TFT sampling prepared successfully.", false);
		btnSampling_TEndlessStart->Enabled = false;
		btnSampling_TLimitedStart->Enabled = true;
		btnSampling_Store->Enabled = false;
		btnSampling_EndlessStore->Enabled = false;

		btnSamplingAddChannelsAll->Enabled = false;
		btnSampling_AddChannels->Enabled = false;
		btnSampling_AddInputsAll->Enabled = false;
		btnSampling_AddDigitalInputs->Enabled = false;
		btnSampling_AddOutputsAll->Enabled = false;
		btnSampling_AddDigitalOutputs->Enabled = false;
	}
	else {
		AddHistoryEntry("Failed preparing TFT sampling.", true);
	}

	SamplingClearNotificationCtrs();
}
		 
		 

/******************************************************************************
* FUNCTION: btnSamplingPreparePosition_Click
*-----------------------------------------------------------------------------
* Prepare position triggered sampling.
******************************************************************************/
private: System::Void btnSamplingPreparePosition_Click(System::Object^  sender, System::EventArgs^  e) {
	unsigned long ulArrayLength = (UINT32)nuSamplingPositionNSamples->Value;
	unsigned long long udMaxSamples = (UINT64)nuSamplingPositionNSamples->Value;
	unsigned long ulTriggerChannelNumber = cbSamplingPositionTriggerChannel->SelectedIndex;
	double fdScale = (double)nuSamplingPositionScale->Value;
	double fdStart = (double)nuSamplingPositionStart->Value;
	double fdDistance = (double)nuSamplingPositionDistance->Value;


	tmrSampling->Enabled = false;
	tmrSamplingEndlessReadData->Enabled = false;

	/* Get sample period from radio buttons */
	unsigned long ulSamplePeriod = ulSamplePeriodFast;
	if (rbSampling_TimeHigh->Checked == true) {
		ulSamplePeriod = ulSamplePeriodUltraFast;
	}
	else if (rbSampling_TimeStandard->Checked == true) {
		ulSamplePeriod = ulSamplePeriodStandard;
	}

	/* --> In this example, a few assumptions are made for simplicity:
	*     - It is assumed that number of samples is limited (e.g. < 100000 per sampling element),
	*       therefore the size of the internal DLL array length is selected to have enough
	*       space for all samples.
	*     - Endless sampling is not implemented in this example, but could be used. */
	NMX_STATUS eStat = clNmx->Sampling_PreparePosition_1(pHandleNmx,
		ulSamplePeriod,
		ulArrayLength,
		udMaxSamples,
		ulTriggerChannelNumber,
		fdScale,
		fdStart,
		fdDistance);
	if (eStat == NST_SUCCESS) {
		AddHistoryEntry("Position-Triggered sampling prepared successfully.", false);
		btnSampling_TEndlessStart->Enabled = false;
		btnSampling_TLimitedStart->Enabled = true;
		btnSampling_Store->Enabled = false;
		btnSampling_EndlessStore->Enabled = false;

		btnSamplingAddChannelsAll->Enabled = false;
		btnSampling_AddChannels->Enabled = false;
		btnSampling_AddInputsAll->Enabled = false;
		btnSampling_AddDigitalInputs->Enabled = false;
		btnSampling_AddOutputsAll->Enabled = false;
		btnSampling_AddDigitalOutputs->Enabled = false;
	}
	else {
		AddHistoryEntry("Failed preparing Position-Triggered sampling.", true);
	}

	SamplingClearNotificationCtrs();
}



/******************************************************************************
* FUNCTION: btnSampling_Start_Click
*-----------------------------------------------------------------------------
* Start time-limited sampling.
******************************************************************************/
private: System::Void btnSampling_Start_Click(System::Object^  sender, System::EventArgs^  e) {
	if (clNmx->Sampling_Start_1(pHandleNmx) == NST_SUCCESS) {
		AddHistoryEntry("Sampling (time-limited) started successfully.", false);
		tmrSampling->Enabled = true;
		btnSampling_TLimitedStart->Enabled = false;
	}
	else {
		AddHistoryEntry("Failed starting time-limited sampling.", true);
	}
}


/******************************************************************************
* FUNCTION: btnSampling_TEndlessStart_Click
*-----------------------------------------------------------------------------
* Start endless sampling.
******************************************************************************/
private: System::Void btnSampling_TEndlessStart_Click(System::Object^  sender, System::EventArgs^  e) {
	if (clNmx->Sampling_Start_1(pHandleNmx) == NST_SUCCESS) {
		AddHistoryEntry("Sampling (endless) started successfully.", false);
		tmrSampling->Enabled = true;
		btnSampling_TEndlessStart->Enabled = false;

		if (rbSampling_TEndlessReadCols->Checked == false) {
			bSamplingReadRows = true;
		}
		else {
			bSamplingReadRows = false;
		}
	}
	else {
		AddHistoryEntry("Failed starting endless sampling.", true);
	}
}


		 
/******************************************************************************
* FUNCTION: btnSampling_Store_Click
*-----------------------------------------------------------------------------
* Time-limited sampling: Store sampled values into a CSV file.
******************************************************************************/
private: System::Void btnSampling_Store_Click(System::Object^  sender, System::EventArgs^  e) {
	FileStream^ cFileStream = nullptr;
	StreamWriter^ cStreamWriter = nullptr;
	wchar_t awcPath[512];
	String^ strPath = nullptr;
	String^ str = "";
	unsigned long ulCtr = 0;
	unsigned long ulPosition = 0;
	signed long slValue = 0;
	unsigned long long udSamplesReceived = 0;
	unsigned long ulSamplesCopied = 0;


	/* ---> In this example with time-limited sampling, all measurement values are
	 * read here from the DLL in a single step. This is possible, if the time and therefore
	 * the memory consumption for the samples is not too large. */



	/* Get number of samples, which are available. */
	clNmx->Sampling_GetStatus_1(pHandleNmx, NULL, NULL, &udSamplesReceived, NULL);


	try
	{
		/* Create file path. Samples.csv will be stored in the same
		* directory as the *.exe-File of the application. */
		GetModuleFileName(NULL, awcPath, 512);
		strPath = gcnew String(awcPath);
		strPath = Path::GetDirectoryName(strPath) + "\\Samples.csv";

		cFileStream = gcnew FileStream(strPath, FileMode::Create);
		cStreamWriter = gcnew StreamWriter(cFileStream);

		/* Writer Header line */
		str = "";
		for (unsigned long ulColumn = 0; ulColumn < ulNSamplingElements; ulColumn++)
		{
			if (ulColumn == 0) {
				str += String::Format("E{0}", ulColumn+1);
			}
			else {
				str += String::Format(";E{0}", ulColumn+1);
			}
		}
		cStreamWriter->WriteLine(str);

		/* There are 2 possibilities reading data from the DLL:
		 * 1. Read data column-wise, which means: read an array of sample-values for a specific sampling element, e.g. a probe. 
		 * 2. Read data row-wise, which means: read the values of all sampling-elements, which have been sampled at the same time.
		 * The first way is a bit better regarding performance. On many PCs this is neglectable. 
		 * See documentation for more information.
		 * Choose the possibility, which is more convenient for you. */
		if (rbSampling_TLimitedReadCols->Checked != false)
		{
			/* ---> Read column-wise */
			bSamplingReadRows = false;

			/* Create arrays for sampling data and read it from DLL */
			signed long **aaslSamples = new signed long*[ulNSamplingElements];
			for (unsigned long ulColumn = 0; ulColumn < ulNSamplingElements; ulColumn++)
			{
				aaslSamples[ulColumn] = new signed long[(unsigned long)udSamplesReceived];
				for (unsigned long ulRow = 0; ulRow < udSamplesReceived; ulRow++) {
					aaslSamples[ulColumn][ulRow] = -2147483647;
				}

				/* Feel free to do some more error handling here, e.g. check ulSamplesCopied and checking the function return code. */
				clNmx->Sampling_ReadColumn32_1(pHandleNmx, aaslSamples[ulColumn], (unsigned long)udSamplesReceived, ulColumn, 1, &ulSamplesCopied, NULL);
			}


			/* Write sample values to file */
			for (unsigned long ulRow = 0; ulRow < udSamplesReceived; ulRow++) {
				str = "";
				for (unsigned long ulColumn = 0; ulColumn < ulNSamplingElements; ulColumn++) {
					if (ulColumn == 0) {
						str += String::Format("{0}", aaslSamples[ulColumn][ulRow]);
					}
					else {
						str += String::Format(";{0}", aaslSamples[ulColumn][ulRow]);
					}
				}
				cStreamWriter->WriteLine(str);
			}

			/* Delete sample arrays */
			for (unsigned long ulColumn = 0; ulColumn < ulNSamplingElements; ulColumn++) {
				delete aaslSamples[ulColumn];
			}
			delete aaslSamples;
		}
		else {
			/* ---> Read row-wise */
			bSamplingReadRows = true;

			/* Create array for values */
			signed long *aslValues = new signed long[ulNSamplingElements];

			for (unsigned long long udRow = 0; udRow < udSamplesReceived; udRow++) {
				for (unsigned long ulColumn = 0; ulColumn < ulNSamplingElements; ulColumn++) {
					aslValues[ulColumn] = -2147483647;
				}

				/* Get values from DLL.
				 * Feel free to do some more error handling here, e.g. check ulSamplesCopied and checking the function return code. */
				clNmx->Sampling_ReadRow32_1(pHandleNmx, aslValues, ulNSamplingElements, &ulSamplesCopied, NULL);

				/* Write line with samples. */
				str = "";
				for (unsigned long ulColumn = 0; ulColumn < ulNSamplingElements; ulColumn++) {
					if (ulColumn == 0) {
						str += String::Format("{0}", aslValues[ulColumn]);
					}
					else {
						str += String::Format(";{0}", aslValues[ulColumn]);
					}
				}
				cStreamWriter->WriteLine(str);
			}

			/* Delete sample array */
			delete aslValues;

			/* Disable this button, since reading row-wise can only be done once. */
			btnSampling_Store->Enabled = false;
		}

		/* Write finished: close file*/
		cStreamWriter->Close();

		str = "Sample values successfully written to " + strPath + ".";
		AddHistoryEntry(str, false);
	}
	catch (Exception^ e)
	{
		str = "Sample values cannot be written Samples.csv (" + e->Message + ").";
		AddHistoryEntry(str, true);
	}
	finally
	{
		if (cStreamWriter)
		{
			cStreamWriter->Close();
		}
	}

	/* Inform user about result of writing the file (success, error) */
	MessageBox::Show(str, "Store sampled measurement values");
}


/******************************************************************************
* FUNCTION: btnSampling_EndlessStore_Click
*-----------------------------------------------------------------------------
* Store last sampled values of endless sampling into a CSV file.
******************************************************************************/
private: System::Void btnSampling_EndlessStore_Click(System::Object^  sender, System::EventArgs^  e) {
	FileStream^ cFileStream = nullptr;
	StreamWriter^ cStreamWriter = nullptr;
	wchar_t awcPath[512];
	String^ str = "";
	String^strPath = "";
	UINT32 ulColumn = 0;
	UINT32 ulRow = 0;
	UINT32 ulArrayIndex = 0;

	/* Check if minimum 1 sample buffer is available */
	if (paaslRingBuf[0] != NULL)
	{
		try
		{
			/* Create file path. Samples.csv will be stored in the same
			* directory as the *.exe-File of the application. */
			GetModuleFileName(NULL, awcPath, 512);
			strPath = gcnew String(awcPath);
			strPath = Path::GetDirectoryName(strPath) + "\\Samples.csv";

			cFileStream = gcnew FileStream(strPath, FileMode::Create);
			cStreamWriter = gcnew StreamWriter(cFileStream);

			/* Writer Header line */
			str = "";
			for (ulColumn = 0; ulColumn < ulNSamplingElements; ulColumn++)
			{
				if (ulColumn == 0) {
					str += String::Format("E{0}", ulColumn+1);
				}
				else {
					str += String::Format(";E{0}", ulColumn+1);
				}
			}
			cStreamWriter->WriteLine(str);


			/* Write sample values to file */
			UINT32 ulTotalRows = ulSamplingEndlessArrayLength;
			UINT32 ulSkip = 0;
			if (ulTotalRows > udSamplingCtrNewest) {
				ulTotalRows = (UINT32)udSamplingCtrNewest;
				ulSkip = ulSamplingEndlessArrayLength - ulTotalRows;
			}
			for (ulRow = 0; ulRow < ulTotalRows; ulRow++) {
				str = "";
				ulArrayIndex = (ulRow + ulSamplingArrayRowNewest + ulSkip) % ulSamplingEndlessArrayLength;
				for (ulColumn = 0; ulColumn < ulNSamplingElements; ulColumn++) {
					if (ulColumn == 0) {
						str += String::Format("{0}", paaslRingBuf[ulColumn][ulArrayIndex]);
					}
					else {
						str += String::Format(";{0}", paaslRingBuf[ulColumn][ulArrayIndex]);
					}
				}
				cStreamWriter->WriteLine(str);
			}

			/* Write finished: close file*/
			cStreamWriter->Close();

			str = "Sample values successfully written to " + strPath + ".";
			AddHistoryEntry(str, false);
		}
		catch (Exception^ e)
		{
			str = "Sample values cannot be written Samples.csv (" + e->Message + ").";
			AddHistoryEntry(str, true);
		}
		finally
		{
			if (cStreamWriter)
			{
				cStreamWriter->Close();
			}
		}

	}
	else {
		str = "No data available.";
	}

	/* Inform user about result of writing the file (success, error) */
	MessageBox::Show(str, "Store sampled measurement values");
}
		 
		 
		 
	/******************************************************************************
	* FUNCTION: btnSampling_Stop_Click
	*-----------------------------------------------------------------------------
	* Stop sampling.
	******************************************************************************/
private: System::Void btnSampling_Stop_Click(System::Object^  sender, System::EventArgs^  e) {
	if (clNmx->Sampling_Stop_1(pHandleNmx) == NST_SUCCESS) {
		AddHistoryEntry("Sampling stop requested.", false);
	}
	else {
		AddHistoryEntry("Failed stopping sampling.", true);
	}
}


	/******************************************************************************
	* FUNCTION: tmrSampling_Tick
	*-----------------------------------------------------------------------------
	* Update sampling status.
	******************************************************************************/
private: System::Void tmrSampling_Tick(System::Object^  sender, System::EventArgs^  e) {
	unsigned char ucStatus = 0;
	unsigned long long udSamplesReceived = 0;
	unsigned long long udSamplesMax = 0;

	/* Disable this timer */
	tmrSampling->Enabled = false;

	/* Update status information */
	lbSampling_NotificationsNewData->Text = String::Format("{0} new-data notifications", ulCtrSamplingNotificationsNewData);
	lbSampling_NotificationAllReceived->Text = String::Format("{0} all-received notifications", ulCtrSamplingNotificationsAllReceived);
	lbSampling_NotificationFinished->Text = String::Format("{0} finished notifications", ulCtrSamplingNotificationsFinished);
	lbSampling_NotificationError->Text = String::Format("{0} error notifications", ulCtrSamplingNotificationsError);
	lbSampling_NotificationBufOverflow->Text = String::Format("{0} buffer overflow notifications", ulCtrSamplingNotificationsBufferOverflow);
	lbSampling_NotificationTimeout->Text = String::Format("{0} timeout notifications", ulCtrSamplingNotificationTimeout);

	if (clNmx->Sampling_GetStatus_1(pHandleNmx, &ucStatus, NULL, &udSamplesReceived, &udSamplesMax) == NST_SUCCESS) {
		lbSampling_NSamplesReceived->Text = String::Format("{0} samples received", udSamplesReceived);

		if ((udSamplesReceived > 0) && (bSamplingReadRows == false)) {
			btnSampling_Store->Enabled = true;
		}

		if (udSamplesMax > 1000000000) {
			/* Just an alternate text to ensure that its length gets not too large with endless sampling. */
			lbSampling_MaxSamples->Text = String::Format("> 1 billion samples max");
		}
		else {
			lbSampling_MaxSamples->Text = String::Format("{0} samples max", udSamplesMax);
		}
	}
	else {
		lbSampling_NSamplesReceived->Text = "*";
		lbSampling_MaxSamples->Text = "*";
	}

	/* Re-enable this timer */
	tmrSampling->Enabled = true;
}


	/******************************************************************************
	* FUNCTION: tmrSamplingEndlessReadData_Tick
	*-----------------------------------------------------------------------------
	* Endless sampling: read sampled data and store it in local (ring-)buffer.
	******************************************************************************/
private: System::Void tmrSamplingEndlessReadData_Tick(System::Object^  sender, System::EventArgs^  e) {
	unsigned long long udSamplesReceived = 0;
	unsigned long ulRemainingRows = 0;
	unsigned long ulSamplesCopied = 0;
	unsigned long long udNoFirstSample = 0;


	/* Disable this timer */
	tmrSamplingEndlessReadData->Enabled = false;

	if (bNewSamplingData != false) {
		bNewSamplingData = false;

		/* Get number of samples, which are available. */
		if (clNmx->Sampling_GetStatus_1(pHandleNmx, NULL, NULL, &udSamplesReceived, NULL) != NST_SUCCESS) {
			AddHistoryEntry("Error reading endless sampling data: cannot get sampling status", true);
			return;
		}

		btnSampling_EndlessStore->Enabled = true;

		/* Calculate remaining array rows until the end of the array. */
		if (ulSamplingArrayRowNewest == (ulSamplingEndlessArrayLength - 1)) {
			/* End of array reached. Start again from beginning. */
			ulRemainingRows = ulSamplingEndlessArrayLength;
		}
		if (ulSamplingEndlessArrayLength >= ulSamplingArrayRowNewest) {
			ulRemainingRows = ulSamplingEndlessArrayLength - ulSamplingArrayRowNewest;
		}
		else {
			ulRemainingRows = 0;
			AddHistoryEntry("Error reading endless sampling data: invalid array index ulSamplingArrayRowNewest", true);
			return;
		}

		/* There are 2 possibilities reading data from the DLL:
		* 1. Read data column-wise, which means: read an array of sample-values for a specific sampling element, e.g. a probe.
		* 2. Read data row-wise, which means: read the values of all sampling-elements, which have been sampled at the same time.
		* The first way is a bit better regarding performance. On many PCs this is neglectable.
		* See documentation for more information.
		* Choose the possibility, which is more convenient for you. */
		if (bSamplingReadRows == false) {
			/* ---> Read column-wise */
			for (unsigned long ulColumn = 0; ulColumn < ulNSamplingElements; ulColumn++) {
				if (clNmx->Sampling_ReadColumn32_1(pHandleNmx, &paaslRingBuf[ulColumn][ulSamplingArrayRowNewest], ulRemainingRows, ulColumn, 0, &ulSamplesCopied, &udNoFirstSample) != NST_SUCCESS) {
					AddHistoryEntry("Error reading endless sampling data: cannot read sample data", true);
					return;
				}

				if (udNoFirstSample != udSamplingCtrNewest) {
					AddHistoryEntry("Error reading endless sampling data: invalid sample counter received", true);
					return;
				}

				/* If more than 1 column is read, make sure that the number of rows read for all columns is identical. */
				if (ulSamplesCopied < ulRemainingRows) {
					ulRemainingRows = ulSamplesCopied;
				}
			}

			/* Update row, which contains the newest sampling data */
			ulSamplingArrayRowNewest = (ulSamplingArrayRowNewest + ulSamplesCopied) % ulSamplingEndlessArrayLength;

			/* Update total counter of sampling data, which has been read */
			udSamplingCtrNewest += (unsigned long long)ulSamplesCopied;
		}
		else {
			/* Read row-wise */

			signed long *aslValues = new signed long[ulNSamplingElements];
			BOOL bError = false;
			while (udSamplingCtrNewest < udSamplesReceived) {
				for (unsigned long ulColumn = 0; ulColumn < ulNSamplingElements; ulColumn++) {
					aslValues[ulColumn] = -2147483647;
				}

				/* Read samples from DLL into local array */
				if (clNmx->Sampling_ReadRow32_1(pHandleNmx, aslValues, ulNSamplingElements, &ulSamplesCopied, &udNoFirstSample) != NST_SUCCESS) {
					AddHistoryEntry("Error reading endless sampling data: cannot read sample data", true);
					bError = true;
					break;;
				}

				if (udNoFirstSample != udSamplingCtrNewest) {
					AddHistoryEntry("Error reading endless sampling data: invalid sample counter received", true);
					bError = true;
					break;
				}

				/* Copy samples from local array to global Ring-buffer */
				for (unsigned long ulColumn = 0; ulColumn < ulNSamplingElements; ulColumn++) {
					paaslRingBuf[ulColumn][ulSamplingArrayRowNewest] = aslValues[ulColumn];
				}
				/* Update row, which contains the newest sampling data */
				ulSamplingArrayRowNewest = (ulSamplingArrayRowNewest + 1) % ulSamplingEndlessArrayLength;


				udSamplingCtrNewest++;
			}
			delete aslValues;
			if (bError != false) {
				return;
			}
		}
	}


	/* Re-enable this timer */
	tmrSamplingEndlessReadData->Enabled = true;
}

/******************************************************************************
* FUNCTION: cbStaticFastUpdate_CheckedChanged
*-----------------------------------------------------------------------------
* Enable/Disable median filter for static values. Default by the system is
* enabled.
******************************************************************************/
private: System::Void cbStaticFastUpdate_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
	if (cbStaticFastUpdate->Checked) {
		/* Enable median filter. Filter depth should be odd. 5 is a good value. */
		clNmx->StaticSetMedianDepth_1(pHandleNmx, 5);
	}
	else {
		/* Disable median filter */
		clNmx->StaticSetMedianDepth_1(pHandleNmx, 1);
	}
}


/******************************************************************************
* FUNCTION: btnDigiEnableOutputWrite_Click
*-----------------------------------------------------------------------------
* Enable/Disable writing the digital output data.
******************************************************************************/
private: System::Void btnDigiEnableOutputWrite_Click(System::Object^  sender, System::EventArgs^  e) {
	if (bWriteDigitalOutputData == false) {
		bWriteDigitalOutputData = true;
		btnDigiEnableOutputWrite->Text = "Click to DISABLE writing output data to device";
		btnDigiEnableOutputWrite->ForeColor = Color::Black;
		cbDOut_1_CheckedChanged(sender, e);
	}
	else {
		bWriteDigitalOutputData = false;
		btnDigiEnableOutputWrite->Text = "Click to ENABLE writing output data to device";
		btnDigiEnableOutputWrite->ForeColor = Color::Red;
		clNmx->DisableOutputUpdate_1(pHandleNmx);
	}
}

/******************************************************************************
* FUNCTION: btnChannelSetParameter_Click
*-----------------------------------------------------------------------------
* Send string with "channel parameter" to device and receive its response.
******************************************************************************/
private: System::Void btnChannelSetParameter_Click(System::Object^  sender, System::EventArgs^  e) {
	char acStrRx[128];
	unsigned long ulRxSize = 0;

	acStrRx[0] = 0;

	IntPtr ptrToNativeString = Marshal::StringToHGlobalAnsi(tbChannelSetParameterTx->Text);
	char* pcNativeString = static_cast<char*>(ptrToNativeString.ToPointer());

	tbChannelSetParameterRx->Text = "";
	if (clNmx->ChannelSetParameter_1(pHandleNmx, (UInt32)nuChannelSetParameterNo->Value, pcNativeString, strlen(pcNativeString), acStrRx, sizeof(acStrRx), &ulRxSize) == NST_SUCCESS)
	{
		AddHistoryEntry("Channel Parameter string exchanged successfully", false);
		tbChannelSetParameterRx->Text = Marshal::PtrToStringAnsi(IntPtr(acStrRx));
	}
	else {
		AddHistoryEntry("Failed exchanging Channel Parameter String", true);
		tbChannelSetParameterRx->Text = "Error";
	}
}


/******************************************************************************
* FUNCTION: btnChannelSetConfig_Click
*-----------------------------------------------------------------------------
* Send string with "channel config" to device and receive its response.
******************************************************************************/
private: System::Void btnChannelSetConfig_Click(System::Object^  sender, System::EventArgs^  e) {
	char acStrRx[128];
	unsigned long ulRxSize = 0;

	acStrRx[0] = 0;

	IntPtr ptrToNativeString = Marshal::StringToHGlobalAnsi(tbChannelSetConfigTx->Text);
	char* pcNativeString = static_cast<char*>(ptrToNativeString.ToPointer());

	tbChannelSetConfigRx->Text = "";
	if (clNmx->ChannelSetConfig_1(pHandleNmx, (UInt32)nuChannelSetConfigNo->Value, pcNativeString, strlen(pcNativeString), acStrRx, sizeof(acStrRx), &ulRxSize) == NST_SUCCESS)
	{
		AddHistoryEntry("Channel Config string exchanged successfully", false);
		tbChannelSetConfigRx->Text = Marshal::PtrToStringAnsi(IntPtr(acStrRx));
	}
	else {
		AddHistoryEntry("Failed exchanging Channel Config String", true);
		tbChannelSetConfigRx->Text = "Error";
	}
}


/******************************************************************************
* FUNCTION: btnSamplingDInTrgSet_Click
*-----------------------------------------------------------------------------
* Sampling: set the digital input trigger.
* Using a trigger is optional! If you do not need it, ignore this code.
******************************************************************************/
private: System::Void btnSamplingDInTrgSet_Click(System::Object^  sender, System::EventArgs^  e) {
	unsigned long ulByte = 0;
	unsigned long ulBit = 0;
	unsigned long ulMode = 0;
	unsigned long ulPol = 0;

	ulByte = cbSamplingDInTrgByte->SelectedIndex;
	ulBit = cbSamplingDInTrgBit->SelectedIndex;
	ulMode = cbSamplingDInTrgMode->SelectedIndex + 1;
	ulPol = cbSamplingDInTrgPol->SelectedIndex + 1;

	if (clNmx->Sampling_SetTriggerDigiIn_1(pHandleNmx, ulByte, ulBit, ulMode, ulPol) == NST_SUCCESS)
	{
		AddHistoryEntry("Sampling: digital input trigger set successfully.", false);
	}
	else {
		AddHistoryEntry("Failed setting digital input trigger for sampling.", true);
	}
}


};

}
